#
# Copyright 2014 Red Hat, Inc.
#
# This software is licensed to you under the GNU General Public
# License as published by the Free Software Foundation; either version
# 2 of the License (GPLv2) or (at your option) any later version.
# There is NO WARRANTY for this software, express or implied,
# including the implied warranties of MERCHANTABILITY,
# NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
# have received a copy of GPLv2 along with this software; if not, see
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.

module Actions
  module Candlepin
    module Product
      class ContentCreate < Candlepin::Abstract
        input_format do
          param :name
          param :type
          param :label
          param :content_url
        end

        def run
          output[:response] = ::Katello::Resources::Candlepin::Content.
              create(name: input[:name],
                     contentUrl: input[:content_url],
                     type: input[:type],
                     label: input[:label],
                     vendor: ::Katello::Provider::CUSTOM)
        end
      end
    end
  end
end
