#
# Copyright 2014 Red Hat, Inc.
#
# This software is licensed to you under the GNU General Public
# License as published by the Free Software Foundation; either version
# 2 of the License (GPLv2) or (at your option) any later version.
# There is NO WARRANTY for this software, express or implied,
# including the implied warranties of MERCHANTABILITY,
# NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
# have received a copy of GPLv2 along with this software; if not, see
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.

module Katello
  module Validators
    class KatelloUrlFormatValidator < ActiveModel::EachValidator
      include KatelloUrlHelper

      def validate_each(record, attribute, value)
        if options[:nil_allowed]
          if options[:nil_allowed].respond_to?(:call)
            return if value.nil? && options[:nil_allowed].call(record)
          else
            return if value.nil?
          end
        end

        attribute_name = options[:field_name] || attribute
        record.errors[attribute_name] << N_("is invalid") unless kurl_valid?(value)
      end
    end
  end
end
