/**
 * Copyright 2013-2014 Red Hat, Inc.
 *
 * This software is licensed to you under the GNU General Public
 * License as published by the Free Software Foundation; either version
 * 2 of the License (GPLv2) or (at your option) any later version.
 * There is NO WARRANTY for this software, express or implied,
 * including the implied warranties of MERCHANTABILITY,
 * NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 * have received a copy of GPLv2 along with this software; if not, see
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
 */

/**
 * @ngdoc object
 * @name  Bastion.subscriptions.controller:SubscriptionProductsController
 *
 * @requires $scope
 * @requires $state
 * @requires Subscription
 * @requires Product
 * @requires CurrentOrganization
 *
 * @description
 *   Provides the functionality for the subscription products action pane.
 */
angular.module('Bastion.subscriptions').controller('SubscriptionProductsController',
    ['$scope', '$state', 'Subscription', 'Product', 'CurrentOrganization', function ($scope, $state, Subscription, Product, CurrentOrganization) {

        $scope.displayArea = { working: true };

        Product.queryUnpaged({'organization_id': CurrentOrganization,
                              'subscription_id': $scope.$stateParams.subscriptionId,
                              enabled: true
                             }, function (response) {
            $scope.products = response.results;
            $scope.displayArea.working = false;
        });

    }]
);
