/**
 Copyright 2014 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
 **/
/**
 * @ngdoc module
 * @name  Bastion.host-collections
 *
 * @description
 *   Module for host collections related functionality.
 */
angular.module("Bastion.host-collections",["ngResource","ui.router","Bastion","Bastion.utils"]),angular.module("Bastion.host-collections").config(["$stateProvider",function($stateProvider){$stateProvider.state("host-collections",{"abstract":!0,controller:"HostCollectionsController",templateUrl:"host-collections/views/host-collections.html"}).state("host-collections.index",{url:"/host_collections",permission:"view_host_collections",views:{table:{templateUrl:"host-collections/views/host-collections-table-full.html"}}}).state("host-collections.new",{"abstract":!0,collapsed:!0,views:{table:{templateUrl:"host-collections/views/host-collections-table-collapsed.html"},"action-panel":{controller:"NewHostCollectionController",templateUrl:"host-collections/new/views/host-collection-new.html"}}}).state("host-collections.new.form",{url:"/host_collections/new",permission:"create_host_collections",collapsed:!0,controller:"HostCollectionFormController",templateUrl:"host-collections/new/views/host-collection-new-form.html"}),$stateProvider.state("host-collections.details",{"abstract":!0,url:"/host_collections/:hostCollectionId",permission:"view_host_collections",collapsed:!0,views:{table:{templateUrl:"host-collections/views/host-collections-table-collapsed.html"},"action-panel":{controller:"HostCollectionDetailsController",templateUrl:"host-collections/details/views/host-collection-details.html"}}}).state("host-collections.details.info",{url:"/info",permission:"view_host_collections",collapsed:!0,templateUrl:"host-collections/details/views/host-collection-info.html"}).state("host-collections.details.content-hosts",{"abstract":!0,collapsed:!0,templateUrl:"host-collections/details/views/host-collection-content-hosts.html"}).state("host-collections.details.content-hosts.list",{url:"/content-hosts",permission:"view_host_collections",collapsed:!0,controller:"HostCollectionContentHostsController",templateUrl:"host-collections/details/views/host-collection-content-hosts-list.html"}).state("host-collections.details.content-hosts.add",{url:"/add-content-hosts",permission:"edit_host_collections",collapsed:!0,controller:"HostCollectionAddContentHostsController",templateUrl:"host-collections/details/views/host-collection-add-content-hosts.html"}).state("host-collections.details.actions",{url:"/actions",permission:"edit_host_collections",collapsed:!0,templateUrl:"host-collections/details/views/host-collection-actions.html"})}]),angular.module("Bastion.host-collections").controller("HostCollectionAddContentHostsController",["$scope","$state","$location","translate","Nutupane","CurrentOrganization","ContentHost","HostCollection",function($scope,$state,$location,translate,Nutupane,CurrentOrganization,ContentHost,HostCollection){var addContentHostsPane,params;params={organization_id:CurrentOrganization,search:$location.search().search||"",page:1,sort_by:"name",sort_order:"ASC",paged:!0},addContentHostsPane=new Nutupane(ContentHost,params),addContentHostsPane.searchTransform=function(term){var addition="NOT ( host_collection_ids:"+$scope.$stateParams.hostCollectionId+" )";return term===""||term===undefined?addition:term+" "+addition},$scope.addContentHostsTable=addContentHostsPane.table,$scope.isAdding=!1,$scope.addContentHostsTable.closeItem=function(){},$scope.disableAddButton=function(){return $scope.addContentHostsTable.numSelected===0||$scope.isAdding},$scope.addSelected=function(){var selected;selected=_.pluck($scope.addContentHostsTable.getSelected(),"uuid"),$scope.isAdding=!0,HostCollection.addContentHosts({id:$scope.hostCollection.id,system_ids:selected},function(data){angular.forEach(data.displayMessages.success,function(success){$scope.$parent.successMessages.push(success)}),angular.forEach(data.displayMessages.error,function(error){$scope.$parent.errorMessages.push(error)}),$scope.isAdding=!1,addContentHostsPane.refresh(),$scope.refreshHostCollection()},function(response){$scope.$parent.errorMessages.push(response.data.displayMessage),$scope.isAdding=!1})}}]),angular.module("Bastion.host-collections").controller("HostCollectionContentHostsController",["$scope","$location","translate","Nutupane","HostCollection",function($scope,$location,translate,Nutupane,HostCollection){var contentHostsPane,params;params={id:$scope.$stateParams.hostCollectionId,search:$location.search().search||"",sort_by:"name",sort_order:"ASC",paged:!0},contentHostsPane=new Nutupane(HostCollection,params,"contentHosts"),$scope.contentHostsTable=contentHostsPane.table,$scope.contentHostsTable.closeItem=function(){},$scope.isRemoving=!1,$scope.removeSelected=function(){var selected=_.pluck($scope.contentHostsTable.getSelected(),"uuid");$scope.isRemoving=!0,HostCollection.removeContentHosts({id:$scope.hostCollection.id,system_ids:selected},function(data){contentHostsPane.table.selectAll(!1),contentHostsPane.refresh(),angular.forEach(data.displayMessages.success,function(success){$scope.$parent.successMessages.push(success)}),angular.forEach(data.displayMessages.error,function(error){$scope.$parent.errorMessages.push(error)}),$scope.refreshHostCollection(),$scope.isRemoving=!1},function(response){$scope.isRemoving=!1,$scope.$parent.errorMessages.push(translate("An error occurred removing the content hosts.")+response.data.displayMessage)})}}]),angular.module("Bastion.host-collections").controller("HostCollectionDetailsController",["$scope","$state","$q","translate","HostCollection",function($scope,$state,$q,translate,HostCollection){$scope.successMessages=[],$scope.errorMessages=[],$scope.copyErrorMessages=[],$scope.hostCollection?$scope.panel={loading:!1}:$scope.panel={loading:!0},$scope.hostCollection=HostCollection.get({id:$scope.$stateParams.hostCollectionId},function(hostCollection){$scope.$broadcast("hostCollection.loaded",hostCollection),$scope.panel.loading=!1}),$scope.refreshHostCollection=function(){$scope.hostCollection.$get().then(function(hostCollection){$scope.$emit("updateContentHostCollection",hostCollection)})},$scope.save=function(hostCollection){var deferred=$q.defer();return hostCollection.$update(function(response){deferred.resolve(response),$scope.successMessages.push(translate("Host Collection updated")),$scope.table.replaceRow(response)},function(response){deferred.reject(response),$scope.errorMessages.push(translate("An error occurred saving the Host Collection: ")+response.data.displayMessage)}),deferred.promise},$scope.copy=function(newName){HostCollection.copy({id:$scope.hostCollection.id,host_collection:{name:newName}},function(response){$scope.showCopy=!1,$scope.table.addRow(response),$scope.transitionTo("host-collections.details.info",{hostCollectionId:response.id})},function(response){$scope.copyErrorMessages.push(response.data.displayMessage)})},$scope.removeHostCollection=function(hostCollection){var id=hostCollection.id;hostCollection.$delete(function(){$scope.removeRow(id),$scope.transitionTo("host-collections.index"),$scope.successMessages.push(translate("Host Collection removed."))},function(response){$scope.errorMessages.push(translate("An error occurred removing the Host Collection: ")+response.data.displayMessage)})}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/host-collections/details/views/host-collection-actions.html",'<span page-title ng-model="hostCollection">{{ \'Actions for: \' | translate }} {{ hostCollection.name }}</span>\n\n<section class="nutupane-sub-section" >\n\n  <span translate>\n    The following actions can be performed on content hosts in this host collection:\n  </span>\n\n  <ul class="bullet">\n    <li>\n      <a translate ng-href="{{ $state.href(\'content-hosts.bulk-actions.packages\') }}?select_all=true&search=host_collection:&quot;{{ hostCollection.name }}&quot;">\n        Package Installation, Removal, and Update\n      </a>\n    </li>\n\n\n    <li>\n      <a translate ng-href="{{ $state.href(\'content-hosts.bulk-actions.errata.list\') }}?select_all=true&search=host_collection:&quot;{{ hostCollection.name }}&quot;">\n        Errata Installation\n      </a>\n    </li>\n\n    <li>\n      <a translate ng-href="{{ $state.href(\'content-hosts.bulk-actions.host-collections\') }}?select_all=true&search=host_collection:&quot;{{ hostCollection.name }}&quot;">\n        Host Collection Membership\n      </a>\n    </li>\n\n    <li>\n      <a translate ng-href="{{ $state.href(\'content-hosts.bulk-actions.environment\') }}?select_all=true&search=host_collection:&quot;{{ hostCollection.name }}&quot;">\n        Change assigned Lifecycle Environment or Content View\n      </a>\n    </li>\n\n  </ul>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/host-collections/details/views/host-collection-add-content-hosts.html",'<span page-title ng-model="hostCollection">{{ \'Add Content Hosts to: \' | translate }} {{ hostCollection.name }}</span>\n<section class="nutupane-sub-section">\n\n  <div class="row">\n\n    <div class="col-sm-3">\n      <div class="input-group input-group">\n        <input type="text"\n               class="form-control"\n               placeholder="{{ \'Search...\' | translate }}"\n               ng-model="addContentHostsTable.searchTerm"\n               bst-on-enter="addContentHostsTable.search(addContentHostsTable.searchTerm)"/>\n        <span class="input-group-btn">\n          <button ng-click="addContentHostsTable.search(addContentHostsTable.searchTerm)" class="btn btn-default" type="button"><i class="icon-search"></i></button>\n        </span>\n      </div>\n    </div>\n\n    <div class="col-sm-3 nutupane-info">\n      <span translate>Showing {{ addContentHostsTable.rows.length }} of {{ addContentHostsTable.resource.subtotal }} ({{ addContentHostsTable.resource.total }} Total) Content Hosts</span>\n    </div>\n\n    <div class="fr">\n      <div class="fl nutupane-info">\n        <span translate>{{ addContentHostsTable.numSelected }} Selected</span>\n      </div>\n\n      <div ng-hide="hostCollection.readonly" class="nutupane-actions fr">\n         <button class="btn btn-primary"\n                 translate\n                 ng-hide="denied(\'edit_content_hosts\')"\n                 ng-disabled="disableAddButton()"\n                 ng-click="addSelected()">\n           Add Selected\n         </button>\n      </div>\n\n    </div>\n  </div>\n\n  <div bst-table="addContentHostsTable" class="nutupane">\n    <div bst-container-scroll bst-infinite-scroll="addContentHostsTable.nextPage()" data="addContentHostsTable.rows">\n\n      <div class="loading-mask" ng-show="addContentHostsTable.working && addContentHostsTable.rows.length == 0">\n        <i class="icon-spinner icon-spin"></i>\n        {{ "Loading..." | translate }}\n      </div>\n\n      <p class="alert alert-info" ng-show="addContentHostsTable.rows.length === 0" translate>\n        You currently don\'t have any Content Hosts, you can create new Content Hosts by selecting Contents Host from main menu and then clicking the button on the right.\n      </p>\n\n      <table ng-class="{\'table-mask\': addContentHostsTable.working}"\n             class="table table-full table-striped"\n             ng-show="addContentHostsTable.rows.length > 0">\n        <thead>\n          <tr bst-table-head row-select>\n            <th bst-table-column="name" translate>Name</th>\n            <th bst-table-column="name" translate>Environment</th>\n            <th bst-table-column="name" translate>Content View</th>\n          </tr>\n        </thead>\n\n        <tbody>\n          <tr bst-table-row ng-repeat="contentHost in addContentHostsTable.rows">\n            <td class="row-select">\n              <input type="checkbox"\n                     ng-model="contentHost.selected"\n                     ng-change="itemSelected(contentHost)"/>\n            </td>\n            <td bst-table-cell>\n              <a ui-sref="content-hosts.details.info({contentHostId: contentHost.uuid})">\n                {{ contentHost.name }}\n              </a>\n            </td>\n            <td bst-table-cell>{{ contentHost.environment.name }}</td>\n            <td bst-table-cell>{{ contentHost.content_view.name }}</td>\n          </tr>\n\n        </tbody>\n      </table>\n    </div>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/host-collections/details/views/host-collection-content-hosts-list.html",'<span page-title ng-model="hostCollection">{{ \'Content Hosts for: \' | translate }} {{ hostCollection.name }}</span>\n\n<section class="nutupane-sub-section" >\n\n  <div class="row">\n\n    <div class="col-sm-3">\n      <div class="input-group input-group">\n        <input type="text"\n               class="form-control"\n               placeholder="{{ \'Search...\' | translate }}"\n               ng-model="contentHostsTable.searchTerm"\n               bst-on-enter="contentHostsTable.search(contentHostsTable.searchTerm)"/>\n        <span class="input-group-btn">\n          <button ng-click="contentHostsTable.search(contentHostsTable.searchTerm)" class="btn btn-default" type="button"><i class="icon-search"></i></button>\n        </span>\n      </div>\n    </div>\n\n    <div class="col-sm-3 nutupane-info">\n      <span translate>Showing {{ contentHostsTable.rows.length }} of {{ contentHostsTable.resource.subtotal }} ({{ contentHostsTable.resource.total }} Total) Content Hosts</span>\n    </div>\n\n    <div class="fr">\n      <div class="fl nutupane-info">\n        <span translate>{{ contentHostsTable.numSelected }} Selected</span>\n      </div>\n\n      <div ng-hide="denied(\'edit_content_hosts\')" class="nutupane-actions fr">\n         <button class="btn btn-primary"\n                 translate\n                 ng-disabled="contentHostsTable.getSelected().length == 0 || isRemoving"\n                 ng-click="removeSelected()">\n           Remove Selected\n         </button>\n      </div>\n    </div>\n  </div>\n\n  <div bst-table="contentHostsTable" class="nutupane">\n    <div bst-container-scroll bst-infinite-scroll="contentHostsTable.nextPage()" data="contentHostsTable.rows">\n\n      <div class="loading-mask" ng-show="contentHostsTable.working && contentHostsTable.rows.length == 0">\n        <i class="icon-spinner icon-spin"></i>\n        {{ "Loading..." | translate }}\n      </div>\n\n      <p class="alert alert-info" ng-show="contentHostsTable.rows.length === 0" translate>\n        You currently don\'t have any Content Hosts in this Host Group, you can add Content Hosts after selecting the \'Add\' tab.\n      </p>\n\n      <table ng-class="{\'table-mask\': contentHostsTable.working}" \n             class="table table-full table-striped"\n             ng-show="contentHostsTable.rows.length > 0">\n        <thead>\n          <tr bst-table-head row-select>\n            <th bst-table-column="name" translate>Name</th>\n            <th bst-table-column="environment" translate>Environment</th>\n            <th bst-table-column="content_view" translate>Content View</th>\n          </tr>\n        </thead>\n\n        <tbody>\n          <tr bst-table-row ng-repeat="contentHost in contentHostsTable.rows" row-select="contentHost">\n            <td bst-table-cell >\n              <a ui-sref="content-hosts.details.info({contentHostId: contentHost.uuid})">\n                {{ contentHost.name}}\n              </a>\n            </td>\n            <td bst-table-cell >{{ contentHost.environment.name}}</td>\n            <td bst-table-cell >{{ contentHost.content_view.name}}</td>\n          </tr>\n\n        </tbody>\n      </table>\n    </div>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/host-collections/details/views/host-collection-content-hosts.html",'<span page-title ng-model="hostCollection">{{ \'Content Hosts for: \' | translate }} {{ hostCollection.name }}</span>\n\n<nav>\n  <ul class="nav nav-tabs" ng-show="permitted(\'edit_host_collections\', hostCollection) && permitted(\'edit_content_hosts\')">\n    <li ng-class="{active: isState(\'host-collections.details.content-hosts.list\')}">\n      <a ui-sref="host-collections.details.content-hosts.list">\n        <span translate>\n          List/Remove\n        </span>\n      </a>\n    </li>\n\n    <li ng-class="{active: stateIncludes(\'host-collections.details.content-hosts.add\')}">\n      <a ui-sref="host-collections.details.content-hosts.add">\n        <span translate>\n          Add\n        </span>\n      </a>\n    </li>\n  </ul>\n</nav>\n\n<div ui-view></div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/host-collections/details/views/host-collection-details.html",'<span page-title ng-model="hostCollection">{{ \'Host Collection: \' | translate }} {{ hostCollection.name }}</span>\n\n<div class="loading-mask loading-mask-panel" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="details-header">\n    <h2 class="fl" translate>Host Collection: {{ hostCollection.name }}</h2>\n\n    <div class="details-actions fr">\n      <button class="btn btn-default"\n              ng-click="openModal()"\n              ng-hide="denied(\'destroy_host_collections\', hostCollection)"\n              translate>\n        Remove\n      </button>\n\n      <button class="btn btn-default"\n              ng-hide="denied(\'create_host_collections\')"\n              ng-click="showCopy = true">\n        <i class="icon-copy"></i>\n        {{ "Copy Collection" | translate }}\n      </button>\n\n      <button class="btn btn-default" ui-sref="host-collections.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n\n      <div bst-modal="removeHostCollection(hostCollection)" model="hostCollection"\n           modal-header="{{ \'Remove Host Collection \' + hostCollection.name + \'?\' | translate }}"\n           modal-body="{{ \'Are you sure you want to remove host collection \' + hostCollection.name + \'?\' | translate }}"></div>\n\n    </div>\n  </header>\n\n  <div ng-show="showCopy" class="fr action-pane" >\n    <form>\n      <h5 translate>Copy</h5>\n      <div class="input">\n        <div bst-alert error-messages="copyErrorMessages"></div>\n        <div class="info-label">\n          <label for="copy_name" translate>New Name:</label>\n        </div>\n        <input ng-model="copyName"\n               id="copy_name"\n               name="copy_name"\n               tabindex="1"\n               autofocus\n               required/>\n        <div>\n          <button class="btn btn-default" ng-click="copy(copyName)">\n            {{ "Create" | translate }}\n          </button>\n          <button class="btn btn-default" ng-click="showCopy = false">\n            {{ "Cancel" | translate }}\n          </button>\n        </div>\n      </div>\n    </form>\n  </div>\n\n  <nav class="details-navigation">\n    <ul>\n      <li ng-class="{active: isState(\'host-collections.details.info\')}">\n        <a ui-sref="host-collections.details.info">\n          <span translate>\n            Details\n          </span>\n        </a>\n      </li>\n\n      <li ng-class="{active: stateIncludes(\'host-collections.details.content-hosts\')}">\n        <a ui-sref="host-collections.details.content-hosts.list">\n          <span translate>\n            Content Hosts\n          </span>\n        </a>\n      </li>\n      <li ng-class="{active: isState(\'host-collections.details.actions\')}"\n          ng-show="permitted(\'edit_host_collections\', hostCollection)">\n        <a ui-sref="host-collections.details.actions">\n          <span translate>\n            Collection Actions\n          </span>\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <section class="nutupane-sub-section" ui-view></section>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/host-collections/details/views/host-collection-info.html",'<span page-title ng-model="hostCollection">{{ \'Host Collection: \' | translate }} {{ hostCollection.name }}</span>\n\n<section>\n\n  <div class="details fl">\n    <section>\n      <div class="detail">\n        <span class="info-label" translate>Name</span>\n        <span class="info-value"\n              bst-edit-text="hostCollection.name"\n              readonly="denied(\'edit_host_collection\', hostCollection)"\n              on-save="save(hostCollection)">\n        </span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Description</span>\n        <span class="info-value"\n              bst-edit-textarea="hostCollection.description"\n              readonly="denied(\'edit_host_collection\', hostCollection)"\n              on-save="save(hostCollection)">\n        </span>\n      </div>\n\n      <div class="detail">\n\n        <span class="info-label" translate>Content Host Limit</span>\n\n        <span class="info-value"\n              bst-edit-custom="hostCollection.max_content_hosts"\n              readonly="denied(\'edit_host_collection\', hostCollection)"\n              formatter="unlimitedFilter"\n              formatter-options="hostCollection.unlimited_content_hosts"\n              on-save="save(hostCollection)">\n\n          <div class="form input">\n            <div>\n              <span translate>\n                Unlimited Content Hosts:\n              </span>\n              <input type=\'checkbox\' ng-model="hostCollection.unlimited_content_hosts"/>\n            </div>\n            <div ng-hide="hostCollection.unlimited_content_hosts" >\n              <span translate>\n                Limit:\n              </span>\n              <input ng-model="hostCollection.max_content_hosts"\n                     name="max_content_hosts"\n                     type="number"\n                     min="1"\n                     ng-required="!hostCollection.unlimited_content_hosts"\n                     tabindex="2"/>\n              <span class="note error" ng-show="hostCollection.max_content_hosts.$invalid">\n                <ul><li ng-repeat="message in hostCollection.max_content_hosts.$error.messages">{{ message }}</li></ul>\n              </span>\n            </div>\n          </div>\n\n        </span>\n      </div>\n    </section>\n  </div>\n</section>\n')}]),angular.module("Bastion.host-collections").factory("HostCollection",["BastionResource",function(BastionResource){return BastionResource("/katello/api/host_collections/:id/:action",{id:"@id"},{get:{method:"GET",params:{fields:"full"}},update:{method:"PUT"},copy:{method:"POST",params:{action:"copy"}},contentHosts:{method:"GET",params:{action:"systems"}},removeContentHosts:{method:"PUT",params:{action:"remove_systems"}},addContentHosts:{method:"PUT",params:{action:"add_systems"}}})}]),angular.module("Bastion.host-collections").controller("HostCollectionsController",["$scope","$location","translate","Nutupane","HostCollection","CurrentOrganization",function($scope,$location,translate,Nutupane,HostCollection,CurrentOrganization){var params={organization_id:CurrentOrganization,search:$location.search().search||"",sort_by:"name",sort_order:"ASC",paged:!0},nutupane=new Nutupane(HostCollection,params);$scope.table=nutupane.table,$scope.removeRow=nutupane.removeRow,$scope.table.closeItem=function(){$scope.transitionTo("host-collections.index")},$scope.$on("updateContentHostCollection",function(event,hostCollectionRow){$scope.table.replaceRow(hostCollectionRow)})}]),angular.module("Bastion.host-collections").controller("HostCollectionFormController",["$scope","$q","HostCollection","CurrentOrganization",function($scope,$q,HostCollection,CurrentOrganization){function success(response){$scope.table.addRow(response),$scope.transitionTo("host-collections.details.info",{hostCollectionId:$scope.hostCollection.id})}function error(response){$scope.working=!1,angular.forEach(response.data.errors,function(errors,field){$scope.hostCollectionForm[field].$setValidity("",!1),$scope.hostCollectionForm[field].$error.messages=errors})}$scope.hostCollection=$scope.hostCollection||new HostCollection,$scope.hostCollection.unlimited_content_hosts=!0,$scope.save=function(hostCollection){hostCollection.organization_id=CurrentOrganization,hostCollection.$save(success,error)}}]),angular.module("Bastion.host-collections").controller("NewHostCollectionController",["$scope","HostCollection",function($scope,HostCollection){$scope.hostCollection=new HostCollection,$scope.panel={loading:!1}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/host-collections/new/views/host-collection-new-form.html",'<form name="hostCollectionForm" class="form-horizontal" novalidate role="form">\n\n  <div bst-form-group label="{{ \'Name\' | translate }}">\n    <input id="name"\n           name="name"\n           ng-model="hostCollection.name"\n           type="text"\n           tabindex="1"\n           autofocus\n           required/>\n  </div>\n\n  <div bst-form-group label="{{ \'Content Host Limit\' | translate }}" field="max_content_hosts">\n    <span translate>Unlimited Content Hosts:</span>\n    <input type="checkbox"\n           name="limit"\n           ng-model="hostCollection.unlimited_content_hosts"/>\n\n    <div bst-form-group label="{{ \'Limit\' | translate }}" ng-hide="hostCollection.unlimited_content_hosts">\n      <input id="max_content_hosts"\n             name="max_content_hosts"\n             class="form-control"\n             ng-model="hostCollection.max_content_hosts"\n             ng-required="!hostCollection.unlimited_content_hosts"\n             type="number"\n             min="1"\n             tabindex="2"/>\n    </div>\n  </div>\n\n  <div bst-form-group label="{{ \'Description\' | translate }}">\n    <textarea id="description"\n              name="description"\n              ng-model="hostCollection.description"\n              tabindex="3">\n    </textarea>\n  </div>\n\n  <div bst-form-buttons\n       on-cancel="transitionTo(\'host-collections.index\')"\n       on-save="save(hostCollection)"\n       working="working">\n  </div>\n\n</form>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/host-collections/new/views/host-collection-new.html",'<span page-title>{{ \'New Host Collection\' | translate }}</span>\n\n<div class="loading-mask loading-mask-panel" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n  <header class="new-header details-header">\n    <h2 class="fl" translate>New Host Collection</h2>\n\n    <div class="details-actions fr">\n      <button class="btn btn-default" ui-sref="host-collections.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <div ui-view></div>\n\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/host-collections/views/host-collections-table-collapsed.html",'<table bst-table="table" class="table table-striped table-full" ng-class="{\'table-mask\': table.working}">\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column sortable><span translate>Name</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row\n        ng-repeat="hostCollection in table.rows"\n        row-select="hostCollection"\n        active-row="stateIncludes(\'host-collections.details\', {hostCollectionId: hostCollection.id})">\n      <td bst-table-cell>\n        <a ui-sref="host-collections.details.info({hostCollectionId: hostCollection.id})">\n          {{ hostCollection.name }}\n        </a>\n      </td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/host-collections/views/host-collections-table-full.html",'<p class="alert alert-info" ng-show="table.rows.length === 0" translate>\n  You currently don\'t have any Host Collections, you can add Host Collections using the button on the right.\n</p>\n<table class="table table-striped" \n       ng-class="{\'table-mask\': table.working}"\n       ng-show="table.rows.length > 0">\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column="name" sortable><span translate>Name</span></th>\n      <th bst-table-column="content-hosts"><span translate>Content Hosts</span></th>\n      <th bst-table-column="limit"><span translate>Limit</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row ng-repeat="hostCollection in table.rows" row-select="hostCollection">\n      <td bst-table-cell>\n        <a ui-sref="host-collections.details.info({hostCollectionId: hostCollection.id})">\n          {{ hostCollection.name }}\n        </a>\n        <i class="icon-chevron-right selected-icon" ng-show="hostCollection.selected"></i>\n      </td>\n      <td bst-table-cell>\n        <a ui-sref="host-collections.details.content-hosts.list({hostCollectionId: hostCollection.id})">\n          {{ hostCollection.total_content_hosts }}\n        </a>\n      </td>\n      <td bst-table-cell>{{ hostCollection.max_content_hosts | unlimitedFilter:hostCollection.unlimited_content_hosts }}</td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/host-collections/views/host-collections.html",'<span page-title>{{ \'Host Collections\' | translate }}</span>\n\n<div data-extend-template="layouts/nutupane.html">\n\n  <div data-block="header">\n    {{ \'Host Collections\' | translate }}\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-primary"\n            ui-sref="host-collections.new.form"\n            ng-hide="denied(\'create_host_collections\')">\n      <i class="icon-plus"></i>\n      {{ "New Host Collection" | translate }}\n    </button>\n  </div>\n\n</div>\n')}]),angular.module("Bastion.content-hosts",["ngResource","ui.router","Bastion","Bastion.components","Bastion.components.formatters","Bastion.organizations","Bastion.subscriptions","Bastion.capsules","Bastion.errata","Bastion.host-collections"]),angular.module("Bastion.content-hosts").config(["$stateProvider",function($stateProvider){$stateProvider.state("content-hosts",{"abstract":!0,controller:"ContentHostsController",templateUrl:"content-hosts/views/content-hosts.html"}),$stateProvider.state("content-hosts.index",{url:"/content_hosts",permission:"view_content_hosts",views:{table:{templateUrl:"content-hosts/views/content-hosts-table-full.html"
}}}),$stateProvider.state("content-hosts.register",{url:"/content_hosts/register",permission:"view_content_hosts",collapsed:!0,views:{table:{templateUrl:"content-hosts/views/content-hosts-table-collapsed.html"},"action-panel":{controller:"ContentHostRegisterController",templateUrl:"content-hosts/views/register.html"}}}),$stateProvider.state("content-hosts.details",{"abstract":!0,url:"/content_hosts/:contentHostId",permission:"view_content_hosts",collapsed:!0,views:{table:{templateUrl:"content-hosts/views/content-hosts-table-collapsed.html"},"action-panel":{controller:"ContentHostDetailsController",templateUrl:"content-hosts/details/views/content-host-details.html"}}}).state("content-hosts.details.info",{url:"/info",permission:"view_content_hosts",collapsed:!0,controller:"ContentHostDetailsInfoController",templateUrl:"content-hosts/details/views/content-host-info.html"}).state("content-hosts.details.provisioning",{url:"/provisioning",permission:"view_content_hosts",collapsed:!0,templateUrl:"content-hosts/details/views/content-host-provisioning-info.html"}).state("content-hosts.details.products",{url:"/products",permission:"view_products",collapsed:!0,controller:"ContentHostProductsController",templateUrl:"content-hosts/details/views/content-host-products.html"}),$stateProvider.state("content-hosts.details.events",{collapsed:!0,url:"/events",permission:"view_content_hosts",controller:"ContentHostEventsController",templateUrl:"content-hosts/details/views/content-host-events.html"}),$stateProvider.state("content-hosts.details.tasks",{"abstract":!0,collapsed:!0,template:"<div ui-view></div>"}).state("content-hosts.details.tasks.index",{url:"/tasks",permission:"view_content_hosts",collapsed:!0,templateUrl:"content-hosts/details/views/content-host-tasks.html"}).state("content-hosts.details.tasks.details",{url:"/tasks/:taskId",permission:"view_content_hosts",collapsed:!0,controller:"TaskDetailsController",templateUrl:"tasks/views/task-details.html"}),$stateProvider.state("content-hosts.details.subscriptions",{"abstract":!0,collapsed:!0,controller:"ContentHostBaseSubscriptionsController",templateUrl:"content-hosts/details/views/content-host-subscriptions.html"}).state("content-hosts.details.subscriptions.list",{url:"/subscriptions",permission:"view_content_hosts",collapsed:!0,controller:"ContentHostSubscriptionsController",templateUrl:"content-hosts/details/views/content-host-subscriptions-list.html"}).state("content-hosts.details.subscriptions.add",{url:"/add-subscriptions",permission:"attach_subscriptions",collapsed:!0,controller:"ContentHostAddSubscriptionsController",templateUrl:"content-hosts/details/views/content-host-add-subscriptions.html"}),$stateProvider.state("content-hosts.details.host-collections",{"abstract":!0,collapsed:!0,templateUrl:"content-hosts/details/views/host-collections.html"}).state("content-hosts.details.host-collections.list",{url:"/host-collections",permission:"view_content_hosts",collapsed:!0,controller:"ContentHostHostCollectionsController",templateUrl:"content-hosts/details/views/host-collections-table.html"}).state("content-hosts.details.host-collections.add",{url:"/host-collections/add",permission:"edit_content_hosts",collapsed:!0,controller:"ContentHostAddHostCollectionsController",templateUrl:"content-hosts/details/views/host-collections-table.html"}),$stateProvider.state("content-hosts.bulk-actions",{"abstract":!0,collapsed:!0,views:{table:{templateUrl:"content-hosts/views/content-hosts-table-collapsed.html"},"action-panel":{controller:"ContentHostsBulkActionController",templateUrl:"content-hosts/bulk/views/bulk-actions.html"}}}).state("content-hosts.bulk-actions.packages",{url:"/content_hosts/bulk-actions/packages",permission:"edit_content_hosts",collapsed:!0,controller:"ContentHostsBulkActionPackagesController",templateUrl:"content-hosts/bulk/views/bulk-actions-packages.html"}).state("content-hosts.bulk-actions.errata",{"abstract":!0,collapsed:!0,controller:"ContentHostsBulkActionErrataController",template:"<div ui-view></div>"}).state("content-hosts.bulk-actions.errata.list",{collapsed:!0,url:"/content_hosts/bulk-actions/errata",permission:"edit_content_hosts",templateUrl:"content-hosts/bulk/views/bulk-actions-errata.html"}).state("content-hosts.bulk-actions.errata.details",{collapsed:!0,url:"/content_hosts/bulk-actions/errata/:errataId",permission:"edit_content_hosts",templateUrl:"content-hosts/bulk/views/errata-details.html"}).state("content-hosts.bulk-actions.errata.content-hosts",{collapsed:!0,url:"/content_hosts/bulk-actions/errata/:errataId/content-hosts",permission:"edit_content_hosts",templateUrl:"content-hosts/bulk/views/errata-content-hosts.html"}).state("content-hosts.bulk-actions.host-collections",{url:"/content_hosts/bulk-actions/bulk-host-collections",permission:"edit_content_hosts",collapsed:!0,controller:"ContentHostsBulkActionHostCollectionsController",templateUrl:"content-hosts/bulk/views/bulk-actions-host-collections.html"}).state("content-hosts.bulk-actions.subscriptions",{url:"/content_hosts/bulk-actions/bulk-subscriptions",permission:"attach_subscriptions",collapsed:!0,controller:"ContentHostsBulkActionSubscriptionsController",templateUrl:"content-hosts/bulk/views/bulk-actions-subscriptions.html"}).state("content-hosts.bulk-actions.environment",{url:"/content_hosts/bulk-actions/bulk-environment",permission:"edit_content_hosts",collapsed:!0,controller:"ContentHostsBulkActionEnvironmentController",templateUrl:"content-hosts/bulk/views/bulk-actions-environment.html"}),$stateProvider.state("content-hosts.details.packages",{url:"/packages",permission:"view_content_hosts",collapsed:!0,controller:"ContentHostPackagesController",templateUrl:"content-hosts/content/views/content-host-packages.html"}),$stateProvider.state("content-hosts.details.errata",{"abstract":!0,collapsed:!0,controller:"ContentHostErrataController",template:"<div ui-view></div>"}).state("content-hosts.details.errata.index",{url:"/errata?search",permission:"view_content_hosts",collapsed:!0,templateUrl:"content-hosts/content/views/content-host-errata.html"}).state("content-hosts.details.errata.details",{url:"/errata/:errataId",permission:"view_content_hosts",collapsed:!0,templateUrl:"content-hosts/content/views/errata-details.html"})}]),angular.module("Bastion.content-hosts").controller("ContentHostsBulkActionEnvironmentController",["$scope","ContentHostBulkAction","Organization","CurrentOrganization","ContentView",function($scope,ContentHostBulkAction,Organization,CurrentOrganization,ContentView){function actionParams(){var params=$scope.nutupane.getAllSelectedResults();return params.organization_id=CurrentOrganization,params.environment_id=$scope.selected.environment.id,params.content_view_id=$scope.selected.contentView.id,params}$scope.setState(!1,[],[]),$scope.selected={environment:undefined,contentView:undefined},$scope.environments=Organization.readableEnvironments({id:CurrentOrganization}),$scope.disableAssignButton=function(confirm){return confirm||$scope.table.numSelected===0||$scope.state.working||$scope.selected.environment===undefined||$scope.selected.contentView===undefined},$scope.$watch("selected.environment",function(environment){environment&&$scope.fetchViews()}),$scope.fetchViews=function(){$scope.fetchingContentViews=!0,ContentView.queryUnpaged({environment_id:$scope.selected.environment.id},function(response){$scope.contentViews=response.results,$scope.fetchingContentViews=!1})},$scope.performAction=function(){$scope.setState(!0,[],[]),ContentHostBulkAction.environmentContentView(actionParams(),function(response){$scope.setState(!1,response.displayMessages.success,response.displayMessages.error)},function(data){$scope.setState(!1,[],data.errors)})}}]),angular.module("Bastion.content-hosts").controller("ContentHostsBulkActionErrataController",["$scope","$q","$location","ContentHostBulkAction","HostCollection","Nutupane","CurrentOrganization","Erratum","translate",function($scope,$q,$location,ContentHostBulkAction,HostCollection,Nutupane,CurrentOrganization,Erratum,translate){function installParams(){var params=$scope.nutupane.getAllSelectedResults();return params.content_type="errata",params.content=_.pluck($scope.detailsTable.getSelected(),"errata_id"),params.organization_id=CurrentOrganization,params}function fetchErratum(errataId){$scope.erratum=Erratum.get({id:errataId,organization_id:CurrentOrganization})}var nutupane;nutupane=new Nutupane(ContentHostBulkAction,{},"applicableErrata"),nutupane.table.closeItem=function(){},$scope.detailsTable=nutupane.table,$scope.detailsTable.errataFilterTerm="",$scope.detailsTable.initialLoad=!1,$scope.outOfDate=!1,$scope.initialLoad=!0,$scope.setState(!1,[],[]),$scope.fetchErrata=function(){var params=$scope.nutupane.getAllSelectedResults("id");params.organization_id=CurrentOrganization,nutupane.setParams(params),$scope.detailsTable.working=!0,$scope.outOfDate=!1,$scope.table.numSelected>0?nutupane.refresh().then(function(){$scope.detailsTable.working=!1,$scope.outOfDate=!1}):$scope.detailsTable.working=!1},$scope.$watch("nutupane.table.rows",function(rows){$scope.initialLoad&&rows.length>0&&($scope.initialLoad=!1,$scope.fetchErrata())}),$scope.$watch("nutupane.table.numSelected",function(numSelected){numSelected>0&&!$scope.detailsTable.working&&($scope.outOfDate=!0)}),$scope.transitionToErrata=function(erratum){fetchErratum(erratum.errata_id),$scope.transitionTo("content-hosts.bulk-actions.errata.details",{errataId:erratum.errata_id})},$scope.transitionToErrataContentHosts=function(erratum){$scope.erratum=erratum,$scope.transitionTo("content-hosts.bulk-actions.errata.content-hosts",{errataId:erratum.errata_id})},$scope.installErrata=function(){var params=installParams();$scope.setState(!0,[],[]),ContentHostBulkAction.installContent(params,function(){$scope.setState(!1,[translate("Successfully scheduled installation of %s errata .").replace("%s",params.content.length)],[])},function(data){$scope.setState(!1,[],data.errors)})}}]),angular.module("Bastion.content-hosts").controller("ContentHostsBulkActionHostCollectionsController",["$scope","$q","$location","translate","Nutupane","ContentHostBulkAction","HostCollection","CurrentOrganization",function($scope,$q,$location,translate,Nutupane,ContentHostBulkAction,HostCollection,CurrentOrganization){var hostCollectionNutupane,params;$scope.hostCollections={action:null},$scope.setState(!1,[],[]),params={organization_id:CurrentOrganization,offset:0,sort_by:"name",sort_order:"ASC",paged:!0},hostCollectionNutupane=new Nutupane(HostCollection,params,"queryPaged"),$scope.setState(!1,[],[]),$scope.detailsTable=hostCollectionNutupane.table,$scope.detailsTable.closeItem=function(){},$scope.confirmHostCollectionAction=function(action){$scope.hostCollections.confirm=!0,$scope.hostCollections.action=action},$scope.performHostCollectionAction=function(){var params,action,success,error,deferred=$q.defer();return action=$scope.hostCollections.action,params=$scope.nutupane.getAllSelectedResults("id"),params.organization_id=CurrentOrganization,params.host_collection_ids=hostCollectionNutupane.getAllSelectedResults("id").included.ids,$scope.hostCollections.action=null,$scope.setState(!0,[],[]),success=function(data){deferred.resolve(data),$scope.setState(!1,data.displayMessages.success,data.displayMessages.error),hostCollectionNutupane.refresh()},error=function(error){deferred.reject(error.data.errors),$scope.setState(!1,[],[error.data.displayMessage]),$scope.editMode=!0},action==="add"?ContentHostBulkAction.addHostCollections(params,success,error):action==="remove"&&ContentHostBulkAction.removeHostCollections(params,success,error),deferred.promise}}]),angular.module("Bastion.content-hosts").controller("ContentHostsBulkActionPackagesController",["$scope","$q","$location","ContentHostBulkAction","HostCollection","CurrentOrganization","translate",function($scope,$q,$location,ContentHostBulkAction,HostCollection,CurrentOrganization,translate){function successMessage(type){var messages={install:translate("Succesfully scheduled package installation"),update:translate("Succesfully scheduled package update"),remove:translate("Succesfully scheduled package removal")};return messages[type]}function installParams(){var params=$scope.nutupane.getAllSelectedResults();return params.content_type=$scope.content.contentType,params.content=$scope.content.content.split(/ *, */),params.organization_id=CurrentOrganization,params}$scope.setState(!1,[],[]),$scope.content={confirm:!1,placeholder:translate("Enter Package Name(s)..."),contentType:"package"},$scope.updatePlaceholder=function(contentType){contentType==="package"?$scope.content.placeholder=translate("Enter Package Name(s)..."):contentType==="package_group"&&($scope.content.placeholder=translate("Enter Package Group Name(s)..."))},$scope.confirmContentAction=function(action,actionInput){$scope.content.confirm=!0,$scope.content.action=action,$scope.content.actionInput=actionInput},$scope.performContentAction=function(){var success,error,params,deferred=$q.defer();return $scope.content.confirm=!1,$scope.setState(!0,[],[]),success=function(data){deferred.resolve(data),$scope.setState(!1,[successMessage($scope.content.action)],[])},error=function(error){$scope.setState(!1,[],error.data.errors),deferred.reject(error.data.errors)},params=installParams(),$scope.content.action==="install"?ContentHostBulkAction.installContent(params,success,error):$scope.content.action==="update"?ContentHostBulkAction.updateContent(params,success,error):$scope.content.action==="remove"&&ContentHostBulkAction.removeContent(params,success,error),deferred.promise}}]),angular.module("Bastion.content-hosts").controller("ContentHostsBulkActionSubscriptionsController",["$scope","$q","$location","HostCollection","CurrentOrganization","translate","Organization","Task",function($scope,$q,$location,HostCollection,CurrentOrganization,translate,Organization,Task){function watchRunningTasks(){var searchParams={type:"resource",active_only:!0,action_types:["Actions::Katello::Organization::AutoAttachSubscriptions"],resource_type:"Organization",resource_id:CurrentOrganization};return Task.registerSearch(searchParams,function(tasks){tasks.length>0?$scope.subscription.monitorTask(tasks[0]):$scope.subscription.taskRunnable=!0})}$scope.actionParams={ids:[]},$scope.subscription={confirm:!1,runningTask:null,taskRunnable:!1,monitorTask:function(task){var promise;$scope.subscription.runningTask=Task.monitorTask(task),promise=$scope.subscription.runningTask.promise,promise.then(function(){$scope.state.successMessages.push(translate("Successfully Scheduled Auto-attach."))}),promise.catch(function(errors){$scope.state.errorMessages.push(translate("An error occurred applying Subscriptions: ")+errors.join("; "))}),promise["finally"](function(){$scope.subscription.runningTask.state==="stopped"&&($scope.subscription.runningTask=null)})}},$scope.$watch("subscription.runningTask",function(value){value&&($scope.subscription.taskRunnable=!1),value&&$scope.subscription.runningTasksSearchId?(Task.unregisterSearch($scope.subscription.runningTasksSearchId),$scope.subscription.runningTasksSearchId=null):!value&&!$scope.subscription.runningTasksSearchId&&($scope.subscription.runningTasksSearchId=watchRunningTasks())}),$scope.$on("$destroy",function(){$scope.subscription.runningTask&&($scope.subscription.runningTask.stopMonitoring(),$scope.subscription.runningTask=null),$scope.subscription.runningTasksSearchId&&Task.unregisterSearch($scope.subscription.runningTasksSearchId)}),$scope.performAutoAttachSubscriptions=function(){$scope.subscription.confirm=!1,$scope.subscription.monitorTask(Organization.autoAttachSubscriptions({id:CurrentOrganization}))}}]),angular.module("Bastion.content-hosts").controller("ContentHostsBulkActionController",["$scope","$q","$location","translate","ContentHostBulkAction","CurrentOrganization",function($scope,$q,$location,translate,ContentHostBulkAction,CurrentOrganization){$scope.successMessages=[],$scope.errorMessages=[],$scope.unregisterContentHosts={confirm:!1,workingMode:!1},$scope.state={successMessages:[],errorMessages:[],working:!1},$scope.setState=function(working,success,errors){$scope.state.working=working,$scope.state.successMessages=success,$scope.state.errorMessages=errors},$scope.actionParams={ids:[]},$scope.performUnregisterContentHosts=function(){var params,success,error,deferred=$q.defer();return $scope.unregisterContentHosts.confirm=!1,$scope.state.working=!0,params=$scope.nutupane.getAllSelectedResults(),params.organization_id=CurrentOrganization,success=function(data){deferred.resolve(data),angular.forEach($scope.contentHostTable.getSelected(),function(row){$scope.removeRow(row.id)}),$scope.setState(!1,data.displayMessages.success,data.displayMessages.error)},error=function(error){deferred.reject(error.data.errors),$scope.setState(!1,[],error.data.errors)},ContentHostBulkAction.unregisterContentHosts(params,success,error),deferred.promise}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/bulk/views/bulk-actions-environment.html",'<span page-title>{{ \'Content Host Bulk Content\' | translate }}</span>\n\n<div class="details">\n  <section>\n    <h4 translate>Assign Environment and Content View</h4>\n\n    <div class="alert alert-info" ng-show="confirm">\n      <p translate>\n        Are you sure you want to assign the {{ table.numSelected }} content host(s) selected to {{ selected.contentView.name }} in {{ selected.environment.name }}?\n      </p>\n      <button class="btn btn-default" ng-click="confirm = false" translate>No</button>\n      <button class="btn btn-default" ng-click="confirm = false; performAction()" translate>Yes</button>\n    </div>\n\n    <div path-selector="environments"\n         ng-model="selected.environment"\n         mode="singleSelect"\n         disable-trigger="disableEnvironmentSelection">\n    </div>\n\n    <form name="contentHostContentForm" class="form" ng-hide="content.workingMode">\n\n      <div>\n        <label translate>Content View:</label>\n\n        <i ng-show="fetchingContentViews" class="icon-spinner inline-icon icon-spin"></i>\n        <select ng-hide="fetchingContentViews || contentViews.length === 0 || !selected.environment"\n                type="select"\n                ng-options="cv as cv.name for cv in contentViews"\n                ng-model="selected.contentView">\n        </select>\n\n        <p class="page-error" ng-show="!fetchingContentViews && contentViews.length === 0" translate>\n          No content views exist for {{selected.environment.name}}\n        </p>\n\n        <p class="page-error" ng-show="!fetchingContentViews && !selected.environment" translate>\n          Please select an environment.\n        </p>\n      </div>\n\n      <button class="btn btn-default fr"\n              translate\n              ng-hide="denied(\'edit_content_hosts\', contentHost)"\n              ng-click="confirm = true"\n              ng-disabled="disableAssignButton(confirm)">\n        Assign\n      </button>\n\n    </form>\n  </section>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/bulk/views/bulk-actions-errata.html",'<span page-title>{{ \'Content Host Bulk Errata\' | translate }}</span>\n\n<section>\n\n  <div class="alert alert-info" ng-show="confirm">\n    <p translate>\n      Are you sure you want to apply the {{ detailsTable.numSelected }} selected errata to the content hosts chosen?\n    </p>\n    <button class="btn btn-default" ng-click="confirm = false; detailsTable.working = false" translate>No</button>\n    <button class="btn btn-default" ng-click="confirm = false; installErrata()" translate>Yes</button>\n  </div>\n\n  <div class="alert alert-warning" ng-show="outOfDate && table.numSelected > 0">\n    <i class="inline-icon icon-exclamation"></i>\n    <span translate>\n      Your selected content hosts have changed, it is highly recommended to refresh the calculated list of errata using the \'Refresh Errata\' button below.\n    </span>\n    <a ng-click="fetchErrata()" translate>\n      Click here to refresh.\n    </a>\n  </div>\n\n  <div data-extend-template="layouts/details-nutupane.html">\n\n    <div data-block="header" translate>Content Host Errata Management</div>\n\n    <div data-block="actions">\n      <button class="btn btn-default"\n              ng-disabled="table.numSelected === 0 || detailsTable.working"\n              ng-click="fetchErrata()">\n        <i class="icon-refresh"></i>\n        {{ "Refresh Table" | translate }}\n      </button>\n\n      <button class="btn btn-primary"\n              ng-disabled="table.numSelected === 0 || detailsTable.working || detailsTable.numSelected === 0"\n              ng-click="confirm = true">\n        <i class="icon-plus"></i>\n        {{ "Install Selected" | translate }}\n      </button>\n    </div>\n\n\n    <div data-block="table">\n      <p class="alert alert-info" ng-show="detailsTable.rows.length === 0">\n        There are no Errata associated with this Content Host to display.\n      </p>\n\n      <table class="table table-striped"\n             ng-class="{\'table-mask\': detailsTable.working}"\n             ng-show="detailsTable.rows.length > 0">\n       <thead>\n         <tr bst-table-head row-select>\n           <th class="small" bst-table-column="type" translate>Type</th>\n           <th class="small" bst-table-column="errata_id" translate>Id</th>\n           <th bst-table-column="title" translate>Title</th>\n           <th class="small" bst-table-column="issued" translate>Issued</th>\n           <th class="small" bst-table-column="content_host_affected" translate>Affected Content Hosts</th>\n         </tr>\n       </thead>\n\n       <tbody>\n         <tr bst-table-row ng-repeat="erratum in detailsTable.rows" row-select="erratum">\n           <td class="small" bst-table-cell>\n               {{ erratum.type }}\n           </td>\n           <td class="small" bst-table-cell>\n             <a ng-click="transitionToErrata(erratum)">\n               {{ erratum.errata_id }}\n             </a>\n           </td>\n\n           <td bst-table-cell>{{ erratum.title }}</td>\n           <td class="small" bst-table-cell>{{ erratum.issued }}</td>\n           <td class="small" bst-table-cell class="number-cell">\n             <a ng-click="transitionToErrataContentHosts(erratum)">\n              {{ erratum.applicable_consumers.length }}\n             </a>\n           </td>\n         </tr>\n       </tbody>\n      </table>\n    </div>\n\n  </div>  \n</section>\n\n\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/bulk/views/bulk-actions-host-collections.html",'<span page-title>{{ \'Content Host Bulk Host Collections\' | translate }}</span>\n\n<div class="alert alert-info" ng-show="hostCollections.action == \'add\'">\n  <div translate>\n    Are you sure you want to add the {{ table.numSelected }} content host(s) selected to the host collection(s) chosen?\n  </div>\n  <button class="btn btn-default" ng-click="hostCollections.action = null; hostCollections.working = false" translate>No</button>\n  <button class="btn btn-default" ng-click="performHostCollectionAction()" translate>Yes</button>\n</div>\n\n<div class="alert alert-info" ng-show="hostCollections.action == \'remove\'">\n  <div translate>\n    Are you sure you want to remove the {{ table.numSelected }} content host(s) selected from the host collection(s) chosen?\n  </div>\n  <button class="btn btn-default" ng-click="hostCollections.action = null; hostCollections.working = false" translate>No</button>\n  <button class="btn btn-default" ng-click="performHostCollectionAction()" translate>Yes</button>\n</div>\n\n<section>\n  <div data-extend-template="layouts/details-nutupane.html">\n\n    <div data-block="header" translate>\n      Host Collection Membership Management\n    </div>\n\n    <div data-block="actions">\n      <button class="btn btn-default"\n              ng-hide="denied(\'edit_content_hosts\', contentHost)"\n              ng-disabled="table.numSelected == 0 || detailsTable.numSelected == 0"\n              ng-click="hostCollections.action = \'add\'; hostCollections.working = true">\n        <i class="icon-plus"></i>\n        {{ "Add To" | translate }}\n      </button>\n\n      <button class="btn btn-default"\n              ng-hide="denied(\'edit_content_hosts\', contentHost)"\n              ng-disabled="table.numSelected == 0 || detailsTable.numSelected == 0"\n              ng-click="hostCollections.action = \'remove\'; hostCollections.working = true">\n        <i class="icon-minus"></i>\n        {{ "Remove From" | translate }}\n      </button>\n    </div>\n\n    <div data-block="table">\n      <p class="alert alert-info" ng-show="detailsTable.rows.length === 0">\n        There are no Host Collections available. You can create new Host Collections after selecting \'Host Collections\' under \'Hosts\' in main menu.\n      </p>\n\n\n      <table data-block="table"  class="table table-striped" ng-class="{\'table-mask\': state.working}">\n        <thead>\n          <tr bst-table-head row-select>\n            <th bst-table-column="name"><span translate>Name</span></th>\n            <th bst-table-column="content_hosts"><span translate>Content Hosts</span></th>\n            <th bst-table-column="limit"><span translate>Limit</span></th>\n          </tr>\n        </thead>      \n\n        <tbody>\n          <tr bst-table-row ng-repeat="hostCollection in detailsTable.rows" row-select="hostCollection">\n            <td bst-table-cell>\n              <a class="clickable" ui-sref="host-collections.details.info({hostCollectionId: hostCollection.id})">\n                {{ hostCollection.name }}\n              </a>\n            </td>\n            <td bst-table-cell>\n              <a class="clickable" ui-sref="host-collections.details.content-hosts({hostCollectionId: hostCollection.id})">\n                {{ hostCollection.total_content_hosts }}\n              </a>\n            </td>\n            <td bst-table-cell>{{ hostCollection.max_content_hosts | unlimitedFilter:hostCollection.unlimited_content_hosts }}</td>\n          </tr>\n        </tbody>\n      </table>\n    </div>\n  </div>\n\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/bulk/views/bulk-actions-packages.html",'<span page-title>{{ \'Content Host Bulk Packages\' | translate }}</span>\n\n<div class="details">\n  <section>\n    <h4 translate>Content Host Package Management</h4>\n\n\n    <form name="systemContentForm" class="form" ng-hide="content.workingMode || denied(\'edit_content_hosts\', contentHost)">\n\n      <div>\n        <input type="radio"\n               ng-model="content.contentType"\n               ng-change="updatePlaceholder(content.contentType)"\n               ng-disabled="content.confirm"\n               value="package"/>\n        <label for="package" translate>Package</label>\n\n        <input type="radio"\n               ng-model="content.contentType"\n               ng-change="updatePlaceholder(content.contentType)"\n               ng-disabled="content.confirm"\n               value="package_group"/>\n        <label for="package_group" translate>Package Group</label>\n\n      </div>\n\n      <div class="form-group">\n        <input class="form-control"\n               name="label"\n               type="text"\n               placeholder="{{ content.placeholder }}"\n               ng-model="content.content"\n               ng-disabled="content.confirm"\n               required/>\n      </div>\n\n      <div>\n        <button class="btn btn-default"\n                translate\n                ng-hide="denied(\'edit_content_hosts\', contentHost)"\n                ng-click="confirmContentAction(\'install\', content)"\n                ng-disabled="(table.numSelected === 0) || !systemContentForm.$valid || content.confirm">\n          Install\n        </button>\n\n        <button class="btn btn-default"\n                translate\n                ng-hide="denied(\'edit_content_hosts\', contentHost)"\n                ng-click="confirmContentAction(\'update\', content)"\n                ng-disabled="(table.numSelected === 0) || !systemContentForm.$valid || content.confirm"\n                ng-hide="content.contentType == \'errata\'">\n          Update\n        </button>\n\n        <button class="btn btn-default"\n                translate\n                ng-hide="content.contentType == \'errata\' || denied(\'edit_content_hosts\', contentHost)"\n                ng-click="confirmContentAction(\'remove\', content)"\n                ng-disabled="(table.numSelected === 0) || !systemContentForm.$valid || content.confirm">\n          Remove\n        </button>\n      </div>\n\n      <div class="inline-confirmation" ng-show="content.confirm">\n        <div class="confirmation_text" ng-show="content.action == \'install\'" translate>\n          Are you sure you want to install {{ content.content }} on the {{ getSelectedSystemIds().length }} system(s) selected?\n        </div>\n        <div class="confirmation_text" ng-show="content.action == \'update\'" translate>\n          Are you sure you want to update {{ content.content }} on the {{ getSelectedSystemIds().length }} system(s) selected?\n        </div>\n        <div class="confirmation_text" ng-show="content.action == \'remove\'" translate>\n          Are you sure you want to remove {{ content.content }} from the {{ getSelectedSystemIds().length }} system(s) selected?\n        </div>\n\n        <button class="btn btn-default" ng-click="performContentAction()" translate>Yes</button>\n        <button class="btn btn-default" ng-click="content.confirm = false" translate>No</button>\n      </div>\n\n    </form>\n\n  </section>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/bulk/views/bulk-actions-subscriptions.html",'<span page-title>{{ \'Content Host Bulk Subscriptions\' | translate }}</span>\n\n<div class="details">\n  <section>\n    <h4 translate>Content Host Subscriptions</h4>\n    <button class="btn btn-primary"\n            translate\n            ng-hide="denied(\'edit_content_hosts\', contentHost)"\n            ng-click="subscription.confirm = true"\n            ng-disabled="! subscription.taskRunnable">\n      Auto-attach available subscriptions to all content hosts\n    </button>\n\n    <span ng-show="subscription.runningTask">\n      <span ng-show="subscription.runningTask.state === \'starting\'">\n        <i class="icon-spinner inline-icon icon-spin"></i>\n        <span translate>Starting</span>\n      </span>\n      <span ng-show="subscription.runningTask.state === \'running\'">\n        <i class="icon-spinner inline-icon icon-spin"></i>\n        <span translate>Working</span>\n      </span>\n      <span ng-show="subscription.runningTask.state === \'paused\'">\n        <i class="icon-warning-sign inline-icon"></i>\n        <span translate>Paused</span>\n      </span>\n      <span translate ng-show="subscription.runningTask.state != \'starting\'">\n        (<a href="/foreman_tasks/tasks/{{ subscription.runningTask.task.id }}">{{ "task details" | translate }}</a>)\n      </span>\n    </span>\n\n    <div class="inline-confirmation" ng-show="subscription.confirm">\n      <div class="confirmation_text" translate>\n        Are you sure you want to auto-attach available subscriptions to all {{ contentHostTable.resource.total }} content hosts?\n      </div>\n      <button class="btn btn-default" ng-click="performAutoAttachSubscriptions()" translate>Yes</button>\n      <button class="btn btn-default" ng-click="subscription.confirm = false" translate>No</button>\n    </div>\n  </section>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/bulk/views/bulk-actions.html",'<span page-title>{{ \'Content Host Bulk Actions\' | translate }}</span>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n  <header class="details-header">\n    <h2 class="fl" translate>Bulk Actions</h2>\n\n    <div class="fr">\n      <button class="btn btn-default"\n              translate\n              ng-hide="denied(\'destroy_content_hosts\')"\n              ng-disabled="removingContentHosts"\n              ng-click="openModal()">\n        Unregister Content Hosts\n      </button>\n\n      <span ng-show="removingContentHosts">\n        <i class="icon-spinner inline-icon icon-spin"></i>\n        <span>{{ "Removing Content Hosts" | translate }}</span>\n      </span>\n\n      <button class="btn btn-default" ui-sref="content-hosts.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n\n      <div bst-modal="performUnregisterContentHosts()" model="table"\n           modal-header=\'Unregister {{ contentHostTable.numSelected  }} Content Hosts?\'\n           modal-body=\'Are you sure you want to unregister the {{ contentHostTable.numSelected }} content host(s) selected?\'></div>\n\n    </div>\n  </header>\n\n  <nav class="details-navigation">\n    <ul>\n      <li ng-class="{active: isState(\'content-hosts.bulk-actions.packages\')}">\n        <a translate\n           ui-sref="content-hosts.bulk-actions.packages">\n          Packages\n        </a>\n      </li>\n\n      <li ng-class="{active: stateIncludes(\'content-hosts.bulk-actions.errata\')}">\n        <a translate\n           ui-sref="content-hosts.bulk-actions.errata.list">\n          Errata\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-hosts.bulk-actions.host-collections\')}">\n        <a translate\n           ui-sref="content-hosts.bulk-actions.host-collections">\n          Host Collections\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-hosts.bulk-actions.environment\')}">\n        <a translate\n           ui-sref="content-hosts.bulk-actions.environment">\n          Content Host Content\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-hosts.bulk-actions.subscriptions\')}">\n        <a translate\n           ui-sref="content-hosts.bulk-actions.subscriptions">\n          Subscriptions\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <div>\n\n    <div class="alert warning alert-warning" ng-show="table.numSelected == 0 && !isState(\'content-hosts.bulk-actions.subscriptions\')">\n      <i class="icon-exclamation-sign"></i>\n      {{ \'At least one content host needs to be selected in order to perform a bulk action.\' | translate }}\n    </div>\n\n    <div bst-alert success-messages="state.successMessages" error-messages="state.errorMessages"></div>\n\n    <div class="alert alert-info" ng-show="state.working">\n      <i class="icon-spinner inline-icon icon-spin"></i>\n      {{ \'Processing\' | translate }}\n    </div>\n\n    <span ng-disabled="table.numSelected == 0">\n      <div ui-view></div>\n    </span>\n  </div>\n\n</section>\n'
)}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/bulk/views/errata-content-hosts.html",'<span page-title>{{ \'Applicable Content Hosts for Errata\' | translate }}</span>\n\n<a ui-sref="content-hosts.bulk-actions.errata.list">\n  <i class="icon-double-angle-left"></i>\n  {{ "Back To Errata List" | translate }}\n</a>\n\n<h3 translate>Applicable hosts for {{ erratum.errata_id }} </h3>\n\n<div class="details details-full">\n  <section>\n    <table class="table">\n      <thead>\n        <tr>\n          <th translate>\n            Name\n          </th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr ng-repeat="contentHost in erratum.applicable_consumers">\n          <td>{{ contentHost.name }}</td>\n        </tr>\n      </tbody>\n    </table>\n  </section>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/bulk/views/errata-details.html",'<span page-title>{{ \'Errata Details\' | translate }}</span>\n\n<a ui-sref="content-hosts.bulk-actions.errata.list">\n  <i class="icon-double-angle-left"></i>\n  {{ "Back To Errata List" | translate }}\n</a>\n\n<h3>{{ erratum.errata_id }} </h3>\n\n<div class="details details-full">\n  <section>\n\n    <div class="detail">\n      <span class="info-label" translate>Type</span>\n      <span class="info-value">{{ erratum.type }}</span>\n    </div>\n    <div class="detail">\n      <span class="info-label" translate>Title</span>\n      <span class="info-value">{{ erratum.title }}</span>\n    </div>\n    <div class="detail">\n      <span class="info-label" translate>Issued</span>\n      <span class="info-value">{{ erratum.issued }}</span>\n    </div>\n    <div class="detail">\n      <span class="info-label" translate>Updated</span>\n      <span class="info-value">{{ erratum.updated }}</span>\n    </div>\n    <div class="detail">\n      <span class="info-label" translate>Reboot Suggested</span>\n      <span class="info-value">{{ erratum.reboot_suggested }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Description</span>\n      <span class="info-value">\n        <p ng-repeat="paragraph in erratum.description.split(\'\\n\\n\')">\n          {{ paragraph }}\n        </p>\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Solution</span>\n      <span class="info-value">\n        <p ng-repeat="paragraph in erratum.solution.split(\'\\n\\n\')">\n          {{ paragraph }}\n        </p>\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Packages</span>\n      <span class="info-value">\n        <ul>\n          <li ng-repeat="package in erratum.packages">\n            {{ package }}\n          </li>\n        </ul>\n      </span>\n    </div>\n\n  </section>\n</div>\n')}]),angular.module("Bastion.content-hosts").factory("ContentHostErratum",["BastionResource",function(BastionResource){return BastionResource("/katello/api/v2/systems/:id/errata/:errata_id/:action",{id:"@uuid"},{get:{method:"GET",isArray:!1,transformResponse:function(data){return data=angular.fromJson(data),angular.forEach(data.results,function(errata){errata.unselectable=!errata.available}),data}},apply:{method:"PUT",params:{action:"apply"}}})}]),angular.module("Bastion.content-hosts").controller("ContentHostEventsController",["$scope","translate","ContentHost","Nutupane",function($scope,translate,ContentHost,Nutupane){var params={id:$scope.$stateParams.contentHostId},nutupane=new Nutupane(ContentHost,params,"events");$scope.eventTable=nutupane.table}]),angular.module("Bastion.content-hosts").factory("ContentHostPackage",["BastionResource",function(BastionResource){return BastionResource("/katello/api/v2/systems/:id/packages/:action",{id:"@uuid"},{get:{method:"GET",isArray:!1},remove:{method:"PUT",params:{action:"remove"}},install:{method:"PUT",params:{action:"install"}},update:{method:"PUT",params:{action:"upgrade"}},updateAll:{method:"PUT",params:{action:"upgrade_all"}}})}]),angular.module("Bastion.content-hosts").controller("ContentHostRegisterController",["$scope","$location","Capsule","Organization","CurrentOrganization","BastionConfig",function($scope,$location,Capsule,Organization,CurrentOrganization,BastionConfig){$scope.organization=Organization.get({id:CurrentOrganization}),$scope.baseURL="http://"+$location.host(),$scope.consumerCertRPM=BastionConfig.consumerCertRPM,$scope.capsules=Capsule.queryUnpaged(function(data){$scope.selectedCapsule=data.results[0]}),$scope.hostname=function(url){return url&&(url=url.split("https://")[1].split(":")[0]),url}}]),angular.module("Bastion.content-hosts").controller("ContentHostStatusController",["$scope","translate",function($scope,translate){$scope.statusReason=translate("Loading..."),$scope.statusRetrieved=!1}]),angular.module("Bastion.content-hosts").factory("ContentHost",["BastionResource",function(BastionResource){return BastionResource("/katello/api/v2/systems/:id/:action/:action2",{id:"@uuid"},{get:{method:"GET",params:{fields:"full"}},update:{method:"PUT"},releaseVersions:{method:"GET",params:{action:"releases"}},subscriptions:{method:"GET",params:{action:"subscriptions"}},events:{method:"GET",params:{action:"events"}},products:{method:"GET",params:{action:"products"}},availableSubscriptions:{method:"GET",params:{action:"subscriptions",action2:"available"}},removeSubscriptions:{method:"PUT",isArray:!1,params:{action:"subscriptions"}},addSubscriptions:{method:"POST",isArray:!1,params:{action:"subscriptions"}},refreshSubscriptions:{method:"PUT",params:{action:"refresh_subscriptions"}},tasks:{method:"GET",params:{action:"tasks",paged:!0}},availableHostCollections:{method:"GET",params:{action:"available_host_collections"}},hostCollections:{method:"GET",transformResponse:function(data){var contentHost=angular.fromJson(data);return{results:contentHost.hostCollections}}},contentOverride:{method:"PUT",isArray:!1,params:{action:"content_override"}}})}]),angular.module("Bastion.content-hosts").factory("ContentHostBulkAction",["BastionResource",function(BastionResource){return BastionResource("/katello/api/v2/systems/bulk/:action",{},{addHostCollections:{method:"PUT",params:{action:"add_host_collections"}},applicableErrata:{method:"POST",params:{action:"applicable_errata"}},removeHostCollections:{method:"PUT",params:{action:"remove_host_collections"}},installContent:{method:"PUT",params:{action:"install_content"}},updateContent:{method:"PUT",params:{action:"update_content"}},removeContent:{method:"PUT",params:{action:"remove_content"}},unregisterContentHosts:{method:"PUT",params:{action:"destroy"}},environmentContentView:{method:"PUT",params:{action:"environment_content_view"}}})}]),angular.module("Bastion.content-hosts").service("ContentHostsHelper",function(){function memoryInGigabytes(memStr){var mems,memory,unit;if(memStr===undefined||memStr==="")return"0";mems=memStr.split(/\s+/),memory=parseFloat(mems[0]),unit=mems[1];switch(unit){case"B":memory=0;break;case"kB":memory=0;break;case"MB":memory/=1024;break;case"GB":break;case"TB":memory*=1024;break;default:memory/=1048576}return memory=Math.round(memory*100)/100,memory}var hostStatusColorMap={"Pending Installation":"light-blue","Alerts disabled":"gray","No reports":"gray","Out of sync":"orange",Error:"red",Active:"light-blue",Pending:"orange","No Change":"green"};this.getStatusColor=function(status){var colors={valid:"green",partial:"yellow",invalid:"red"};return colors[status]?colors[status]:"red"},this.getProvisioningStatusColor=function(status){var color;if(status!==undefined&&(color=hostStatusColorMap[status])===undefined)throw"Unknown status = "+status;return color},this.memory=function(facts){var mem;return facts!==undefined?(facts.memory!==undefined&&(mem=facts.memory.memtotal),mem===undefined&&facts.dmi!==undefined&&facts.dmi.memory!==undefined&&(mem=facts.dmi.memory.size),memoryInGigabytes(mem)):"0"}}),angular.module("Bastion.content-hosts").controller("ContentHostsController",["$scope","$state","$location","translate","Nutupane","ContentHost","CurrentOrganization","ContentHostsHelper",function($scope,$state,$location,translate,Nutupane,ContentHost,CurrentOrganization,ContentHostsHelper){$scope.successMessages=[],$scope.errorMessages=[];var params={organization_id:CurrentOrganization,search:$location.search().search||"",sort_by:"name",sort_order:"ASC"},nutupane=new Nutupane(ContentHost,params);$scope.contentHostTable=nutupane.table,$scope.removeRow=nutupane.removeRow,$scope.nutupane=nutupane,nutupane.enableSelectAllResults(),$location.search().select_all&&(nutupane.table.initialSelectAll=!0),$scope.contentHostTable.getStatusColor=ContentHostsHelper.getStatusColor,$scope.contentHostTable.getProvisioningStatusColor=ContentHostsHelper.getProvisioningStatusColor,$scope.contentHostTable.closeItem=function(){$scope.transitionTo("content-hosts.index")},$scope.table=$scope.contentHostTable,$scope.unregisterContentHost=function(contentHost){contentHost.$remove(function(){$scope.removeRow(contentHost.id),$scope.successMessages.push(translate("Content Host %s has been deleted.").replace("%s",contentHost.name)),$scope.transitionTo("content-hosts.index")})},$scope.reloadSearch=function(search){$scope.table.search(search),$state.go("content-hosts.index")}}]),angular.module("Bastion.content-hosts").controller("ContentHostErrataController",["$scope","translate","ContentHostErratum","Nutupane","Organization","Environment",function($scope,translate,ContentHostErratum,Nutupane,Organization,Environment){function loadErratum(errataId){$scope.erratum=ContentHostErratum.get({id:$scope.$stateParams.contentHostId,errata_id:errataId})}var errataNutupane=new Nutupane(ContentHostErratum,{id:$scope.$stateParams.contentHostId,searchTerm:$scope.$stateParams.search},"get");$scope.detailsTable=errataNutupane.table,$scope.detailsTable.errataFilterTerm="",$scope.detailsTable.errataCompare=function(item){var searchText=$scope.detailsTable.errataFilterTerm;return item.type.indexOf(searchText)>=0||item.errata_id.indexOf(searchText)>=0||item.title.indexOf(searchText)>=0},$scope.selectedErrataOption="current",$scope.errataOptions=[{name:"Current Environment",label:"current"},{name:"foo",label:"bar"}],$scope.setupErrataOptions=function(host){var libraryString=translate("Library Synced Content"),currentEnv=translate("Current Environment (%e/%cv)").replace("%e",host.environment.name).replace("%cv",host.content_view.name),previousEnv;$scope.errataOptions=[{name:currentEnv,label:"current",order:3}],host.environment.library||Environment.get({id:host.environment.id}).$promise.then(function(env){previousEnv=translate("Previous Environment (%e/%cv)").replace("%e",env.prior.name).replace("%cv",host.content_view.name),$scope.errataOptions.push({name:previousEnv,label:"prior",order:2,content_view_id:host.content_view_id,environment_id:env.prior.id})}),host.content_view.default||Organization.get({id:host.environment.organization.id}).$promise.then(function(org){$scope.errataOptions.push({name:libraryString,label:"library",order:1,content_view_id:org.default_content_view_id,environment_id:org.library_id})})},$scope.contentHost.$promise.then($scope.setupErrataOptions),$scope.refreshErrata=function(selected){var option,params;params={id:$scope.$stateParams.contentHostId};if(selected==="library"||selected==="prior")option=_.find($scope.errataOptions,function(option){return option.label===selected}),params.content_view_id=option.content_view_id,params.environment_id=option.environment_id;errataNutupane.setParams(params),errataNutupane.refresh()},$scope.transitionToErratum=function(erratum){loadErratum(erratum.errata_id),$scope.transitionTo("content-hosts.details.errata.details",{errataId:erratum.errata_id})},$scope.applySelected=function(){var selected,errataIds=[];selected=$scope.detailsTable.getSelected(),selected.length>0&&(angular.forEach(selected,function(value){errataIds.push(value.errata_id)}),ContentHostErratum.apply({uuid:$scope.contentHost.uuid,errata_ids:errataIds},function(task){$scope.detailsTable.selectAll(!1),$scope.transitionTo("content-hosts.details.tasks.details",{taskId:task.id})}))},$scope.$stateParams.errataId&&loadErratum($scope.$stateParams.errataId)}]),angular.module("Bastion.content-hosts").controller("ContentHostPackagesController",["$scope","ContentHostPackage","translate","Nutupane",function($scope,ContentHostPackage,translate,Nutupane){const PACKAGES_PER_PAGE=50;var packagesNutupane,packageActions,openEventInfo;openEventInfo=function(event){event.label?$scope.transitionTo("content-hosts.details.tasks.details",{taskId:event.id}):$scope.transitionTo("content-hosts.details.events.details",{eventId:event.id}),$scope.working=!1};var errorHandler=function(response){$scope.errorMessages=response.data.errors,$scope.working=!1};$scope.packageAction={actionType:"packageInstall"},$scope.errorMessages=[],$scope.working=!1,$scope.updateAll=function(){$scope.working=!0,ContentHostPackage.updateAll({uuid:$scope.contentHost.uuid},openEventInfo,errorHandler)},$scope.performPackageAction=function(){var action,terms;action=$scope.packageAction.actionType,terms=$scope.packageAction.term.split(/ *, */),$scope.working=!0,packageActions[action](terms)},packageActions={packageInstall:function(termList){ContentHostPackage.install({uuid:$scope.contentHost.uuid,packages:termList},openEventInfo,errorHandler)},packageUpdate:function(termList){ContentHostPackage.update({uuid:$scope.contentHost.uuid,packages:termList},openEventInfo,errorHandler)},packageRemove:function(termList){ContentHostPackage.remove({uuid:$scope.contentHost.uuid,packages:termList},openEventInfo,errorHandler)},groupInstall:function(termList){ContentHostPackage.install({uuid:$scope.contentHost.uuid,groups:termList},openEventInfo,errorHandler)},groupRemove:function(termList){ContentHostPackage.remove({uuid:$scope.contentHost.uuid,groups:termList},openEventInfo,errorHandler)}},packagesNutupane=new Nutupane(ContentHostPackage,{id:$scope.$stateParams.contentHostId},"get"),packagesNutupane.load(),$scope.currentPackagesTable=packagesNutupane.table,$scope.currentPackagesTable.openEventInfo=openEventInfo,$scope.currentPackagesTable.contentHost=$scope.contentHost,$scope.currentPackagesTable.taskFailed=function(task){return task===undefined||task.failed||task.affected_units===0},$scope.currentPackagesTable.removePackage=function(pkg){$scope.working||($scope.working=!0,ContentHostPackage.remove({uuid:$scope.contentHost.uuid,packages:[{name:pkg.name,version:pkg.version,arch:pkg.arch,release:pkg.release}]},openEventInfo,errorHandler))},$scope.currentPackagesTable.limit=PACKAGES_PER_PAGE,$scope.currentPackagesTable.loadMorePackages=function(){$scope.$evalAsync(function(scope){scope.currentPackagesTable.limit=scope.currentPackagesTable.limit+PACKAGES_PER_PAGE})}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/content/views/content-host-errata.html",'<span page-title ng-model="contentHost">{{ \'Errata for: \' | translate }} {{ contentHost.name }}</span>\n\n<p class="alert alert-info" ng-hide="contentHost.katello_agent_installed" translate>\n  The katello-agent package is required to manage errata on this Host.\n  Please install the katello-agent package to manage errata on\n  {{ contentHost.name }}.\n</p>\n\n<div data-extend-template="layouts/details-nutupane.html">\n  <div data-block="header" translate>Applicable Errata</div>\n\n  <span data-block="filters">\n    <form class="well form-horizontal col-sm-12">\n      <div class="form-group">\n        <label translate class="control-label col-sm-1">\n          Show from:\n        </label>\n        <div class="col-sm-3">\n          <select class="form-control"\n                  ng-model="selectedErrataOption"\n                  ng-change="refreshErrata(selectedErrataOption)"\n                  ng-options="option.label as option.name for option in errataOptions | orderBy: \'order\'"></select>\n        </div>\n      </div>\n    </form>\n  </span>\n\n  <span data-block="actions">\n      <div ng-hide="contentHost.readonly" class="fr">\n         <button class="btn btn-primary"\n                 translate\n                 ng-hide="denied(\'edit_content_hosts\', contentHost)"\n                 ng-disabled="detailsTable.getSelected().length == 0"\n                 ng-click="applySelected()">\n           Apply Selected\n         </button>\n      </div>\n  </span>\n\n  <div data-block="table">\n    <p translate class="alert alert-info" ng-show="detailsTable.rows.length === 0">There are no Errata to display.</p>\n\n    <table class="table table-striped table-bordered" ng-class="{\'table-mask\': detailsTable.working}">\n      <thead>\n        <tr bst-table-head row-select>\n          <th bst-table-column="type" translate>Type</th>\n          <th bst-table-column="errata_id" translate>Id</th>\n          <th bst-table-column="title" translate>Title</th>\n          <th bst-table-column="issued" translate>Issued</th>\n        </tr>\n      </thead>\n      <tbody>\n        <tr bst-table-row ng-repeat="erratum in detailsTable.rows | filter:detailsTable.errataCompare" row-select="erratum">\n          <td bst-table-cell>\n              <span ng-show="erratum.type == \'security\'">\n                <i class="icon-warning-sign inline-icon" title="{{ \'Security\' | translate }}"></i>\n              </span>\n    \n              <span ng-show="erratum.type == \'bugfix\'">\n                <i class="icon-bug inline-icon" title="{{ \'Bug Fix\' | translate }}"></i>\n              </span>\n    \n              <span ng-show="erratum.type == \'enhancement\'">\n                <i class="icon-plus-sign-alt inline-icon" title="{{ \'Enhancement\' | translate }}"></i>\n              </span>\n    \n            {{ erratum.type | errataType}}\n            <span ng-show="erratum.severity">- {{ erratum.severity | errataSeverity}}</span>\n          </td>\n          <td bst-table-cell >\n            <a ng-click="transitionToErratum(erratum)">\n              {{ erratum.errata_id }}\n            </a>\n          </td>\n          <td bst-table-cell >{{ erratum.title }}</td>\n          <td bst-table-cell >{{ erratum.updated | date:\'shortDate\' }}</td>\n        </tr>\n      </tbody>\n    </table>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/content/views/content-host-packages.html",'<span page-title ng-model="contentHost">{{ \'Packages for: \' | translate }} {{ contentHost.name }}</span>\n<section ng-hide="denied(\'edit_content_hosts\', contentHost)">\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n  <h4 translate>Package Actions</h4>\n  <p class="alert alert-info" ng-hide="contentHost.katello_agent_installed" translate>\n    The katello-agent package is required to manage packages on this Host.\n    Please install the katello-agent package to manage packages on\n    {{ contentHost.name }}. To install the package, connect directly to the\n    host from a terminal and use yum.\n  </p>\n  <section>\n    <form ng-submit="performPackageAction()" role="form" class="row">\n\n      <div class="col-sm-2">\n        <select class="form-control" ng-model="packageAction.actionType" required>\n          <option value="packageInstall" translate>Package Install</option>\n          <option value="packageUpdate" translate>Package Update</option>\n          <option value="packageRemove" translate>Package Remove</option>\n          <option value="groupInstall" translate>Group Install</option>\n          <option value="groupRemove" translate>Group Remove</option>\n        </select>\n      </div>\n\n      <div class="input-group col-sm-5">\n        <input class="form-control"\n               type="text"\n               placeholder="{{ \'Package/Group Name\' | translate}}"\n               ng-model="packageAction.term"/>\n\n        <span class="input-group-btn">\n          <button class="btn btn-default"\n                  ng-hide="denied(\'edit_content_hosts\', contentHost)"\n                  ng-disabled="working || packageAction.term === undefined || packageAction.term.length === 0"\n                  translate>\n            Perform</button>\n        </span>\n      </div>\n    </form>\n  </section>\n</section>\n\n<section>\n  <h4 translate>Installed Packages</h4>\n\n  <div class="row">\n    <form>\n      <input type="text"\n             class="form-control filter-input"\n             placeholder="{{ \'Filter\' | translate }}"\n             ng-model="currentPackagesTable.filter"/>\n    </form>\n    <span class="nutupane-info" translate>Showing {{ currentPackagesTable.resource.total }} Packages</span>\n\n    <div class="fr" ng-hide="denied(\'edit_content_hosts\', contentHost)">\n       <button class="btn btn-primary"\n               translate\n               ng-click="updateAll()"\n               ng-disabled="working">\n         Update All\n       </button>\n    </div>\n  </div>\n\n  <p class="alert alert-info" ng-show="currentPackagesTable.rows.length === 0">\n    You currently do not have any Packages installed. You can use Package Actions above this message to install new Packages. \n  </p>\n\n  <div bst-table="currentPackagesTable" ng-show="currentPackagesTable.rows.length > 0">\n    <div bst-container-scroll control-width="table" bst-infinite-scroll="currentPackagesTable.loadMorePackages()" data="currentPackagesTable.rows">\n\n      <table ng-class="{\'table-mask\': currentPackagesTable.working}" class="table table-striped">\n        <thead>\n          <tr bst-table-head>\n            <th bst-table-column="name" translate>Installed Package</th>\n            <th bst-table-column="remove" translate ng-hide="currentPackagesTable.contentHost.readonly">Remove</th>\n          </tr>\n        </thead>\n\n        <tbody>\n\n            <tr bst-table-row ng-repeat="package in currentPackagesTable.rows | filter: currentPackagesTable.filter | limitTo: currentPackagesTable.limit" >\n            <td bst-table-cell>{{ package.nvrea }}</td>\n            <td bst-table-cell ng-hide="currentPackagesTable.contentHost.readonly">\n\n                <i class="active icon-remove-sign" ng-hide="package.removeTask" tooltip="{{ \'Remove\' | translate }}"\n                   ng-click="currentPackagesTable.removePackage(package)"></i>\n\n                <i class="icon-spinner icon-spin" ng-show="package.removeTask.pending"></i>\n                <span ng-show="package.removeTask && !package.removeTask.pending">\n\n                  <i ng-show="currentPackagesTable.taskFailed(package.removeTask)" class="icon-exclamation-sign" tooltip="{{ \'Failed\' | translate }}"></i>\n                  <i ng-hide="currentPackagesTable.taskFailed(package.removeTask)" class="icon-check-sign" tooltip="{{ \'Success\' | translate }}"></i>\n\n                  <a ng-click="currentPackagesTable.openEventInfo(package.removeTask)" >\n                    <span translate ng-show="package.removeTask.affected_units == 1">\n                      {{ package.removeTask.affected_units }} package removed\n                    </span>\n\n                    <span translate ng-show="!package.removeTask.failed && package.removeTask.affected_units != 1">\n                      {{ package.removeTask.affected_units }} packages removed\n                    </span>\n\n                    <span translate ng-show="package.removeTask.failed">\n                        Package removal failed\n                    </span>\n                  </a>\n                </span>\n            </td>\n\n          </tr>\n        </tbody>\n      </table>\n    </div>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/content/views/errata-details.html",'<span page-title>{{ \'Errata Details\' | translate }}</span>\n<a ui-sref="content-hosts.details.errata.index">\n  <i class="icon-double-angle-left"></i>\n  {{ "Back To Errata List" | translate }}\n</a>\n\n<h3>{{ erratum.errata_id }} </h3>\n\n<div class="details details-full">\n  <section>\n\n    <div class="detail">\n      <span class="info-label" translate>Type</span>\n      <span class="info-value">{{ erratum.type }}</span>\n    </div>\n    <div class="detail">\n      <span class="info-label" translate>Title</span>\n      <span class="info-value">{{ erratum.title }}</span>\n    </div>\n    <div class="detail">\n      <span class="info-label" translate>Issued</span>\n      <span class="info-value">{{ erratum.issued }}</span>\n    </div>\n    <div class="detail">\n      <span class="info-label" translate>Updated</span>\n      <span class="info-value">{{ erratum.updated }}</span>\n    </div>\n    <div class="detail">\n      <span class="info-label" translate>Reboot Suggested</span>\n      <span class="info-value">{{ erratum.reboot_suggested }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Description</span>\n      <span class="info-value">\n        <p ng-repeat="paragraph in erratum.description.split(\'\\n\\n\')">\n          {{ paragraph }}\n        </p>\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Solution</span>\n      <span class="info-value">\n        <p ng-repeat="paragraph in erratum.solution.split(\'\\n\\n\')">\n          {{ paragraph }}\n        </p>\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Packages</span>\n      <span class="info-value">\n        <ul>\n          <li ng-repeat="package in erratum.packages">\n            {{ package }}\n          </li>\n        </ul>\n      </span>\n    </div>\n\n  </section>\n</div>\n')}]),angular.module("Bastion.content-hosts").controller("ContentHostAddHostCollectionsController",["$scope","$q","$location","translate","ContentHost","Nutupane",function($scope,$q,$location,translate,ContentHost,Nutupane){var hostCollectionsPane,params;$scope.successMessages=[],$scope.errorMessages=[],params={search:$location.search().search||"",sort_by:"name",sort_order:"ASC",paged:!0,id:$scope.$stateParams.contentHostId},hostCollectionsPane=new Nutupane(ContentHost,params,"availableHostCollections"),$scope.hostCollectionsTable=hostCollectionsPane.table,$scope.addHostCollections=function(contentHost){var deferred=$q.defer(),success,error,hostCollections,hostCollectionsToAdd;return success=function(data){$scope.successMessages=[translate('Added %x host collections to content host "%y".').replace("%x",$scope.hostCollectionsTable.numSelected).replace("%y",$scope.contentHost.name)],$scope.hostCollectionsTable.working=!1,$scope.hostCollectionsTable.selectAll(!1),hostCollectionsPane.refresh(),$scope.contentHost.$get(),deferred.resolve(data)},error=function(error){deferred.reject(error.data.errors),$scope.errorMessages=error.data.errors.base,$scope.hostCollectionsTable.working=!1},$scope.hostCollectionsTable.working=!0,hostCollections=_.pluck($scope.contentHost.hostCollections,"id"),hostCollectionsToAdd=_.pluck($scope.hostCollectionsTable.getSelected(),"id"),contentHost.host_collection_ids=_.union(hostCollections,hostCollectionsToAdd),contentHost.$update({id:$scope.contentHost.uuid},success,error),deferred.promise}}]),angular.module("Bastion.content-hosts").controller("ContentHostAddSubscriptionsController",["$scope","$location","translate","CurrentOrganization","Subscription","ContentHost","SubscriptionsHelper",function($scope,$location,translate,CurrentOrganization,Subscription,ContentHost,SubscriptionsHelper){$scope.addSubscriptionsTable=$scope.addSubscriptionsPane.table,$scope.isAdding=!1,$scope.addSubscriptionsTable.closeItem=function(){},$scope.groupedSubscriptions={},$scope.$watch("addSubscriptionsTable.rows",function(rows){$scope.groupedSubscriptions=SubscriptionsHelper.groupByProductName(rows)}),$scope.disableAddButton=function(){return $scope.addSubscriptionsTable.numSelected===0||$scope.isAdding},$scope.addSelected=function(){var selected;selected=SubscriptionsHelper.getSelectedSubscriptionAmounts($scope.addSubscriptionsTable),$scope.isAdding=!0,ContentHost.addSubscriptions({uuid:$scope.contentHost.uuid,subscriptions:selected},function(){ContentHost.get({id:$scope.$stateParams.contentHostId},function(host){$scope.$parent.contentHost=host,$scope.successMessages.push(translate("Successfully added %s subscriptions.").replace("%s",selected.length)),$scope.isAdding=!1,$scope.addSubscriptionsPane.refresh(),$scope.subscriptionsPane.refresh(),$scope.nutupane.refresh()})},function(response){$scope.$parent.errorMessages=response.data.displayMessage,$scope.isAdding=!1})},$scope.amountSelectorValues=function(subscription){var step,value,values;step=subscription.instance_multiplier;if(!step||step<1)step=1;values=[];for(value=step;value<subscription.quantity&&values.length<5;value+=step)values.push(value);return values.push(subscription.quantity),values}}]),angular.module("Bastion.content-hosts").controller("ContentHostBaseSubscriptionsController",["$scope","translate","CurrentOrganization","Subscription","ContentHost","Nutupane",function($scope,translate,CurrentOrganization,Subscription,ContentHost,Nutupane){function success(){$scope.subscription.workingMode=!1,$scope.$parent.successMessages=[translate("Successfully updated subscriptions.")],$scope.addSubscriptionsPane.refresh(),$scope.subscriptionsPane.refresh(),$scope.contentHost.$get()}function failure(){$scope.subscription.workingMode=!1,$scope.$parent.errorMessages=[translate("An error occurred trying to auto-attach subscriptions.  Please check your log for further information.")]}var params={id:$scope.$stateParams.contentHostId,organization_id:CurrentOrganization,sort_by:"name",sort_order:"ASC"};$scope.subscription={workingMode:!1},$scope.addSubscriptionsPane=new Nutupane(ContentHost,params,"availableSubscriptions"),$scope.subscriptionsPane=new Nutupane(ContentHost,params,"subscriptions"),$scope.autoAttachSubscriptions=function(){$scope.subscription.workingMode=!0,ContentHost.refreshSubscriptions({uuid:$scope.contentHost.uuid},success,failure)}}]),angular.module("Bastion.content-hosts").controller("ContentHostDetailsInfoController",["$scope","$q","translate","CustomInfo","ContentHost","ContentView","Organization","CurrentOrganization","ContentHostsHelper",function($scope,$q,translate,CustomInfo,ContentHost,ContentView,Organization,CurrentOrganization,ContentHostsHelper){function dotNotationToObj(dotString){var dotObject={},tempObject,parts,part,key;for(var property in dotString)if(dotString.hasOwnProperty(property)){tempObject=dotObject,parts=property.split("."),key=parts.pop();while(parts.length)part=parts.shift(),tempObject=tempObject[part]=tempObject[part]||{};tempObject[key]=dotString[property]}return dotObject}function populateExcludedFacts(){$scope.advancedInfoLeft={},$scope.advancedInfoRight={};var index=0;angular.forEach($scope.contentHostFacts,function(value,key){index%2===0?$scope.advancedInfoLeft[key]=value:$scope.advancedInfoRight[key]=value,index+=1}),$scope.hasAdvancedInfo=Object.keys($scope.advancedInfoLeft).length>0||Object.keys($scope.advancedInfoRight).length>0}$scope.successMessages=[],$scope.errorMessages=[];var customInfoErrorHandler=function(response){$scope.errorMessages=response.data.errors};$scope.showVersionAlert=!1,$scope.editContentView=!1,$scope.disableEnvironmentSelection=!1,$scope.environments=[],$scope.environments=Organization.readableEnvironments({id:CurrentOrganization}),$scope.contentHost.$promise.then(function(){$scope.contentHostFacts=dotNotationToObj($scope.contentHost.facts),populateExcludedFacts(),$scope.originalEnvironment=$scope.contentHost.environment}),$scope.$watch("contentHost.environment",function(environment){environment&&$scope.originalEnvironment&&environment.id!==$scope.originalEnvironment.id&&($scope.editContentView=!0,$scope.disableEnvironmentSelection=!0)}),$scope.cancelReleaseVersionUpdate=function(){$scope.showVersionAlert=!1},$scope.cancelContentViewUpdate=function(){$scope.editContentView&&($scope.editContentView=!1,$scope.contentHost.environment=$scope
.originalEnvironment,$scope.disableEnvironmentSelection=!1)},$scope.saveContentView=function(contentHost){$scope.editContentView=!1,$scope.save(contentHost).then(function(contentHost){$scope.originalEnvironment=contentHost.environment}),$scope.disableEnvironmentSelection=!1},$scope.releaseVersions=function(){var deferred=$q.defer();return ContentHost.releaseVersions({id:$scope.contentHost.uuid},function(response){response.total===0&&($scope.showVersionAlert=!0),deferred.resolve(response.results)}),deferred.promise},$scope.clearReleaseVersion=function(){$scope.contentHost.release_ver="",$scope.save($scope.contentHost)},$scope.clearServiceLevel=function(){$scope.contentHost.service_level="",$scope.save($scope.contentHost)},$scope.contentViews=function(){var deferred=$q.defer();return ContentView.queryUnpaged({environment_id:$scope.contentHost.environment.id},function(response){deferred.resolve(response.results),$scope.contentViews=response.results}),deferred.promise},$scope.saveCustomInfo=function(info){return CustomInfo.update({id:$scope.contentHost.id,type:"system",action:info.keyname},{custom_info:info},function(){$scope.successMessages=[translate("Successfully updated custom info.")]},customInfoErrorHandler)},$scope.addCustomInfo=function(info){var success=function(){$scope.contentHost.customInfo.push(info),$scope.successMessages=[translate("Successfully saved custom info.")]};return CustomInfo.save({id:$scope.contentHost.id,type:"system"},{custom_info:info},success,customInfoErrorHandler)},$scope.deleteCustomInfo=function(info){var success=function(){$scope.contentHost.customInfo=_.filter($scope.contentHost.customInfo,function(keyValue){return keyValue!==info},this),$scope.successMessages=[translate("Successfully removed custom info.")]};return CustomInfo.delete({id:$scope.contentHost.id,type:"system",action:info.keyname},success,customInfoErrorHandler)},$scope.getActivationKeyLink=function(activationKey){return"/activation_keys!=&panel=activation_key_%s&panelpage=edit".replace("%s",activationKey.id)},$scope.getTemplateForType=function(value){var template="content-hosts/details/views/partials/content-host-detail-value.html";return typeof value=="object"&&(template="content-hosts/details/views/partials/content-host-detail-object.html"),template},$scope.memory=ContentHostsHelper.memory,$scope.virtualGuestIds=function(contentHost){var ids=[];return angular.forEach(contentHost.virtual_guests,function(host){ids.push("id:%s".replace("%s",host.id))}),ids.join(" ")}}]),angular.module("Bastion.content-hosts").controller("ContentHostDetailsController",["$scope","$state","$q","translate","ContentHost","Organization","CurrentOrganization","MenuExpander",function($scope,$state,$q,translate,ContentHost,Organization,CurrentOrganization,MenuExpander){$scope.menuExpander=MenuExpander,$scope.successMessages=[],$scope.errorMessages=[],$scope.contentHost?$scope.panel={loading:!1}:$scope.panel={loading:!0},$scope.contentHost=ContentHost.get({id:$scope.$stateParams.contentHostId},function(contentHost){$scope.$watch("contentHostTable.rows.length > 0",function(){$scope.contentHostTable.replaceRow(contentHost)}),$scope.$broadcast("contentHost.loaded",contentHost),$scope.panel.loading=!1}),$scope.save=function(contentHost){var deferred=$q.defer();return contentHost.$update(function(response){deferred.resolve(response),$scope.successMessages.push(translate("Save Successful."))},function(response){deferred.reject(response),_.each(response.data.errors,function(errorMessage){$scope.errorMessages.push(translate("An error occurred saving the Content Host: ")+errorMessage)})}),deferred.promise},$scope.transitionTo=function(state,params){var contentHostId=$scope.$stateParams.contentHostId;return $scope.contentHost&&$scope.contentHost.uuid&&(contentHostId=$scope.contentHost.uuid),contentHostId?(params=params?params:{},params.contentHostId=contentHostId,$state.transitionTo(state,params),!0):!1},$scope.serviceLevels=function(){var deferred=$q.defer();return Organization.get({id:CurrentOrganization},function(organization){deferred.resolve(organization.service_levels)}),deferred.promise}}]),angular.module("Bastion.content-hosts").controller("ContentHostHostCollectionsController",["$scope","$q","$location","translate","ContentHost","Nutupane",function($scope,$q,$location,translate,ContentHost,Nutupane){var hostCollectionsPane,params;$scope.successMessages=[],$scope.errorMessages=[],params={id:$scope.$stateParams.contentHostId,search:$location.search().search||"",sort_by:"name",sort_order:"ASC",paged:!0},hostCollectionsPane=new Nutupane(ContentHost,params,"hostCollections"),$scope.hostCollectionsTable=hostCollectionsPane.table,$scope.removeHostCollections=function(contentHost){var deferred=$q.defer(),success,error,hostCollections,hostCollectionsToRemove;return success=function(data){$scope.successMessages=[translate('Removed %x host collections from content host "%y".').replace("%x",$scope.hostCollectionsTable.numSelected).replace("%y",$scope.contentHost.name)],$scope.hostCollectionsTable.working=!1,$scope.hostCollectionsTable.selectAll(!1),hostCollectionsPane.refresh(),$scope.contentHost.$get(),deferred.resolve(data)},error=function(error){deferred.reject(error.data.errors),$scope.errorMessages=error.data.errors,$scope.hostCollectionsTable.working=!1},$scope.hostCollectionsTable.working=!0,hostCollections=_.pluck($scope.contentHost.hostCollections,"id"),hostCollectionsToRemove=_.pluck($scope.hostCollectionsTable.getSelected(),"id"),contentHost.host_collection_ids=_.difference(hostCollections,hostCollectionsToRemove),contentHost.$update({id:$scope.contentHost.uuid},success,error),deferred.promise}}]),angular.module("Bastion.content-hosts").controller("ContentHostProductDetailsController",["$scope","translate","ContentHost",function($scope,translate,ContentHost){$scope.expanded=!0,$scope.details=null,$scope.productDetails=function(product){var override;$scope.details===null&&($scope.details=product,angular.forEach($scope.details.available_content,function(content){override=_.findWhere($scope.contentHost.content_overrides,{contentLabel:content.content.label,name:"enabled"}),override===undefined?content.overrideEnabled=null:content.overrideEnabled=Number(override.value),content.enabledText=$scope.getEnabledText(content.enabled,content.overrideEnabled)}))},$scope.overrideEnableChoices=function(content){return[{name:$scope.getEnabledText(content.enabled,null),id:null},{name:$scope.getEnabledText(null,1),id:1},{name:$scope.getEnabledText(null,0),id:0}]},$scope.getEnabledText=function(enabled,overrideEnabled){var enabledText;return overrideEnabled===null?enabledText=enabled?translate("Yes (Default)"):translate("No (Default)"):overrideEnabled===1?enabledText=translate("Override to Yes"):enabledText=translate("Override to No"),enabledText},$scope.success=function(content){content.enabledText=$scope.getEnabledText(content.enabled,content.overrideEnabled),$scope.successMessages.push(translate('Updated override to "%x".').replace("%x",content.enabledText))},$scope.error=function(error){$scope.errorMessages.push(error.data.errors)},$scope.saveContentOverride=function(content){content.overrideEnabled===null?ContentHost.contentOverride({id:$scope.contentHost.uuid},{content_override:{content_label:content.content.label,name:"enabled"}},function(){$scope.success(content)},$scope.error):ContentHost.contentOverride({id:$scope.contentHost.uuid},{content_override:{content_label:content.content.label,name:"enabled",value:content.overrideEnabled}},function(){$scope.success(content)},$scope.error)}}]),angular.module("Bastion.content-hosts").controller("ContentHostProductsController",["$scope","translate","ContentHost","Product","CurrentOrganization",function($scope,translate,ContentHost,Product,CurrentOrganization){$scope.successMessages=[],$scope.errorMessages=[],$scope.displayArea={working:!0,isAvailableContent:!1},$scope.isAnyAvailableContent=function(products){var isAvailableContent=!1;return angular.forEach(products,function(product){product.available_content.length>0&&(isAvailableContent=!0)}),isAvailableContent},$scope.contentHost.$promise.then(function(){ContentHost.products({id:$scope.contentHost.uuid,organization_id:CurrentOrganization,enabled:!0,full_result:!0},function(response){$scope.products=response.results,$scope.displayArea.isAvailableContent=$scope.isAnyAvailableContent($scope.products),$scope.displayArea.working=!1})})}]),angular.module("Bastion.content-hosts").controller("ContentHostSubscriptionsController",["$scope","$location","translate","Subscription","ContentHost","SubscriptionsHelper",function($scope,$location,translate,Subscription,ContentHost,SubscriptionsHelper){$scope.subscriptionsTable=$scope.subscriptionsPane.table,$scope.subscriptionsTable.closeItem=function(){},$scope.isRemoving=!1,$scope.groupedSubscriptions={},$scope.$watch("subscriptionsTable.rows",function(rows){$scope.groupedSubscriptions=SubscriptionsHelper.groupByProductName(rows)}),$scope.disableRemoveButton=function(){return $scope.subscriptionsTable.numSelected===0||$scope.isRemoving},$scope.removeSelected=function(){var selected;selected=SubscriptionsHelper.getSelectedSubscriptions($scope.subscriptionsTable),$scope.isRemoving=!0,ContentHost.removeSubscriptions({uuid:$scope.contentHost.uuid,subscriptions:selected},function(){ContentHost.get({id:$scope.$stateParams.contentHostId},function(host){$scope.$parent.contentHost=host,$scope.subscriptionsPane.table.selectAll(!1),$scope.subscriptionsPane.refresh(),$scope.successMessages.push(translate("Successfully removed %s subscriptions.").replace("%s",selected.length)),$scope.isRemoving=!1,$scope.nutupane.refresh()})},function(response){$scope.isRemoving=!1,$scope.errorMessages.push(translate("An error occurred removing the subscriptions.")+response.data.displayMessage)})}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/content-host-add-subscriptions.html",'<section class="nutupane-sub-section">\n\n  <div class="row">\n\n    <div class="col-sm-3">\n      <div class="input-group input-group">\n        <input type="text"\n               class="form-control"\n               placeholder="{{ \'Search...\' | translate }}"\n               ng-model="addSubscriptionsTable.searchTerm"\n               bst-on-enter="addSubscriptionsTable.search(addSubscriptionsTable.searchTerm)"/>\n        <span class="input-group-btn">\n          <button ng-click="addSubscriptionsTable.search(addSubscriptionsTable.searchTerm)" class="btn btn-default" type="button"><i class="icon-search"></i></button>\n        </span>\n      </div>\n    </div>\n\n    <div class="col-sm-3 nutupane-info">\n      <span translate>Showing {{ addSubscriptionsTable.rows.length }} of {{ addSubscriptionsTable.resource.subtotal }} ({{ addSubscriptionsTable.resource.total }} Total) Subscriptions</span>\n    </div>\n\n    <div class="fr">\n      <div class="fl nutupane-info">\n        <span translate>{{ addSubscriptionsTable.numSelected }} Selected</span>\n      </div>\n\n      <div ng-hide="system.readonly" class="nutupane-actions fr">\n         <button class="btn btn-primary"\n                 translate\n                 ng-hide="denied(\'edit_content_hosts\', contentHost)"\n                 ng-disabled="disableAddButton()"\n                 ng-click="addSelected()">\n           Add Selected\n         </button>\n      </div>\n\n    </div>\n  </div>\n\n  <div bst-table="addSubscriptionsTable" class="nutupane">\n    <div bst-container-scroll bst-infinite-scroll="addSubscriptionsTable.nextPage()">\n\n      <div class="loading-mask icon-3x" ng-show="addSubscriptionsTable.working && addSubscriptionsTable.rows.length == 0">\n        <i class="icon-spinner icon-spin"></i>\n        {{ "Loading..." | translate }}\n      </div>\n\n      <p class="alert alert-info" ng-show="addSubscriptionsTable.rows.length === 0" translate>\n        You currently don\'t have any Products to subscribe to, you can add Products after selecting \'Products\' under \'Content\' in the main menu.\n      </p>\n\n      <table ng-class="{\'table-mask\': addSubscriptionsTable.working}"\n             class="table table-full table-striped" \n             ng-show="addSubscriptionsTable.rows.length > 0" >\n        <thead>\n          <tr bst-table-head row-select>\n            <th bst-table-column="quantity" sortable class="align-center"><span translate>Quantity</span></th>\n            <th bst-table-column="attached" sortable><span translate>Attached</span></th>\n            <th bst-table-column="type"><span translate>Type</span></th>\n            <th bst-table-column="startDate" sortable><span translate>Starts</span></th>\n            <th bst-table-column="endDate" sortable><span translate>Expires</span></th>\n            <th bst-table-column="supportLevel"><span translate>Support Level</span></th>\n            <th bst-table-column="contractNumber" sortable><span translate>Contract</span></th>\n            <th bst-table-column="accountNumber" sortable><span translate>Account</span></th>\n          </tr>\n        </thead>\n\n        <tbody>\n          <tr bst-table-row ng-repeat-start="(name, subscriptions) in groupedSubscriptions">\n            <td bst-table-cell colspan="8">\n              <a href=\'/subscriptions?search=productName:"{{ name }}"\'>\n                {{ name }}\n              </a>\n            </td>\n          </tr>\n          <tr bst-table-row ng-repeat-end ng-repeat="subscription in subscriptions" row-select="subscription">\n            <td bst-table-cell>\n              <span ng-hide="subscription.multi_entitlement">\n                1\n              </span>\n              <select ng-hide="!subscription.multi_entitlement"\n                      ng-model="subscription.amount"\n                      ng-options="amount for amount in amountSelectorValues(subscription)"\n                      >\n                <option value="">{{ "Automatic" | translate }}</option>\n              </select>\n            </td>\n            <td bst-table-cell>{{ subscription | subscriptionConsumedFilter }}</td>\n            <td bst-table-cell><div subscription-type="subscription"></div></td>\n            <td bst-table-cell>{{ subscription.start_date | date:"shortDate" }}</td>\n            <td bst-table-cell>{{ subscription.end_date | date:"shortDate" }}</td>\n            <td bst-table-cell>{{ subscription.support_level }}</td>\n            <td bst-table-cell>{{ subscription.contract_number }}</td>\n            <td bst-table-cell>{{ subscription.account_number }}</td>\n          </tr>\n        </tbody>\n\n      </table>\n    </div>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/content-host-details.html",'<span page-title ng-model="contentHost">{{ \'Content Host:\' | translate }} {{ contentHost.name }}</span>\n\n<div class="loading-mask loading-mask-panel" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="details-header">\n    <h2 class="fl" translate>Content Host {{ contentHost.name }}</h2>\n\n    <div class="fr">\n\n      <div bst-modal="unregisterContentHost(contentHost)" model="contentHost"\n           modal-header=\'Unregister Content Host "{{contentHost.name}}"?\'\n           modal-body=\'Are you sure you want to unregister content host "{{ contentHost.name }}"?\'></div>\n\n      <button class="btn btn-default"\n              ng-hide="denied(\'destroy_content_hosts\', contentHost)"\n              ng-click="openModal()" translate>Unregister Content Host</button>\n      <button class="btn btn-default" ui-sref="content-hosts.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <nav>\n    <ul class="nav nav-tabs">\n      <li ng-class="{active: isState(\'content-hosts.details.info\')}">\n        <a translate\n           ui-sref="content-hosts.details.info">\n          Details\n        </a>\n      </li>\n      <li ng-class="{active: isState(\'content-hosts.details.provisioning\')}">\n        <a translate\n           ui-sref="content-hosts.details.provisioning">\n          Provisioning Details\n        </a>\n      </li>\n      <li class="dropdown"\n          ng-class="{active: stateIncludes(\'content-hosts.details.subscriptions.list\') || stateIncludes(\'content-hosts.details.events\')}">\n        <a class="dropdown-toggle">\n          <span translate>Subscriptions</span>\n          <i class="icon-chevron-down"></i>\n        </a>\n        <ul class="dropdown-menu">\n          <li>\n            <a ui-sref="content-hosts.details.subscriptions.list" translate>\n              Subscriptions\n            </a>\n          </li>\n          <li>\n            <a ui-sref="content-hosts.details.events" translate>\n              Events\n            </a>\n          </li>\n        </ul>\n      </li>\n      <li ng-class="{active: $state.includes(\'content-hosts.details.host-collections\')}">\n        <a translate\n           ui-sref="content-hosts.details.host-collections.list">\n          Host Collections\n        </a>\n      </li>\n      <li ng-class="{active: stateIncludes(\'content-hosts.details.tasks\')}">\n        <a translate\n           ui-sref="content-hosts.details.tasks.index">\n          Tasks\n        </a>\n      </li>\n      <li ng-class="{active: isState(\'content-hosts.details.packages\')}">\n        <a translate\n           ui-sref="content-hosts.details.packages">\n          Packages\n        </a>\n      </li>\n      <li ng-class="{active: isState(\'content-hosts.details.errata.index\')}">\n        <a translate\n           ui-sref="content-hosts.details.errata.index">\n          Errata\n        </a>\n      </li>\n      <li ng-hide="denied(\'view_products\')" ng-class="{active: isState(\'content-hosts.details.products\')}">\n        <a translate\n           ui-sref="content-hosts.details.products">\n          Product Content\n        </a>\n      </li>\n      <li ng-repeat="menuItem in menuExpander.getMenu(\'contentHost\')">\n        <a href="{{ menuItem.url }}">\n          {{ menuItem.label }}\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <section class="nutupane-sub-section" ui-view></section>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/content-host-events.html",'<section class="nutupane-sub-section">\n  <div bst-container-scroll bst-infinite-scroll="eventTable.nextPage()">\n    <table bst-table="eventTable" class="table table-striped">\n      <thead>\n        <tr bst-table-head>\n          <th bst-table-column="Type" class=\'type\' translate>Type</th>\n          <th bst-table-column="Target" translate>Target</th>\n          <th bst-table-column="Message" class=\'type\' translate>Message</th>\n          <th bst-table-column="Date" translate>Date</th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row ng-repeat="event in eventTable.rows">\n          <td bst-table-cell>{{ event.type }}</td>\n          <td bst-table-cell>{{ event.target }}</td>\n          <td bst-table-cell>{{ event.messageText }}</td>\n          <td bst-table-cell>{{ event.timestamp | date:"short" }}</td>\n        </tr>\n      </tbody>\n    </table>\n  </div>\n</section>\n\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/content-host-info.html",'<span page-title ng-model="contentHost">{{ \'Content Host\' | translate }} {{ contentHost.name }}</span>\n\n<section>\n\n  <div class="details fl">\n    <section>\n      <h4 translate>Basic Information</h4>\n\n      <div class="detail">\n        <span class="info-label" translate>Name</span>\n        <span class="info-value"\n              bst-edit-text="contentHost.name"\n              readonly="denied(\'edit_content_hosts\', contentHost)"\n              on-save="save(contentHost)">\n        </span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>UUID</span>\n        <span class="info-value">{{ contentHost.uuid }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Description</span>\n        <span class="info-value"\n              bst-edit-textarea="contentHost.description"\n              readonly="denied(\'edit_content_hosts\', contentHost)"\n              on-save="save(contentHost)">\n        </span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Type</span>\n        <span class="info-value">{{ contentHost.type }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Katello Agent</span>\n        <span class="info-value" ng-show="contentHost.katello_agent_installed">\n          <span class="icon-circle green"></span>\n          <span translate>Installed</span>\n        </span>\n        <span class="info-value" ng-hide="contentHost.katello_agent_installed">\n          <span class="icon-circle yellow"></span>\n          <span translate>Not installed</span>\n        </span>\n      </div>\n\n      <div ng-show="contentHost.virtual_guests" class="detail">\n        <span class="info-label" translate>Virtual Guests</span>\n        <div class="info-value">\n          <a ng-click="reloadSearch(virtualGuestIds(contentHost))"\n               translate translate-n="contentHost.virtual_guests.length"\n               translate-plural="{{ contentHost.virtual_guests.length }} Content Hosts">\n             1 Content Host\n          </a>\n        </div>\n      </div>\n\n      <div ng-show="contentHost.virtual_host" class="detail">\n        <span class="info-label" translate>Virtual Host</span>\n        <div class="info-value">\n          <a ui-sref="content-hosts.details.info({contentHostId: contentHost.virtual_host.uuid })">{{ contentHost.virtual_host.name }}</a>\n        </div>\n      </div>\n\n      <div class="divider"></div>\n    </section>\n\n    <section>\n      <h4 translate>Subscriptions</h4>\n\n      <div class="detail">\n        <span class="info-label" translate>Subscription Status</span>\n        <span class="info-value">\n          <i class="icon-circle" ng-class="contentHostTable.getStatusColor(contentHost.compliance.status)"></i>\n          {{ contentHost.compliance.status }}\n        </span>\n      </div>\n\n      <div ng-show="contentHost.compliance.reasons.length > 0" class="detail">\n        <span class="info-label" translate>Details</span>\n        <div class="info-value">\n          <ul class="compliance-reasons">\n            <li ng-repeat="reason in contentHost.compliance.reasons">{{ reason.attributes.name}} - {{ reason.message }}</li>\n          </ul>\n        </div>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Auto-Attach</span>\n        <span class="info-value"\n              bst-edit-checkbox="contentHost.autoheal"\n              readonly="denied(\'edit_content_hosts\', contentHost)"\n              formatter="booleanToYesNo"\n              on-save="save(contentHost)">\n        </span>\n      </div>\n      <div class="detail">\n        <span class="info-label" translate>Service Level</span>\n        <span class="info-value"\n              bst-edit-select="contentHost.service_level"\n              readonly="denied(\'edit_content_hosts\', contentHost)"\n              selector="contentHost.service_level"\n              options="serviceLevels()"\n              options-format="option for option in options"\n              deletable="true"\n              on-delete="clearServiceLevel()"\n              on-save="save(contentHost)">\n          </span>\n      </div>\n\n      <div class="divider"></div>\n    </section>\n\n    <section>\n      <h4 translate>Content Host Properties</h4>\n\n      <div class="detail">\n        <span class="info-label" translate>OS</span>\n        <span class="info-value">{{ contentHostFacts.distribution["name"] }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Release</span>\n        <span class="info-value">{{ contentHostFacts.uname["release"] }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Arch</span>\n        <span class="info-value">{{ contentHostFacts.uname["machine"] }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Number of CPUs</span>\n        <span class="info-value">{{ contentHostFacts.cpu["cpu(s)"] }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Sockets</span>\n        <span class="info-value">{{ contentHostFacts.cpu["cpu_socket(s)"] }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Cores per Socket</span>\n        <span class="info-value">{{ contentHostFacts.cpu["core(s)_per_socket"] }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>RAM (GB)</span>\n        <span class="info-value">{{ memory(contentHostFacts) }}</span>\n      </div>\n\n      <div class="divider"></div>\n    </section>\n\n    <section>\n      <h4 translate>Installed Products</h4>\n\n      <p translate ng-show="!contentHost.installedProducts || contentHost.installedProducts.length == 0">\n        You do not have any Installed Products\n      </p>\n\n      <div ng-show="contentHost.installedProducts.length > 0">\n        <div ng-repeat="product in contentHost.installedProducts" class="detail">\n          <span class="info-label" translate>Product</span>\n          <span class="info-value">{{ product.productName }} {{ product.version }}</span>\n        </div>\n      </div>\n\n    </section>\n  </div>\n\n\n\n  <div class="fr details">\n    <section>\n      <h4 translate>Errata</h4>\n\n      <div class="detail">\n        <span class="info-label" translate>Security</span>\n        <span class="info-value">\n          <a ui-sref="content-hosts.details.errata.index({search: \'type:security\'})">\n            <i class="icon-warning-sign inline-icon"\n               ng-class="{black: contentHost.errata_counts.security === 0, red: contentHost.errata_counts.security > 0}"\n               title="{{ \'Security\' | translate }}"></i>\n            {{ contentHost.errata_counts.security || 0 }}\n          </a>\n        </span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Bug Fix</span>\n        <span class="info-value">\n          <a ui-sref="content-hosts.details.errata.index({search: \'type:bugfix\'})">\n            <i class="icon-bug inline-icon"\n               ng-class="{black: contentHost.errata_counts.bugfix === 0, yellow: contentHost.errata_counts.bugfix > 0}"\n               title="{{ \'Bug Fix\' | translate }}"></i>\n            {{ contentHost.errata_counts.bugfix || 0 }}\n          </a>\n        </span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Enhancement</span>\n        <span class="info-value">\n          <a ui-sref="content-hosts.details.errata.index({search: \'type:enhancement\'})">\n            <i class="icon-plus-sign-alt inline-icon"\n               ng-class="{black: contentHost.errata_counts.enhancement === 0, yellow: contentHost.errata_counts.enhancement > 0}"\n               title="{{ \'Enhancement\' | translate }}"></i>\n            {{ errataCounts.enhancement || 0 }}\n          </a>\n        </span>\n      </div>\n      <div class="divider"></div>\n    </section>\n\n    <section>\n      <h4 translate>Content Host Content</h4>\n\n      <div class="detail">\n        <span class="info-label" translate>Release Version</span>\n        <span class="info-value"\n              bst-edit-select="contentHost.release_ver"\n              readonly="denied(\'edit_content_hosts\', contentHost)"\n              selector="contentHost.release_ver"\n              options="releaseVersions()"\n              options-format="option for option in options"\n              deletable="true"\n              on-delete="clearReleaseVersion()"\n              on-save="save(contentHost)"\n              on-cancel="cancelReleaseVersionUpdate()">\n        </span>\n        <div alert type="\'info\'" ng-show="showVersionAlert">\n          <p translate>\n            No alternate release version choices are available. The available releases are based upon what is available in "{{ contentHost.content_view.name }}", the selected <a href="/content_views">content view</a> this content host is attached to for the given <a href="/lifecycle_environments">lifecycle environment</a>, "{{ contentHost.environment.name }}".\n          </p>\n        </div>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Content View</span>\n        <span class="info-value"\n              bst-edit-select="contentHost.content_view.name"\n              readonly="denied(\'edit_content_hosts\', contentHost)"\n              selector="contentHost.content_view.id"\n              options="contentViews()"\n              on-cancel="cancelContentViewUpdate()"\n              on-save="saveContentView(contentHost)"\n              edit-trigger="editContentView">\n        </span>\n      </div>\n\n      <div class="detail">\n        <div alert type="\'info\'" ng-show="editContentView">\n          <p translate ng-show="contentViews.length === 0">\n            The host requires being attached to a content view and the environment you have chosen has no content views promoted to it.\n            See the <a href="/content_views">content views page</a> to manage and promote a content view.\n          </p>\n          <p translate ng-show="contentViews.length !== 0">\n            You must select a new content view before your change of environment can be saved.\n          </p>\n          <p translate>\n            Use the cancel button on content view selection to revert your environment selection.\n          </p>\n        </div>\n        <span class="info-label" translate>Environment</span>\n        <span path-selector="environments"\n              ng-model="contentHost.environment"\n              mode="singleSelect"\n              disabled="denied(\'edit_content_hosts\', contentHost)"\n              disable-trigger="disableEnvironmentSelection">\n        </span>\n      </div>\n\n      <div class="divider"></div>\n    </section>\n\n    <section>\n      <h4 translate>Content Host Status</h4>\n\n      <div class="detail">\n        <span class="info-label" translate>Registered</span>\n        <span class="info-value">{{ contentHost.created | date:\'short\' }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate> Registered By</span>\n        <span class="info-value"\n              translate\n              ng-show="contentHost.activation_keys.length == 0">\n          {{ contentHost.registered_by }}\n        </span>\n        <span class="info-value"\n              ng-show="contentHost.activation_keys.length > 0"\n              translate\n              translate-n="contentHost.activation_keys.length"\n              translate-plural="Activation Keys">\n          Activation Key\n        </span>\n        <span class="info-value">\n          <ul ng-show="contentHost.activation_keys.length > 0">\n            <li ng-repeat="activation_key in contentHost.activation_keys">\n              <span>\n                <a ui-sref="activation-keys.details.info({activationKeyId: activation_key.id})">\n                  {{ activation_key.name }}\n                </a>\n              </span>\n              <span ng-show="activation_key.description"> - {{ activation_key.description }}</span>\n            </li>\n          </ul>\n        </span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Checkin</span>\n        <span class="info-value">{{ (contentHost.checkin_time | date:\'short\') || ("Never checked in" | translate) }}</span>\n      </div>\n\n      <div class="divider"></div>\n    </section>\n\n    <section>\n      <h4 translate>Networking</h4>\n\n      <div class="detail">\n        <span class="info-label" translate>Hostname</span>\n        <span class="info-value">{{ contentHostFacts.network.hostname }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>IPv4 Address</span>\n        <span class="info-value">{{ contentHostFacts.network.ipv4_address }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>IPv6 Address</span>\n        <span class="info-value">{{ contentHostFacts.network.ipv6_address }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Interfaces</span>\n        <div class="info-value">\n          <div ng-repeat="(interfaceName, interface) in contentHostFacts.net.interface" >\n            <i ng-class="{\'icon-plus\': !expanded, \'icon-minus\': expanded}" class="expand-icon"\n               ng-hide="editMode" ng-click="expanded = !expanded"></i>\n            {{ interfaceName }}\n            <div class="sub-detail" ng-show="expanded">\n              <div ng-repeat="(key, value) in interface">\n                <span class="info-sub-label">{{ key.replace("_", " ") }}:</span>\n                <span class="info-sub-value">{{ value }}</span>\n              </div>\n            </div>\n          </div>\n        </div>\n      </div>\n\n      <div class="divider"></div>\n    </section>\n\n    <section class="custom-information">\n      <h4 translate>Custom Information</h4>\n\n      <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n      <span bst-edit-add-item="contentHost.customInfo"\n            ng-show="perimtted(\'edit_content_hosts\', contentHost)"\n            on-add="addCustomInfo(value)">\n      </span>\n      <p translate ng-show="contentHost.customInfo.length == 0">\n        You don\'t have any custom information, add some above\n      </p>\n      <div class="existing-items" ng-show="contentHost.customInfo.length > 0">\n        <h5 translate>Existing Items</h5>\n        <input type="text" ng-model="searchTerm" placeholder="{{ \'Filter\' | translate }}"/>\n        <div class="details-container">\n          <div class="detail" ng-repeat="customInfo in contentHost.customInfo | filter:searchTerm">\n            <span class="info-label">{{ customInfo.keyname }}</span>\n          <span class="info-value"\n                bst-edit-text="customInfo.value"\n                on-save="saveCustomInfo(customInfo)"\n                readonly="denied(\'edit_content_hosts\', contentHost)"\n                deletable="true"\n                on-delete="deleteCustomInfo(customInfo)">\n          </span>\n          </div>\n        </div>\n      </div>\n    </section>\n  </div>\n\n  <div class="advanced-info" ng-show="hasAdvancedInfo">\n    <header class="details-sub-header">\n       <h3>\n        <i class="expand-icon" ng-class="{\'icon-plus\': !showAdvanced, \'icon-minus\': showAdvanced}"\n           ng-click="showAdvanced = !showAdvanced"></i>\n         <span translate>Advanced Information</span>\n       </h3>\n    </header>\n    <div ng-show="showAdvanced" class="details fl">\n      <section ng-show="showAdvanced" ng-repeat="(sectionName, subSection) in advancedInfoLeft">\n        <h4>{{ sectionName }}</h4>\n        <div ng-repeat="(key, value) in subSection track by $index" >\n          <div ng-include="getTemplateForType(value)"></div>\n        </div>\n        <div class="divider" ng-show="!$last"></div>\n      </section>\n    </div>\n    <div ng-show="showAdvanced" class="details fr">\n      <section ng-show="showAdvanced" ng-repeat="(sectionName, subSection) in advancedInfoRight">\n        <h4>{{ sectionName }}</h4>\n        <div ng-repeat="(key, value) in subSection track by $index" >\n          <div ng-include="getTemplateForType(value)"></div>\n        </div>\n        <div class="divider" ng-show="!$last"></div>\n      </section>\n    </div>\n  </div>\n</section>\n'
)}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/content-host-products.html",'<div alert type="\'info\'">\n  {{ "Below are the repository content sets currently available for this content host through its subscriptions. For Red Hat subscriptions, additional content can be made available through the" | translate}}\n  <a ng-href="/katello/providers/redhat_provider" translate>Red Hat Repositories page</a>.\n  {{ "Changing default settings requires subscription-manager version 1.10 or newer to be installed on this host." | translate }}\n</div>\n\n<div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n<div class="loading-mask loading-mask-panel" ng-show="displayArea.working">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<div class="details details-full pull-left">\n  <section>\n    <div ng-hide="displayArea.isAvailableContent" translate>\n      This Content Host is not attached to any subscriptions that provide content\n    </div>\n\n    <div ng-repeat="product in products" ng-hide="product.available_content.length < 1"\n         ng-controller="ContentHostProductDetailsController" ng-init="productDetails(product)">\n      <i ng-class="{\'icon-plus\': !expanded, \'icon-minus\': expanded}" class="expand-icon"\n         ng-click="expanded = !expanded">\n        <b>{{ product.name }}</b>\n      </i>\n\n      <div class="row" ng-show="expanded">\n        <div class="col-md-11 col-md-offset-1" ng-show="details.available_content.length < 1"\n             translate>\n          No repository content.\n        </div>\n\n        <div class="col-md-11 col-md-offset-1" ng-repeat="content in product.available_content">\n          <h4><u>{{ content.content.name }}</u></h4>\n\n          <div class="detail row">\n            <span class="col-sm-4" translate>Enabled?</span>\n            <span class="col-sm-3"\n                  bst-edit-select="content.enabledText"\n                  readonly="denied(\'edit_content_hosts\', contentHost)"\n                  selector="content.overrideEnabled"\n                  options="overrideEnableChoices(content)"\n                  on-save="saveContentOverride(content)">\n            </span>\n          </div>\n        </div>\n      </div>\n    </div>\n  </section>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/content-host-provisioning-info.html",'<span page-title ng-model="contentHost">{{ \'Content Host\' | translate }} {{ contentHost.name }}</span>\n\n<section>\n  <div class="details fl">\n\n    <section ng-show="!contentHost.host">\n      <div translate>No provisioning details are available for this content host.</div>\n    </section>\n\n    <section ng-hide="!contentHost.host">\n\n      <h4 translate>Provisioning Host Details</h4>\n\n      <div class="detail">\n        <span class="info-label" translate>Name</span>\n        <span class="info-value">\n          <a href="/hosts/{{ contentHost.host.name }}">\n            {{ contentHost.host.name }}\n          </a>\n        </span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Status</span>\n        <span class="info-value">\n          <i class="icon-circle provisioning-status" ng-class="contentHostTable.getProvisioningStatusColor(contentHost.host.status)"></i>\n          {{ contentHost.host.status | translate }}\n        </span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Operating System</span>\n        <span class="info-value">{{ contentHost.host.operatingsystem.description }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Puppet Environment</span>\n        <span class="info-value">{{ contentHost.host.puppet_environment.name }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Last Puppet Report</span>\n        <span class="info-value">{{ contentHost.host.last_report | date:\'short\' }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Model</span>\n        <span class="info-value">{{ contentHost.host.model.name }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Host Group</span>\n        <span class="info-value">\n          <a href="/hostgroups/{{ contentHost.host.hostgroup.id }}-{{ contentHost.host.hostgroup.name }}/edit">\n            {{ contentHost.host.hostgroup.name }}\n          </a>\n        </span>\n      </div>\n\n    </section>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/content-host-subscriptions-list.html",'<section class="nutupane-sub-section" >\n\n  <div class="row">\n\n    <div class="col-sm-3">\n      <div class="input-group input-group">\n        <input type="text"\n               class="form-control"\n               placeholder="{{ \'Search...\' | translate }}"\n               ng-model="subscriptionsTable.searchTerm"\n               bst-on-enter="subscriptionsTable.search(subscriptionsTable.searchTerm)"/>\n        <span class="input-group-btn">\n          <button ng-click="subscriptionsTable.search(subscriptionsTable.searchTerm)" class="btn btn-default" type="button"><i class="icon-search"></i></button>\n        </span>\n      </div>\n    </div>\n\n    <div class="col-sm-3 nutupane-info">\n      <span translate>Showing {{ subscriptionsTable.rows.length }} of {{ subscriptionsTable.resource.subtotal }} ({{ subscriptionsTable.resource.total }} Total) Subscriptions</span>\n    </div>\n\n    <div class="fr">\n      <div class="fl nutupane-info">\n        <span translate>{{ subscriptionsTable.numSelected }} Selected</span>\n      </div>\n\n      <div ng-hide="system.readonly" class="nutupane-actions fr">\n         <button class="btn btn-primary"\n                 translate\n                 ng-hide="denied(\'edit_content_hosts\', contentHost)"\n                 ng-disabled="disableRemoveButton()"\n                 ng-click="removeSelected()">\n           Remove Selected\n         </button>\n      </div>\n    </div>\n  </div>\n\n  <div bst-table="subscriptionsTable" class="nutupane">\n    <div bst-container-scroll bst-infinite-scroll="subscriptionsTable.nextPage()">\n\n      <div class="loading-mask icon-3x" ng-show="subscriptionsTable.working && subscriptionsTable.rows.length == 0">\n        <i class="icon-spinner icon-spin"></i>\n        {{ "Loading..." | translate }}\n      </div>\n\n      <p class="alert alert-info" ng-show="subscriptionsTable.rows.length === 0" translate>\n        You currently don\'t have any Subscriptions associated with this Content Host, you can add Subscriptions after selecting the \'Add\' tab.\n      </p>\n\n      <table ng-class="{\'table-mask\': subscriptionsTable.working}" \n             class="table table-full table-striped"\n             ng-show="subscriptionsTable.rows.length > 0">\n        <thead>\n          <tr bst-table-head row-select>\n            <th bst-table-column="quantity" sortable class="align-center"><span translate>Quantity</span></th>\n            <th bst-table-column="attached" sortable><span translate>Attached</span></th>\n            <th bst-table-column="type"><span translate>Type</span></th>\n            <th bst-table-column="startDate" sortable><span translate>Starts</span></th>\n            <th bst-table-column="endDate" sortable><span translate>Expires</span></th>\n            <th bst-table-column="supportLevel"><span translate>Support Level</span></th>\n            <th bst-table-column="contractNumber" sortable><span translate>Contract</span></th>\n            <th bst-table-column="accountNumber" sortable><span translate>Account</span></th>\n          </tr>\n        </thead>\n\n        <tbody>\n          <tr bst-table-row  ng-repeat-start="(name, subscriptions) in groupedSubscriptions">\n            <td bst-table-cell colspan="8">\n              <a href=\'/subscriptions?search=productName:"{{ name }}"\'>\n                {{ name }}\n              </a>\n            </td>\n          </tr>\n          <tr bst-table-row ng-repeat-end ng-repeat="subscription in subscriptions" row-select="subscription">\n            <td bst-table-cell>{{ subscription | subscriptionAttachAmountFilter }}</td>\n            <td bst-table-cell>\n              <a ui-sref="subscriptions.details.info({subscriptionId: subscription.subscription_id})">\n                {{ subscription | subscriptionConsumedFilter }}\n              </a>\n            </td>\n            <td bst-table-cell><div subscription-type="subscription"></div></td>\n            <td bst-table-cell>{{ subscription.start_date | date:"shortDate" }}</td>\n            <td bst-table-cell>{{ subscription.end_date | date:"shortDate" }}</td>\n            <td bst-table-cell>{{ subscription.service_level }}</td>\n            <td bst-table-cell>{{ subscription.contract_number }}</td>\n            <td bst-table-cell>{{ subscription.account_number }}</td>\n          </tr>\n        </tbody>\n      </table>\n    </div>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/content-host-subscriptions.html",'<span page-title ng-model="contentHost">{{ \'Subscriptions for: \' | translate }} {{ contentHost.name }}</span>\n\n<button class="btn btn-primary fr"\n        ng-hide="denied(\'edit_content_hosts\', contentHost)"\n        ng-click="autoAttachSubscriptions()"\n        ng-disabled="subscription.workingMode">\n{{ "Run Auto-Attach" | translate }}\n</button>\n\n<span ng-show="subscription.workingMode">\n  <i class="icon-spinner inline-icon icon-spin fr"></i>\n  <span translate>Working</span>\n</span>\n\n<section class="details">\n  <h4 translate>Subscription Details</h4>\n  <div class="detail">\n    <span class="info-label" translate>Status</span>\n      <span class="info-value">\n        <i class="icon-circle" ng-class="contentHostTable.getStatusColor(contentHost.compliance.status)"></i>\n        {{ contentHost.compliance.status }}\n      </span>\n  </div>\n\n  <div ng-show="contentHost.compliance.reasons.length > 0" class="detail">\n    <span class="info-label" translate>Details</span>\n    <div class="info-value">\n      <ul class="compliance-reasons">\n        <li ng-repeat="reason in contentHost.compliance.reasons">{{ reason.attributes.name}} - {{ reason.message }}</li>\n      </ul>\n    </div>\n  </div>\n\n  <div class="detail">\n    <span class="info-label" translate>Auto-Attach</span>\n    <span class="info-value"\n          bst-edit-checkbox="contentHost.autoheal"\n          formatter="booleanToYesNo"\n          readonly="denied(\'edit_content_hosts\', contentHost)"\n          on-save="save(contentHost)">\n    </span>\n  </div>\n  <div class="detail">\n    <span class="info-label" translate>Service Level</span>\n        <span class="info-value"\n              bst-edit-select="contentHost.service_level"\n              readonly="denied(\'edit_content_hosts\', contentHost)"\n              selector="contentHost.service_level"\n              options="serviceLevels()"\n              options-format="option for option in options"\n              on-save="save(contentHost)">\n        </span>\n  </div>\n</section>\n\n<nav>\n  <ul class="nav nav-tabs" ng-show="permitted(\'attach_subscriptions\')">\n    <li ng-class="{active: isState(\'content-hosts.details.subscriptions.list\')}">\n      <a ui-sref="content-hosts.details.subscriptions.list">\n        <!-- TODO: other pages too - label "List" vs. "List/Remove" based on edit permissions -->\n        <span translate>\n          List/Remove\n        </span>\n      </a>\n    </li>\n\n    <li ng-class="{active: stateIncludes(\'content-hosts.details.subscriptions.add\')}">\n      <a ui-sref="content-hosts.details.subscriptions.add">\n        <span translate>\n          Add\n        </span>\n      </a>\n    </li>\n  </ul>\n</nav>\n\n<div ui-view></div>\n\n<!--\nhttp://projects.theforeman.org/issues/4253\n  <div ui-view></div>\n    <div class="filter-options">\n      <span class="filter-option">\n        <input type="checkbox"\n               id="subscriptions-match"\n               class="input"\n               ng-model="availableSubscriptionsTable.matchSystem"\n               ng-change="availableSubscriptionsTable.filterSubscriptions()"/>\n        <label for="subscriptions-match" translate>Subscriptions match system</label>\n      </span>\n      <span class="filter-option">\n        <input type="checkbox"\n               id="subscriptions-match-installed"\n               class="input"\n               ng-model="availableSubscriptionsTable.matchInstalled"\n               ng-change="availableSubscriptionsTable.filterSubscriptions()"/>\n        <label for="subscriptions-match-installed" translate>Subscriptions match installed software</label>\n      </span>\n\n      <span class="filter-option">\n        <input type="checkbox"\n               id="subscriptions-no-overlap"\n               class="input"\n               ng-model="availableSubscriptionsTable.noOverlap"\n               ng-change="availableSubscriptionsTable.filterSubscriptions()"/>\n        <label for="subscriptions-no-overlap" translate>No overlap with current</label>\n        </span>\n    </div>\n-->\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/content-host-tasks.html",'<div tasks-table  details-state="content-hosts.details.tasks.details"\n              known-context="contentHost,organization"\n              resource-type="Katello::System"\n              resource-id="{{ contentHost.id }}"/>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/host-collections-table.html",'<section class="nutupane-sub-section">\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <div class="row">\n\n    <div class="col-sm-3">\n      <div class="input-group">\n        <input type="text"\n               class="form-control"\n               placeholder="{{ \'Filter\' | translate }}"\n               ng-model="hostCollectionFilter"/>\n      </div>\n    </div>\n\n    <div class="fr select-action">\n      <span class="nutupane-info">\n        <span translate>{{ hostCollectionsTable.numSelected }} Selected</span>\n      </span>\n\n      <button ng-if="isState(\'content-hosts.details.host-collections.list\')"\n              class="btn btn-default"\n              ng-hide="denied(\'edit_content_hosts\', contentHost)"\n              ng-disabled="hostCollectionsTable.numSelected == 0 || hostCollectionsTable.working"\n              ng-click="removeHostCollections(contentHost)">\n        {{ \'Remove Selected\' | translate }}\n      </button>\n      <button ng-if="isState(\'content-hosts.details.host-collections.add\')"\n              class="btn btn-default"\n              ng-hide="denied(\'edit_content_hosts\', contentHost)"\n              ng-disabled="hostCollectionsTable.numSelected == 0 || hostCollectionsTable.working"\n              ng-click="addHostCollections(contentHost)">\n        {{ \'Add Selected\' | translate }}\n      </button>\n\n    </div>\n  </div>\n\n  <div bst-table="hostCollectionsTable" class="nutupane">\n    <div bst-container-scroll bst-infinite-scroll="hostCollectionsTable.nextPage()">\n\n      <div ng-show="hostCollectionsTable.rows.length == 0">\n        <div class="loading-mask" ng-show="hostCollectionsTable.working">\n          <i class="icon-spinner icon-spin"></i>\n          {{ "Loading..." | translate }}\n        </div>\n\n        <p class="alert alert-info" \n           ng-if="isState(\'content-hosts.details.host-collections.list\')"\n           ng-hide="hostCollectionsTable.working"\n           translate>No Host Collections to show, you can add Host Collections after selecting the \'Add\' tab.\n        </p>\n\n        <p class="alert alert-info" \n           ng-if="isState(\'content-hosts.details.host-collections.add\')"\n           ng-hide="hostCollectionsTable.working"\n           translate>No Host Collections to show, you can add Host Collections after selecting \'Host Collections\'\n                     under \'Hosts\' in main menu.\n        </p>\n      </div>\n\n      <table ng-show="hostCollectionsTable.rows.length > 0"\n             ng-class="{\'table-mask\': hostCollectionsTable.working}" class="table table-full table-striped">\n        <thead>\n          <tr bst-table-head row-select="hostCollection">\n            <th bst-table-column="name" translate>Name</th>\n            <th bst-table-column="description" translate>Description</th>\n            <th bst-table-column="capacity" translate>Capacity</th>\n          </tr>\n        </thead>\n\n        <tbody>\n          <tr bst-table-row ng-repeat="hostCollection in hostCollectionsTable.rows | filter:hostCollectionFilter" row-select="hostCollection">\n            <td bst-table-cell>\n              <a ui-sref="host-collections.details.info({hostCollectionId: hostCollection.id})">\n                {{ hostCollection.name }}\n              </a>\n            </td>\n            <td bst-table-cell>{{ hostCollection.description }}</td>\n            <td bst-table-cell>{{ hostCollection.total_content_hosts }} / {{ hostCollection.max_content_hosts | unlimitedFilter:hostCollection.unlimited_content_hosts }}</td>\n          </tr>\n        </tbody>\n      </table>\n    </div>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/host-collections.html",'<span page-title ng-model="contentHost">{{ \'Host Collections for:\' | translate }} {{ contentHost.name }}</span>\n\n<h4 translate>Host Collection Management</h4>\n<nav>\n  <ul class="nav nav-tabs" ng-show="permitted(\'edit_content_hosts\', contentHost)">\n    <li ng-class="{active: isState(\'content-hosts.details.host-collections.list\')}">\n      <a ui-sref="content-hosts.details.host-collections.list">\n        <span translate>List/Remove</span>\n      </a>\n    </li>\n\n    <li ng-class="{active: isState(\'content-hosts.details.host-collections.add\')}">\n      <a ui-sref="content-hosts.details.host-collections.add">\n        <span translate>Add</span>\n      </a>\n    </li>\n  </ul>\n</nav>\n\n<div ui-view></div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/partials/content-host-detail-object.html",'<div>\n  <div class="sub-detail">\n    <span class="info-label">{{ key.replace("_", " ") }}</span>\n    <div ng-repeat="(key, value) in value">\n      <div ng-include="getTemplateForType(value)"></div>\n    </div>\n  </div>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/details/views/partials/content-host-detail-value.html",'<div class="detail">\n  <span class="info-label">{{ key.replace("_", " ") }}</span>\n  <span class="info-value">{{ value }}</span>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/views/content-hosts-table-collapsed.html",'<table class="table table-striped table-bordered" ng-class="{\'table-mask\': contentHostTable.working}">\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column sortable><span translate>Name</span></th>\n    </tr>\n  </thead>\n\n  <div data-extend-template="layouts/select-all-results.html"></div>\n\n  <tbody>\n    <tr bst-table-row\n        ng-repeat="contentHost in contentHostTable.rows"\n        row-select="contentHost"\n        active-row="stateIncludes(\'content-hosts.details\', {contentHostId: contentHost.uuid})"\n        ng-controller="ContentHostStatusController">\n      <td bst-table-cell>\n        <span class="icon-circle" ng-class="contentHostTable.getStatusColor(contentHost.entitlementStatus)">\n        </span>\n        <a ui-sref="content-hosts.details.info({contentHostId: contentHost.uuid})">\n          {{ contentHost.name }}\n        </a>\n      </td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/views/content-hosts-table-full.html",'<p class="alert alert-info" ng-show="contentHostTable.rows.length === 0" translate>\n      You currently don\'t have any Content Hosts, you can register Content Hosts using the button on the right.\n</p>\n<table class="table table-striped table-bordered"\n       ng-class="{\'table-mask\': contentHostTable.working}"\n       ng-show="contentHostTable.rows.length > 0">\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column="name" sortable><span translate>Name</span></th>\n      <th bst-table-column="status">\n        {{ "Subscription Status" | translate }}\n      </th>\n      <th bst-table-column="status">\n        <span translate>Available Errata</span>\n      </th>\n      <th bst-table-column="os"><span translate>OS</span></th>\n      <th bst-table-column="environment" sortable><span translate>Environment</span></th>\n      <th bst-table-column="contentView"><span translate>Content View</span></th>\n      <th bst-table-column="registered"><span translate>Registered</span></th>\n      <th bst-table-column="lastCheckin" sortable><span translate>Last Checkin</span></th>\n    </tr>\n  </thead>\n\n  <div data-extend-template="layouts/select-all-results.html"></div>\n\n  <tbody>\n    <tr bst-table-row ng-repeat="contentHost in contentHostTable.rows" row-select="contentHost"\n        ng-controller="ContentHostStatusController">\n      <td bst-table-cell>\n        <a ui-sref="content-hosts.details.info({contentHostId: contentHost.uuid})">\n          {{ contentHost.name }}\n        </a>\n      </td>\n      <td bst-table-cell>\n        <span class="icon-circle" ng-class="contentHostTable.getStatusColor(contentHost.entitlementStatus)">\n        </span>\n      </td>\n      <td>\n        <a ui-sref="content-hosts.details.errata.index({contentHostId: contentHost.uuid})">\n          <span class="aligned-errata-count" errata-counts="contentHost.errata_counts"></span>\n        </a>\n      </td>\n      <td bst-table-cell>{{ contentHost.distribution }}</td>\n      <td bst-table-cell>{{ contentHost.environment.name }}</td>\n      <td bst-table-cell>{{ contentHost.content_view.name || "" }}</td>\n      <td bst-table-cell>{{ contentHost.created | date:\'short\' }}</td>\n      <td bst-table-cell>{{ (contentHost.checkin_time | date:\'short\') || ("Never checked in" | translate) }}</td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/views/content-hosts.html",'<span page-title>{{ \'Content Hosts\' | translate }}</span>\n\n<div data-extend-template="layouts/nutupane.html">\n\n  <div data-block="header">\n    {{ \'Content Hosts\' | translate }}\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-default"\n            ng-show="permitted(\'edit_content_hosts\') || permitted(\'destroy_content_hosts\')"\n            ui-sref="content-hosts.bulk-actions.packages">\n      <i class="icon-group leading-icon"></i>\n      {{ "Bulk Actions" | translate }}\n    </button>\n\n    <button class="btn btn-primary"\n            ng-show="permitted(\'create_content_hosts\')"\n            ui-sref="content-hosts.register">\n      <i class="icon-signin leading-icon"></i>\n      {{ "Register Content Host" | translate }}\n    </button>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-hosts/views/register.html",'<span page-title>{{ \'Register a Content Host\' | translate }}</span>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="details-header new-header">\n    <h2 class="fl" translate>Content Host Registration</h2>\n\n    <div class="fr">\n      <button class="btn btn-default" ui-sref="content-hosts.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <p translate>To register a content host to this server, run the following commands within a console on the client host.</p>\n\n  <p translate>Install the pre-built bootstrap RPM. This will configure the host to use this server.</p>\n\n  <pre>rpm -Uvh {{ baseURL }}/pub/{{ consumerCertRPM }}</pre>\n\n  <p translate>Use Subscription Manager to register.</p>\n\n  <pre><code>subscription-manager register --org="{{ organization.label }}" --environment="Library"</code></pre>\n\n  <p translate>Use an Activation Key to register.</p>\n\n  <pre><code>subscription-manager register --org="{{ organization.label }}" --activationkey="activationkey1"</code></pre>\n\n  <div ng-show="capsules.results.length > 0">\n    <p>\n      <h5 translate>Consuming Content From a Capsule</h5>\n      {{ "Selected Capsule:" | translate }}\n      <select ng-model="selectedCapsule"\n              ng-options="capsule.url for capsule in capsules.results">\n      </select>\n\n      <pre ng-show="selectedCapsule"><code>subscription-manager register --org="{{ organization.label }}" --baseurl="https://{{ hostname(selectedCapsule.url) }}/pulp/repos"</code></pre>\n    </p>\n  </div>\n</section>\n')}]),angular.module("Bastion.subscriptions",["ngResource","ui.router","Bastion","Bastion.organizations","Bastion.components","Bastion.components.formatters"]),angular.module("Bastion.subscriptions").config(["$stateProvider",function($stateProvider){$stateProvider.state("subscriptions",{"abstract":!0,controller:"SubscriptionsController",templateUrl:"subscriptions/views/subscriptions.html"}),$stateProvider.state("subscriptions.index",{url:"/subscriptions",permission:"view_subscriptions",views:{table:{templateUrl:"subscriptions/views/subscriptions-table-full.html"}}}).state("subscriptions.details",{"abstract":!0,url:"/subscriptions/:subscriptionId",permission:"view_subscriptions",collapsed:!0,views:{table:{templateUrl:"subscriptions/views/subscriptions-table-collapsed.html"},"action-panel":{controller:"SubscriptionDetailsController",templateUrl:"subscriptions/details/views/subscription-details.html"}}}).state("subscriptions.details.info",{url:"/info",permission:"view_subscriptions",collapsed:!0,templateUrl:"subscriptions/details/views/subscription-info.html"}).state("subscriptions.details.products",{url:"/products",permission:"view_subscriptions",collapsed:!0,controller:"SubscriptionProductsController",templateUrl:"subscriptions/details/views/subscription-products.html"}).state("subscriptions.details.associations-activation-keys",{url:"/associations/activation-keys",permission:"view_subscriptions",collapsed:!0,controller:"SubscriptionAssociationsActivationKeysController",templateUrl:"subscriptions/details/views/subscription-associations-activation-keys.html"}).state("subscriptions.details.associations-content-hosts",{url:"/associations/content-hosts",permission:"view_subscriptions",collapsed:!0,controller:"SubscriptionAssociationsContentHostsController",templateUrl:"subscriptions/details/views/subscription-associations-content-hosts.html"}).state("subscriptions.manifest",{"abstract":!0,collapsed:!0,views:{table:{templateUrl:"subscriptions/views/subscriptions-table-collapsed.html"},"action-panel":{controller:"ManifestController",templateUrl:"subscriptions/manifest/views/manifest.html"}}}).state("subscriptions.manifest.import",{url:"/subscriptions/manifest/import",permission:"import_subscriptions",collapsed:!0,controller:"ManifestImportController",templateUrl:"subscriptions/manifest/views/manifest-import.html"}).state("subscriptions.manifest.details",{url:"/subscriptions/manifest/details",permission:"import_subscriptions",collapsed:!0,controller:"ManifestDetailsController",templateUrl:"subscriptions/manifest/views/manifest-details.html"}).state("subscriptions.manifest.history",{url:"/subscriptions/manifest/history",permission:"import_subscriptions",collapsed:!0,controller:"ManifestHistoryController",templateUrl:"subscriptions/manifest/views/manifest-import-history.html"})}]),angular.module("Bastion.subscriptions").controller("SubscriptionAssociationsActivationKeysController",["$scope","$q","translate","Subscription",function($scope,$q,translate,Subscription){$scope.activationKeys?$scope.working=!1:$scope.working=!0,Subscription.get({id:$scope.$stateParams.subscriptionId},function(subscription){$scope.activationKeys=subscription.activation_keys,$scope.working=!1})}]),angular.module("Bastion.subscriptions").controller("SubscriptionAssociationsContentHostsController",["$scope","translate","Subscription","ContentHostsHelper",function($scope,translate,Subscription,ContentHostsHelper){$scope.contentHosts?$scope.working=!1:$scope.working=!0,Subscription.get({id:$scope.$stateParams.subscriptionId},function(subscription){$scope.contentHosts=subscription.systems,$scope.working=!1}),$scope.getStatusColor=ContentHostsHelper.getStatusColor,$scope.memory=ContentHostsHelper.memory,$scope.virtual=function(facts){return facts.virt===undefined||facts.virt.is_guest===undefined?!1:facts.virt.is_guest===!0||facts.virt.is_guest==="true"}}]),angular.module("Bastion.subscriptions").controller("SubscriptionDetailsController",["$scope","translate","Subscription",function($scope,translate,Subscription){$scope.subscription?$scope.panel={loading:!1}:$scope.panel={loading:!0},$scope.subscription=Subscription.get({id:$scope.$stateParams.subscriptionId},function(){$scope.panel.loading=!1}),$scope.subscriptionLimits=function(subscription){var limits=[];return subscription.sockets&&limits.push(translate("Sockets: %s").replace("%s",subscription.sockets)),subscription.cores&&limits.push(translate("Cores: %s").replace("%s",subscription.cores)),subscription.ram&&limits.push(translate("RAM: %s GB").replace("%s",subscription.ram)),limits.length>0?limits.join(", "):""}}]),angular.module("Bastion.subscriptions").controller("SubscriptionProductDetailsController",["$scope",function($scope){$scope.expanded=!0}]),angular.module("Bastion.subscriptions").controller("SubscriptionProductsController",["$scope","$state","Subscription","Product","CurrentOrganization",function($scope,$state,Subscription,Product,CurrentOrganization){$scope.displayArea={working:!0},Product.queryUnpaged({organization_id:CurrentOrganization,subscription_id:$scope.$stateParams.subscriptionId,enabled:!0},function(response){$scope.products=response.results,$scope.displayArea.working=!1})}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/details/views/subscription-associations-activation-keys.html",'<span page-title ng-model="subscription">{{ \'Activation Keys for Subscription:\' | translate }} {{ subscription.product_name }}</span>\n\n<div class="details details-full">\n\n  <h3 translate>\n    Included in Activation Keys\n  </h3>\n\n  <table class="table table-striped" bst-table="table" ng-class="{\'table-mask\': working}">\n    <thead>\n      <tr bst-table-head>\n        <th bst-table-column="name" sortable><span translate>Name</span></th>\n        <th bst-table-column="environment"><span translate>Environment</span></th>\n        <th bst-table-column="contentView"><span translate>Content View</span></th>\n        <th bst-table-column="contentView"><span translate>Service Level</span></th>\n        <th bst-table-column="contentView"><span translate>Release Version</span></th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr ng-show="!working && activationKeys.length === 0">\n        <td colspan="5" translate>This subscription is not associated with any activation keys.</td>\n      </tr>\n\n      <tr ng-show="working">\n        <td colspan="5" translate>\n          <div class="loading-mask icon-3x" ng-show="working">\n            <i class="icon-spinner icon-spin"></i>\n            {{ "Loading..." | translate }}\n          </div>\n        </td>\n      </tr>\n\n      <tr bst-table-row ng-repeat="activationKey in activationKeys">\n        <td bst-table-cell>\n          <a ui-sref="activation-keys.details.info({activationKeyId: activationKey.id})">\n            {{ activationKey.name }}\n          </a>\n        </td>\n        <td bst-table-cell>{{ activationKey.environment.name || "" }}</td>\n        <td bst-table-cell>{{ activationKey.content_view.name || "" }}</td>\n        <td bst-table-cell>{{ activationKey.service_level || "" }}</td>\n        <td bst-table-cell>{{ activationKey.release_version || "" }}</td>\n      </tr>\n    </tbody>\n  </table>\n\n</div>\n'
)}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/details/views/subscription-associations-content-hosts.html",'<span page-title ng-model="subscription">{{ \'Content Hosts for Subscription:\' | translate }} {{ subscription.name }}</span>\n\n<div class="details details-full">\n\n  <h3 translate>\n    Attached to Content Hosts\n  </h3>\n\n  <table class="table table-striped" bst-table="table" ng-class="{\'table-mask\': working}">\n    <thead>\n      <tr bst-table-head>\n        <th bst-table-column="name" sortable><span translate>Name</span></th>\n        <th bst-table-column="status">\n          {{ "Subscription Status" | translate }}\n        </th>\n        <th bst-table-column="virtual"><span translate>Virtual</span></th>\n        <th bst-table-column="environment" sortable><span translate>Environment</span></th>\n        <th bst-table-column="contentView"><span translate>Content View</span></th>\n        <th bst-table-column="serviceLevel"><span translate>Service Level</span></th>\n        <th bst-table-column="sockets"><span translate>Sockets</span></th>\n        <th bst-table-column="cores"><span translate>Cores per Socket</span></th>\n        <th bst-table-column="memory"><span translate>RAM (GB)</span></th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr ng-show="!working && contentHosts.length === 0">\n        <td colspan="9" translate>This subscription is not attached to any content hosts.</td>\n      </tr>\n\n      <tr ng-show="working">\n        <td colspan="9" translate>\n          <div class="loading-mask icon-3x" ng-show="working">\n            <i class="icon-spinner icon-spin"></i>\n            {{ "Loading..." | translate }}\n          </div>\n        </td>\n      </tr>\n\n      <tr bst-table-row ng-repeat="contentHost in contentHosts"\n          ng-controller="ContentHostStatusController">\n        <td bst-table-cell>\n          <a ui-sref="content-hosts.details.info({contentHostId: contentHost.uuid})">\n            {{ contentHost.name }}\n          </a>\n        </td>\n        <td bst-table-cell>\n          <span class="icon-circle" ng-class="getStatusColor(contentHost[\'entitlement_status\'])">\n          </span>\n        </td>\n        <td bst-table-cell>{{ virtual(contentHost.facts) | booleanToYesNo }}</td>\n        <td bst-table-cell>{{ contentHost.environment.name }}</td>\n        <td bst-table-cell>{{ contentHost.content_view.name || "" }}</td>\n        <td bst-table-cell>{{ contentHost.service_level }}</td>\n        <td bst-table-cell>{{ contentHost.facts.cpu[\'cpu_socket(s)\'] }}</td>\n        <td bst-table-cell>{{ contentHost.facts.cpu[\'core(s)_per_socket\'] }}</td>\n        <td bst-table-cell>{{ memory(contentHost.facts) }}</td>\n      </tr>\n    </tbody>\n  </table>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/details/views/subscription-details.html",'<div class="loading-mask loading-mask-panel" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="details-header">\n    <h2 class="pull-left">{{ subscription.product_name }}</h2>\n\n    <div class="fr">\n      <button class="btn btn-default" ui-sref="subscriptions.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n\n  </header>\n\n  <nav>\n    <ul class="nav nav-tabs">\n      <li ng-class="{active: isState(\'subscriptions.details.info\')}">\n        <a translate ui-sref="subscriptions.details.info({subscriptionId: subscription.id})">\n          Details\n        </a>\n      </li>\n      <li ng-class="{active: stateIncludes(\'subscriptions.details.products\')}">\n        <a translate ui-sref="subscriptions.details.products({subscriptionId: subscription.id})">\n          Product Content\n        </a>\n      </li>\n      <li class="dropdown"\n          ng-class="{active: stateIncludes(\'subscriptions.details.associations-activation-keys\') || stateIncludes(\'subscriptions.details.associations-content-hosts\')}">\n        <a class="dropdown-toggle">\n          <span translate>Associations</span>\n          <i class="icon-chevron-down"></i>\n        </a>\n        <ul class="dropdown-menu">\n          <li>\n            <a ui-sref="subscriptions.details.associations-activation-keys({subscriptionId: subscription.id})" translate>\n              Activation Keys\n            </a>\n          </li>\n          <li>\n            <a ui-sref="subscriptions.details.associations-content-hosts({subscriptionId: subscription.id})" translate>\n              Content Hosts\n            </a>\n          </li>\n        </ul>\n      </li>\n    </ul>\n  </nav>\n\n  <section class="nutupane-sub-section" ui-view></section>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/details/views/subscription-info.html",'<div class="details-full pull-left">\n  <section>\n    <h4 translate>Subscription Info</h4>\n\n    <div class="detail">\n      <span class="info-label" translate>Name</span>\n      <span class="info-value">{{ subscription.product_name }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Description</span>\n      <span class="info-value">{{ subscription.description }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Consumed</span>\n      <span class="info-value">{{ subscription | subscriptionConsumedFilter }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Starts</span>\n      <span class="info-value">{{ subscription.start_date | date:"short" }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Ends</span>\n      <span class="info-value">{{ subscription.end_date | date:"short" }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Product ID</span>\n      <span class="info-value">{{ subscription.product_id }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Contract Number</span>\n      <span class="info-value">{{ subscription.contract_number }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Account Number</span>\n      <span class="info-value">{{ subscription.account_number }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Support Level</span>\n      <span class="info-value">{{ subscription.support_level }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Support Type</span>\n      <span class="info-value">{{ subscription.support_type }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Architecture(s)</span>\n      <span class="info-value">{{ subscription.arch }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Type</span>\n      <span class="info-value"><div subscription-type="subscription"></div></span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Limits</span>\n      <span class="info-value">{{ subscriptionLimits(subscription) }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Multi-entitlement</span>\n      <span class="info-value">{{ subscription.multi_entitlement | booleanToYesNo }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Instance-based</span>\n      <span class="info-value">{{ formatInstanceBased(subscription) }}</span>\n    </div>\n\n    <div class="detail" ng-hide="subscription.stacking_id == \'\'">\n      <span class="info-label" translate>Stacking ID</span>\n      <span class="info-value">{{ subscription.stacking_id }}</span>\n    </div>\n\n    <div class="detail" ng-hide="subscription.source_pool_id == undefined || subscription.source_pool_id == \'\'">\n      <span class="info-label" translate>Virtual Guest From</span>\n      <span class="info-value">{{ subscription.product_name }}</span>\n    </div>\n\n    <div class="detail" ng-hide="subscription.host_id == undefined || subscription.host_id == \'\'">\n      <span class="info-label" translate>Required Host</span>\n      <span class="info-value">{{ subscription.host.name }}</span>\n    </div>\n  </section>\n\n  <section ng-show="subscription.provided_products.length > 0" class="subscription-products">\n    <h4 translate>Provided Products</h4>\n    <div class="detail" ng-repeat="product in subscription.provided_products">\n      <div class="product">{{ product.name }}</div>\n    </div>\n  </section>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/details/views/subscription-products.html",'<div alert type="\'info\'">\n  {{ "Below are the product\'s repository content sets currently available for this subscription. For Red Hat subscriptions, additional content can be made available through the" | translate}}\n  <a ng-href="/katello/providers/redhat_provider" translate>Red Hat Repositories page</a>.\n</div>\n\n<div class="loading-mask loading-mask-panel" ng-show="displayArea.working">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<div class="details details-full pull-left">\n  <section>\n    <div ng-show="products.length < 1" translate>\n      No repository content provided through this subscription.\n    </div>\n\n    <div ng-repeat="product in products" ng-hide="product.available_content.length < 1"\n         ng-controller="SubscriptionProductDetailsController">\n      <i ng-class="{\'icon-plus\': !expanded, \'icon-minus\': expanded}"\n         class="expand-icon" ng-click="expanded = !expanded"></i>\n      <b>{{ product.name }}</b>\n\n      <div ng-show="expanded">\n        <div ng-show="details.available_content.length < 1" translate>\n          No repository content.\n        </div>\n\n        <div ng-repeat="content in product.available_content">\n          <h4><u>{{ content.content.name }}</u></h4>\n\n          <div class="detail">\n            <span class="info-label" translate>Content Download URL</span>\n            <span class="info-value">{{ content.content.contentUrl }}</span>\n          </div>\n\n          <div class="detail">\n            <span class="info-label" translate>GPG Key URL</span>\n            <span class="info-value">{{ content.content.gpgUrl }}</span>\n          </div>\n\n          <div class="detail">\n            <span class="info-label" translate>Repo Type</span>\n            <span class="info-value">{{ content.content.type }}</span>\n          </div>\n\n          <div class="detail">\n            <span class="info-label" translate>Enabled?</span>\n            <span class="info-value">{{ content.enabled | booleanToYesNo }}</span>\n          </div>\n        </div>\n      </div>\n    </div>\n  </section>\n</div>\n')}]),angular.module("Bastion.subscriptions").controller("ManifestDetailsController",["$scope","$q","CurrentOrganization","Organization",function($scope,$q,CurrentOrganization,Organization){$scope.organization=Organization.get({id:CurrentOrganization}),$q.all([$scope.organization.$promise]).then(function(){$scope.details=$scope.organization.owner_details,$scope.upstream=$scope.details.upstreamConsumer,angular.forEach($scope.redhatProvider.owner_imports,function(value){value.upstreamId===$scope.upstream.uuid&&($scope.manifestImport=value)}),$scope.panel.loading=!1})}]),angular.module("Bastion.subscriptions").controller("ManifestHistoryController",["$scope","Subscription",function($scope,Subscription){$scope.histories=Subscription.manifestHistory(),$scope.histories.$promise.then(function(result){$scope.statuses=result,$scope.panel.loading=!1})}]),angular.module("Bastion.subscriptions").controller("ManifestImportController",["$scope","$q","translate","CurrentOrganization","Organization","Task","Subscription",function($scope,$q,translate,CurrentOrganization,Organization,Task,Subscription){function buildManifestLink(upstream){var url=upstream.webUrl,upstreamId=upstream.uuid;return url.match(/^http/)||(url="https://"+url),url.match(/\/$/)||(url+="/"),url+=upstreamId,url}function initializeManifestDetails(organization){$scope.details=organization.owner_details,$scope.upstream=$scope.details.upstreamConsumer,_.isNull($scope.upstream)||($scope.manifestLink=buildManifestLink($scope.upstream),$scope.manifestName=$scope.upstream.name||$scope.upstream.uuid)}$scope.uploadErrorMessages=[],$scope.progress={uploading:!1},$scope.uploadURL="/katello/api/v2/organizations/"+CurrentOrganization+"/subscriptions/upload",$scope.organization=Organization.get({id:CurrentOrganization}),$q.all([$scope.organization.$promise]).then(function(){$scope.panel.loading=!1,initializeManifestDetails($scope.organization)}),$scope.$on("$destroy",function(){$scope.unregisterSearch()}),$scope.unregisterSearch=function(){Task.unregisterSearch($scope.searchId),$scope.searchId=undefined},$scope.handleTaskErrors=function(task,errorMessage){var errorMessageWithDetails=errorMessage;if(task.result==="error"||task.result==="warning")task.humanized.output&&task.humanized.output.length>0&&(errorMessageWithDetails+=" "+task.humanized.output),$scope.errorMessages.push(errorMessageWithDetails),$scope.histories=Subscription.manifestHistory()},$scope.updateTask=function(task){$scope.task=task,$scope.task.pending||($scope.unregisterSearch(),$scope.task.result==="success"?($scope.refreshOrganizationInfo(),$scope.successMessages.push(translate("Manifest successfully imported.")),$scope.refreshTable()):$scope.handleTaskErrors(task,translate("Error importing manifest.")))},$scope.deleteManifest=function(){Subscription.deleteManifest(function(returnData){$scope.deleteTask=returnData,$scope.searchId=Task.registerSearch({type:"task",task_id:$scope.deleteTask.id},$scope.deleteManifestTask)},function(response){$scope.saveError=!0,$scope.errors=response.data.errors})},$scope.deleteManifestTask=function(task){$scope.deleteTask=task,$scope.deleteTask.pending||($scope.unregisterSearch(),$scope.deleteTask.result==="success"?($scope.saveSuccess=!0,$scope.successMessages.push(translate("Manifest successfully deleted.")),$scope.refreshTable(),$scope.refreshOrganizationInfo()):$scope.handleTaskErrors(task,translate("Error deleting manifest.")))},$scope.refreshOrganizationInfo=function(){$scope.organization=Organization.get({id:CurrentOrganization}),$q.all([$scope.organization.$promise]).then(function(){initializeManifestDetails($scope.organization)}),$scope.histories=Subscription.manifestHistory()},$scope.refreshManifest=function(){Subscription.refreshManifest(function(returnData){$scope.refreshTask=returnData,$scope.searchId=Task.registerSearch({type:"task",task_id:$scope.refreshTask.id},$scope.refreshManifestTask)},function(response){$scope.saveError=!0,$scope.errors=response.data.errors})},$scope.refreshManifestTask=function(task){$scope.refreshTask=task,$scope.refreshTask.pending||($scope.unregisterSearch(),$scope.refreshTask.result==="success"?($scope.saveSuccess=!0,$scope.successMessages.push(translate("Manifest successfully refreshed.")),$scope.refreshTable(),$scope.refreshOrganizationInfo()):$scope.handleTaskErrors(task,translate("Error refreshing manifest.")))},$scope.saveCdnUrl=function(organization){var deferred=$q.defer();return organization.$update(function(response){deferred.resolve(response),$scope.successMessages.push(translate("Repository URL updated")),$scope.refreshTable(),$scope.refreshOrganizationInfo()},function(response){deferred.reject(response),angular.forEach(response.data.errors,function(errorMessage){$scope.errorMessages.push(translate("An error occurred saving the URL: ")+errorMessage)})}),deferred.promise},$scope.uploadManifest=function(content){var returnData;if(content){try{returnData=JSON.parse(angular.element(content).html())}catch(err){returnData=content}returnData||(returnData=content),returnData!==null&&returnData.errors===undefined?($scope.task=returnData,$scope.searchId=Task.registerSearch({type:"task",task_id:$scope.task.id},$scope.updateTask)):$scope.uploadErrorMessages=[translate("Error during upload: ")+returnData.displayMessage],$scope.progress.uploading=!1}},$scope.histories=Subscription.manifestHistory(),$scope.showHistoryMoreLink=!1,$scope.truncateHistories=function(histories){var numToDisplay=4,result=[];return angular.forEach(histories,function(history,index){index<numToDisplay&&result.push(history)}),result},$scope.isTruncated=function(subset,set){return subset.length<set.length},$scope.$watch("histories",function(changes){changes.$promise.then(function(results){$scope.statuses=$scope.truncateHistories(results),$scope.showHistoryMoreLink=$scope.isTruncated($scope.statuses,results)})})}]),angular.module("Bastion.subscriptions").controller("ManifestController",["$scope",function($scope){$scope.panel={loading:!0}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/manifest/views/manifest-details.html",'<div class="details pull-left">\n  <section>\n    <h4 translate>Subscription Details</h4>\n\n    <div class="detail">\n      <span class="info-label" translate>Upstream Subscription</span>\n      <span class="info-value">{{ upstream.name }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Upstream Type</span>\n      <span class="info-value">{{ upstream.type.label }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Upstream User</span>\n      <span class="info-value">{{ manifestImport.generatedBy }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Generated On</span>\n      <span class="info-value">{{ manifestImport.generatedDate | date:"short" }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Last Updated</span>\n      <span class="info-value">{{ upstream.updated | date:"short" }}</span>\n    </div>\n\n  </section>\n\n  <section>\n    <h4 translate>Subscription Server Details</h4>\n\n    <div class="detail">\n      <span class="info-label" translate>Rules Source</span>\n      <span class="info-value">{{ redhatProvider.rules_source }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Rules Version</span>\n      <span class="info-value">{{ redhatProvider.rules_version }}</span>\n    </div>\n\n  </section>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/manifest/views/manifest-import-history.html",'<table class="table table-striped manifest-history">\n  <thead>\n    <tr>\n      <th translate>Message</th>\n      <th translate>Time</th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr ng-repeat="status in statuses track by $index">\n        <td>\n          <i ng-class="status.status == \'FAILURE\' ? \'icon-warning-sign\' : \'icon-ok\'" />\n          {{ status.statusMessage }}\n        </td>\n        <td>{{ status.created | date:"short" }}</td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/manifest/views/manifest-import.html",'<section>\n  <div class="details">\n    <h4 translate>Red Hat Provider Details</h4>\n\n    <div class="detail">\n      <span class="info-label" translate>Red Hat CDN URL</span>\n      <span class="info-value"\n        bst-edit-text="organization.redhat_repository_url"\n        on-save="saveCdnUrl(organization)"\n        readonly="organization.readonly">\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Red Hat Docker Registry URL</span>\n      <span class="info-value"\n        bst-edit-text="organization.redhat_docker_registry_url"\n        on-save="saveCdnUrl(organization)"\n        readonly="organization.readonly">\n      </span>\n    </div>\n\n  </div>\n</section>\n\n<section>\n  <div class="details">\n    <h4 translate>Subscription Manifest</h4>\n\n    <div class="detail">\n      <span class="info-label" translate>Upstream Subscription Managment Application</span>\n      <span class="info-value" ng-show="upstream.uuid != undefined">\n        <a href="{{ manifestLink }}" target="_blank">{{ manifestName }}</a>\n      </span>\n      <span class="info-value" ng-show="upstream.uuid == undefined" translate>No subscription manifest imported</span>\n    </div>\n\n    <div class="detail pull-left" ng-show="upstream != null">\n      <button class="btn btn-default"\n              ng-hide="denied(\'delete_manifest\')"\n              ng-click="deleteManifest()">\n         <i class="icon-spinner icon-spin" ng-show="deleteTask.pending"></i>\n          <span ng-show="deleteTask.pending" translate>Deleting Manifest...</span>\n          <span ng-hide="deleteTask.pending" translate>Delete Manifest</span>\n      </button>\n      <button class="btn btn-default" ng-disabled="upstream.idCert == undefined || upstream.idCert.cert == undefined"\n        ng-click="refreshManifest()">\n         <i class="icon-spinner icon-spin" ng-show="refreshTask.pending"></i>\n          <span ng-show="refreshTask.pending" translate>Refreshing Manifest...</span>\n          <span ng-hide="refreshTask.pending" translate>Refresh Manifest</span>\n      </button>\n      <span ng-show="upstream.idCert == undefined || upstream.idCert.cert == undefined"\n        translate>\n        Refreshing manifest not suppported by this manifest.\n      </span>\n    </div>\n  </div>\n</section>\n\n<section>\n  <h4 translate>Upload New Manifest</h4>\n\n  <div bst-alert error-messages="uploadErrorMessages"></div>\n\n  <form role="form"\n        action="{{ uploadURL }}"\n        ng-upload="uploadManifest(content, completed)"\n        ng-hide="denied(\'import_manifest\')"\n        upload-options-enable-controls\n        upload-options-enable-rails-csrf>\n\n    <div class="control-group">\n      <div class="input">\n        <input type="file" name="content"/>\n      </div>\n    </div>\n\n    <div class="control-group">\n      <div class="control-button">\n        <button class="primary" upload-submit>\n          <i class="icon-spinner icon-spin" ng-show="task.pending"></i>\n          <span ng-show="task.pending" translate>Uploading...</span>\n          <span ng-hide="task.pending" translate>Upload</span>\n        </button>\n      </div>\n    </div>\n\n  </form>\n\n</section>\n\n<section>\n  <h4 translate>Manifest History</h4>\n\n  <div ng-include="\'subscriptions/manifest/views/manifest-import-history.html\'"></div>\n\n  <a ui-sref="subscriptions.manifest.history()" ng-show="showHistoryMoreLink" translate>More...</a>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/manifest/views/manifest.html",'<div class="loading-mask loading-mask-panel" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="details-header">\n    <h2 class="pull-left" translate>Subscription Manifest</h2>\n\n    <div class="fr">\n      <button class="btn btn-default" ui-sref="subscriptions.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <nav>\n    <ul class="nav nav-tabs">\n      <li ng-class="{active: isState(\'subscriptions.manifest.details\')}">\n        <a class="clickable"\n           translate\n           ui-sref="subscriptions.manifest.details()">\n          Details\n        </a>\n      </li>\n      <li ng-class="{active: stateIncludes(\'subscriptions.manifest.import\')}">\n        <a class="clickable"\n           translate\n           ui-sref="subscriptions.manifest.import()">\n          Actions\n        </a>\n      </li>\n      <li ng-class="{active: stateIncludes(\'subscriptions.manifest.history\')}">\n        <a class="clickable"\n           translate\n           ui-sref="subscriptions.manifest.history()">\n          Import History\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <section class="nutupane-sub-section" ui-view></section>\n\n</section>\n')}]),angular.module("Bastion.subscriptions").directive("subscriptionType",function(){return{restrict:"AE",scope:{subscription:"=subscriptionType"},templateUrl:"subscriptions/views/subscription-type.html"}}),angular.module("Bastion.subscriptions").filter("subscriptionAttachAmountFilter",["translate",function(translate){return function(subscription){var amount=subscription.amount;return!amount||amount<1?translate("Automatic"):amount}}]),angular.module("Bastion.subscriptions").filter("subscriptionConsumedFilter",["$filter","translate",function($filter,translate){return function(subscription){var quantity=$filter("unlimitedFilter")(subscription.quantity);return translate("%(consumed)s out of %(quantity)s").replace("%(consumed)s",subscription.consumed).replace("%(quantity)s",quantity)}}]),angular.module("Bastion.subscriptions").service("SubscriptionsHelper",function(){this.groupByProductName=function(rows){var grouped,offset,subscription;grouped={};for(offset=0;offset<rows.length;offset+=1)subscription=rows[offset],grouped[subscription.product_name]===undefined&&(grouped[subscription.product_name]=[]),grouped[subscription.product_name].push(subscription);return grouped},this.getSelectedSubscriptionAmounts=function(table){var selected,amount;return selected=[],angular.forEach(table.getSelected(),function(subscription){subscription.multi_entitlement?(amount=subscription.amount,amount||(amount=0)):amount=1,selected.push({id:subscription.id,quantity:amount})}),selected},this.getSelectedSubscriptions=function(table){var selected;return selected=[],angular.forEach(table.getSelected(),function(subscription){selected.push({id:subscription.id})}),selected}}),angular.module("Bastion.subscriptions").controller("SubscriptionsController",["$scope","$filter","$q","$location","translate","Nutupane","Subscription","Organization","CurrentOrganization","SubscriptionsHelper",function($scope,$filter,$q,$location,translate,Nutupane,Subscription,Organization,CurrentOrganization,SubscriptionsHelper){var params={organization_id:CurrentOrganization,search:$location.search().search||"",sort_by:"name",sort_order:"ASC",enabled:!0,paged:!0},nutupane=new Nutupane(Subscription,params);$scope.table=nutupane.table,$scope.refreshTable=nutupane.refresh,$scope.successMessages=[],$scope.errorMessages=[],$scope.table.closeItem=function(){$scope.transitionTo("subscriptions.index")},$scope.groupedSubscriptions={},$scope.$watch("table.rows",function(rows){$scope.groupedSubscriptions=SubscriptionsHelper.groupByProductName(rows)}),$scope.formatConsumed=function(subscription){var quantity=$filter("unlimitedFilter")(subscription.quantity);return translate("%(consumed)s out of %(quantity)s").replace("%(consumed)s",subscription.consumed).replace("%(quantity)s",quantity)},$scope.formatInstanceBased=function(subscription){return subscription.instance_multiplier===undefined||subscription.instance_multiplier===""||subscription.instance_multiplier===0?translate("No"):translate("Yes")},$scope.redhatProvider=Organization.redhatProvider(),$scope.subscriptions=Subscription.queryPaged(),$q.all([$scope.subscriptions.$promise]).then(function(){$scope.subscriptions.results.length<1&&$scope.transitionTo("subscriptions.manifest.import")})}]),angular.module("Bastion.subscriptions").factory("Subscription",["BastionResource","CurrentOrganization",function(BastionResource,CurrentOrganization){return BastionResource("/katello/api/v2/organizations/:org/subscriptions/:id/:action",{org:CurrentOrganization,id:"@id"},{deleteManifest:{method:"POST",url:"/katello/api/v2/organizations/:org/subscriptions/delete_manifest",params:{org:CurrentOrganization}},refreshManifest:{method:"PUT",url:"/katello/api/v2/organizations/:org/subscriptions/refresh_manifest",params:{org:CurrentOrganization}},manifestHistory:{method:"GET",url:"/katello/api/v2/organizations/:org/subscriptions/:action",params:{action:"manifest_history"},isArray:!0}})}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/views/subscription-type.html","\n<div ng-if=\"subscription.virt_only === false\">\n  {{ 'Physical' | translate }}\n</div>\n<div ng-if=\"subscription.virt_only === true && !subscription.host\">\n  {{ 'Virtual' | translate }}\n</div>\n<div ng-if=\"subscription.virt_only === true && subscription.host\">\n  <span translate> Guests of </span>\n  <a href='/content_hosts/{{ subscription.host.id }}/info' translate>\n    {{ subscription.host.name }}\n  </a>\n</div>\n")}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/views/subscriptions-delete-bulk.html","<form>\n  This will be the form to bulk delete subscriptions.\n</form>\n\n")}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/views/subscriptions-table-collapsed.html",'<table class="table table-striped table-full" ng-class="{\'table-mask\': table.working}">\n  <thead>\n    <tr bst-table-head>\n      <th bst-table-column sortable><span translate>Consumed</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row ng-repeat-start="(name, subscriptions) in groupedSubscriptions">\n      <td bst-table-cell>\n        <b>{{ name }}</b>\n      </td>\n    </tr>\n    <tr bst-table-row\n        ng-repeat-end\n        ng-repeat="subscription in subscriptions"\n        active-row="stateIncludes(\'subscriptions.details\', {subscriptionId: subscription.id})">\n      <td bst-table-cell>\n        <a ui-sref="subscriptions.details.info({subscriptionId: subscription.id})">\n          {{ formatConsumed(subscription) }}\n        </a>\n      </td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/views/subscriptions-table-full.html",'<p class="alert alert-info" ng-show="table.rows.length === 0" translate>\n  You currently don\'t have any Subscriptions, you can add Subscriptions by importing a manifest using the button on the right labeled \'Manage Manifest\'.\n</p>\n<table class="table table-striped" ng-class="{\'table-mask\': table.working}" ng-show="table.rows.length > 0">\n  <thead>\n    <tr bst-table-head>\n      <th bst-table-column="consumed" class="align-center"><span translate>Consumed</span></th>\n      <th bst-table-column="type"><span translate>Type</span></th>\n      <th bst-table-column="startDate"><span translate>Starts</span></th>\n      <th bst-table-column="endDate"><span translate>Expires</span></th>\n      <th bst-table-column="supportLevel"><span translate>Support Level</span></th>\n      <th bst-table-column="contractNumber"><span translate>Contract</span></th>\n      <th bst-table-column="accountNumber"><span translate>Account</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row ng-repeat-start="(name, subscriptions) in groupedSubscriptions">\n      <td bst-table-cell colspan="7">\n        <b>{{ name }}</b>\n      </td>\n    </tr>\n    <tr bst-table-row ng-repeat-end ng-repeat="subscription in subscriptions">\n      <td bst-table-cell>\n        <a ui-sref="subscriptions.details.info({subscriptionId: subscription.id})">\n          {{ subscription | subscriptionConsumedFilter }}\n        </a>\n      </td>\n      <td bst-table-cell><div subscription-type="subscription"></div></td>\n      <td bst-table-cell>{{ subscription.start_date | date:"shortDate" }}</td>\n      <td bst-table-cell>{{ subscription.end_date | date:"shortDate" }}</td>\n      <td bst-table-cell>{{ subscription.support_level }}</td>\n      <td bst-table-cell>{{ subscription.contract_number }}</td>\n      <td bst-table-cell>{{ subscription.account_number }}</td>\n    </tr>\n  </tbody>\n</table>\n'
)}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/subscriptions/views/subscriptions.html",'<span page-title>{{ \'Subscriptions\' | translate }}</span>\n\n<div data-extend-template="layouts/nutupane.html">\n\n  <div data-block="header">\n    {{ \'Subscriptions\' | translate }}\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-primary" ui-sref="subscriptions.manifest.import()"\n            ng-hide="denied(\'import_manifest\') && denied(\'delete_manifest\')">\n      {{ "Manage Manifest" | translate }}\n    </button>\n  </div>\n\n</div>\n')}]),angular.module("Bastion.content-views.versions",["ngResource","ui.router","Bastion","Bastion.components","Bastion.repositories","Bastion.packages","Bastion.errata","Bastion.package-groups","Bastion.puppet-modules"]),function(){"use strict";function ContentViewVersionContentController($scope,translate,Nutupane,Package,Erratum,PackageGroup,PuppetModule,Repository){var nutupane,contentTypes,currentState,params;currentState=$scope.$state.current.name.split(".").pop(),contentTypes={repositories:{type:Repository},packages:{type:Package},"package-groups":{type:PackageGroup,params:{sort_by:"name",sort_order:"DESC"}},errata:{type:Erratum},"puppet-modules":{type:PuppetModule}},params=angular.extend({content_view_version_id:$scope.$stateParams.versionId},contentTypes[currentState].params),nutupane=new Nutupane(contentTypes[currentState].type,params,"queryPaged"),nutupane.masterOnly=!0,$scope.nutupane=nutupane,$scope.detailsTable=nutupane.table,$scope.repository={name:translate("All Repositories"),id:"all"},$scope.repositories=[],$scope.version.$promise.then(function(version){$scope.repositories=version.repositories,$scope.repositories.unshift($scope.repository)}),$scope.$watch("repository",function(repository){var params=nutupane.getParams();repository.id==="all"?(params.repository_id=null,nutupane.setParams(params)):(params.repository_id=repository.id,nutupane.setParams(params)),nutupane.refresh()})}angular.module("Bastion.content-views.versions").controller("ContentViewVersionContentController",ContentViewVersionContentController),ContentViewVersionContentController.$inject=["$scope","translate","Nutupane","Package","Erratum","PackageGroup","PuppetModule","Repository"]}(),function(){"use strict";function ContentViewVersionController($scope,ContentViewVersion){$scope.version=ContentViewVersion.get({id:$scope.$stateParams.versionId})}angular.module("Bastion.content-views.versions").controller("ContentViewVersionController",ContentViewVersionController),ContentViewVersionController.$inject=["$scope","ContentViewVersion"]}(),angular.module("Bastion.content-views.versions").factory("ContentViewVersion",["BastionResource",function(BastionResource){return BastionResource("/katello/api/v2/content_view_versions/:id/:action",{id:"@id"},{update:{method:"PUT"},promote:{method:"POST",params:{action:"promote"}}})}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/versions/views/content-view-version-details.html",'<div class="details">\n\n  <div class="detail">\n    <span class="info-label" translate>Version</span>\n    <span class="info-value">{{ version.version }}</span>\n  </div>\n\n  <div class="detail">\n    <span class="info-label" translate>Description</span>\n    <span class="info-value">{{ version.description }}</span>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/versions/views/content-view-version-errata.html",'<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="header"></div>\n  <div data-block="selection-summary"></div>\n\n  <table data-block="table" class="table table-striped table-bordered">\n  <thead>\n    <tr bst-table-head>\n      <th bst-table-column="errataId" sortable>{{ "Errata ID" | translate }}</th>\n      <th bst-table-column="title">{{ "Title" | translate }}</th>\n      <th bst-table-column="type">{{ "Type" | translate }}</th>\n      <th bst-table-column="numberOfContentHosts">{{ "Affected Content Hosts" | translate }}</th>\n      <th bst-table-column="updated">{{ "Updated" | translate }}</th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row ng-repeat="errata in detailsTable.rows">\n      <td bst-table-cell>\n          {{ errata.errata_id }}\n        <i class="icon-chevron-right selected-icon" ng-show="errata.selected"></i>\n      </td>\n      <td bst-table-cell>\n        <a>\n          {{ errata.title }}\n        </a>\n      </td>\n      <td bst-table-cell>\n          <span ng-show="errata.type == \'security\'">\n            <i class="icon-warning-sign inline-icon" title="{{ \'Security\' | translate }}"></i>\n          </span>\n\n          <span ng-show="errata.type == \'bugfix\'">\n            <i class="icon-bug inline-icon" title="{{ \'Bug Fix\' | translate }}"></i>\n          </span>\n\n          <span ng-show="errata.type == \'enhancement\'">\n            <i class="icon-plus-sign-alt inline-icon" title="{{ \'Enhancement\' | translate }}"></i>\n          </span>\n\n        {{ errata.type }}\n        <span ng-show="errata.severity">- {{ errata.severity }}</span>\n      </td>\n      <td bst-table-cell>{{ errata.systems_available_count || 0 }}</td>\n      <td bst-table-cell>{{ errata.updated | date:\'shortDate\'}}</td>\n    </tr>\n  </tbody>\n</table>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/versions/views/content-view-version-package-groups.html",'<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="header"></div>\n  <div data-block="selection-summary"></div>\n\n  <span class="input-group-addon" data-block="search-filter">\n    <select ng-model="repository" ng-options="repository.name for (id, repository) in repositories">\n    </select>\n  </span>\n\n  <table data-block="table" class="table table-striped table-bordered">\n    <thead>\n      <tr bst-table-head>\n        <th bst-table-column translate>Name</th>\n        <th bst-table-column translate>Repository</th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr bst-table-row ng-repeat="packageGroup in detailsTable.rows">\n        <td bst-table-cell>{{ packageGroup.name }}</td>\n        <td bst-table-cell>{{ packageGroup.repository.name }}</td>\n      </tr>\n    </tbody>\n  </table>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/versions/views/content-view-version-packages.html",'<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="header"></div>\n  <div data-block="selection-summary"></div>\n\n  <span class="input-group-addon" data-block="search-filter">\n    <select ng-model="repository" ng-options="repository.name for (id, repository) in repositories">\n    </select>\n  </span>\n\n  <table data-block="table" class="table table-striped table-bordered">\n    <thead>\n      <tr bst-table-head>\n        <th bst-table-column translate>Name</th>\n        <th bst-table-column translate>Version</th>\n        <th bst-table-column translate>Release</th>\n        <th bst-table-column translate>Arch</th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr bst-table-row ng-repeat="package in detailsTable.rows">\n        <td bst-table-cell>{{ package.name }}</td>\n        <td bst-table-cell>{{ package.version }}</td>\n        <td bst-table-cell>{{ package.release }}</td>\n        <td bst-table-cell>{{ package.arch }}</td>\n      </tr>\n    </tbody>\n  </table>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/versions/views/content-view-version-puppet-modules.html",'<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="header"></div>\n  <div data-block="selection-summary"></div>\n\n  <table data-block="table" class="table table-striped table-bordered">\n    <thead>\n      <tr bst-table-head>\n        <th bst-table-column translate>Name</th>\n        <th bst-table-column translate>Author</th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr bst-table-row ng-repeat="puppetModule in detailsTable.rows">\n        <td bst-table-cell>{{ puppetModule.name }}</td>\n        <td bst-table-cell>{{ puppetModule.author }}</td>\n      </tr>\n    </tbody>\n  </table>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/versions/views/content-view-version-repositories.html",'<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="header"></div>\n  <div data-block="selection-summary"></div>\n\n  <table data-block="table" class="table table-striped table-bordered">\n    <thead>\n      <tr bst-table-head>\n        <th bst-table-column translate>Name</th>\n        <th bst-table-column translate>Product</th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr bst-table-row ng-repeat="repository in detailsTable.rows">\n        <td bst-table-cell>{{ repository.name }}</td>\n        <td bst-table-cell>{{ repository.product.name }}</td>\n      </tr>\n    </tbody>\n  </table>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/versions/views/content-view-version.html",'<span page-title ng-model="version">{{ \'Version:\' | translate }} {{ version.version }}</span>\n\n<div class="loading-mask loading-mask-panel icon-3x" ng-show="version.id === undefined">\n    <i class="icon-spinner icon-spin"></i>\n    {{ "Loading..." | translate }}\n</div>\n\n<div class="details details-full" ng-show="version.id !== undefined">\n\n  <ol class="breadcrumb">\n    <li ng-class="{active: isState(\'content-views.details.versions\')}">\n      <a ui-sref="content-views.details.versions" translate>Versions</a>\n    </li>\n\n    <li>\n      <span translate>Version {{ version.version }}</span>\n    </li>\n  </ol>\n\n  <h3 translate>\n    Version {{ version.version }}\n  </h3>\n\n  <h4>\n    <span translate>Environments: </span>\n    <span ng-repeat="environment in version.environments" ng-if="environment.permissions.readable">\n      {{ environment.name }} <span ng-if="!$last">,</span>\n    </span>\n  </h4>\n\n  <nav class="details-navigation">\n    <ul>\n\n      <li ng-class="{active: isState(\'content-views.details.version.repositories\')}">\n        <a ui-sref="content-views.details.version.repositories({versionId: version.id})">\n          <span translate>Repositories</span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.version.packages\')}">\n        <a ui-sref="content-views.details.version.packages({versionId: version.id})">\n          <span translate>Packages</span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.version.package-groups\')}">\n        <a ui-sref="content-views.details.version.package-groups({versionId: version.id})">\n          <span translate>Package Groups</span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.version.errata\')}">\n        <a ui-sref="content-views.details.version.errata({versionId: version.id})">\n          <span translate>Errata</span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.version.puppet-modules\')}">\n        <a ui-sref="content-views.details.version.puppet-modules({versionId: version.id})">\n          <span translate>Puppet Modules</span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.version.details\')}">\n        <a ui-sref="content-views.details.version.details({versionId: version.id})">\n          <span translate>Details</span>\n        </a>\n      </li>\n\n    </ul>\n  </nav>\n\n  <div ui-view></div>\n\n</div>\n')}]),angular.module("Bastion.content-views",["ngResource","ui.router","Bastion","Bastion.utils","Bastion.content-views.versions","Bastion.components","Bastion.packages"]),angular.module("Bastion.content-views").factory("ContentView",["BastionResource","translate","CurrentOrganization",function(BastionResource,translate,CurrentOrganization){return BastionResource("/katello/api/v2/content_views/:id/:action",{id:"@id",organization_id:CurrentOrganization},{copy:{method:"POST",params:{action:"copy"}},update:{method:"PUT"},publish:{method:"POST",params:{action:"publish"}},history:{method:"GET",params:{action:"history"}},removeAssociations:{method:"PUT",params:{action:"remove"}},versions:{method:"GET",isArray:!1,params:{action:"content_view_versions"}},components:{method:"GET",transformResponse:function(data){var contentView=angular.fromJson(data);return{results:contentView.components}}},availablePuppetModules:{method:"GET",params:{action:"available_puppet_modules"},transformResponse:function(data){var response=angular.fromJson(data);return angular.forEach(_.groupBy(response.results,"author"),function(puppetModules){var latest=angular.copy(puppetModules[0]);latest.version=translate("Use Latest (currently %s)").replace("%s",latest.version),latest.useLatest=!0,response.results.push(latest)}),response}},availablePuppetModuleNames:{method:"GET",params:{action:"available_puppet_module_names"}}})}]),angular.module("Bastion.content-views").controller("ContentViewsController",["$scope","Nutupane","ContentView","CurrentOrganization",function($scope,Nutupane,ContentView,CurrentOrganization){var nutupane=new Nutupane(ContentView,{nondefault:!0,organization_id:CurrentOrganization,sort_by:"name",sort_order:"ASC"});$scope.table=nutupane.table,$scope.removeRow=nutupane.removeRow,$scope.table.closeItem=function(){$scope.transitionTo("content-views.index")}}]),angular.module("Bastion.content-views").config(["$stateProvider",function($stateProvider){$stateProvider.state("content-views",{"abstract":!0,controller:"ContentViewsController",templateUrl:"content-views/views/content-views.html"}).state("content-views.index",{url:"/content_views",permission:"view_content_views",views:{table:{templateUrl:"content-views/views/content-views-table-full.html"}}}).state("content-views.new",{collapsed:!0,url:"/content_views/new",permission:"create_content_views",views:{table:{templateUrl:"content-views/views/content-views-table-collapsed.html"},"action-panel":{controller:"NewContentViewController",templateUrl:"content-views/new/views/content-view-new.html"}}}).state("content-views.details",{"abstract":!0,url:"/content_views/:contentViewId",permission:"view_content_views",views:{table:{templateUrl:"content-views/views/content-views-table-collapsed.html"},"action-panel":{controller:"ContentViewDetailsController",templateUrl:"content-views/details/views/content-view-details.html"}}}).state("content-views.details.versions",{collapsed:!0,url:"/versions",permission:"view_content_views",controller:"ContentViewVersionsController",templateUrl:"content-views/details/views/content-view-versions.html"}).state("content-views.details.version",{collapsed:!0,"abstract":!0,url:"/versions/:versionId",controller:"ContentViewVersionController",templateUrl:"content-views/versions/views/content-view-version.html"}).state("content-views.details.version.details",{collapsed:!0,url:"/details",permission:"view_content_views",templateUrl:"content-views/versions/views/content-view-version-details.html"}).state("content-views.details.version.repositories",{collapsed:!0,url:"/repositories",permission:"view_content_views",controller:"ContentViewVersionContentController",templateUrl:"content-views/versions/views/content-view-version-repositories.html"}).state("content-views.details.version.packages",{collapsed:!0,url:"/packages",permission:"view_content_views",controller:"ContentViewVersionContentController",templateUrl:"content-views/versions/views/content-view-version-packages.html"}).state("content-views.details.version.package-groups",{collapsed:!0,url:"/package_groups",permission:"view_content_views",controller:"ContentViewVersionContentController",templateUrl:"content-views/versions/views/content-view-version-package-groups.html"}).state("content-views.details.version.errata",{collapsed:!0,url:"/errata",permission:"view_content_views",controller:"ContentViewVersionContentController",templateUrl:"content-views/versions/views/content-view-version-errata.html"}).state("content-views.details.version.puppet-modules",{collapsed:!0,url:"/puppet_modules",permission:"view_content_views",controller:"ContentViewVersionContentController",templateUrl:"content-views/versions/views/content-view-version-puppet-modules.html"}).state("content-views.details.promotion",{collapsed:!0,url:"/versions/:versionId/promotion",permission:"promote_or_remove_content_views",controller:"ContentViewPromotionController",templateUrl:"content-views/details/views/content-view-promotion.html"}).state("content-views.details.version-deletion",{collapsed:!0,"abstract":!0,controller:"ContentViewVersionDeletionController",template:"<div ui-view></div>"}).state("content-views.details.version-deletion.environments",{collapsed:!0,url:"/versions/:versionId/delete/environments",permission:"promote_or_remove_content_views",controller:"ContentViewVersionDeletionEnvironmentsController",templateUrl:"content-views/deletion/views/version-deletion-environments.html"}).state("content-views.details.version-deletion.content-hosts",{url:"/versions/:versionId/delete/content-hosts",permission:"promote_or_remove_content_views",collapsed:!0,controller:"ContentViewVersionDeletionContentHostsController",templateUrl:"content-views/deletion/views/version-deletion-content-hosts.html"}).state("content-views.details.version-deletion.activation-keys",{url:"/versions/:versionId/delete/activation-keys",permission:"promote_or_remove_content_views",collapsed:!0,controller:"ContentViewVersionDeletionActivationKeysController",templateUrl:"content-views/deletion/views/version-deletion-activation-keys.html"}).state("content-views.details.version-deletion.confirm",{url:"/versions/:versionId/delete/confirm",permission:"promote_or_remove_content_views",collapsed:!0,controller:"ContentViewVersionDeletionConfirmController",templateUrl:"content-views/deletion/views/version-deletion-confirm.html"}).state("content-views.details.deletion",{collapsed:!0,url:"/delete",permission:"promote_or_remove_content_views",controller:"ContentViewDeletionController",templateUrl:"content-views/deletion/views/content-view-deletion.html"}).state("content-views.details.repositories",{"abstract":!0,collapsed:!0,template:"<div ui-view></div>"}).state("content-views.details.repositories.yum",{"abstract":!0,collapsed:!0,template:"<div ui-view></div>"}).state("content-views.details.repositories.yum.list",{collapsed:!0,url:"/repositories/yum",permission:"view_content_views",controller:"ContentViewRepositoriesListController",templateUrl:"content-views/details/views/content-view-repositories.html"}).state("content-views.details.repositories.yum.available",{collapsed:!0,url:"/repositories/yum/available",permission:"view_content_views",controller:"ContentViewAvailableRepositoriesController",templateUrl:"content-views/details/views/content-view-repositories.html"}).state("content-views.details.repositories.docker",{"abstract":!0,collapsed:!0,template:"<div ui-view></div>"}).state("content-views.details.repositories.docker.list",{collapsed:!0,url:"/repositories/docker",permission:"view_content_views",controller:"ContentViewDockerRepositoriesListController",templateUrl:"content-views/details/views/content-view-docker-repositories.html"}).state("content-views.details.repositories.docker.available",{collapsed:!0,url:"/repositories/docker/available",permission:"view_content_views",controller:"ContentViewAvailableDockerRepositoriesController",templateUrl:"content-views/details/views/content-view-docker-repositories.html"}).state("content-views.details.history",{collapsed:!0,url:"/history",permission:"view_content_views",controller:"ContentViewHistoryController",templateUrl:"content-views/details/views/content-view-details-history.html"}).state("content-views.details.composite-content-views",{"abstract":!0,collapsed:!0,templateUrl:"content-views/details/views/content-view-composite.html"}).state("content-views.details.composite-content-views.list",{collapsed:!0,url:"/content-views",permission:"view_content_views",controller:"ContentViewCompositeContentViewsListController",templateUrl:"content-views/details/views/content-view-composite-content-views-list.html"}).state("content-views.details.composite-content-views.available",{collapsed:!0,url:"/content-views/available",permission:"edit_content_views",controller:"ContentViewCompositeAvailableContentViewsController",templateUrl:"content-views/details/views/content-view-composite-available-content-views.html"}).state("content-views.details.puppet-modules",{"abstract":!0,collapsed:!0,template:"<div ui-view></div>"}).state("content-views.details.puppet-modules.list",{collapsed:!0,url:"/puppet_modules",permission:"view_content_views",controller:"ContentViewPuppetModulesController",templateUrl:"content-views/details/puppet-modules/views/content-view-puppet-modules.html"}).state("content-views.details.puppet-modules.names",{collapsed:!0,url:"/puppet_modules/names",permission:"edit_content_views",controller:"ContentViewPuppetModuleNamesController",templateUrl:"content-views/details/puppet-modules/views/content-view-puppet-module-names.html"}).state("content-views.details.puppet-modules.versions",{collapsed:!0,url:"/puppet_modules/:moduleName/versions",permission:"edit_content_views",controller:"ContentViewPuppetModuleVersionsController",templateUrl:"content-views/details/puppet-modules/views/content-view-puppet-module-versions.html"}).state("content-views.details.puppet-modules.versionsForModule",{collapsed:!0,url:"/puppet_modules/:moduleName/versions/:moduleId",permission:"edit_content_views",controller:"ContentViewPuppetModuleVersionsController",templateUrl:"content-views/details/puppet-modules/views/content-view-puppet-module-versions.html"}).state("content-views.details.info",{collapsed:!0,url:"/info",permission:"view_content_views",templateUrl:"content-views/details/views/content-view-info.html"}).state("content-views.details.publish",{collapsed:!0,url:"/publish",permission:"publish_content_views",controller:"ContentViewPublishController",templateUrl:"content-views/details/views/content-view-publish.html"}).state("content-views.details.filters",{"abstract":!0,collapsed:!0,controller:"FiltersController",template:"<div ui-view></div>"}).state("content-views.details.filters.list",{collapsed:!0,url:"/filters",permission:"view_content_views",templateUrl:"content-views/details/filters/views/filters.html"}).state("content-views.details.filters.new",{collapsed:!0,url:"/filters/new",permission:"edit_content_views",controller:"NewFilterController",templateUrl:"content-views/details/filters/views/new-filter.html"}).state("content-views.details.filters.details",{"abstract":!0,collapsed:!0,controller:"FilterDetailsController",templateUrl:"content-views/details/filters/views/filter-details.html"}).state("content-views.details.filters.details.rpm",{"abstract":!0,collapsed:!0,url:"/filters/:filterId/package",permission:"view_content_views",controller:"PackageFilterController",templateUrl:"content-views/details/filters/views/package-filter.html"}).state("content-views.details.filters.details.rpm.details",{url:"/details",permission:"view_content_views",collapsed:!0,controller:"PackageFilterController",templateUrl:"content-views/details/filters/views/package-filter-details.html"}).state("content-views.details.filters.details.rpm.edit",{url:"/edit",collapsed:!0,controller:"FilterEditController",permission:"edit_content_views",templateUrl:"content-views/details/filters/views/edit-filter.html"}).state("content-views.details.filters.details.rpm.repositories",{collapsed:!0,url:"/repositories",permission:"view_content_views",controller:"FilterRepositoriesController",templateUrl:"content-views/details/filters/views/filter-repositories.html"}).state("content-views.details.filters.details.package_group",{"abstract":!0,collapsed:!0,controller:"PackageGroupFilterController",url:"/filters/:filterId/package-group",templateUrl:"content-views/details/filters/views/package-group-filter.html"}).state("content-views.details.filters.details.package_group.edit",{url:"/edit",collapsed:!0,controller:"FilterEditController",permission:"edit_content_views",templateUrl:"content-views/details/filters/views/edit-filter.html"}).state("content-views.details.filters.details.package_group.list",{collapsed:!0,url:"/list",permission:"view_content_views",controller:"PackageGroupFilterListController",templateUrl:"content-views/details/filters/views/package-group-filter-details.html"}).state("content-views.details.filters.details.package_group.available",{collapsed:!0,url:"/available",permission:"edit_content_views",controller:"AvailablePackageGroupFilterController",templateUrl:"content-views/details/filters/views/package-group-filter-details.html"}).state("content-views.details.filters.details.package_group.repositories",{collapsed:!0,url:"/repositories",permission:"view_content_views",controller:"FilterRepositoriesController",templateUrl:"content-views/details/filters/views/filter-repositories.html"}).state("content-views.details.filters.details.erratum",{"abstract":!0,collapsed:!0,url:"/filters/:filterId/errata",controller:"ErrataFilterController",templateUrl:"content-views/details/filters/views/errata-filter.html"}).state("content-views.details.filters.details.erratum.edit",{url:"/edit",collapsed:!0,controller:"FilterEditController",permission:"edit_content_views",templateUrl:"content-views/details/filters/views/edit-filter.html"}).state("content-views.details.filters.details.erratum.list",{collapsed:!0,url:"/list",permission:"view_content_views",controller:"ErrataFilterListController",templateUrl:"content-views/details/filters/views/errata-filter-details.html"}).state("content-views.details.filters.details.erratum.available",{collapsed:!0,url:"/available",permission:"edit_content_views",controller:"AvailableErrataFilterController",templateUrl:"content-views/details/filters/views/errata-filter-details.html"}).state("content-views.details.filters.details.erratum.dateType",{collapsed:!0,url:"/date_type",permission:"view_content_views",controller:"DateTypeErrataFilterController",templateUrl:"content-views/details/filters/views/date-type-errata-filter.html"}).state("content-views.details.filters.details.erratum.repositories",{collapsed:!0,url:"/repositories",permission:"view_content_views",controller:"FilterRepositoriesController",templateUrl:"content-views/details/filters/views/filter-repositories.html"}).state("content-views.details.tasks",{"abstract":!0,collapsed:!0,template:"<div ui-view></div>"}).state("content-views.details.tasks.index",{url:"/tasks",permission:"view_content_views",collapsed:!0,templateUrl:"content-views/details/views/content-view-details-tasks.html"}).state("content-views.details.tasks.details",{url:"/tasks/:taskId",permission:"view_content_views",collapsed:!0,controller:"TaskDetailsController",templateUrl:"tasks/views/task-details.html"})}]),angular.module("Bastion.content-views").controller("ContentViewDeletionController",["$scope","ContentView",function($scope,ContentView){function success(){$scope.removeRow($scope.contentView.id),$scope.transitionTo("content-views.index"),$scope.working=!1}function failure(response){$scope.$parent.errorMessages=[response.data.displayMessage],$scope.working=!1}$scope.versions===undefined&&$scope.reloadVersions(),$scope.delete=function(){$scope.working=!0,ContentView.remove({id:$scope.contentView.id},success,failure)},$scope.conflictingVersions=function(){return _.reject($scope.versions,function(version){return version.environments.length===0})},$scope.environmentNames=function(version){return _.pluck($scope.readableEnvironments(version),"name")},$scope.readableEnvironments=function(version){return _.reject(version.environments,function(env){return!env.permissions.readable})}}]),angular.module("Bastion.content-views").controller("ContentViewVersionDeletionActivationKeysController",["$scope","$location","Organization","CurrentOrganization","Nutupane","ActivationKey",function($scope,$location,Organization,CurrentOrganization,Nutupane,ActivationKey){var params,nutupane;$scope.validateEnvironmentSelection(),params={organization_id:CurrentOrganization,content_view_id:$scope.contentView.id,sort_by:"name",sort_order:"ASC"},nutupane=new Nutupane(ActivationKey,params),nutupane.searchTransform=function(term){var addition="(environment_id:("+$scope.selectedEnvironmentIds().join(" OR ")+"))";return term===""||term===undefined?addition:term+" AND "+addition},$scope.detailsTable=nutupane.table,$scope.detailsTable.closeItem=function(){},$scope.environments=Organization.readableEnvironments({id:CurrentOrganization}),$scope.initEnvironmentWatch($scope),$scope.deleteOptions.activationKeys.contentView&&($scope.selectedContentViewId=$scope.deleteOptions.activationKeys.contentView.id),$scope.selectedEnvironment=$scope.deleteOptions.activationKeys.environment,$scope.processSelection=function(){$scope.deleteOptions.activationKeys.environment=$scope.selectedEnvironment,$scope.deleteOptions.activationKeys.contentView=_.findWhere($scope.contentViewsForEnvironment,{id:$scope.selectedContentViewId}),$scope.selectedEnvironment=undefined,$scope.selectedContentViewId=undefined,$scope.transitionToNext()},$scope.activationKeyLink=function(){var search=$scope.searchString($scope.contentView,$scope.deleteOptions.environments);return $scope.$state.href("activation-keys.index")+"?search="+search},$scope.toggleKeys=function(){$scope.showKeys=!$scope.showKeys}}]),angular.module("Bastion.content-views").controller("ContentViewVersionDeletionConfirmController",["$scope","ContentView","translate",function($scope,ContentView,translate){function success(){var message=translate("Successfully initiated removal of %cv version %ver.");$scope.deleteOptions.deleteArchive&&(message=translate("Successfully initiated deletion of %cv version %ver.")),message=message.replace("%cv",$scope.contentView.name).replace("%ver",$scope.version.version),$scope.successMessages.push(message),$scope.transitionTo("content-views.details.versions",{contentViewId:$scope.contentView.id})}function error(response){$scope.deleting=!1,$scope.$parent.$parent.errorMessages=response.data.errors}$scope.validateEnvironmentSelection(),$scope.performDeletion=function(){var params={id:$scope.contentView.id,environment_ids:$scope.selectedEnvironmentIds()};$scope.deleting=!0,$scope.deleteOptions.deleteArchive&&(params.content_view_version_ids=[$scope.version.id]),$scope.deleteOptions.activationKeys.contentView&&(params.key_content_view_id=$scope.deleteOptions.activationKeys.contentView.id),$scope.deleteOptions.activationKeys.environment&&(params.key_environment_id=$scope.deleteOptions.activationKeys.environment.id),$scope.deleteOptions.contentHosts.contentView&&(params.system_content_view_id=$scope.deleteOptions.contentHosts.contentView.id),$scope.deleteOptions.contentHosts.environment&&(params.system_environment_id=$scope.deleteOptions.contentHosts.environment.id),ContentView.removeAssociations(params,success,error)}}]),angular.module("Bastion.content-views").controller("ContentViewVersionDeletionContentHostsController",["$scope","$location","Organization","CurrentOrganization","Nutupane","ContentHost",function($scope,$location,Organization,CurrentOrganization,Nutupane,ContentHost){var params,nutupane;$scope.validateEnvironmentSelection(),params={organization_id:CurrentOrganization,content_view_id:$scope.contentView.id,sort_by:"name",sort_order
:"ASC"},nutupane=new Nutupane(ContentHost,params),nutupane.searchTransform=function(term){var addition="(environment_id:("+$scope.selectedEnvironmentIds().join(" OR ")+"))";return term===""||term===undefined?addition:term+" AND "+addition},$scope.detailsTable=nutupane.table,$scope.detailsTable.closeItem=function(){},$scope.environments=Organization.readableEnvironments({id:CurrentOrganization}),$scope.initEnvironmentWatch($scope),$scope.selectedEnvironment=$scope.deleteOptions.contentHosts.environment,$scope.deleteOptions.contentHosts.contentView&&($scope.selectedContentViewId=$scope.deleteOptions.contentHosts.contentView.id),$scope.processSelection=function(){$scope.deleteOptions.contentHosts.environment=$scope.selectedEnvironment,$scope.deleteOptions.contentHosts.contentView=_.findWhere($scope.contentViewsForEnvironment,{id:$scope.selectedContentViewId}),$scope.selectedEnvironment=undefined,$scope.selectedContentViewId=undefined,$scope.transitionToNext()},$scope.contentHostsLink=function(){var search=$scope.searchString($scope.contentView,$scope.deleteOptions.environments);return $scope.$state.href("content-hosts.index")+"?search="+search},$scope.toggleHosts=function(){$scope.showHosts=!$scope.showHosts}}]),angular.module("Bastion.content-views").controller("ContentViewVersionDeletionEnvironmentsController",["$scope",function($scope){$scope.environmentsTable={rows:{}},$scope.version.$promise.then(function(){var numSelections;$scope.environmentsTable.rows=$scope.version.environments,$scope.version.environments.length===0?$scope.deleteOptions.deleteArchive=!0:(angular.forEach($scope.environmentsTable.rows,function(row){row.unselectable=!row.permissions.promotable_or_removable||!row.permissions.all_systems_editable||!row.permissions.all_keys_editable}),$scope.deleteOptions.environments.length===0?angular.forEach($scope.environmentsTable.rows,function(row){row.selected=!row.unselectable}):angular.forEach($scope.environmentsTable.rows,function(row){row.selected=_.findWhere($scope.deleteOptions.environments,{unselectable:!1,id:row.id})!==undefined}),numSelections=_.countBy($scope.environmentsTable.rows,function(row){return row.selected?"selected":"unselected"}),$scope.environmentsTable.numSelected=numSelections.selected)}),$scope.canDeleteArchive=function(){return $scope.environmentsTable.numSelected===$scope.environmentsTable.rows.length},$scope.selectionEmpty=function(){return!$scope.deleteOptions.deleteArchive&&$scope.environmentsTable.numSelected===0},$scope.anySelectable=function(){var anySelectable;return $scope.environmentsTable.rows.length===0?anySelectable=!0:anySelectable=_.findWhere($scope.environmentsTable.rows,{unselectable:!1})!==undefined,anySelectable},$scope.allSelectable=function(){return _.findWhere($scope.environmentsTable.rows,{unselectable:!0})===undefined},$scope.processSelection=function(){$scope.deleteOptions.environments=$scope.environmentsTable.getSelected(),$scope.transitionToNext()}}]),angular.module("Bastion.content-views").controller("ContentViewVersionDeletionController",["$scope","$state","ContentViewVersion","ContentView",function($scope,$state,ContentViewVersion,ContentView){$scope.version=ContentViewVersion.get({id:$scope.$stateParams.versionId}),$scope.stepStates={environments:"content-views.details.version-deletion.environments",activationKeys:"content-views.details.version-deletion.activation-keys",contentHosts:"content-views.details.version-deletion.content-hosts",confirm:"content-views.details.version-deletion.confirm"},$scope.deleteOptions===undefined&&($scope.deleteOptions={deleteArchive:!1,environments:[],contentHosts:{},activationKeys:{}}),$scope.isStep=function(step){return $state.is($scope.stepStates[step])},$scope.transitionToNext=function(currentState){var stepStates=$scope.stepStates;currentState===undefined&&(currentState=$state.current.name),currentState===stepStates.environments?$scope.needHosts()?$scope.transitionTo(stepStates.contentHosts,{contentViewId:$scope.contentView.id,versionId:$scope.version.id}):$scope.transitionToNext(stepStates.contentHosts):currentState===stepStates.contentHosts?$scope.needActivationKeys()?$scope.transitionTo(stepStates.activationKeys,{contentViewId:$scope.contentView.id,versionId:$scope.version.id}):$scope.transitionToNext(stepStates.activationKeys):$scope.transitionTo(stepStates.confirm,{contentViewId:$scope.contentView.id,versionId:$scope.version.id})},$scope.transitionBack=function(currentState){var stepStates=$scope.stepStates;currentState===undefined&&(currentState=$state.current.name),currentState===stepStates.confirm?$scope.needActivationKeys()?$scope.transitionTo(stepStates.activationKeys,{contentViewId:$scope.contentView.id,versionId:$scope.version.id}):$scope.transitionBack(stepStates.activationKeys):currentState===stepStates.activationKeys?$scope.needHosts()?$scope.transitionTo(stepStates.contentHosts,{contentViewId:$scope.contentView.id,versionId:$scope.version.id}):$scope.transitionBack(stepStates.contentHosts):currentState===stepStates.contentHosts&&$scope.transitionTo(stepStates.environments,{contentViewId:$scope.contentView.id,versionId:$scope.version.id})},$scope.validateEnvironmentSelection=function(){!$scope.deleteOptions.deleteArchive&&$scope.deleteOptions.environments.length===0&&$scope.transitionTo("content-views.details.version-deletion.environments",{contentViewId:$scope.$stateParams.contentViewId,versionId:$scope.$stateParams.versionId})},$scope.needHosts=function(){return $scope.totalHostCount()>0},$scope.needActivationKeys=function(){return $scope.totalActivationKeyCount()>0},$scope.selectedEnvironmentIds=function(){return _.pluck($scope.deleteOptions.environments,"id")},$scope.totalHostCount=function(){return _.reduce($scope.deleteOptions.environments,function(sum,env){return sum+env.system_count},0)},$scope.totalActivationKeyCount=function(){return _.reduce($scope.deleteOptions.environments,function(sum,env){return sum+env.activation_key_count},0)},$scope.searchString=function(contentView,environments){var envStrings=[],string='content_view:"%s"'.replace("%s",contentView.name);return angular.forEach(environments,function(environment){envStrings.push('environment:"%s"'.replace("%s",environment.name))}),string=string+" AND ("+envStrings.join(" OR ")+")",string.replace(/"/g,"%22")},$scope.initEnvironmentWatch=function(childScope){var removingEnvironment;childScope.$watch("selectedEnvironment",function(){childScope.selectedEnvironment===undefined?childScope.contentViewsForEnvironment=[]:(removingEnvironment=_.findWhere(childScope.deleteOptions.environments,{id:childScope.selectedEnvironment.id})!==undefined,$scope.fetchingViews=!0,ContentView.queryUnpaged({environment_id:childScope.selectedEnvironment.id},function(response){$scope.fetchingViews=!1,childScope.contentViewsForEnvironment=_.reject(response.results,function(view){return view.id===childScope.version.content_view_id&&removingEnvironment})}))})}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/deletion/views/content-view-deletion.html",'<span page-title ng-model="contentView">{{ \'Remove Content View \' | translate }} {{ contentView.name }}</span>\n\n<div>\n  <h3 translate>Delete {{ contentView.name }}</h3>\n\n  <div ng-show="conflictingVersions().length > 0">\n    <i class="icon-warning-sign"></i>\n    <span translate>\n      {{ contentView.name }} cannot be deleted as one or more Content View Versions are still promoted to a Lifecycle Environment.\n      Each Content View Version must be removed from their Lifecycle Environments before the Content View can be deleted.\n    </span>\n\n    <br/><br/>\n    <table class="table table-striped table-bordered" bst-table="table">\n      <thead>\n        <tr>\n          <th translate>Version</th>\n          <th translate>Lifecycle Environments</th>\n          <th translate>Actions</th>\n        </tr>\n      </thead>\n      <tbody>\n        <tr ng-repeat="version in conflictingVersions()">\n          <td>{{ version.version }}</td>\n          <td>{{ environmentNames(version).join(\', \') }}</td>\n          <td>\n            <a ui-sref="content-views.details.version-deletion.environments({contentViewId: contentView.id, versionId: version.id})" ng-show="version.permissions.deletable">\n              <button class="btn btn-default">\n                <i class="icon-trash"></i>\n                <span translate>Remove Version</span>\n              </button>\n            </a>\n          </td>\n        </tr>\n      </tbody>\n    </table>\n  </div>\n\n  <div class="details" ng-show="conflictingVersions().length === 0">\n    <p translate>\n      Are you sure you want to delete Content View "{{ contentView.name }}"?\n    </p>\n\n    <div ng-show="versions.length > 0">\n      <i class="icon-warning-sign"></i>\n      <span translate translate-n="versions.length" translate-plural=" As part of this deletion, {{ versions.length }} Content View Versions will be deleted.">\n        As part of this deletion, 1 Content View Version will be deleted.\n      </span>\n    </div>\n\n    <br/><br/>\n    <div class="fr">\n      <button ng-disabled="working" class="btn-danger btn-lg" ng-click="delete()" >\n        <i class="icon-spinner icon-spin" ng-show="working"></i>\n        <span translate>Delete</span>\n      </button>\n\n      <a ui-sref="content-views.details.versions" ng-disabled="working" class="btn btn-default btn-lg"  translate role="button">\n        Cancel\n      </a>\n    </div>\n  </div>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/deletion/views/version-deletion-activation-keys.html",'<span page-title ng-model="version">{{ "Remove Version" | translate }} {{ version.version }}</span>\n\n  <section class="details details-full">\n    <h3 translate>Activation Keys using Version {{ version.version }}</h3>\n\n    <div data-extend-template="content-views/deletion/views/version-deletion-breadcrumb.html"></div>\n\n    <p translate>\n      The Activation Keys listed below are currently using this Content View Version.  Before deleting the Version you must move these Activation Keys to a Lifecycle Environment where this Version is not in use.\n    </p>\n\n    <p translate>\n       If you would prefer to move portions of these Activation Keys to different Content Views or Lifecycle Environments click <a href="{{ activationKeyLink() }}">here</a> to manage them individually.\n    </p>\n\n\n    <p translate>\n      <span translate>\n        If you would prefer to move portions of these Activation Keys to different content views or Lifecycle Environments click\n      </span>\n      <a ui-sref="activation-keys.index({})" translate >here</a>\n      <span translate>to manage them individually.</span>\n    </p>\n\n    <div class="details">\n\n      <p translate>\n        Please select a Lifecycle Environment and Content View to move the affected Activation Keys to:\n      </p>\n\n      <div path-selector="environments"\n           ng-model="selectedEnvironment"\n           mode="singleSelect"></div>\n\n      <div>\n        <span translate>Content View:</span>\n        <select ng-show="!fetchingViews && selectedEnvironment && contentViewsForEnvironment.length > 0"\n                ng-options="cv.id as cv.name for cv in contentViewsForEnvironment"\n                ng-model="selectedContentViewId"></select>\n        <i ng-show="fetchingViews" class="icon-spinner icon-spin"></i>\n        <span translate ng-hide="selectedEnvironment">\n          Please select a Lifecycle Environment.\n        </span>\n        <span translate ng-show="!fetchingViews && selectedEnvironment && contentViewsForEnvironment.length === 0">\n          No Content Views available, please select another environment.\n        </span>\n      </div>\n\n      <div class="fr">\n        <a ui-sref="content-views.details.versions({contentViewId: contentView.id})" >\n          <button class="btn btn-default" translate>\n            Cancel\n          </button>\n        </a>\n        <button class="btn btn-default" ng-click="transitionBack()" translate>\n          Back\n        </button>\n        <button class="btn btn-primary" ng-click="processSelection()" ng-disabled="selectedContentViewId === undefined" translate>\n          Next\n        </button>\n      </div>\n    </div>\n\n    <br/><br/>\n    <a ng-click="toggleKeys()">\n      <p ng-show="!showKeys" translate>Show affected Activation Keys</p>\n      <p ng-show="showKeys" translate>Hide affected Activation Keys</p>\n    </a>\n\n    <div ng-show="showKeys">\n      <div data-extend-template="layouts/details-nutupane.html">\n        <h5 translate>Affected Activation Keys</h5>\n\n        <div data-block="selection-summary"></div>\n\n        <table data-block="table" class="table table-striped table-bordered">\n          <thead>\n            <tr bst-table-head>\n              <th bst-table-column="name"><span translate>Name</span></th>\n              <th bst-table-column="environment.name"><span translate>Lifecycle Environments</span></th>\n            </tr>\n          </thead>\n\n          <tbody>\n            <tr bst-table-row ng-repeat="key in detailsTable.rows">\n              <td bst-table-cell>\n                  {{ key.name }}\n              </td>\n              <td bst-table-cell>\n                  {{ key.environment.name }}\n              </td>\n            </tr>\n          </tbody>\n        </table>\n      </div>\n    </div>\n  </section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/deletion/views/version-deletion-breadcrumb.html","<ul class=\"wizard\">\n  <li ng-class=\"{active: isStep('environments')}\">\n    <span translate>Lifecycle Environments</span>\n  </li>\n\n  <li ng-show=\"needHosts() && !isStep('environments')\" ng-class=\"{active: isStep('contentHosts')}\">\n    <span translate>Content Hosts</span>\n  </li>\n\n  <li ng-show=\"needActivationKeys() && !isStep('environments') && !isStep('contentHosts')\"\n      ng-class=\"{active: isStep('activationKeys')}\">\n    <span translate>Activation Keys</span>\n  </li>\n\n  <li ng-show=\"isStep('confirm')\" ng-class=\"{active: isStep('confirm')}\">\n    <span translate>Confirmation</span>\n  </li>\n</ul>\n")}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/deletion/views/version-deletion-confirm.html",'<span page-title ng-model="version">{{ "Remove Version Confirmation" | translate }} {{ version.version }}</span>\n\n<section class="details details-full">\n  <h3 translate>Confirm Version Removal: Version {{ version.version }}</h3>\n\n  <div data-extend-template="content-views/deletion/views/version-deletion-breadcrumb.html"></div>\n\n  <div class="details">\n\n    <div ng-hide="deleteOptions.environments.length === 0">\n      <h5 translate>Environments</h5>\n      <i class="icon-warning-sign"></i>\n      <span translate>This version will be removed from:</span>\n      <ul class="bullet">\n        <li ng-repeat="env in deleteOptions.environments" ng-if="env.permissions.readable">{{ env.name }}</li>\n      </ul>\n    </div>\n\n    <br/>\n\n    <div>\n      <h5 translate>Archived Copy</h5>\n      <p ng-hide="deleteOptions.deleteArchive" translate>\n        The archive of this Version will not be deleted.  This Version will still be available to be promoted to a Lifecycle Environment.\n      </p>\n      <p ng-show="deleteOptions.deleteArchive">\n        <i class="icon-warning-sign"></i>\n        <span translate>\n          The archive of this Version will be deleted.  This Version will not be available once deletion is complete.\n        </span>\n      </p>\n    </div>\n\n    <br/>\n\n    <div>\n      <h5 translate>Content Hosts</h5>\n      <p ng-show="totalHostCount() > 0">\n        <i class="icon-warning-sign"></i>\n        <span translate>\n          {{ totalHostCount() }} Content Hosts will be moved to {{ deleteOptions.contentHosts.contentView.name }} in {{ deleteOptions.contentHosts.environment.name }}\n        </span>\n      </p>\n      <p ng-show="totalHostCount() === 0" translate>\n         No Content Hosts are affected.\n      </p>\n    </div>\n\n    <br/>\n\n    <div>\n      <h5 translate>Activation Keys</h5>\n      <p ng-show="totalActivationKeyCount() > 0">\n        <i class="icon-warning-sign"></i>\n        <span translate>\n          {{ totalActivationKeyCount() }} Activation Keys will be moved to {{ deleteOptions.activationKeys.contentView.name }} in {{ deleteOptions.activationKeys.environment.name }}\n        </span>\n      </p>\n      <p ng-show="totalActivationKeyCount() === 0" translate>\n        No activation keys are affected.\n      </p>\n    </div>\n\n    <div class="fr">\n      <a ui-sref="content-views.details.versions({contentViewId: contentView.id})" >\n        <button class="btn btn-default" ng-disabled="deleting" translate>\n          Cancel\n        </button>\n      </a>\n      <button class="btn btn-default" ng-click="transitionBack()" ng-disabled="deleting" translate>\n        Back\n      </button>\n      <button class="btn btn-primary" ng-click="performDeletion()" ng-disabled="deleting">\n        <i class="icon-spinner icon-spin" ng-show="deleting"></i>\n        <span translate>Confirm Remove</span>\n      </button>\n    </div>\n\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/deletion/views/version-deletion-content-hosts.html",'<span page-title ng-model="version">{{ "Remove Version" | translate }} {{ version.version }}</span>\n\n  <section class="details details-full">\n    <h3 translate>Content Hosts using Version {{ version.version }}</h3>\n\n    <div data-extend-template="content-views/deletion/views/version-deletion-breadcrumb.html"></div>\n\n    <p translate>\n      The Content Hosts listed below are currently using this Content View Version.  Before removing the version you must move these Content Hosts to an environment where this version is not in use.\n    </p>\n\n    <p translate>\n      If you would prefer to move portions of these Content Hosts to different content views or environments click <a href="{{ contentHostsLink() }}">here</a>  to manage these Content Hosts in bulk.\n    </p>\n\n    <div class="details">\n\n      <p translate>\n        Please select a Lifecycle Environment and Content View to move these Content Hosts to:\n      </p>\n\n      <div path-selector="environments"\n           ng-model="selectedEnvironment"\n           mode="singleSelect"></div>\n\n      <div>\n        <span translate>Content View:</span>\n        <select ng-show="!fetchingViews && selectedEnvironment && contentViewsForEnvironment.length > 0"\n                ng-options="cv.id as cv.name for cv in contentViewsForEnvironment"\n                ng-model="selectedContentViewId"></select>\n        <i ng-show="fetchingViews" class="icon-spinner icon-spin"></i>\n        <span translate ng-hide="selectedEnvironment">\n          Please select an environment.\n        </span>\n        <span translate ng-show="!fetchingViews && selectedEnvironment && contentViewsForEnvironment.length === 0">\n          No Content Views available, please select another environment.\n        </span>\n      </div>\n\n      <div class="fr">\n        <a ui-sref="content-views.details.versions({contentViewId: contentView.id})" >\n          <button class="btn btn-default" translate>\n            Cancel\n          </button>\n        </a>\n        <button class="btn btn-default" ng-click="transitionBack()" translate>\n          Back\n        </button>\n        <button class="btn btn-primary" ng-click="processSelection()" ng-disabled="selectedContentViewId === undefined" translate>\n          Next\n        </button>\n      </div>\n    </div>\n\n    <br/><br/>\n    <a ng-click="toggleHosts()">\n      <p ng-show="!showHosts" translate>Show affected Content Hosts</p>\n      <p ng-show="showHosts" translate>Hide affected Content Hosts</p>\n    </a>\n\n    <div ng-show="showHosts">\n      <div data-extend-template="layouts/details-nutupane.html">\n        <h5 translate>Affected Content Hosts</h5>\n\n        <div data-block="selection-summary"></div>\n\n        <table data-block="table"  class="table table-striped table-bordered">\n          <thead>\n            <tr bst-table-head>\n              <th bst-table-column="name"><span translate>Name</span></th>\n              <th bst-table-column="name"><span translate>Environment</span></th>\n            </tr>\n          </thead>\n\n          <tbody>\n            <tr bst-table-row ng-repeat="host in detailsTable.rows">\n              <td bst-table-cell>\n                  {{ host.name }}\n              </td>\n              <td bst-table-cell>\n                  {{ host.environment.name }}\n              </td>\n            </tr>\n          </tbody>\n        </table>\n      </div>\n    </div>\n\n  </section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/deletion/views/version-deletion-environments.html",'<span page-title ng-model="version">{{ "Remove Version" | translate }} {{ version.version }}</span>\n\n<section class="details details-full">\n\n  <h3 translate>Delete Version {{ version.version }}</h3>\n\n  <div data-extend-template="content-views/deletion/views/version-deletion-breadcrumb.html"></div>\n\n  <div class="details details-full">\n    <div alert warning alert-warning ng-hide="allSelectable()">\n      <i class="icon-warning-sign"></i>\n       <span translate> This Version cannot be deleted from some of the Lifecycle Environments due to one of the reasons below.</span>\n       <ul>\n         <li translate> No "Promote/Remove" permissions on the Lifecycle Environment.</li>\n         <li translate> No "Edit" permissions on some of the Content Hosts in that Lifecycle Environment.</li>\n         <li translate> No "Edit" permissions on some of the Activation Keys in that Lifecycle Environment.</li>\n       </ul>\n    </div>\n  </div>\n\n  <p translate>\n    Select the Lifecycle Environments you would like to remove Version {{ version.version }} from:\n  </p>\n\n  <table bst-table="environmentsTable"\n         class="table table-striped table-bordered"\n         ng-class="{\'table-mask\': environmentsTable.working}">\n    <thead>\n      <tr bst-table-head row-select>\n        <th translate>Name</th>\n        <th translate>Affected Systems</th>\n        <th translate>Affected Activation Keys</th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr ng-show="!environmentsTable.working && environmentsTable.rows.length === 0">\n        <td colspan="4" translate>This Version is not associated with any Lifecycle Environments.</td>\n      </tr>\n\n      <tr bst-table-row\n          row-select="environment"\n          ng-repeat="environment in environmentsTable.rows">\n        <td>{{ environment.name }}</td>\n        <td>{{ environment.system_count }} <span class="note warning" ng-hide="environment.permissions.all_systems_editable" translate>  (Not all Content Hosts editable )</span></td>\n        <td>{{ environment.activation_key_count }} <span class="note warning"  ng-hide="environment.permissions.all_keys_editable" translate>  (Not all Activation Keys editable )</span></td>\n      </tr>\n    </tbody>\n\n  </table>\n\n  <br/>\n  <div class="details">\n    <span translate> Completely remove version? </span>\n    <span>\n      <input type="checkbox" ng-model="deleteOptions.deleteArchive" ng-disabled="!canDeleteArchive()"/>\n    </span>\n    <div alert alert-info>\n      <i class="icon-info-sign"></i>\n      <span translate>Selecting this option will result in the Version being completely deleted and no longer being available for promotion.  The version must be removed from all Lifecycle Environments in order to select this option.</span>\n    </div>\n\n    <br/>\n    <div class="fr">\n      <a ui-sref="content-views.details.versions({contentViewId: contentView.id})" >\n        <button class="btn btn-default" translate>\n          Cancel\n        </button>\n      </a>\n\n      <button class="btn btn-primary" ng-click="processSelection()" ng-disabled="!anySelectable() || selectionEmpty()" translate>\n        Next\n      </button>\n    </div>\n  </div>\n\n</section>\n')}]),angular.module("Bastion.content-views").controller("ContentViewAvailableDockerRepositoriesController",["$scope","Repository","Nutupane","CurrentOrganization","ContentViewRepositoriesUtil",function($scope,Repository,Nutupane,CurrentOrganization,ContentViewRepositoriesUtil){var nutupane;ContentViewRepositoriesUtil($scope),nutupane=new Nutupane(Repository,{organization_id:CurrentOrganization,library:!0,content_type:"docker"},"queryUnpaged"),nutupane.searchTransform=function(){return"NOT ( content_view_ids:"+$scope.$stateParams.contentViewId+" )"},$scope.repositoriesTable=nutupane.table,$scope.addRepositories=function(contentView){$scope.addSelectedRepositoriesToContentView(nutupane,contentView)}}]),angular.module("Bastion.content-views").controller("AvailablePuppetModulesController",[function(){}]),angular.module("Bastion.content-views").controller("ContentViewAvailableRepositoriesController",["$scope","Repository","Nutupane","CurrentOrganization","ContentViewRepositoriesUtil",function($scope,Repository,Nutupane,CurrentOrganization,ContentViewRepositoriesUtil){var nutupane;ContentViewRepositoriesUtil($scope),nutupane=new Nutupane(Repository,{organization_id:CurrentOrganization,library:!0,content_type:"yum"},"queryUnpaged"),nutupane.searchTransform=function(){return"NOT ( content_view_ids:"+$scope.$stateParams.contentViewId+" )"},$scope.repositoriesTable=nutupane.table,$scope.addRepositories=function(contentView){$scope.addSelectedRepositoriesToContentView(nutupane,contentView)}}]),angular.module("Bastion.content-views").controller("ContentViewCompositeAvailableContentViewsController",["$scope","Nutupane","CurrentOrganization","ContentView",function($scope,Nutupane,CurrentOrganization,ContentView){var nutupane,params;$scope.contentView.$promise.then(function(contentView){var filterIds=[];contentView.components&&(filterIds=_.pluck(contentView.components,"content_view_id")),filterIds.push(contentView.id),params={organization_id:CurrentOrganization,full_result:!0,nondefault:!0,noncomposite:!0,"without[]":filterIds},nutupane=new Nutupane(ContentView,params),$scope.detailsTable=nutupane.table}),$scope.addContentViews=function(){var selectedRows=nutupane.getAllSelectedResults().included.resources,existingComponentsIds=$scope.contentView.component_ids,versionIds=[];angular.forEach(selectedRows,function(contentView){contentView.versionId||(contentView.versionId=contentView.versions[contentView.versions.length-1].id),versionIds.push(contentView.versionId)}),$scope.contentView.component_ids=existingComponentsIds.concat(versionIds),$scope.save($scope.contentView).then(function(){var newContentIds=_.pluck(selectedRows,"id");params["without[]"]=params["without[]"].concat(newContentIds),nutupane.setParams(params),nutupane.refresh()},function(){$scope.contentView.component_ids=existingComponentsIds})}}]),angular.module("Bastion.content-views").controller("ContentViewCompositeContentViewsListController",["$scope","$q","translate","Nutupane","CurrentOrganization","ContentView",function($scope,$q,translate,Nutupane,CurrentOrganization,ContentView){var nutupane=new Nutupane(ContentView,{organization_id:CurrentOrganization,id:$scope.$stateParams.contentViewId,full_result:!0},"components");$scope.detailsTable=nutupane.table,$scope.getContentViewForVersion=function(contentViewVersion){var deferred=$q.defer();return ContentView.get({id:contentViewVersion.content_view_id},function(response){deferred.resolve(response.versions)}),deferred.promise},$scope.saveContentViewVersion=function(contentViewVersion){var contentViewVersionToRemove=_.find($scope.contentView.components,function(component){return component.content_view_id===contentViewVersion.content_view_id});$scope.contentView.component_ids=_.without($scope.contentView.component_ids,contentViewVersionToRemove.id),$scope.contentView.component_ids.push(contentViewVersion.id),$scope.save($scope.contentView).then(function(){nutupane.refresh()})},$scope.removeContentViews=function(){var selected=nutupane.getAllSelectedResults().included.ids;$scope.contentView.component_ids=_.difference($scope.contentView.component_ids,selected),$scope.save($scope.contentView).then(function(){nutupane.refresh()})},$scope.getVersionString=function(contentViewVersion){return translate("Version %s").replace("%s",contentViewVersion.version.toString())}}]),angular.module("Bastion.content-views").controller("ContentViewHistoryController",["$scope","translate","ContentView","Nutupane",function($scope,translate,ContentView,Nutupane){var nutupane;nutupane=new Nutupane(ContentView,{id:$scope.$stateParams.contentViewId,sort_by:"created_at",sort_order:"DESC"},"history"),nutupane.table.closeItem=function(){},$scope.detailsTable=nutupane.table,$scope.actionText=function(history){var message,taskType=history.task.label,taskTypes=$scope.taskTypes;return taskType===taskTypes.deletion?message=translate("Deleted from %s").replace("%s",history.environment.name):taskType===taskTypes.promotion?message=translate("Promoted to %s").replace("%s",history.environment.name):taskType===taskTypes.publish&&(message=translate("Published new version")),message}}]),angular.module("Bastion.content-views").controller("ContentViewDetailsController",["$scope","ContentView","ContentViewVersion","AggregateTask","translate",function($scope,ContentView,ContentViewVersion,AggregateTask,translate){function processTasks(versions){_.each(versions,function(version){var taskIds=_.map(version.active_history,function(history){return history.task.id});taskIds.length>0&&(version.task=AggregateTask.new(taskIds,function(task){taskUpdated(version,task),task.label===$scope.taskTypes.publish&&!task.pending&&task.result==="success"&&updateVersion(version)}))})}function taskUpdated(version,task){var taskTypes=$scope.taskTypes;!task.pending&&task.result==="success"&&(task.label===taskTypes.promotion?$scope.successMessages.push(promotionMessage(version,task)):task.label===taskTypes.publish?$scope.successMessages.push(publishMessage(version)):task.label===taskTypes.deletion&&$scope.successMessages.push(deletionMessage(version,task)))}function promotionMessage(version,task){return translate("Successfully promoted %cv version %ver to %env").replace("%cv",version.content_view.name).replace("%ver",version.version).replace("%env",task.input.environment_name)}function deletionMessage(version,task){var message;return task.input.content_view_ids&&task.input.content_view_ids.length>0?message=translate("Successfully deleted %cv version %ver.").replace("%cv",version.content_view.name).replace("%ver",version.version):message=translate("Successfully removed %cv version %ver from environments: %env").replace("%cv",version.content_view.name).replace("%ver",version.version).replace("%env",task.input.environment_names.join(", ")),message}function publishMessage(version){return translate("Successfully published %cv version %ver and promoted to Library").replace("%cv",version.content_view.name).replace("%ver",version.version)}function updateVersion(version){var versionIds=_.map($scope.contentView.versions,function(ver){return ver.id}),versionIndex=versionIds.indexOf(version.id);ContentViewVersion.get({id:version.id}).$promise.then(function(newVersion){$scope.contentView.versions[versionIndex]=newVersion,$scope.versions[versionIndex]=newVersion})}function saveSuccess(){$scope.successMessages=[translate("Content View updated.")]}function saveError(response){angular.forEach(response.data.errors,function(errorMessage){$scope.errorMessages=[translate("An error occurred updating the Content View: ")+errorMessage]})}$scope.successMessages=[],$scope.errorMessages=[],$scope.contentView=ContentView.get({id:$scope.$stateParams
.contentViewId}),$scope.taskTypes={publish:"Actions::Katello::ContentView::Publish",promotion:"Actions::Katello::ContentView::Promote",deletion:"Actions::Katello::ContentView::Remove",incrementalUpdate:"Actions::Katello::ContentView::IncrementalUpdates"},$scope.copy=function(newName){ContentView.copy({id:$scope.contentView.id,content_view:{name:newName}},function(response){$scope.showCopy=!1,$scope.table.addRow(response),$scope.transitionTo("content-views.details.info",{contentViewId:response.id})},function(response){$scope.copyErrorMessages.push(response.data.displayMessage)})},$scope.reloadVersions=function(){var contentViewId=$scope.contentView.id||$scope.$stateParams.contentViewId;$scope.contentView.versions=[],$scope.loadingVersions=!0,ContentViewVersion.queryUnpaged({content_view_id:contentViewId},function(data){$scope.versions=data.results,$scope.contentView&&($scope.contentView.versions=data.results),$scope.loadingVersions=!1,processTasks($scope.versions)})},$scope.save=function(contentView){return contentView.$update(saveSuccess,saveError)}}]),angular.module("Bastion.content-views").controller("ContentViewDockerRepositoriesListController",["$scope","Repository","Nutupane","CurrentOrganization","ContentViewRepositoriesUtil",function($scope,Repository,Nutupane,CurrentOrganization,ContentViewRepositoriesUtil){var nutupane;ContentViewRepositoriesUtil($scope),nutupane=new Nutupane(Repository,{organization_id:CurrentOrganization,content_view_id:$scope.$stateParams.contentViewId,content_type:"docker"},"queryUnpaged"),$scope.repositoriesTable=nutupane.table,$scope.removeRepositories=function(){$scope.removeSelectedRepositoriesFromContentView(nutupane,$scope.contentView)}}]),angular.module("Bastion.content-views").controller("ContentViewPromotionController",["$scope","$q","translate","ContentViewVersion","Organization","CurrentOrganization",function($scope,$q,translate,ContentViewVersion,Organization,CurrentOrganization){function success(){var message=translate("Successfully initiated promotion of %cv version %ver to %env.");message=message.replace("%cv",$scope.contentView.name).replace("%env",$scope.selectedEnvironment.name),message=message.replace("%ver",$scope.version.version),$scope.promoting=!1,$scope.$parent.successMessages=[message],$scope.transitionTo("content-views.details.versions",{contentViewId:$scope.contentView.id})}function failure(response){$scope.promoting=!1,$scope.$parent.errorMessages=[response.data.displayMessage]}$scope.promotion={},$scope.working=!1,$scope.version=ContentViewVersion.get({id:$scope.$stateParams.versionId}),$scope.currentOrganization=CurrentOrganization,$scope.availableEnvironments=Organization.paths({id:CurrentOrganization,permission_type:"promotable"}),$q.all([$scope.availableEnvironments.$promise,$scope.version.$promise]).then(function(args){var environments=args[0],version=args[1];angular.forEach(environments,function(path){angular.forEach(path.environments,function(environment){environment.disabled=$scope.checkDisabled(environment,version.environments)})}),$scope.working=!0}),$scope.checkDisabled=function(env,environments){var enabled=!1,envIds=_.pluck(environments,"id");return env.prior||(env.prior={}),envIds.indexOf(env.id)!==-1?enabled=!1:env.library?enabled=!0:envIds.length!==0&&envIds.indexOf(env.prior.id)!==-1&&(enabled=!0),!enabled},$scope.promote=function(){$scope.promoting=!0,ContentViewVersion.promote({id:$scope.version.id,environment_id:$scope.selectedEnvironment.id},success,failure)}}]),angular.module("Bastion.content-views").controller("ContentViewPublishController",["$scope","translate","ContentView",function($scope,translate,ContentView){function success(){$scope.transitionTo("content-views.details.versions",{contentViewId:$scope.contentView.id}),$scope.$parent.contentView=ContentView.get({id:$scope.$stateParams.contentViewId}),$scope.working=!1}function failure(response){$scope.$parent.errorMessages=[response.data.displayMessage],$scope.working=!1}$scope.version={},$scope.publish=function(contentView){var description=$scope.version.description,data={id:contentView.id,description:description};$scope.working=!0,ContentView.publish(data,success,failure)}}]),angular.module("Bastion.content-views").controller("ContentViewRepositoriesListController",["$scope","Repository","Nutupane","CurrentOrganization","ContentViewRepositoriesUtil",function($scope,Repository,Nutupane,CurrentOrganization,ContentViewRepositoriesUtil){var nutupane;ContentViewRepositoriesUtil($scope),nutupane=new Nutupane(Repository,{organization_id:CurrentOrganization,content_view_id:$scope.$stateParams.contentViewId,content_type:"yum"},"queryUnpaged"),$scope.repositoriesTable=nutupane.table,$scope.removeRepositories=function(){$scope.removeSelectedRepositoriesFromContentView(nutupane,$scope.contentView)}}]),angular.module("Bastion.content-views").service("ContentViewRepositoriesUtil",["translate",function(translate){return function(scope){function extractProducts(repositories){var products={};return scope.product={name:translate("All Products"),id:"all"},angular.forEach(repositories,function(repository){products[repository.product.id]=repository.product}),products[scope.product.id]=scope.product,products}scope.product={id:"all"},scope.products={},scope.filteredItems=[],scope.$watch("repositoriesTable.rows",function(repositories){scope.products=extractProducts(repositories)}),scope.repositoryFilter=function(repository){var include=!0;return scope.product&&scope.product.id!=="all"&&repository.product.id!==scope.product.id&&(include=!1),include},scope.getSelected=function(nutupane){var selected=nutupane.getAllSelectedResults().included.ids,filtered=_.pluck(scope.filteredItems,"id");return selected=_.reject(selected,function(id){return!_.contains(filtered,id)}),selected},scope.removeSelectedRepositoriesFromContentView=function(nutupane,contentView){var ids=[],selected=scope.getSelected(nutupane);angular.forEach(contentView.repository_ids,function(id){selected.indexOf(id)===-1&&ids.push(id)}),contentView.repository_ids=ids,scope.save(contentView).then(function(){nutupane.refresh()})},scope.addSelectedRepositoriesToContentView=function(nutupane,contentView){var selected=scope.getSelected(nutupane);contentView.repository_ids=contentView.repository_ids.concat(selected),scope.save(contentView).then(function(){nutupane.refresh()})}}}]),angular.module("Bastion.content-views").controller("ContentViewVersionsController",["$scope","translate",function($scope,translate){function findTaskTypes(activeHistory,taskType){return _.filter(activeHistory,function(history){return history.task.label===taskType})}function deleteMessage(count){var messages=[translate("Deleting from 1 environment."),translate("Deleting from %count environments.").replace("%count",count)];return pluralSafe(count,messages)}function publishMessage(count){var messages=[translate("Publishing and promoting to 1 environment."),translate("Publishing and promoting to %count environments.").replace("%count",count)];return pluralSafe(count,messages)}function promoteMessage(count){var messages=[translate("Promoting to 1 environment."),translate("Promoting to %count environments.").replace("%count",count)];return pluralSafe(count,messages)}function pluralSafe(count,strings){return count===1?strings[0]:strings[1]}$scope.table={},$scope.reloadVersions(),$scope.$on("$destroy",function(){_.each($scope.versions,function(version){version.task&&version.task.unregisterAll()})}),$scope.hideProgress=function(version){return version.active_history.length===0||version.task.state==="stopped"&&version.task.progressbar.type==="success"},$scope.historyText=function(version){var taskTypes=$scope.taskTypes,taskType=version.last_event.task.label,message="";return taskType===taskTypes.deletion?message=translate("Deletion from %s").replace("%s",version.last_event.environment.name):taskType===taskTypes.promotion?message=translate("Promoted to %s").replace("%s",version.last_event.environment.name):taskType===taskTypes.publish?message=translate("Published"):taskType===taskTypes.incrementalUpdate&&(message=translate("Incremental Update")),message},$scope.status=function(version){var taskTypes=$scope.taskTypes,deletionEvents=findTaskTypes(version.active_history,taskTypes.deletion),promotionEvents=findTaskTypes(version.active_history,taskTypes.promotion),publishEvents=findTaskTypes(version.active_history,taskTypes.publish),messages="";return deletionEvents.length>0?messages=deleteMessage(deletionEvents.length):promotionEvents.length>0?messages=promoteMessage(promotionEvents.length):publishEvents.length>0&&(messages=publishMessage(publishEvents.length)),messages},$scope.taskInProgress=function(version){var inProgress=!1;return version.task&&(version.task.state==="pending"||version.task.state==="running")&&(inProgress=!0),inProgress},$scope.taskFailed=function(version){var failed=!1;return version.task&&version.task.result==="error"&&(failed=!0),failed}}]),angular.module("Bastion.content-views").controller("AvailableErrataFilterController",["$scope","translate","Nutupane","Filter","Rule",function($scope,translate,Nutupane,Filter,Rule){function saveRules(rules,filter){var params={filterId:filter.id};return rules.$save(params,success,failure)}function success(data){$scope.filter.rules=_.union($scope.filter.rules,data.results),$scope.$parent.successMessages=[translate("Errata successfully added.")],nutupane.table.selectAllResults(!1),nutupane.refresh()}function failure(response){$scope.$parent.errorMessages=[response.data.displayMessage]}var nutupane,filterByDate;$scope.nutupane=nutupane=new Nutupane(Filter,{filterId:$scope.$stateParams.filterId,sort_order:"DESC",sort_by:"issued"},"availableErrata"),nutupane.enableSelectAllResults(),filterByDate=function(date,type){date=date.toISOString().split("T")[0],nutupane.addParam(type,date),nutupane.refresh()},$scope.detailsTable=nutupane.table,$scope.addErrata=function(filter){var errataIds,rules,results=nutupane.getAllSelectedResults("errata_id");nutupane.table.allResultsSelected?rules=new Rule({errata_ids:results}):(errataIds=results.included.ids,rules=new Rule({errata_ids:errataIds})),nutupane.table.working=!0,saveRules(rules,filter)},$scope.updateTypes=function(errataTypes){var types=[];angular.forEach(errataTypes,function(value,key){value&&types.push(key)}),nutupane.addParam("types[]",types),nutupane.refresh()},$scope.$watch("rule.start_date",function(start){start&&filterByDate(start,"start_date")}),$scope.$watch("rule.end_date",function(end){end&&filterByDate(end,"end_date")})}]),angular.module("Bastion.content-views").controller("AvailablePackageGroupFilterController",["$scope","translate","Filter","Rule","Nutupane",function($scope,translate,Filter,Rule,Nutupane){function saveRule(rule,filter){var params={filterId:filter.id};rule.$save(params,success,failure)}function success(rule){nutupane.removeRow(rule.uuid,"id"),$scope.filter.rules.push(rule),$scope.successMessages=[translate("Package Group successfully added.")]}function failure(response){$scope.errorMessages=[response.data.displayMessage]}var nutupane;nutupane=new Nutupane(Filter,{filterId:$scope.$stateParams.filterId},"availablePackageGroups"),$scope.detailsTable=nutupane.table,nutupane.table.closeItem=function(){},$scope.addPackageGroups=function(filter){var packageGroups=nutupane.getAllSelectedResults().included.resources;angular.forEach(packageGroups,function(group){var rule=new Rule({uuid:group.id,name:group.name});saveRule(rule,filter)})}}]),angular.module("Bastion.content-views").controller("DateTypeErrataFilterController",["$scope","translate","Rule",function($scope,translate,Rule){function success(){$scope.successMessages=[translate("Updated errata filter - "+$scope.filter.name)]}function failure(response){$scope.rule.working=!1,$scope.errorMessages=[response.data.displayMessage]}$scope.filter.$promise.then(function(filter){$scope.types={enhancement:!1,bugfix:!1,security:!1},$scope.rule=new Rule(filter.rules[0]),angular.forEach($scope.types,function(value,type){$scope.rule.types.indexOf(type)>-1&&($scope.types[type]=!0)})}),$scope.updateTypes=function(types){$scope.rule.types=[],angular.forEach(types,function(chosen,type){chosen&&$scope.rule.types.push(type)})},$scope.save=function(rule,filter){var params={filterId:filter.id,ruleId:rule.id};rule.$update(params,success,failure),$scope.filter=$scope.filter.$get()}}]),angular.module("Bastion.content-views").controller("FilterEditController",["$scope","$q","translate",function($scope,$q,translate){$scope.save=function(filter){var deferred=$q.defer(),success,failure=function(response){deferred.reject(response),angular.forEach(response.data.errors,function(errorMessage){$scope.errorMessages.push(translate("An error occurred saving the Filter: ")+errorMessage)}),$scope.working=!1};return success=function(response){deferred.resolve(response),$scope.successMessages.push(translate("Filter Saved")),$scope.working=!1,$scope.$emit("filter.updated")},filter.$update(success,failure),deferred.promise}}]),angular.module("Bastion.content-views").controller("ErrataFilterListController",["$scope","translate","Nutupane","Filter","Rule",function($scope,translate,Nutupane,Filter,Rule){function success(rule){nutupane.removeRow(rule.errata_id,"errata_id"),$scope.filter.rules=_.reject($scope.filter.rules,function(filterRule){return rule.id===filterRule.id}),$scope.$parent.successMessages=[translate("Errata successfully removed.")]}function failure(response){$scope.$parent.errorMessages=[response.data.displayMessage]}function findRules(errataIds){var rules=[];return angular.forEach(errataIds,function(id){var found;found=_.find($scope.filter.rules,function(rule){return rule.errata_id===id}),found&&rules.push(new Rule(found))}),rules}var nutupane;$scope.nutupane=nutupane=new Nutupane(Filter,{filterId:$scope.$stateParams.filterId,sort_order:"DESC",sort_by:"issued"},"errata"),$scope.detailsTable=nutupane.table,$scope.removeErrata=function(){var errataIds=nutupane.getAllSelectedResults("errata_id").included.ids,rules;nutupane.table.working=!0,rules=findRules(errataIds),angular.forEach(rules,function(rule){rule.$delete(success,failure)})},$scope.errataFilter=function(){return!0}}]),angular.module("Bastion.content-views").controller("ErrataFilterController",["$scope",function($scope){$scope.successMessages=[],$scope.errorMessages=[],$scope.rule={errataType:"all",start_date:null,end_date:null},$scope.date={startOpen:!1,endOpen:!1},$scope.types={enhancement:!0,bugfix:!0,security:!0},$scope.errataFilter=function(errata){var include=!1,issued=new Date(errata.issued);return $scope.types[errata.type]&&(include=!0),$scope.rule.start_date&&(include=include&&issued.getTime()>=$scope.rule.start_date.getTime()),$scope.rule.end_date&&(include=include&&issued.getTime()<=$scope.rule.end_date.getTime()),include},$scope.openEndDate=function($event){$event.preventDefault(),$event.stopPropagation(),$scope.date.endOpen=!0,$scope.date.startOpen=!1},$scope.openStartDate=function($event){$event.preventDefault(),$event.stopPropagation(),$scope.date.startOpen=!0,$scope.date.endOpen=!1},$scope.onlySelected=function(object,type){var selected=_.filter(object,function(value){return value});return object[type]&&selected.length===1}}]),angular.module("Bastion.content-views").filter("filterContentType",["FilterHelper",function(FilterHelper){return function(type){return FilterHelper.contentType(type)}}]),angular.module("Bastion.content-views").controller("FilterDetailsController",["$scope","Filter",function($scope,Filter){$scope.filter=Filter.get({content_view_id:$scope.$stateParams.contentViewId,filterId:$scope.$stateParams.filterId}),$scope.updateFilter=function(filter){filter.$update()}}]),angular.module("Bastion.content-views").service("FilterHelper",["translate",function(translate){this.contentTypes={rpm:translate("Packages"),erratum:translate("Errata"),package_group:translate("Package Groups")},this.contentType=function(type){return this.contentTypes[type]},this.type=function(type){return type?translate("Include"):translate("Exclude")}}]),angular.module("Bastion.content-views").controller("FilterRepositoriesController",["$scope","translate","Filter","ContentViewRepositoriesUtil",function($scope,translate,Filter,ContentViewRepositoriesUtil){var refreshTable,success,error;ContentViewRepositoriesUtil($scope),refreshTable=function(filter){$scope.$parent.filter=filter;var displayedRepositories=filter.content_view.repositories,filterRepositories=filter.repositories;filterRepositories.length===0?displayedRepositories=_.map(displayedRepositories,function(repository){return repository.selected=!0,repository}):displayedRepositories=_.map(displayedRepositories,function(repository){return repository.selected=_.pluck(filterRepositories,"id").indexOf(repository.id)>=0,repository}),$scope.repositoriesTable.rows=displayedRepositories,$scope.showRepos=filterRepositories.length!==0},success=function(filter){refreshTable(filter),$scope.successMessages=[translate("Affected repositories have been updated.")]},error=function(response){$scope.errorMessages=response.data.errors},$scope.successMessages=[],$scope.errorMessages=[],$scope.showRepos=!1,$scope.repositoriesTable={},$scope.filter.$promise.then(refreshTable),$scope.updateRepositories=function(){var repositoryIds=_.pluck($scope.repositoriesTable.getSelected(),"id");repositoryIds.length===0?$scope.errorMessages=[translate("You must select at least one repository.")]:Filter.update({id:$scope.filter.id,repository_ids:repositoryIds},success,error)},$scope.selectAllRepositories=function(){Filter.update({id:$scope.filter.id,repository_ids:[]},success,error)}}]),angular.module("Bastion.content-views").filter("filterType",["FilterHelper",function(FilterHelper){return function(type){return FilterHelper.type(type)}}]),angular.module("Bastion.content-views").factory("Filter",["BastionResource",function(BastionResource){return BastionResource("/katello/api/v2/content_view_filters/:filterId/:action",{filterId:"@id",content_view_id:"@content_view.id"},{update:{method:"PUT"},availableErrata:{method:"GET",params:{action:"available_errata"}},errata:{method:"GET",params:{action:"errata"}},availablePackageGroups:{method:"GET",params:{action:"available_package_groups"}},packageGroups:{method:"GET",params:{action:"package_groups"}}})}]),angular.module("Bastion.content-views").controller("FiltersController",["$scope","translate","Filter","Nutupane",function($scope,translate,Filter,Nutupane){function removeFilter(id){var success,failure;success=function(){nutupane.removeRow(id),$scope.successMessages=[translate("Filters successfully removed.")]},failure=function(response){$scope.errorMessages=[response.data.displayMessage]},Filter.delete({filterId:id},success,failure)}var nutupane;nutupane=new Nutupane(Filter,{content_view_id:$scope.$stateParams.contentViewId}),$scope.detailsTable=nutupane.table,$scope.$on("filter.created",function(){nutupane.refresh()}),$scope.$on("filter.updated",function(){nutupane.refresh()}),$scope.removeFilters=function(){var filterIds=nutupane.getAllSelectedResults().included.ids;angular.forEach(filterIds,removeFilter)},nutupane.table.closeItem=function(){},$scope.getFilterState=function(filter){var state;switch(filter.type){case"erratum":state="content-views.details.filters.details.erratum.list({filterId: filter.id})",filter.rules[0].types&&(state="content-views.details.filters.details.erratum.dateType({filterId: filter.id})");break;case"rpm":state="content-views.details.filters.details.rpm({filterId: filter.id})";break;case"package_group":state="content-views.details.filters.details.package_group.list({filterId: filter.id})"}return state}}]),angular.module("Bastion.content-views").controller("NewFilterController",["$scope","Filter","Rule",function($scope,Filter,Rule){function success(filter){filterType==="erratumDateType"?addErrataDateTypeRule(filter):transitionToDetails(filter)}function failure(response){$scope.working=!1,angular.forEach(response.data.errors,function(errors,field){$scope.filterForm[field].$setValidity("server",!1),$scope.filterForm[field].$error.messages=errors})}function transitionToDetails(filter){var state="";filterType==="erratumId"?state="content-views.details.filters.details.erratum.available":filterType==="erratumDateType"?state="content-views.details.filters.details.erratum.dateType":filterType==="rpm"?state="content-views.details.filters.details.rpm.details":filterType==="package_group"&&(state="content-views.details.filters.details.package_group.available"),$scope.$emit("filter.created"),$scope.transitionTo(state,{filterId:filter.id,contentViewId:filter.content_view.id})}function addErrataDateTypeRule(filter){var rule=new Rule({types:["security","enhancement","bugfix"]}),success,failure;success=function(){transitionToDetails(filter)},failure=function(response){$scope.errorMessages=[response.data.displayMessage]},rule.$save({filterId:filter.id},success,failure)}var filterType;$scope.filter=new Filter,$scope.working=!1,$scope.save=function(filter,contentView){filterType=filter.type;if(filter.type==="erratumId"||filter.type==="erratumDateType")filter.type="erratum";filter.$save({content_view_id:contentView.id},success,failure)}}]),angular.module("Bastion.content-views").controller("PackageFilterController",["$scope","translate","Rule","Package",function($scope,translate,Rule,Package){function removeRule(rule){var success,rulesCopy=angular.copy($scope.filter.rules),ruleId=rule.id;success=function(){angular.forEach(rulesCopy,function(rule,index){rule.id===ruleId&&$scope.filter.rules.splice(index,1)}),$scope.successMessages=[translate("Package successfully removed.")]},Rule.delete({filterId:rule.content_view_filter_id,ruleId:ruleId},success,failure)}function addSuccess(rule){$scope.rule={type:"all"},$scope.rule.editMode=!1,$scope.rule.working=!1,addType([rule]),$scope.filter.rules.push(rule),$scope.successMessages=[translate("Package successfully added.")]}function failure(response){$scope.errorMessages=[response.data.displayMessage]}function addType(rules){angular.forEach(rules,function(rule){rule.type=type(rule)})}function type(rule){var typeId;return rule.version?typeId="equal":rule.min_version&&!rule.max_version?typeId="greater":!rule.min&&rule.max_version?typeId="less":rule.min&&rule.max_version?typeId="range":typeId="all",typeId}$scope.successMessages=[],$scope.errorMessages=[],$scope.rule={type:"all",editMode:!1,working:!1},$scope.filter.$promise.then(function(filter){addType(filter.rules)}),$scope.addRule=function(rule,filter){$scope.valid(rule)&&Rule.save({filterId:filter.id},rule,addSuccess,failure)},$scope.updateRule=function(rule,filter){var params={filterId:filter.id,ruleId:rule.id},success,failure;success=function(){rule.previous={},rule.editMode=!1,rule.working=!1,$scope.successMessages=[translate("Package successfully updated.")]},failure=function(){rule.working=!1},Rule.update(params,rule,success,failure)},$scope.valid=function(rule){var valid=rule.name?!0:!1;return rule.type==="equal"?valid=valid&&rule.version:rule.type==="less"?valid=valid&&rule.max_version:rule.type==="greater"?valid=valid&&rule.min_version:rule.type==="range"&&(valid=valid&&rule.min_version&&rule.max_version),valid},$scope.clearValues=function(rule){rule.version=undefined,rule.min_version=undefined,rule.max_version=undefined},$scope.backupPrevious=function(rule){rule.previous={},angular.copy(rule,rule.previous)},$scope.restorePrevious=function(rule){angular.copy(rule.previous,rule),rule.previous={}},$scope.getSelectedRules=function(filter){var rules=[];return angular.forEach(filter.rules,function(rule){rule.selected&&rules.push(rule)}),rules},$scope.removeRules=function(filter){angular.forEach($scope.getSelectedRules(filter),function(rule){removeRule(rule)})},$scope.fetchAutocomplete=function(term){var repositoryIds=$scope.contentView.repository_ids,promise;return promise=Package.autocomplete({repoids:repositoryIds,term:term}).$promise,promise.then(function(data){return data.results})}}]),angular.module("Bastion.content-views").controller("PackageGroupFilterController",["$scope",function($scope){$scope.successMessages=[],$scope.errorMessages=[]}]),angular.module("Bastion.content-views").controller("PackageGroupFilterListController",["$scope","translate","Filter","Rule","Nutupane",function($scope,translate,Filter,Rule,Nutupane){function success(rule){nutupane.removeRow(rule.uuid,"id"),$scope.filter.rules=_.reject($scope.filter.rules,function(filterRule){return rule.id===filterRule.id}),$scope.successMessages=[translate("Package Group successfully removed.")]}function failure(response){$scope.errorMessages=[response.data.displayMessage]}function findRules(packageGroupIds){var rules=[];return angular.forEach(packageGroupIds,function(id){var found;found=_.find($scope.filter.rules,function(rule){return rule.uuid===id}),found&&rules.push(new Rule(found))}),rules}var nutupane;nutupane=new Nutupane(Filter,{filterId:$scope.$stateParams.filterId},"packageGroups"),$scope.detailsTable=nutupane.table,nutupane.table.closeItem=function(){},$scope.removePackageGroups=function(){var packageGroupIds=nutupane.getAllSelectedResults().included.ids,rules;rules=findRules(packageGroupIds),angular.forEach(rules,function(rule){rule.$delete(success,failure)})}}]),angular.module("Bastion.content-views").factory("Rule",["BastionResource",function(BastionResource){return BastionResource("/katello/api/v2/content_view_filters/:filterId/rules/:ruleId",{ruleId:"@id",filterId:"@content_view_filter_id"},{update:{method:"PUT"}})}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/date-type-errata-filter.html",'<form name="errataForm" class="form-horizontal">\n\n  <div ng-include="\'content-views/details/filters/views/date-type-errata.html\'"></div>\n\n  <div bst-form-buttons\n       on-cancel="transitionTo(\'content-views.details.filters.list\', {contentViewId: contentView.id})"\n       on-save="save(rule, filter)"\n       working="rule.working">\n  </div>\n\n</form>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/date-type-errata.html",'<div data-block="messages" bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n<div bst-form-group label="{{ \'Errata Type\' | translate }}">\n\n  <label class="checkbox-inline">\n    <input type="checkbox"\n           name="types"\n           value="{{ types.security }}"\n           ng-model="types.security"\n           ng-change="updateTypes(types)"\n           ng-disabled="onlySelected(types, \'security\')"/>\n    <span translate>Security</span>\n  </label>\n\n  <label class="checkbox-inline">\n    <input type="checkbox"\n           name="types"\n           value="{{ types.enhancement }}"\n           ng-model="types.enhancement"\n           ng-change="updateTypes(types)"\n           ng-disabled="onlySelected(types, \'enhancement\')"/>\n    <span translate>Enhancement</span>\n  </label>\n\n  <label class="checkbox-inline">\n    <input type="checkbox"\n           name="types"\n           value="{{ types.bugfix }}"\n           ng-model="types.bugfix"\n           ng-change="updateTypes(types)"\n           ng-disabled="onlySelected(types, \'bugfix\')"/>\n    <span translate>Bugfix</span>\n  </label>\n\n</div>\n\n<div bst-form-group label="{{ \'Start Date\' | translate }}">\n  <div class="input-group">\n    <input class="form-control" datepicker-popup="dd-MMMM-yyyy" ng-model="rule.start_date" is-open="date.startOpen" ng-click="openStartDate($event)"/>\n    <span class="input-group-btn">\n      <button class="btn btn-default" type="button" ng-click="openStartDate($event)">\n        <i class="icon-calendar inline-icon"></i>\n      </button>\n    </span>\n  </div>\n</div>\n\n<div bst-form-group label="{{ \'End Date\' | translate }}">\n  <div class="input-group">\n    <input class="form-control" datepicker-popup="dd-MMMM-yyyy" ng-model="rule.end_date" is-open="date.endOpen" ng-click="openEndDate($event)"/>\n    <span class="input-group-btn">\n      <button class="btn btn-default" type="button" ng-click="openEndDate($event)">\n        <i class="icon-calendar inline-icon"></i>\n      </button>\n    </span>\n  </div>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/edit-filter.html",'<span page-title ng-model="filter">{{ \'Filter information for:\' | translate }} {{ filter.name }}</span>\n    <div class="detail">\n      <span class="info-label" translate>Name</span>\n      <span class="info-value"\n            bst-edit-text="filter.name"\n            on-save="save(filter)"\n            readonly="denied(\'edit_content_views\', contentView)">\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Description</span>\n      <span class="info-value"\n            bst-edit-textarea="filter.description"\n            on-save="save(filter)"\n            readonly="denied(\'edit_content_views\', contentView)">\n      </span>\n    </div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/errata-filter-details.html",'<div ng-if="isState(\'content-views.details.filters.details.erratum.available\')">\n  <form name="errataForm" class="form-horizontal">\n    <div ng-include="\'content-views/details/filters/views/date-type-errata.html\'"></div>\n  </form>\n</div>\n\n<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="header"></div>\n\n  <div data-block="actions">\n    <button class="btn btn-primary fr"\n            ng-show="isState(\'content-views.details.filters.details.erratum.list\') && permitted(\'edit_content_views\', contentView)"\n            ng-disabled="detailsTable.working || detailsTable.numSelected === 0"\n            ng-click="removeErrata(contentView)">\n      <i class="icon-trash"></i>\n      <span translate>Remove Errata</span>\n    </button>\n    <button class="btn btn-primary fr"\n            ng-show="isState(\'content-views.details.filters.details.erratum.available\') && permitted(\'edit_content_views\', contentView)"\n            ng-disabled="detailsTable.working || detailsTable.numSelected === 0"\n            ng-click="addErrata(filter)">\n      <i class="icon-plus"></i>\n      <span translate>Add Errata</span>\n    </button>\n  </div>\n\n  <table data-block="table" class="table table-bordered table-striped">\n    <thead>\n      <tr bst-table-head row-select>\n        <th bst-table-column translate>Errata ID</th>\n        <th bst-table-column translate>Errata Type</th>\n        <th bst-table-column translate>Issued</th>\n        <th bst-table-column translate>Title</th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr bst-table-row ng-repeat="errata in detailsTable.rows" row-select="errata">\n        <td bst-table-cell>{{ errata.errata_id }}</td>\n        <td bst-table-cell>\n          {{ errata.type }}\n        </td>\n        <td bst-table-cell>\n          {{ errata.issued | date:\'M/d/yy\' }}\n        </td>\n        <td bst-table-cell>{{ errata.title }}</td>\n      </tr>\n    </tbody>\n  </table>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/errata-filter.html",'<span page-title ng-model="filter">{{ \'Errata Filter:\' | translate }} {{ filter.name }}</span>\n\n<div class="details details-full">\n  \n  <nav>\n    <ul class="nav nav-tabs">\n\n      <li ng-class="{active: isState(\'content-views.details.filters.details.erratum.edit\')}">\n        <a ui-sref="content-views.details.filters.details.erratum.edit">\n        <span translate>\n	  Details\n        </span>\n        </a>\n      </li>\n\n      <li ng-if="!filter.rules[0].types" ng-class="{active: isState(\'content-views.details.filters.details.erratum.list\')}">\n        <a ui-sref="content-views.details.filters.details.erratum.list({filterId: filter.id})">\n        <span translate>\n          List/Remove\n        </span>\n        </a>\n      </li>\n\n      <li ng-if="!filter.rules[0].types" ng-class="{active: isState(\'content-views.details.filters.details.erratum.available\')}"\n          ng-show="permitted(\'edit_content_views\', contentView)">\n        <a ui-sref="content-views.details.filters.details.erratum.available({filterId: filter.id})">\n        <span translate>\n          Add\n        </span>\n        </a>\n      </li>\n\n      <li ng-if="filter.rules[0].types" ng-class="{active: isState(\'content-views.details.filters.details.erratum.dateType\')}"\n          ng-show="permitted(\'edit_content_views\', contentView)">\n        <a ui-sref="content-views.details.filters.details.erratum.dateType({filterId: filter.id})">\n        <span translate>\n          Erratum Date Range\n        </span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.filters.details.erratum.repositories\')}"\n          ng-show="permitted(\'edit_content_views\', contentView)">\n        <a ui-sref="content-views.details.filters.details.erratum.repositories({filterId: filter.id})"\n           ng-include="\'content-views/details/filters/views/partials/filter-repositories-count.html\'">\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <div ui-view></div>\n\n</div>\n'
)}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/filter-details.html",'<span page-title ng-model="filter">{{ \'Filter:\' | translate }} {{ filter.name }}</span>\n\n<div class="loading-mask loading-mask-panel icon-3x" ng-show="filter.id === undefined">\n    <i class="icon-spinner icon-spin"></i>\n    {{ "Loading..." | translate }}\n</div>\n\n<div class="details details-full" ng-show="filter.id !== undefined">\n\n  <ol class="breadcrumb">\n    <li ng-class="{active: isState(\'content-views.details.filters.list\')}">\n      <a ui-sref="content-views.details.filters.list" translate>Filters</a>\n    </li>\n    \n    <li ng-if="filter.type === \'erratum\'" \n        ng-class="{active: stateIncludes(\'content-views.details.filters.details.erratum\')}">\n      <a ng-if="!filter.rules[0].types"\n         ui-sref="content-views.details.filters.details.erratum.list({filterId: filter.id})">\n        {{ filter.name }}\n      </a>\n      <a ng-if="filter.rules[0].types"\n         ui-sref="content-views.details.filters.details.erratum.dateType({filterId: filter.id})">\n        {{ filter.name }}\n      </a>\n    </li>\n    \n    <li ng-if="filter.type === \'rpm\'"\n        ng-class="{active: stateIncludes(\'content-views.details.filters.details.rpm\')}">\n      <a ui-sref="content-views.details.filters.details.rpm({filterId: filter.id})">\n        {{ filter.name }}\n      </a>\n    </li>\n    \n    <li ng-if="filter.type === \'package_group\'"\n        ng-class="{active: stateIncludes(\'content-views.details.filters.details.package_group\')}">\n    <a ui-sref="content-views.details.filters.details.package_group.list({filterId: filter.id})">\n        {{ filter.name }}\n      </a>\n    </li>\n  </ol>\n\n  <header class="details-header">\n    <h3>{{ filter.name }} ({{ filter.inclusion | filterType }} {{ filter.type | filterContentType }})</h3>\n  </header>\n\n  <div ui-view></div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/filter-repositories.html",'<span page-title ng-model="filter">{{ \'Repositories for Filter:\' | translate }} {{ filter.name }}</span>\n\n<div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n<section class="details details-full">\n\n  <div class="details-header">\n    <div class="well col-sm-8">\n      <div class="radio">\n        <label>\n          <input type="radio"\n                 ng-value="false"\n                 ng-model="showRepos"\n                 ng-hide="denied(\'edit_content_views\', contentView)"\n                 ng-click="selectAllRepositories()"/>\n          <span translate>This filter applies to all repositories in the content view (current and future).</span>\n        </label>\n      </div>\n      <div class="radio">\n        <label>\n          <input type="radio"\n                 ng-value="true"\n                 ng-hide="denied(\'edit_content_views\', contentView)"\n                 ng-model="showRepos"/>\n          <span translate>This filter applies only to a subset of repositories in the content view.</span>\n        </label>\n      </div>\n    </div>\n  </div>\n\n  <div ng-class="{\'table-mask\': !showRepos}">\n    <span class="pull-right">\n      <button class="btn btn-primary"\n              translate\n              ng-hide="denied(\'edit_content_views\', contentView)"\n              ng-disabled="!showRepos || repositoriesTable.numSelected === 0"\n              ng-click="updateRepositories()">\n        Update Repositories\n      </button>\n    </span>\n\n    <div class="row">\n      <div class="col-sm-8">\n        <div class="input-group">\n\n          <span class="input-group-addon">\n            <select ng-model="product" ng-options="product.name for (id, product) in products">\n            </select>\n          </span>\n\n          <input type="text"\n                 class="form-control filter-input"\n                 placeholder="{{ \'Filter\' | translate }}"\n                 ng-model="repositorySearch"/>\n\n        </div>\n      </div>\n    </div>\n\n    <table bst-table="repositoriesTable"\n           class="table table-striped"\n           ng-class="{\'table-mask\': repositoriesTable.working}">\n      <thead>\n        <tr bst-table-head>\n          <th bst-table-column="affectedRepos">Affected?</th>\n          <th bst-table-column="name" translate>Name</th>\n          <th bst-table-column="product" translate>Product</th>\n          <th bst-table-column="type" translate>Type</th>\n          <th bst-table-column="sync-status" translate>Sync Status</th>\n          <th bst-table-column="content" translate>Content</th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row\n            row-select="repository"\n            ng-hide="denied(\'edit_content_views\', contentView)"\n            ng-disabled="!showRepos"\n            ng-repeat="repository in repositoriesTable.rows | filter:repositorySearch | filter:repositoryFilter">\n          <td bst-table-cell>\n            <a ui-sref="products.details.repositories.info({productId: repository.product.id, repositoryId: repository.id})">\n              {{ repository.name }}\n            </a>\n          </td>\n          <td bst-table-cell>\n            <a ui-sref="products.details.info({productId: repository.product.id})">\n              {{ repository.product.name }}\n            </a>\n          </td>\n          <td bst-table-cell>{{ repository.content_type }}</td>\n          <td bst-table-cell>\n              <span ng-show="repository.url">\n                <span ng-show="repository.last_sync == null" translate>\n                  Not Synced\n                </span>\n                <span ng-hide="repository.last_sync == null">\n                  <a href="/foreman_tasks/tasks/{{repository.last_sync.id}}">{{ repository.last_sync.result | capitalize}}</a>\n                  ({{ repository.last_sync.ended_at | date:"short" }})\n                </span>\n              </span>\n            <span ng-hide="repository.url" translate>N/A</span>\n          </td>\n          <td bst-table-cell>\n              <span ng-show="repository.content_type == \'puppet\'">\n                <a translate ng-href="/katello/content_search#/!=&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_puppet_modules">\n                  {{ repository.content_counts.puppet_module || 0 }} Puppet Modules\n                </a>\n              </span>\n\n              <span ng-hide="repository.content_type == \'puppet\'">\n                <div>\n                  <a translate ng-href="/katello/content_search#/!=&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_packages">\n                    {{ repository.content_counts.rpm || 0 }} Packages\n                  </a>\n                </div>\n\n                <div>\n                  <a translate ng-href="/katello/content_search#/!=&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_errata">\n                    {{ repository.content_counts.erratum || 0 }} Errata\n                  </a>\n                </div>\n              </span>\n          </td>\n        </tr>\n      </tbody>\n    </table>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/filters.html",'<span page-title ng-model="contentView">{{ \'Filters for Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div data-extend-template="layouts/details-nutupane.html">\n   \n  <div data-block="messages"></div>\n\n  <div data-block="header">\n    <h3 translate>Filters</h3>\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-default"\n            ng-hide="denied(\'edit_content_views\', contentView)"\n            ui-sref="content-views.details.filters.new">\n      <i class="icon-plus"></i>\n      <span translate>New Filter</span>\n    </button>\n    <button class="btn btn-default"\n            ng-hide="denied(\'edit_content_views\', contentView)"\n            ng-disabled="detailsTable.numSelected === 0"\n            ng-click="removeFilters()">\n      <i class="icon-trash"></i>\n      <span translate>Remove Filters</span>\n    </button>\n  </div>\n\n  <div data-block="table">\n    <p class="alert alert-info" ng-show="detailsTable.rows.length === 0" translate>\n      You currently don\'t have any Filters included in this Content View, you can add a new Filter by using the button on the right.\n    </p>\n\n    <table class="table table-striped table-bordered" ng-show="detailsTable.rows.length > 0"\n           ng-class="{\'table-mask\': detailsTable.working}">\n\n      <thead>\n        <tr bst-table-head row-select>\n          <th bst-table-column><span translate>Name</span></th>\n          <th bst-table-column><span translate>Description</span></th>\n          <th bst-table-column><span translate>Updated</span></th>\n          <th bst-table-column><span translate>Content Type</span></th>\n          <th bst-table-column><span translate>Type</span></th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row ng-repeat="filter in detailsTable.rows" row-select="filter">\n          <td bst-table-cell>\n            <a ng-if="filter.type === \'erratum\' && !filter.rules[0].types"\n               ui-sref="content-views.details.filters.details.erratum.list({filterId: filter.id})">\n              {{ filter.name }}\n            </a>\n            <a ng-if="filter.type === \'erratum\' && filter.rules[0].types"\n               ui-sref="content-views.details.filters.details.erratum.dateType({filterId: filter.id})">\n              {{ filter.name }}\n            </a>\n            <a ng-if="filter.type === \'rpm\'"\n               ui-sref="content-views.details.filters.details.rpm.details({filterId: filter.id})">\n              {{ filter.name }}\n            </a>\n            <a ng-if="filter.type === \'package_group\'"\n               ui-sref="content-views.details.filters.details.package_group.list({filterId: filter.id})">\n              {{ filter.name }}\n            </a>\n          </td>\n          <td bst-table-cell>{{ filter.description }}</td>\n          <td bst-table-cell>{{ filter.updated_at | date:"short" }}</td>\n          <td bst-table-cell>\n            {{ filter.type | filterContentType }}\n            <span ng-if="filter.type === \'erratum\' && filter.rules[0].types">{{ \'- Date and Type\' | translate }}</span>\n          </td>\n          <td bst-table-cell>{{ filter.inclusion | filterType }}</td>\n        </tr>\n      </tbody>\n\n    </table>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/new-filter.html",'<span page-title ng-model="contentView">{{ \'New Filter for Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div class="details details-full">\n\n  <a ui-sref="content-views.details.filters.list">\n    <i class="icon-double-angle-left"></i>\n    <span translate>Filters List</span>\n  </a>\n\n  <header class="details-header">\n    <h3 translate>Add New Filter</h3>\n  </header>\n\n  <form name="filterForm" class="form-horizontal" role="form" novalidate>\n    <div bst-form-group label="{{ \'Name\' | translate }}">\n      <input id="name"\n             name="name"\n             ng-model="filter.name"\n             type="text"\n             tabindex="1"\n             autofocus\n             required/>\n    </div>\n    \n    <div bst-form-group label="{{ \'Content Type\' | translate }}">\n      <select id="type"\n              name="type"\n              ng-model="filter.type"\n              tabindex="2"\n              required>\n        <option value="rpm" translate>Package</option>\n        <option value="package_group" translate>Package Group</option>\n        <option value="erratumId" translate>Erratum - by ID</option>\n        <option value="erratumDateType" translate>Erratum - by Date and Type</option>\n      </select>\n    </div>\n\n    <div bst-form-group label="{{ \'Type\' | translate }}">\n      <select id="inclusion"\n              name="inclusion"\n              ng-model="filter.inclusion"\n              tabindex="3"\n              required>\n        <option value="true" translate>Include</option>\n        <option value="false" translate>Exclude</option>\n      </select>\n    </div>\n\n    <div bst-form-group label="{{ \'Description\' | translate }}">\n      <textarea id="description"\n                name="description"\n                ng-model="filter.description"\n                tabindex="3">\n      </textarea>\n    </div>\n\n    <div bst-form-buttons\n         on-cancel="transitionTo(\'content-views.details.filters.list\', {contentViewId: contentView.id})"\n         on-save="save(filter, contentView)"\n         working="working">\n    </div>\n  </form>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/package-filter-details.html",'<div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n<div class="details-header">\n  <div>\n    <input type="text"\n           class="form-control filter-input"\n           placeholder="{{ \'Filter\' | translate }}"\n           ng-model="packageFilter"/>\n  </div>\n\n  <div>\n    <input type="checkbox"\n           ng-model="filter.original_packages"\n           ng-change="updateFilter(filter)"/>\n\n    <span ng-show="filter.inclusion" translate>\n      Include all packages with no errata.\n    </span>\n\n    <span ng-show="!filter.inclusion" translate>\n      Exclude all packages with no errata.\n    </span>\n  </div>\n\n  <button class="btn btn-default fr"\n          ng-disabled="getSelectedRules(filter).length === 0"\n          ng-hide="denied(\'edit_content_views\', contentView)"\n          ng-click="removeRules(filter)">\n    <i class="icon-trash"></i>\n    <span translate>Remove Packages</span>\n  </button>\n</div>\n\n<table class="table table-bordered table-striped">\n\n  <thead>\n  <tr>\n    <th class="row-select"><input type="checkbox"\n                                  ng-model="allSelected"\n                                  ng-change="selectAll(allSelected)"\n                                  ng-hide="denied(\'edit_content_views\', contentView)"/></th>\n    <th translate>Package Name</th>\n    <th class="col-sm-5" translate>Detail</th>\n    <th class="col-sm-2"></th>\n  </tr>\n  </thead>\n\n  <tbody>\n  <tr>\n    <td></td><!-- Empty cell since the first row is special -->\n    <td>\n      <input type="text"\n             class="form-control"\n             typeahead="package for package in fetchAutocomplete($viewValue)"\n             ng-hide="denied(\'edit_content_views\', contentView)"\n             ng-model="rule.name"/>\n    </td>\n    <td>\n        <span class="col-sm-12" ng-class="{ \'col-sm-7\': rule.type != \'all\'}">\n          <select class="form-control"\n                  ng-model="rule.type"\n                  ng-change="clearValues(rule)"\n                  ng-hide="denied(\'edit_content_views\', contentView)">\n            <option value="all" translate>All Versions</option>\n            <option value="equal" translate>Equal To</option>\n            <option value="greater" translate>Greater Than</option>\n            <option value="less" translate>Less Than</option>\n            <option value="range" translate>Range</option>\n          </select>\n        </span>\n\n        <span ng-show="rule.type === \'greater\' || rule.type === \'less\' || rule.type === \'range\'">\n          <span class="col-sm-2">\n            <input type="text"\n                   class="form-control"\n                   ng-model="rule.min_version"\n                   ng-hide="denied(\'edit_content_views\', contentView)"\n                   ng-disabled="rule.type === \'less\'"/>\n          </span>\n          <span class="fl">-</span>\n          <span class="col-sm-2">\n            <input type="text"\n                   class="form-control"\n                   ng-model="rule.max_version"\n                   ng-hide="denied(\'edit_content_views\', contentView)"\n                   ng-disabled="rule.type === \'greater\'"/>\n          </span>\n        </span>\n\n        <span ng-show="rule.type === \'equal\'">\n          <span class="col-sm-4">\n            <input type="text" class="form-control"\n                   ng-model="rule.version"\n                   ng-hide="denied(\'edit_content_views\', contentView)"/>\n          </span>\n        </span>\n    </td>\n    <td class="action-cell">\n      <button class="btn btn-default"\n              ng-click="addRule(rule, filter)"\n              ng-hide="denied(\'edit_content_views\', contentView)"\n              ng-disabled="!valid(rule)">\n        <i class="icon-plus"></i>\n        <span translate>Add</span>\n      </button>\n    </td>\n  </tr>\n\n  <tr ng-repeat="rule in filter.rules | filter:packageFilter" row-select="rule">\n    <td class="row-select">\n      <input type="checkbox"\n             ng-hide="denied(\'edit_content_views\', contentView)"\n             ng-model="rule.selected"/>\n    </td>\n    <td>\n      <input class="form-control"\n             ng-hide="denied(\'edit_content_views\', contentView)"\n             ng-model="rule.name"\n             ng-readonly="!rule.editMode"/>\n    </td>\n    <td>\n        <span class="col-sm-12" ng-class="{ \'col-sm-7\': rule.type != \'all\'}">\n          <select class="form-control"\n                  ng-model="rule.type"\n                  ng-hide="denied(\'edit_content_views\', contentView)"\n                  ng-readonly="!rule.editMode"\n                  ng-disabled="!rule.editMode"\n                  ng-change="clearValues(rule)">\n            <option value="all" translate>All Versions</option>\n            <option value="equal" translate>Equal To</option>\n            <option value="greater" translate>Greater Than</option>\n            <option value="less" translate>Less Than</option>\n            <option value="range" translate>Range</option>\n          </select>\n        </span>\n\n        <span ng-show="rule.type === \'greater\' || rule.type === \'less\' || rule.type === \'range\'">\n          <span class="col-sm-2">\n            <input type="text"\n                   class="form-control"\n                   ng-model="rule.min_version"\n                   ng-readonly="!rule.editMode"\n                   ng-disabled="rule.type === \'less\'"/>\n          </span>\n          <span class="fl" ng-show="rule.type === \'range\' && rule.editMode">-</span>\n          <span class="col-sm-2">\n            <input type="text"\n                   class="form-control"\n                   ng-model="rule.max_version"\n                   ng-readonly="!rule.editMode"\n                   ng-disabled="rule.type === \'greater\'"/>\n          </span>\n        </span>\n\n        <span ng-show="rule.type === \'equal\'">\n          <span class="col-sm-4">\n            <input type="text"\n                   class="form-control"\n                   ng-model="rule.version"\n                   ng-readonly="!rule.editMode"/>\n          </span>\n        </span>\n    </td>\n    <td class="action-cell">\n      <button class="btn btn-default" ng-click="rule.editMode = true; backupPrevious(rule)" ng-hide="rule.editMode">\n        <i class="icon-edit"></i>\n        <span translate>Edit</span>\n      </button>\n\n      <button bst-save-control\n              on-cancel="restorePrevious(rule); rule.editMode = false"\n              on-save="updateRule(rule, filter)"\n              working="rule.working"\n              invalid="!valid(rule)"\n              ng-show="rule.editMode">\n      </button>\n    </td>\n  </tr>\n  </tbody>\n\n</table>\n\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/package-filter.html",'<span page-title ng-model="filter">{{ \'Package Filter:\' | translate }} {{ filter.name }}</span>\n\n<div class="details details-full">\n\n  <div data-block="messages" bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <nav>\n    <ul class="nav nav-tabs">\n\n      <li ng-class="{active: isState(\'content-views.details.filters.details.rpm.edit\')}">\n        <a ui-sref="content-views.details.filters.details.rpm.edit">\n        <span translate>\n	  Details\n        </span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.filters.details.rpm.details\')}">\n        <a ui-sref="content-views.details.filters.details.rpm.details">\n        <span translate>\n          Packages\n        </span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.filters.details.rpm.repositories\')}"\n          ng-show="!contentView.permissions.editable">\n        <a ui-sref="content-views.details.filters.details.rpm.repositories({filterId: filter.id})"\n           ng-include="\'content-views/details/filters/views/partials/filter-repositories-count.html\'">\n        </a>\n      </li>\n\n    </ul>\n  </nav>\n\n  <div ui-view></div>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/package-group-filter-details.html",'<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="actions">\n    <button class="btn btn-primary fr"\n            ng-disabled="detailsTable.numSelected === 0"\n            ng-show="isState(\'content-views.details.filters.details.package_group.list\') && permitted(\'edit_content_views\', contentView)"\n            ng-click="removePackageGroups(filter)">\n      <i class="icon-trash"></i>\n      <span translate>Remove Package Group</span>\n    </button>\n\n    <button class="btn btn-primary fr"\n            ng-disabled="detailsTable.numSelected === 0"\n            ng-show="isState(\'content-views.details.filters.details.package_group.available\') && permitted(\'edit_content_views\', contentView)"\n            ng-click="addPackageGroups(filter)">\n      <i class="icon-plus"></i>\n      <span translate>Add Package Group</span>\n    </button>\n  </div>\n\n  <div data-block="table">\n    <table class="table table-striped table-bordered" ng-class="{\'table-mask\': detailsTable.working}">\n\n      <thead>\n        <tr bst-table-head row-select>\n          <th bst-table-column><span translate>Name</span></th>\n          <th bst-table-column><span translate>Product</span></th>\n          <th bst-table-column><span translate>Repository</span></th>\n          <th bst-table-column><span translate>Description</span></th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row ng-repeat="packageGroup in detailsTable.rows" row-select="packageGroup">\n          <td bst-table-cell>{{ packageGroup.name }}</td>\n          <td bst-table-cell>{{ packageGroup.repository.product.name }}</td>\n          <td bst-table-cell>{{ packageGroup.repository.name }}</td>\n          <td bst-table-cell>{{ packageGroup.description }}</td>\n        </tr>\n      </tbody>\n\n    </table>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/package-group-filter.html",'<span page-title ng-model="filter">{{ \'Package Group Filter:\' | translate }} {{ filter.name }}</span>\n\n<div class="details details-full">\n\n  <div data-block="messages" bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <nav>\n    <ul class="nav nav-tabs">\n\n      <li ng-class="{active: isState(\'content-views.details.filters.details.package_group.edit\')}">\n        <a ui-sref="content-views.details.filters.details.package_group.edit">\n        <span translate>\n	  Details\n        </span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.filters.details.package_group.list\')}">\n        <a ui-sref="content-views.details.filters.details.package_group.list({filterId: filter.id})">\n        <span translate>\n          List/Remove\n        </span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.filters.details.package_group.available\')}"\n          ng-show="!contentView.permissions.editable">\n        <a ui-sref="content-views.details.filters.details.package_group.available({filterId: filter.id})">\n        <span translate>\n          Add\n        </span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.filters.details.package_group.repositories\')}"\n          ng-show="!contentView.permissions.editable">\n        <a ui-sref="content-views.details.filters.details.package_group.repositories({filterId: filter.id})"\n           ng-include="\'content-views/details/filters/views/partials/filter-repositories-count.html\'">\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <div ui-view></div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/filters/views/partials/filter-repositories-count.html","<span translate>Affected repositories</span>\n<span class=\"badge\">{{ filter.repositories.length || 'all' | translate }}</span>\n")}]),angular.module("Bastion.content-views").controller("ContentViewPuppetModuleNamesController",["$scope","Nutupane","ContentView",function($scope,Nutupane,ContentView){var nutupane=new Nutupane(ContentView,{id:$scope.$stateParams.contentViewId},"availablePuppetModuleNames");$scope.detailsTable=nutupane.table,$scope.selectVersion=function(moduleName){$scope.transitionTo("content-views.details.puppet-modules.versions",{contentViewId:$scope.$stateParams.contentViewId,moduleName:moduleName})}}]),angular.module("Bastion.content-views").controller("ContentViewPuppetModuleVersionsController",["$scope","translate","ContentView","ContentViewPuppetModule",function($scope,translate,ContentView,ContentViewPuppetModule){var success,error;$scope.versionsLoading=!0,$scope.successMessages=[],$scope.erroressages=[],$scope.versions=ContentView.availablePuppetModules({name:$scope.$stateParams.moduleName,id:$scope.$stateParams.contentViewId},function(){$scope.versionsLoading=!1}),$scope.selectVersion=function(module){var contentViewPuppetModule,contentViewPuppetModuleData={contentViewId:$scope.$stateParams.contentViewId,uuid:module.id,author:module.author,name:module.name};module.useLatest&&(contentViewPuppetModuleData.uuid=null),contentViewPuppetModule=new ContentViewPuppetModule(contentViewPuppetModuleData),$scope.$stateParams.moduleId?(contentViewPuppetModule.id=$scope.$stateParams.moduleId,contentViewPuppetModule.$update(success,error)):contentViewPuppetModule.$save(success,error)},success=function(){$scope.transitionTo("content-views.details.puppet-modules.list",{contentViewId:$scope.$stateParams.contentViewId}),$scope.successMessages=[translate("Puppet module added to Content View")]},error=function(response){angular.forEach(response.data.errors,function(errorMessage){$scope.errorMessages.push(translate("An error occurred updating the Content View: ")+errorMessage)})}}]),angular.module("Bastion.content-views").factory("ContentViewPuppetModule",["BastionResource","CurrentOrganization",function(BastionResource,CurrentOrganization){return BastionResource("/katello/api/v2/content_views/:contentViewId/content_view_puppet_modules/:id/:action",{id:"@id",contentViewId:"@contentViewId",organization_id:CurrentOrganization},{update:{method:"PUT"}})}]),angular.module("Bastion.content-views").controller("ContentViewPuppetModulesController",["$scope","translate","Nutupane","ContentViewPuppetModule",function($scope,translate,Nutupane,ContentViewPuppetModule){var nutupane=new Nutupane(ContentViewPuppetModule,{contentViewId:$scope.$stateParams.contentViewId,paged:!0});$scope.detailsTable=nutupane.table,$scope.successMessages=[],$scope.errorMessages=[],$scope.versionText=function(module){var version=translate("Latest (Currently %s)").replace("%s",module.computed_version);return module.puppet_module&&(version=module.puppet_module.version),version},$scope.selectNewVersion=function(module){$scope.transitionTo("content-views.details.puppet-modules.versionsForModule",{contentViewId:$scope.$stateParams.contentViewId,moduleName:module.name,moduleId:module.id})},$scope.removeModule=function(module){var success,error;success=function(){$scope.successMessages=[translate("Module %s removed from Content View.").replace("%s",module.name)],nutupane.removeRow(module.id)},error=function(response){angular.forEach(response.data.errors,function(errorMessage){$scope.errorMessages=[translate("An error occurred updating the Content View: ")+errorMessage]})},ContentViewPuppetModule.remove({contentViewId:$scope.$stateParams.contentViewId,id:module.id},success,error)}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/puppet-modules/views/content-view-puppet-module-names.html",'<span page-title ng-model="contentView">{{ \'Available Puppet Modules for Content View:\' | translate }} {{ contentView.name }}</span>\n\n<ol class="breadcrumb">\n  <li class="active">\n    <a ui-sref="content-views.details.puppet-modules.list">\n      {{ "Module List" | translate }}\n    </a>\n  </li>\n</ol>\n\n<div data-extend-template="layouts/details-nutupane.html">\n  <div class="loading-mask loading-mask-panel" ng-show="namesLoading">\n    <i class="icon-spinner icon-spin"></i>\n    {{ "Loading..." | translate }}\n  </div>\n\n  <a ui-sref="content-views.details.puppet-modules.list" >\n    <i class="icon-double-angle-left"></i>\n    {{ "Back to Module List" | translate }}\n  </a>\n\n  <span data-block="header" translate>Select A New Puppet Module To Add</span>\n  <span data-block="messages"></span>\n  <div data-block="search">\n    <input type="text"\n           class="form-control"\n           placeholder="{{ \'Filter\' | translate }}"\n           ng-model="filterTerm"/>\n  </div>\n\n  <span data-block="selection-summary"></span>\n\n  <div data-block="table">\n    <table class="table table-striped table-bordered">\n      <thead>\n        <tr bst-table-head>\n          <th bst-table-column><span translate>Name</span></th>\n          <th bst-table-column><span translate>Actions</span></th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row ng-repeat="item in detailsTable.rows | filter:filterTerm">\n          <td bst-table-cell>{{ item.module_name }}</td>\n          <td bst-table-cell class="action-cell">\n            <button translate\n                    ng-hide="denied(\'edit_content_views\', contentView)"\n                    ng-click="selectVersion(item.module_name)">\n              Select a Version\n            </button>\n          </td>\n        </tr>\n      </tbody>\n    </table>\n  </div>\n</div>\n\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/puppet-modules/views/content-view-puppet-module-versions.html",'<span page-title ng-model="$stateParams">{{ \'Versions for Puppet Module:\' | translate }} {{ $stateParams.moduleName }}</span>\n\n<div class="details details-full">\n  <div class="loading-mask loading-mask-panel" ng-show="versionsLoading">\n    <i class="icon-spinner icon-spin"></i>\n    {{ "Loading..." | translate }}\n  </div>\n\n  <ol class="breadcrumb">\n    <li>\n      <a ui-sref="content-views.details.puppet-modules.list">\n        {{ "Module List" | translate }}\n      </a>\n    </li>\n    <li>\n      <a ui-sref="content-views.details.puppet-modules.names">\n        {{ "Select Module" | translate }}\n      </a>\n    </li>\n    <li class="active">\n      {{ $stateParams.moduleName }}\n    </li>\n  </ol>\n\n  <h3 translate>Select an Available Version of {{ $stateParams.moduleName }}</h3>\n\n  <div class="details-header">\n    <input type="text"\n           class="form-control filter-input"\n           placeholder="{{ \'Filter\' | translate }}"\n           ng-model="filterTerm"/>\n  </div>\n\n  <table class="table table-striped table-bordered" bst-table="table" ng-class="{\'table-mask\': table.working}">\n    <thead>\n      <tr bst-table-head>\n        <th bst-table-column><span translate>Author</span></th>\n        <th bst-table-column><span translate>Version</span></th>\n        <th bst-table-column><span translate>Summary</span></th>\n        <th bst-table-column><span translate>Repositories</span></th>\n        <th bst-table-column><span translate>Actions</span></th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr bst-table-row ng-repeat="item in versions.results | filter:filterTerm | orderBy: [\'author\', \'-version\']">\n        <td bst-table-cell >{{ item.author }}</td>\n        <td bst-table-cell >{{ item.version }}</td>\n        <td bst-table-cell >{{ item.summary }}</td>\n        <td bst-table-cell >\n          <ul ng-repeat="repo in item.repositories">\n            <li>{{ repo.name }}</li>\n          </ul>\n        </td>\n        <td bst-table-cell class="action-cell">\n          <button translate\n                  ng-hide="denied(\'edit_content_views\', contentView)"\n                  ng-click="selectVersion(item)">\n            Select Version\n          </button>\n        </td>\n      </tr>\n    </tbody>\n  </table>\n</div>\n'
)}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/puppet-modules/views/content-view-puppet-modules.html",'<span page-title ng-model="contentView">{{ \'Puppet Modules for Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div data-extend-template="layouts/details-nutupane.html">\n  <span data-block="messages"></span>\n\n  <span data-block="header" translate>Currently Selected Puppet Modules</span>\n\n  <div data-block="actions">\n    <button class="btn btn-primary fr"\n            ng-hide="denied(\'edit_content_views\', contentView)"\n            ui-sref="content-views.details.puppet-modules.names">\n      <i class="icon-plus"></i>\n      <span translate>Add New Module</span>\n    </button>\n  </div>\n\n  <div data-block="search">\n    <input type="text"\n           class="form-control"\n           placeholder="{{ \'Filter\' | translate }}"\n           ng-model="filterTerm"/>\n  </div>\n\n  <div data-block="table">\n    <p class="alert alert-info" ng-show="detailsTable.rows.length === 0" translate>\n      You currently don\'t have any Puppet Modules included in this Content View, you can add Puppet Modules using the button on the right.\n    </p>\n\n    <table class="table table-striped table-bordered" ng-show="detailsTable.rows.length > 0">\n      <thead>\n        <tr bst-table-head>\n          <th bst-table-column><span translate>Name</span></th>\n          <th bst-table-column><span translate>Author</span></th>\n          <th bst-table-column><span translate>Version</span></th>\n          <th bst-table-column><span translate>Actions</span></th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row ng-repeat="contentViewPuppetModule in detailsTable.rows | filter:filterTerm">\n          <td bst-table-cell >{{ contentViewPuppetModule.name}}</td>\n          <td bst-table-cell >{{ contentViewPuppetModule.author}}</td>\n          <td bst-table-cell >{{ versionText(contentViewPuppetModule) }}</td>\n          <td bst-table-cell class="action-cell">\n            <button translate\n                    ng-hide="denied(\'edit_content_views\', contentView)"\n                    ng-click="selectNewVersion(contentViewPuppetModule)">\n              Select new version\n            </button>\n            <button translate\n                    ng-hide="denied(\'edit_content_views\', contentView)"\n                    ng-click="removeModule(contentViewPuppetModule)">\n              Remove Module\n            </button>\n          </td>\n        </tr>\n      </tbody>\n    </table>\n  </div>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-composite-available-content-views.html",'<span page-title ng-model="contentView">{{ \'Available Content Views for Composite Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div data-extend-template="layouts/details-nutupane.html">\n  <div data-block="messages">\n    <p class="alert alert-info" ng-show="contentView.components.length === 0" translate>\n      In order to add a content view to a composite view you must first publish an initial version of the content view.\n    </p>\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-primary fr"\n            ng-disabled="detailsTable.numSelected === 0"\n            ng-click="addContentViews()">\n      <i class="icon-plus"></i>\n      <span translate>Add Content Views</span>\n    </button>\n  </div>\n\n  <div data-block="search">\n    <input type="text"\n           class="form-control"\n           placeholder="{{ \'Filter...\' | translate }}"\n           ng-model="contentViewFilter"/>\n  </div>\n\n  <span data-block="result-count"></span>\n\n  <div data-block="table">\n    <table class="table table-bordered table-striped">\n      <thead>\n        <tr bst-table-head row-select>\n          <th bst-table-column translate>Name</th>\n          <th bst-table-column translate>Version</th>\n          <th bst-table-column translate>Environment</th>\n          <th bst-table-column translate>Description</th>\n          <th bst-table-column translate>Content</th>\n        </tr>\n      </thead>\n\n      <tbody>\n      <tr bst-table-row\n          ng-repeat="contentView in detailsTable.rows | filter:contentViewFilter | orderBy:\'name\'"\n          row-select="contentView">\n        <td bst-table-cell>{{ contentView.name }}</td>\n        <td bst-table-cell>\n          <select class="form-control"\n                  name="contentView.version"\n                  ng-show="contentView.versions.length > 1"\n                  ng-model="contentView.versionId"\n                  ng-options="cvv.id as cvv.version for cvv in contentView.versions">\n          </select>\n          <span ng-show="contentView.versions.length === 1" ng-model="contentView.version" translate>Version 1</span>\n        </td>\n        <td bst-table-cell>\n          <span ng-show="contentView.environments.length !== 0"\n                ng-repeat="environment in contentView.environments">\n            {{ environment.name }}<span ng-if="!$last">, </span>\n          </span>\n          <span ng-show="contentView.environments.length === 0" translate>\n            Not yet published\n          </span>\n        </td>\n        <td bst-table-cell>{{ contentView.description }}</td>\n        <td bst-table-cell>\n          <div>\n            <a ui-sref="content-views.details.repositories.yum.list({contentViewId: contentView.id})" translate>\n              {{ contentView.repositories.length || 0 }} Repositories\n            </a>\n          </div>\n          <div>\n            <a ui-sref="content-views.details.puppet-modules.list({contentViewId: contentView.id})" translate>\n              {{ contentView.puppet_modules.length || 0 }} Puppet Modules\n            </a>\n          </div>\n        </td>\n      </tr>\n      </tbody>\n    </table>\n  </div>\n</div>\n\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-composite-content-views-list.html",'<span page-title ng-model="contentView">{{ \'Content Views for Composite Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div data-extend-template="layouts/details-nutupane.html">\n  <div data-block="messages"></div>\n\n  <div data-block="actions">\n    <button class="btn btn-primary fr"\n            ng-hide="denied(\'edit_content_views\', contentView)"\n            ng-disabled="detailsTable.numSelected === 0"\n            ng-click="removeContentViews()">\n      <i class="icon-trash"></i>\n      <span translate>Remove Content Views</span>\n    </button>\n  </div>\n\n  <div data-block="search">\n    <input type="text"\n           class="form-control"\n           placeholder="{{ \'Filter...\' | translate }}"\n           ng-model="contentViewVersionFilter"/>\n  </div>\n\n  <span data-block="result-count"></span>\n\n  <div data-block="table">\n    <table class="table table-bordered table-striped">\n      <thead>\n      <tr bst-table-head row-select>\n        <th bst-table-column translate>Name</th>\n        <th bst-table-column translate>Version</th>\n        <th bst-table-column translate>Environment</th>\n        <th bst-table-column translate>Description</th>\n        <th bst-table-column translate>Content</th>\n      </tr>\n      </thead>\n\n      <tbody>\n      <tr bst-table-row ng-repeat="contentViewVersion in detailsTable.rows | filter:contentViewVersionFilter | orderBy:\'name\'"\n          row-select="contentViewVersion">\n        <td bst-table-cell>{{ contentViewVersion.content_view.name }}</td>\n        <td bst-table-cell>\n          <span bst-edit-select="contentViewVersion.id"\n                display-value="getVersionString(contentViewVersion)"\n                display-value-default="getVersionString(contentViewVersion)"\n                readonly="denied(\'edit_content_views\', contentView)"\n                selector="contentViewVersion.id"\n                options="getContentViewForVersion(contentViewVersion)"\n                options-format="option.id as option.version for option in options"\n                on-save="saveContentViewVersion(contentViewVersion)">\n          </span>\n        </td>\n        <td bst-table-cell>\n        <span ng-show="contentViewVersions.environments.length !== 0"\n              ng-repeat="environment in contentViewVersion.environments">\n          {{ environment.name }}<span ng-if="!$last">, </span>\n        </span>\n        <span ng-show="contentViewVersion.environments.length === 0" translate>\n          Not yet published\n        </span>\n        </td>\n        <td bst-table-cell>{{ contentViewVersion.content_view.description }}</td>\n        <td bst-table-cell>\n          <div>\n            <a ui-sref="content-views.details.repositories.yum.list({contentViewId: contentViewVersion.content_view.id})" translate>\n              {{ contentViewVersion.repositories.length || 0 }} Repositories\n            </a>\n          </div>\n          <div>\n            <a ui-sref="content-views.details.puppet-modules.list({contentViewId: contentViewVersion.content_view.id})" translate>\n              {{ contentViewVersion.puppet_modules.length || 0 }} Puppet Modules\n            </a>\n          </div>\n        </td>\n      </tr>\n      </tbody>\n    </table>\n  </div>\n</div>\n\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-composite.html",'<div class="details details-full">\n\n  <nav>\n    <ul class="nav nav-tabs" ng-show="permitted(\'edit_content_views\', contentView)">\n      <li ng-class="{active: isState(\'content-views.details.composite-content-views.list\')}">\n        <a ui-sref="content-views.details.composite-content-views.list">\n          <span translate>\n            List/Remove\n          </span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.composite-content-views.available\')}" ng-show="!contentView.permissions.editable">\n        <a ui-sref="content-views.details.composite-content-views.available">\n          <span translate>\n            Add\n          </span>\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <div ui-view></div>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-details-history.html",'<span page-title ng-model="contentView">{{ \'History for Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="header" translate>Promotion History</div>\n\n  <div data-block="messages"></div>\n  <div data-block="selection-summary"></div>\n\n  <div data-block="table">\n    <table class="table table-striped table-bordered" ng-class="{\'table-mask\': detailsTable.working}">\n     <thead>\n       <tr bst-table-head>\n         <th translate>Date</th>\n         <th translate>Version</th>\n         <th translate>Action</th>\n         <th translate>User</th>\n         <th translate>Status</th>\n       </tr>\n     </thead>\n\n     <tbody>\n       <tr bst-table-row ng-repeat="history in detailsTable.rows">\n         <td bst-table-cell>{{ history.created_at | date:\'short\' }}</td>\n         <td bst-table-cell>{{ history.version }} </td>\n         <td bst-table-cell>{{ actionText(history) }}</td>\n         <td bst-table-cell>{{ history.user }}</td>\n         <td bst-table-cell>{{ history.task.result }}</td>\n       </tr>\n     </tbody>\n    </table>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-details-tasks.html",'<span page-title ng-model="contentView">{{ \'Tasks for Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div tasks-table  details-state="content-views.details.tasks.details"\n                  known-context="content_view,organization"\n                  resource-type="Katello::ContentView"\n                  resource-id="{{ contentView.id }}"/>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-details.html",'<span page-title ng-model="contentView">{{ \'Content View:\' | translate }} {{ contentView.name }}</span>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="details-header row">\n    <h2 class="col-sm-6" ng-hide="contentView.composite">{{ contentView.name }}</h2>\n    <h2 class="col-sm-6" ng-show="contentView.composite" translate>Composite Content View {{ contentView.name }}</h2>\n\n    <div class="col-sm-6">\n      <div class="fr">\n        <a class="btn btn-primary" ui-sref="content-views.details.publish"\n           ng-hide="denied(\'publish_content_views\', contentView)">\n          <i class="icon-paste"></i>\n          <span translate>Publish New Version</span>\n        </a>\n\n        <a class="btn btn-default"\n           ng-hide="denied(\'create_content_views\')"\n           ng-click="showCopy = true">\n          <i class="icon-copy"></i>\n          <span translate>Copy View</span>\n        </a>\n\n        <button class="btn btn-default" ui-sref="content-views.details.deletion"\n                ng-hide="denied(\'destroy_content_views\', contentView)">\n          <i class="icon-trash"></i>\n          {{ "Remove View" | translate }}\n        </button>\n\n        <a class="btn btn-default" ui-sref="content-views.index">\n          <i class="icon-remove"></i>\n          <span translate>Close</span>\n        </a>\n      </div>\n\n    </div>\n  </header>\n\n  <div ng-show="showCopy" class="fr action-pane" >\n    <form>\n      <h5 translate>Copy</h5>\n      <div class="input">\n        <div bst-alert error-messages="copyErrorMessages"></div>\n        <div class="info-label">\n          <label for="copy_name" translate>New Name:</label>\n        </div>\n        <input ng-model="copyName"\n               id="copy_name"\n               name="copy_name"\n               tabindex="1"\n               autofocus\n               required/>\n        <div>\n          <button class="btn btn-default" ng-click="copy(copyName)">\n              <span translate>Create</span>\n          </button>\n          <button class="btn btn-default" ng-click="showCopy = false">\n            <span translate>Cancel</span>\n          </button>\n        </div>\n      </div>\n    </form>\n  </div>\n\n  <nav>\n    <ul class="nav nav-tabs">\n      <li ng-class="{active: stateIncludes(\'content-views.details.version\') || stateIncludes(\'content-views.details.versions\')}">\n        <a ui-sref="content-views.details.versions" translate>\n          Versions\n        </a>\n      </li>\n\n      <li ng-class="{active: stateIncludes(\'content-views.details.composite-content-views\')}" ng-show="contentView.composite">\n        <a ui-sref="content-views.details.composite-content-views.list" translate>\n          Content Views\n        </a>\n      </li>\n\n      <li class="dropdown"\n          ng-class="{active: stateIncludes(\'content-views.details.repositories.yum\') || stateIncludes(\'content-views.details.filters\')}"\n          ng-hide="contentView.composite">\n        <a class="dropdown-toggle">\n          <span translate>Yum Content</span>\n          <i class="icon-chevron-down"></i>\n        </a>\n        <ul class="dropdown-menu">\n          <li>\n            <a ui-sref="content-views.details.repositories.yum.list" translate>\n              Repositories\n            </a>\n          </li>\n          <li>\n            <a ui-sref="content-views.details.filters.list" translate>\n              Filters\n            </a>\n          </li>\n        </ul>\n      </li>\n\n      <li ng-class="{active: stateIncludes(\'content-views.details.puppet-modules\')}"\n          ng-hide="contentView.composite">\n        <a ui-sref="content-views.details.puppet-modules.list" translate>\n          Puppet Modules\n        </a>\n      </li>\n\n      <li ng-class="{active: stateIncludes(\'content-views.details.repositories.docker\')}">\n        <a ui-sref="content-views.details.repositories.docker.list" translate>\n          Docker Images\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.history\')}">\n        <a ui-sref="content-views.details.history" translate>\n          History\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.info\') || isState(\'content-views.details.deletion\')}">\n        <a ui-sref="content-views.details.info" translate>\n          Details\n        </a>\n      </li>\n      <li ng-class="{active: stateIncludes(\'content-views.details.tasks\')}">\n        <a translate\n           ui-sref="content-views.details.tasks.index({contentViewId: contentView.id})">\n          Tasks\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n  <div ui-view></div>\n\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-docker-repositories.html",'<span page-title ng-model="contentView">{{ \'Repositories for Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div class="details details-full">\n\n  <h3 translate>\n    Repository Selection\n  </h3>\n\n  <nav>\n    <ul class="nav nav-tabs">\n      <li ng-class="{active: isState(\'content-views.details.repositories.docker.list\')}">\n        <a ui-sref="content-views.details.repositories.docker.list">\n          <span translate>\n            List/Remove\n          </span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.repositories.docker.available\')}" ng-show="!contentView.permissions.editable">\n        <a ui-sref="content-views.details.repositories.docker.available" translate>\n          Add\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <div class="details-header row">\n    <div class="col-sm-8">\n      <div class="input-group">\n\n        <span class="input-group-addon">\n          <select ng-model="product" ng-options="product.name for (id, product) in products">\n          </select>\n        </span>\n\n        <input type="text"\n               class="form-control filter-input"\n               placeholder="{{ \'Filter\' | translate }}"\n               ng-model="repositorySearch"/>\n\n      </div>\n    </div>\n\n    <div class="col-sm-4">\n      <button class="btn btn-primary fr"\n              ng-disabled="repositoriesTable.numSelected === 0"\n              ng-show="isState(\'content-views.details.repositories.docker.list\') && permitted(\'edit_content_views\', contentView)"\n              ng-click="removeRepositories(contentView)">\n        <i class="icon-trash"></i>\n        <span translate>Remove Repositories</span>\n      </button>\n      <button class="btn btn-primary fr"\n              ng-disabled="repositoriesTable.numSelected === 0"\n              ng-show="isState(\'content-views.details.repositories.docker.available\') && permitted(\'edit_content_views\', contentView)"\n              ng-click="addRepositories(contentView)">\n        <i class="icon-plus"></i>\n        <span translate>Add Repositories</span>\n      </button>\n    </div>\n  </div>\n\n  <div bst-table="repositoriesTable" class="nutupane">\n\n    <div ng-show="repositoriesTable.rows.length === 0 && !repositoriesTable.working">\n      <p class="alert alert-info" ng-show="isState(\'content-views.details.repositories.docker.list\')" translate>\n        There are currently no repositories associated with this Content View, you can add some by clicking on the "Add" tab above.\n      </p>\n      <p class="alert alert-info" ng-show="isState(\'content-views.details.repositories.docker.available\')">\n        <span translate>There are currently no repositories to add to this Content View,</span>\n        <a ui-sref="products.index" translate>add some repositories.</a>\n      </p>\n    </div>\n\n    <div class="loading-mask loading-mask-panel" ng-show="repositoriesTable.working">\n      <i class="icon-spinner icon-spin"></i>\n      {{ "Loading..." | translate }}\n    </div>\n\n    <div bst-infinite-scroll="repositoriesTable.nextPage()" data="repositoriesTable.rows">\n\n      <table ng-show="repositoriesTable.rows.length > 0"  class="table table-bordered table-striped">\n        <thead>\n          <tr bst-table-head row-select>\n            <th bst-table-column translate>Name</th>\n            <th bst-table-column translate>Product</th>\n            <th bst-table-column translate>Last Sync</th>\n            <th bst-table-column translate>Sync State</th>\n            <th bst-table-column translate>Content</th>\n          </tr>\n        </thead>\n\n        <tbody>\n          <tr bst-table-row\n              row-select="repository"\n              ng-repeat="repository in repositoriesTable.rows | filter:repositorySearch | filter:repositoryFilter | as:\'filteredItems\'">\n            <td bst-table-cell>\n              <a ui-sref="products.details.repositories.info({productId: repository.product.id, repositoryId: repository.id})">\n                {{ repository.name }}\n              </a>\n            </td>\n            <td bst-table-cell>{{ repository.product.name }}</td>\n            <td bst-table-cell>\n              <span ng-show="repository.url">\n                {{ repository.last_sync.ended_at | date:"short" }}\n              </span>\n              <span ng-hide="repository.url" translate>N/A</span>\n            </td>\n            <td bst-table-cell>\n              <span ng-show="repository.url">\n                <a href="/foreman_tasks/tasks/{{repository.last_sync.id}}">{{ repository.last_sync.result | capitalize }}</a>\n              </span>\n              <span ng-hide="repository.url" translate>N/A</span>\n            </td>\n            <td bst-table-cell>\n              <div>\n                <span translate>\n                  {{ repository.content_counts.docker_image || 0 }} Docker Images\n                </span>\n              </div>\n              <div>\n                <span translate>\n                  {{ repository.content_counts.docker_tag || 0 }} Docker Tags\n                </span>\n              </div>\n            </td>\n          </tr>\n        </tbody>\n      </table>\n\n    </div>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-info.html",'<span page-title ng-model="contentView">{{ \'Details for Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div class="details">\n\n  <div class="detail">\n    <span class="info-label" translate>Name</span>\n    <span class="info-value"\n          bst-edit-text="contentView.name"\n          on-save="save(contentView)"\n          readonly="denied(\'edit_content_views\', contentView)">\n    </span>\n  </div>\n\n  <div class="detail">\n    <span class="info-label" translate>Label</span>\n    <span class="info-value">{{ contentView.label }}</span>\n  </div>\n\n  <div class="detail">\n    <span class="info-label" translate>Description</span>\n    <span class="info-value"\n          bst-edit-textarea="contentView.description"\n          on-save="save(contentView)"\n          readonly="denied(\'edit_content_views\', contentView)">\n    </span>\n  </div>\n\n  <div class="detail">\n    <span class="info-label" translate>Composite?</span>\n    <span class="info-value" ng-show="contentView.composite" translate>Yes</span>\n    <span class="info-value" ng-hide="contentView.composite" translate>No</span>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-promotion.html",'<span page-title ng-model="contentView">{{ \'Promote Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div>\n\n  <a ui-sref="content-views.details.versions({contentViewId: contentView.id})" >\n    <i class="icon-double-angle-left"></i>\n    {{ "Back to Version List" | translate }}\n  </a>\n\n  <h3 translate>Promote Version {{ version.version }}</h3>\n\n  <p class="details" translate>\n    Choose a lifecycle environment from the available promotion paths.\n  </p>\n\n  <p ng-hide="working">\n    <i class="icon-spinner icon-spin"></i>\n    <span translate>Loading Environment Paths...</span>\n  </p>\n  <div path-selector="availableEnvironments"\n       ng-model="selectedEnvironment"\n       mode="singleSelect"\n       selection-required="false"\n       path-attribute="environments"\n       disabled="denied(\'promote_or_remove_content_views\', contentView)"\n       ng-show="working">\n  </div>\n\n  <div>\n    <button class="btn btn-primary btn-lg" ng-disabled="promoting || !selectedEnvironment" ng-click="promote()" translate>\n      Promote Version\n    </button>\n\n    <a ui-sref="content-views.details.versions" class="btn btn-default btn-lg"  translate role="button">\n      Cancel\n    </a>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-publish.html",'<span page-title ng-model="contentView">{{ \'Publish Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div class="details">\n\n  <h3 translate>Publish New Version</h3>\n\n  <p translate>\n    A new version of {{ contentView.name }} and promoted to the Library environment.\n    It can be promoted to other environments from the Versions tab of this Content View.\n  </p>\n\n  <header class="details-header">\n    <h3 translate>Version Details</h3>\n  </header>\n\n  <form name="versionForm" class="form-horizontal" role="form" novalidate>\n\n    <div bst-form-group label="{{ \'Version\' | translate }}">\n      <span>{{ contentView[\'next_version\'] }}</span>\n    </div>\n\n    <div bst-form-group label="{{ \'Description\' | translate }}">\n      <textarea id="description"\n                name="description"\n                ng-model="version.description"\n                tabindex="1">\n      </textarea>\n    </div>\n\n    <div bst-form-buttons\n         on-cancel="transitionTo(\'content-views.details.versions\', {contentViewId: contentView.id})"\n         on-save="publish(contentView)"\n         working="working">\n    </div>\n  </form>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-repositories.html",'<span page-title ng-model="contentView">{{ \'Repositories for Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div class="details details-full">\n\n  <h3 translate>\n    Repository Selection\n  </h3>\n\n  <nav>\n    <ul class="nav nav-tabs">\n      <li ng-class="{active: isState(\'content-views.details.repositories.yum.list\')}">\n        <a ui-sref="content-views.details.repositories.yum.list">\n          <span translate>\n            List/Remove\n          </span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'content-views.details.repositories.yum.available\')}" ng-show="!contentView.permissions.editable">\n        <a ui-sref="content-views.details.repositories.yum.available" translate>\n          Add\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <div class="details-header row">\n    <div class="col-sm-8">\n      <div class="input-group">\n\n        <span class="input-group-addon">\n          <select ng-model="product" ng-options="product.name for (id, product) in products">\n          </select>\n        </span>\n\n        <input type="text"\n               class="form-control filter-input"\n               placeholder="{{ \'Filter\' | translate }}"\n               ng-model="repositorySearch"/>\n\n      </div>\n    </div>\n\n    <div class="col-sm-4">\n      <button class="btn btn-primary fr"\n              ng-disabled="repositoriesTable.numSelected === 0"\n              ng-show="isState(\'content-views.details.repositories.yum.list\') && permitted(\'edit_content_views\', contentView)"\n              ng-click="removeRepositories(contentView)">\n        <i class="icon-trash"></i>\n        <span translate>Remove Repositories</span>\n      </button>\n      <button class="btn btn-primary fr"\n              ng-disabled="repositoriesTable.numSelected === 0"\n              ng-show="isState(\'content-views.details.repositories.yum.available\') && permitted(\'edit_content_views\', contentView)"\n              ng-click="addRepositories(contentView)">\n        <i class="icon-plus"></i>\n        <span translate>Add Repositories</span>\n      </button>\n    </div>\n  </div>\n\n  <div bst-table="repositoriesTable" class="nutupane">\n\n    <div ng-show="repositoriesTable.rows.length === 0 && !repositoriesTable.working">\n      <p class="alert alert-info" ng-show="isState(\'content-views.details.repositories.yum.list\')" translate>\n        There are currently no repositories associated with this Content View, you can add some by clicking on the "Add" tab above.\n      </p>\n      <p class="alert alert-info" ng-show="isState(\'content-views.details.repositories.yum.available\')">\n        <span translate>There are currently no repositories to add to this Content View,</span>\n        <a ui-sref="products.index" translate>add some repositories.</a>\n      </p>\n    </div>\n\n    <div class="loading-mask loading-mask-panel" ng-show="repositoriesTable.working">\n      <i class="icon-spinner icon-spin"></i>\n      {{ "Loading..." | translate }}\n    </div>\n\n    <div bst-infinite-scroll="repositoriesTable.nextPage()" data="repositoriesTable.rows">\n\n      <table ng-show="repositoriesTable.rows.length > 0"  class="table table-bordered table-striped">\n        <thead>\n          <tr bst-table-head row-select>\n            <th bst-table-column translate>Name</th>\n            <th bst-table-column translate>Product</th>\n            <th bst-table-column translate>Last Sync</th>\n            <th bst-table-column translate>Sync State</th>\n            <th bst-table-column translate>Content</th>\n          </tr>\n        </thead>\n\n        <tbody>\n          <tr bst-table-row\n              row-select="repository"\n              ng-repeat="repository in repositoriesTable.rows | filter:repositorySearch | filter:repositoryFilter | as:\'filteredItems\'">\n            <td bst-table-cell>\n              <a ui-sref="products.details.repositories.info({productId: repository.product.id, repositoryId: repository.id})">\n                {{ repository.name }}\n              </a>\n            </td>\n            <td bst-table-cell>{{ repository.product.name }}</td>\n            <td bst-table-cell>\n              <span ng-show="repository.url">\n                {{ repository.last_sync.ended_at | date:"short" }}\n              </span>\n              <span ng-hide="repository.url" translate>N/A</span>\n            </td>\n            <td bst-table-cell>\n              <span ng-show="repository.url">\n                <a href="/foreman_tasks/tasks/{{repository.last_sync.id}}">{{ repository.last_sync.result | capitalize }}</a>\n              </span>\n              <span ng-hide="repository.url" translate>N/A</span>\n            </td>\n            <td bst-table-cell>\n              <div>\n                <a ng-href="/katello/content_search#/!=&search[packages][search]=&search[content_type]=packages&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_packages"\n                   ng-show="repository.content_type == \'yum\'"\n                   translate>\n                  {{ repository.content_counts.rpm || 0 }} Packages\n                </a>\n              </div>\n              <div>\n                <a ng-href="/katello/content_search#/!=&search[errata][search]=&search[content_type]=errata&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_errata"\n                   ng-show="repository.content_type == \'yum\'"\n                   translate>\n                  {{ repository.content_counts.erratum || 0 }} Errata\n                </a>\n              </div>\n              <div>\n                <a ng-href="/katello/content_search#/!=&search[puppet_modules][search]=&search[content_type]=puppet_modules&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_puppet_modules"\n                   ng-show="repository.content_type == \'puppet\'"\n                   translate>\n                  {{ repository.content_counts.puppet_module || 0 }} Puppet Modules\n                </a>\n              </div>\n            </td>\n          </tr>\n        </tbody>\n      </table>\n\n    </div>\n  </div>\n\n</div>\n'
)}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/details/views/content-view-versions.html",'<span page-title ng-model="contentView">{{ \'Versions for Content View:\' | translate }} {{ contentView.name }}</span>\n\n<div class="details details-full nutupane">\n\n  <div class="loading-mask loading-mask-panel icon-3x" ng-show="loadingVersions">\n    <i class="icon-spinner icon-spin"></i>\n    {{ "Loading..." | translate }}\n  </div>\n  <div class="details-header">\n    <input type="text"\n           class="form-control filter-input"\n           placeholder="{{ \'Filter\' | translate }}"\n           ng-model="filterTerm"/>\n  </div>\n\n  <table class="table table-striped table-bordered" bst-table="table" ng-class="{\'table-mask\': loadingVersions}">\n    <thead>\n      <tr bst-table-head>\n        <th bst-table-column><span translate>Version</span></th>\n        <th bst-table-column><span translate>Status</span></th>\n        <th bst-table-column><span translate>Environments</span></th>\n        <th bst-table-column><span translate>Content</span></th>\n        <th bst-table-column><span translate>Author</span></th>\n        <th class="col-sm-2" bst-table-column><span translate>Actions</span></th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr bst-table-row ng-repeat="version in versions | filter:filterTerm">\n        <td bst-table-cell translate>\n          <a ui-sref="content-views.details.version.details({versionId: version.id})" >Version {{ version.version }}</a>\n        </td>\n        <td bst-table-cell >\n          <a ui-sref="content-views.details.history" ng-hide="hideProgress(version)">\n            <div ng-class="{ active: taskInProgress(version) }"\n                 class="progress progress-striped">\n              <span progressbar animate="false" value="version.task.progressbar.value" type="{{version.task.progressbar.type}}"></span>\n            </div>\n              {{ status(version) }}\n          </a>\n          <span ng-show="hideProgress(version)">\n            {{ historyText(version) }}\n            ({{ version.last_event.created_at | date:\'short\' }})\n          </span>\n        </td>\n        <td bst-table-cell>\n          <ul>\n            <li ng-repeat="environment in version.environments" ng-if="environment.permissions.readable">\n              {{ environment.name }}\n            </li>\n          </ul>\n        </td>\n        <td bst-table-cell>\n          <div translate>\n            {{ version.package_count || 0 }} Packages\n          </div>\n	  <span translate>{{ version.errata_counts.total || 0 }} Errata</span>\n          (<span errata-counts="version.errata_counts"></span>)\n          <div translate>\n            {{ version.puppet_module_count || 0 }} Puppet Modules\n          </div>\n          <div translate>\n            {{ version.docker_image_count || 0 }} Docker Images\n          </div>\n          <div translate>\n            {{ version.docker_tag_count || 0 }} Docker Tags\n          </div>\n\n        </td>\n        <td bst-table-cell>{{ version.user }}</td>\n        <td class="col-sm-2">\n          <button class="btn btn-default"\n                  ui-sref="content-views.details.promotion({contentViewId: contentView.id, versionId: version.id})"\n                  ng-hide="denied(\'promote_or_remove_content_views\', contentView)"\n                  ng-disabled="taskInProgress(version) || taskFailed(version)">\n            <i class="icon-share-alt"></i>\n            <span translate>\n              Promote\n            </span>\n          </button>\n          <button class="btn btn-default"\n                  ui-sref="content-views.details.version-deletion.environments({contentViewId: contentView.id, versionId: version.id})"\n                  ng-hide="denied(\'promote_or_remove_content_views\', contentView)"\n                  ng-disabled="taskInProgress(version) || taskFailed(version)">\n            <i class="icon-trash"></i>\n            <span translate>\n              Remove\n            </span>\n          </button>\n        </td>\n      </tr>\n    </tbody>\n  </table>\n\n</div>\n')}]),angular.module("Bastion.content-views").controller("NewContentViewController",["$scope","ContentView","FormUtils","CurrentOrganization",function($scope,ContentView,FormUtils,CurrentOrganization){function success(response){var successState="content-views.details.repositories.yum.available";response.composite&&(successState="content-views.details.composite-content-views.available"),$scope.$parent.table.addRow(response),$scope.transitionTo(successState,{contentViewId:response.id})}function error(response){$scope.working=!1,angular.forEach(response.data.errors,function(errors,field){$scope.contentViewForm[field].$setValidity("server",!1),$scope.contentViewForm[field].$error.messages=errors})}$scope.contentView=new ContentView({organization_id:CurrentOrganization}),$scope.createOption="new",$scope.table={},$scope.save=function(contentView){contentView.$save(success,error)},$scope.$watch("contentView.name",function(){$scope.contentViewForm.name&&($scope.contentViewForm.name.$setValidity("server",!0),FormUtils.labelize($scope.contentView))})}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/new/views/content-view-new.html",'<span page-title>{{ \'New Content View\' | translate }}</span>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="new-header details-header">\n    <h2 class="fl" translate>New Content View</h2>\n    <div class="fr">\n      <button class="btn btn-default" ui-sref="content-views.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <div class="row">\n    <form name="optionsForm" class="col-sm-12">\n      <label class="radio-inline" ng-hide="true">\n        <input type="radio"\n               ng-model="createOption"\n               name="createOptions"\n               id="createOptions1"\n               value="new"\n               checked/>\n        {{ "Create new view" | translate }}\n      </label>\n      <label class="radio-inline" ng-hide="true">\n        <input type="radio"\n               ng-model="createOption"\n               name="createOptions"\n               id="createOptions2"\n               value="existing"/>\n        {{ "Create view from existing views" | translate }}\n      </label>\n    </form>\n  </div>\n\n  <div class="row">\n    <h3 class="col-sm-12" translate>View Details</h3>\n\n    <form name="contentViewForm" class="form-horizontal col-sm-8" novalidate role="form">\n      <div bst-form-group label="{{ \'Name\' | translate }}">\n        <input id="name"\n               name="name"\n               ng-model="contentView.name"\n               type="text"\n               tabindex="1"\n               autofocus\n               required/>\n      </div>\n\n      <div bst-form-group label="{{ \'Label\' | translate }}">\n        <input id="label"\n               name="label"\n               ng-model="contentView.label"\n               type="text"\n               tabindex="2"\n               required/>\n      </div>\n\n      <div bst-form-group label="{{ \'Description\' | translate }}">\n        <textarea id="description"\n                  name="description"\n                  ng-model="contentView.description"\n                  tabindex="3">\n        </textarea>\n      </div>\n\n      <div bst-form-group label="{{ \'Composite View?\' | translate }}">\n        <input id="composite"\n               name="composite"\n               ng-model="contentView.composite"\n               type="checkbox"\n               tabindex="4"/>\n        <p class="help-block" translate>A composite view contains other content views.</p>\n      </div>\n\n      <div bst-form-buttons\n           on-cancel="transitionTo(\'content-views.index\')"\n           on-save="save(contentView)"\n           working="working">\n      </div>\n    </form>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/views/content-views-table-collapsed.html",'<table class="table table-striped" ng-class="{\'table-mask\': table.working}">\n\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column sortable><span translate>Name</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row\n        ng-repeat="contentView in table.rows"\n        row-select="contentView"\n        active-row="stateIncludes(\'content-views.details\', {contentViewId: contentView.id})">\n      <td bst-table-cell>\n        <a ui-sref="content-views.details.versions({contentViewId: contentView.id})">\n          {{ contentView.name }}\n        </a>\n      </td>\n    </tr>\n  </tbody>\n\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/views/content-views-table-full.html",'<p class="alert alert-info" ng-show="table.rows.length === 0" translate>\n  You currently don\'t have any Content Views, you can create Content View using the button on the right.\n</p>\n\n<table class="table table-striped table-bordered"  \n       bst-table="table" \n       ng-class="{\'table-mask\': table.working}"\n       ng-show="table.rows.length > 0">\n\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column><span translate>Name</span></th>\n      <th bst-table-column><span translate>Composite View?</span></th>\n      <th bst-table-column><span translate>Last Published</span></th>\n      <th bst-table-column><span translate>Environments</span></th>\n      <th bst-table-column><span translate>Repositories</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row ng-repeat="contentView in table.rows" row-select="contentView">\n      <td bst-table-cell>\n        <a ui-sref="content-views.details.versions({contentViewId: contentView.id})">\n          {{ contentView.name }}\n        </a>\n      </td>\n      <td bst-table-cell>\n        <span ng-show="contentView.composite" translate>Yes</span>\n        <span ng-hide="contentView.composite" translate>No</span>\n      </td>\n      <td bst-table-cell>\n        <span ng-show="contentView.last_published">{{ contentView.last_published | date:"medium" }}</span>\n        <span ng-hide="contentView.last_published" translate>\n          Not yet published\n        </span>\n      </td>\n      <td bst-table-cell>\n        <span ng-show="contentView.environments.length !== 0"\n              ng-repeat="environment in contentView.environments" ng-if="environment.permissions.readable">\n          {{ environment.name }}<span ng-if="!$last">, </span>\n        </span>\n        <span ng-show="contentView.environments.length === 0" translate>\n          Not yet published\n        </span>\n      </td>\n      <td bst-table-cell class="number-cell">{{ contentView.repositories.length }}</td>\n    </tr>\n  </tbody>\n\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/content-views/views/content-views.html",'<span page-title>{{ \'Content Views\' | translate }}</span>\n\n<div data-extend-template="layouts/nutupane.html">\n\n  <div data-block="header">\n    <span translate>Content Views</span>\n  </div>\n\n  <div data-block="actions">\n    <a class="btn btn-default" ui-sref="content-views.new" ng-hide="denied(\'create_content_views\')">\n      <i class="icon-plus"></i>\n      <span translate>Create New View</span>\n    </a>\n  </div>\n\n</div>\n')}]),function(){"use strict";angular.module("Bastion.docker-images",["Bastion"])}(),function(){"use strict";function DockerImage(BastionResource){return BastionResource("/katello/api/v2/docker_images/:id",{id:"@id"})}angular.module("Bastion.docker-images").factory("DockerImage",DockerImage),DockerImage.$inject=["BastionResource"]}(),angular.module("Bastion.errata",["ngResource","Bastion","Bastion.components.formatters"]),angular.module("Bastion.errata").controller("ErrataContentHostsController",["$scope","translate","Nutupane","ContentHost","ContentHostBulkAction","CurrentOrganization",function($scope,translate,Nutupane,ContentHost,ContentHostBulkAction,CurrentOrganization){var nutupane,params;$scope.successMessages=[],$scope.errorMessages=[],params={erratum_id:$scope.$stateParams.errataId,organization_id:CurrentOrganization},nutupane=new Nutupane(ContentHost,params),nutupane.table.closeItem=function(){},nutupane.enableSelectAllResults(),$scope.nutupane=nutupane,$scope.detailsTable=nutupane.table,$scope.toggleAvailable=function(){nutupane.table.params.erratum_restrict_available=$scope.errata.showAvailable,nutupane.refresh()},$scope.applyErrata=function(){var params=$scope.nutupane.getAllSelectedResults(),success,error;params.content_type="errata",params.content=[$scope.errata.errata_id],params.organization_id=CurrentOrganization,success=function(){$scope.successMessages=[translate("Successfully scheduled installation of errata")],$scope.nutupane.refresh()},error=function(data){$scope.errorMessages=data.errors},ContentHostBulkAction.installContent(params,success,error)}}]),angular.module("Bastion.errata").controller("ErrataDetailsRepositoriesController",["$scope","$q","Nutupane","Repository","Environment","ContentView","CurrentOrganization",function($scope,$q,Nutupane,Repository,Environment,ContentView,CurrentOrganization){var repositoriesNutupane,environment,contentView,params={erratum_id:$scope.$stateParams.errataId,organization_id:CurrentOrganization};repositoriesNutupane=new Nutupane(Repository,params),$scope.detailsTable=repositoriesNutupane.table,$scope.detailsTable.initialLoad=!1,repositoriesNutupane.masterOnly=!0,repositoriesNutupane.searchKey="repositoriesSearch",environment=Environment.queryUnpaged(function(response){$scope.environments=response.results,$scope.environmentFilter=_.findWhere($scope.environments,{library:!0}).id}),contentView=ContentView.queryUnpaged(function(response){$scope.contentViews=response.results,$scope.contentViewFilter=_.findWhere($scope.contentViews,{"default":!0})}),$scope.detailsTable.working=!0,$q.all([contentView.$promise,environment.$promise]).then(function(){$scope.filterErrata(),$scope.detailsTable.working=!1}),$scope.filterErrata=function(){params.environment_id=$scope.environmentFilter,params.content_view_version_id=$scope.contentViewFilter,$scope.contentViewFilter&&(params.content_view_version_id=_.pluck($scope.contentViewFilter.versions,"id")),repositoriesNutupane.setParams=params,repositoriesNutupane.refresh()}}]),angular.module("Bastion.errata").controller("ErrataDetailsController",["$scope","Erratum",function($scope,Erratum){$scope.errata?$scope.panel={loading:!1}:$scope.panel={loading:!0},$scope.errata=Erratum.get({id:$scope.$stateParams.errataId},function(){$scope.panel.loading=!1})}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/errata/details/views/errata-details-content-hosts.html",'<span page-title>{{ \'Apply Errata to Content Hosts\' | translate }}</span>\n\n<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="header">\n    <h3 translate>Apply to Content Hosts</h3>\n  </div>\n\n  <div data-block="actions"></div>\n\n  <div data-block="filters">\n    <div class="checkbox">\n      <label>\n        <input type="checkbox" ng-model="errata.showAvailable" ng-change="toggleAvailable()"/>\n        <span translate>Only show content hosts where {{ errata.title }} is currently available in the host\'s Lifecycle Environment.</span>\n\n      </label>\n    </div>\n  </div>\n\n  <div data-block="table">\n    <p class="alert alert-warning" data-i18n\n       ng-show="detailsTable.rows.length > 0 && stateIncludes(\'errata.details.content-hosts.unavailable\')">\n      The Content View or Lifecycle Environment needs to be updated in order to make errata available to these hosts.\n    </p>\n\n    <p class="alert alert-info" ng-show="detailsTable.rows.length === 0" translate>\n      No Content Hosts match this Erratum.\n    </p>\n\n    <table class="table table-striped table-bordered"\n           ng-class="{\'table-mask\': detailsTable.working}"\n           ng-show="detailsTable.rows.length > 0">\n      <thead>\n        <tr bst-table-head row-select>\n          <th bst-table-column="name"><span translate>Name</span></th>\n          <th bst-table-column="os"><span translate>OS</span></th>\n          <th bst-table-column="environment"><span translate>Environment</span></th>\n          <th bst-table-column="contentView"><span translate>Content View</span></th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row ng-repeat="contentHost in detailsTable.rows" row-select="contentHost"\n            ng-controller="ContentHostStatusController">\n          <td bst-table-cell>\n            <a ui-sref="content-hosts.details.info({contentHostId: contentHost.uuid})">\n              {{ contentHost.name }}\n            </a>\n          </td>\n          <td bst-table-cell>{{ contentHost.distribution }}</td>\n          <td bst-table-cell>{{ contentHost.environment.name }}</td>\n          <td bst-table-cell>{{ contentHost.content_view.name || "" }}</td>\n        </tr>\n      </tbody>\n    </table>\n\n  </div>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/errata/details/views/errata-details-info.html",'<span page-title ng-model="errata">{{ \'Errata: \' | translate }} {{ errata.title }}</span>\n\n<section>\n\n  <div class="details-full">\n    <section>\n      <div class="detail">\n        <span class="info-label" translate>Advisory</span>\n        <span class="info-value">{{ errata.errata_id }}</span>\n      </div>\n      <div class="detail">\n        <span class="info-label" translate>CVEs</span>\n        <span class="info-value">\n          <span ng-repeat="cve in errata.cves">\n            <a href="{{ cve.href }}">{{ cve.cve_id }}</a>\n            <span ng-show="!$last">,</span>\n          </span>\n        </span>\n      </div>\n      <div class="detail">\n        <span class="info-label" translate>Type</span>\n        <span class="info-value">{{ errata.type | errataType }}</span>\n      </div>\n      <div class="detail">\n        <span class="info-label" translate>Severity</span>\n        <span class="info-value">{{ errata.severity | errataSeverity }}</span>\n      </div>\n      <div class="detail">\n        <span class="info-label" translate>Issued</span>\n        <span class="info-value">{{ errata.issued | date:\'shortDate\' }}</span>\n      </div>\n      <div class="detail">\n        <span class="info-label" translate>Last Updated On</span>\n        <span class="info-value">{{ errata.updated | date:\'shortDate\' }}</span>\n      </div>\n      <div class="detail">\n        <span class="info-label" translate>Reboot Suggested?</span>\n        <span class="info-value">{{ errata.reboot_suggested | booleanToYesNo }}</span>\n      </div>\n\n      <h3 translate>Topic</h3>\n      <p class="info-paragraph">{{ errata.summary }}</p>\n\n\n      <h3 translate>Description</h3>\n      <p class="info-paragraph">{{ errata.description }}</p>\n\n      <h3 translate>Solution</h3>\n      <p class="info-paragraph">{{ errata.solution }}</p>\n\n      <h3 translate>Affected Packages</h3>\n      <ul>\n        <li ng-repeat="package in errata.packages">\n          {{ package }}\n        </li>\n      </ul>\n    </section>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/errata/details/views/errata-details-repositories.html",'<span page-title ng-model="errata">{{ \'Repositories for Errata: \' | translate }} {{ errata.title }}</span>\n\n<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="header">\n    <h3 translate>Repositories containing Errata {{ errata.errata_id }}</h3>\n  </div>\n\n  <div data-block="actions"></div>\n\n  <div data-block="filters">\n    <form class="form-horizontal">\n      <div class="form-group">\n        <div class="col-sm-2">\n          <select class="form-control"\n                  ng-disabled="!environments"\n                  ng-model="environmentFilter"\n                  ng-options="e.id as e.name for e in environments"\n                  ng-change="filterErrata()">\n          </select>\n        </div>\n\n        <div class="col-sm-2">\n          <select class="form-control"\n                  ng-disabled="!contentViews || filteredCVs.length === 0"\n                  ng-model="contentViewFilter"\n                  ng-options="cv as cv.name for cv in filteredCVs = (contentViews | filter:{environments: environmentFilter})"\n                  ng-change="filterErrata()">\n          </select>\n          <p class="help-block" translate ng-show="filteredCVs.length === 0">\n            There are no Content Views in this Environment.\n          </p>\n        </div>\n      </div>\n    </form>\n  </div>\n\n  <div data-block="table">\n    <p class="alert alert-info" ng-show="detailsTable.rows.length === 0" translate>\n      No Repositories contain this Erratum.\n    </p>\n\n    <table class="table table-striped table-bordered"\n           ng-class="{\'table-mask\': detailsTable.working}"\n           ng-show="detailsTable.rows.length > 0">\n      <thead>\n        <tr bst-table-head row-select>\n          <th bst-table-column="name"><span translate>Name</span></th>\n          <th bst-table-column="product"><span translate>Product</span></th>\n          <th bst-table-column="contentView"><span translate>Content View</span></th>\n          <th bst-table-column="lastSync"><span translate>Last Sync</span></th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row\n            ng-repeat="repository in detailsTable.rows"\n            row-select="repository">\n          <td bst-table-cell>\n            <a ng-href="/products/{{ repository.product.id }}/repositories/{{ repository.library_instance_id || repository.id }}">\n              {{ repository.name }}\n            </a>\n          </td>\n          <td bst-table-cell>\n            <a ng-href="/products/{{ repository.product.id }}">\n              {{ repository.product.name }}\n            </a>\n          </td>\n          <td bst-table-cell>\n            <a ng-href="/content_views/{{ repository.content_view.id }}">\n              {{ repository.content_view.name }}\n            </a>\n          </td>\n          <td bst-table-cell>\n              <span ng-show="repository.url">\n              <span ng-show="repository.last_sync == null" translate>\n                Not Synced\n              </span>\n              <span ng-hide="repository.last_sync == null">\n                <a href="/foreman_tasks/tasks/{{repository.last_sync.id}}">{{ repository.last_sync.result | capitalize}}</a>\n                <span translate>{{ repository.last_sync_words }} ago</span>\n              </span>\n            </span>\n            <span ng-hide="repository.url" translate>N/A</span>\n          </td>\n        </tr>\n      </tbody>\n    </table>\n  </div>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/errata/details/views/errata-details.html",'<span page-title ng-model="errata">{{ \'Errata: \' | translate }} {{ errata.title }}</span>\n\n<div class="loading-mask loading-mask-panel" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="details-header">\n    <h2 class="fl">{{ errata.title }}</h2>\n\n    <div class="details-actions fr">\n      <button class="btn btn-default" ui-sref="errata.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <nav class="details-navigation">\n    <ul>\n      <li ng-class="{active: isState(\'errata.details.info\')}">\n        <a ui-sref="errata.details.info">\n          <span translate>\n            Details\n          </span>\n        </a>\n      </li>\n      <li ng-class="{active: isState(\'errata.details.content-hosts\')}">\n        <a ui-sref="errata.details.content-hosts">\n          <span translate>\n            Content Hosts\n          </span>\n        </a>\n      </li>\n      <li ng-class="{active: isState(\'errata.details.repositories\')}">\n        <a ui-sref="errata.details.repositories">\n          <span translate>\n            Repositories\n          </span>\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <section ui-view></section>\n</section>\n')}]),angular.module("Bastion.errata").directive("errataCounts",function(){return{restrict:"AE",replace:!0,templateUrl:"errata/views/errata-counts.html",scope:{errataCounts:"="}}}),angular.module("Bastion.errata").filter("errataSeverity",["translate",function(translate){return function(type){var errataSeverity;switch(type){case"Moderate":errataSeverity=translate("Moderate");break;case"Important":errataSeverity=translate("Important");break;case"Critical":errataSeverity=translate("Critical");break;case"":errataSeverity=translate("N/A");break;default:errataSeverity=type}return errataSeverity}}]),angular.module("Bastion.errata").filter("errataType",["translate",function(translate){return function(type){var errataType;switch(type){case"bugfix":errataType=translate("Bug Fix Advisory");break;case"enhancement":errataType=translate("Product Enhancement Advisory");break;case"security":errataType=translate("Security Advisory");break;default:errataType=type}return errataType}}]),angular.module("Bastion.errata").controller("ErrataController",["$scope","$location","Nutupane","Erratum","CurrentOrganization",function($scope,$location,Nutupane,Erratum,CurrentOrganization){var params={organization_id:CurrentOrganization,search:$location.search().search||"",sort_by:"updated",sort_order:"DESC",paged:!0},nutupane=new Nutupane(Erratum,params);$scope.table=nutupane.table,$scope.removeRow=nutupane.removeRow,$scope.table.closeItem=function(){$scope.transitionTo("errata.index")}}]),angular.module("Bastion.errata").config(["$stateProvider",function($stateProvider){$stateProvider.state("errata",{"abstract":!0,controller:"ErrataController",templateUrl:"errata/views/errata.html"}).state("errata.index",{url:"/errata",permission:["view_products","view_content_views"],views:{table:{templateUrl:"errata/views/errata-table-full.html"}}}).state("errata.details",{"abstract":!0,url:"/errata/:errataId",permission:["view_products","view_content_views"],collapsed:!0,views:{table:{templateUrl:"errata/views/errata-table-collapsed.html"},"action-panel":{controller:"ErrataDetailsController",templateUrl:"errata/details/views/errata-details.html"}}}).state("errata.details.info",{url:"/info",collapsed:!0,permission:["view_products","view_content_views"],templateUrl:"errata/details/views/errata-details-info.html"}).state("errata.details.content-hosts",{url:"/content-hosts",collapsed:!0,permission:["view_products","view_content_views"],controller:"ErrataContentHostsController",templateUrl:"errata/details/views/errata-details-content-hosts.html"}).state("errata.details.repositories",{url:"/repositories",collapsed:!0,permission:["view_products","view_content_views"],controller:"ErrataDetailsRepositoriesController",templateUrl:"errata/details/views/errata-details-repositories.html"})}]),angular.module("Bastion.errata").factory("Erratum",["BastionResource",function(BastionResource){return BastionResource("/katello/api/v2/errata/:id/",{id:"@id",sort_by:"issued",sort_order:"DESC"},{autocomplete:{method:"GET",isArray:!0,params:{id:"auto_complete_search"}},applicableContentHosts:{method:"GET",transformResponse:function(data){var erratum=angular.fromJson(data),systems=erratum.systems_applicable;return{results:systems,subtotal:systems.length,total:systems.length}}}})}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/errata/views/errata-counts.html",'<span>\n  <span class="errata-count">\n    <span>\n      {{ errataCounts.security || 0 }}\n    </span>\n    <i class="icon-warning-sign inline-icon"\n       ng-class="{black: errataCounts.security === 0, red: errataCounts.security > 0}"\n       title="{{ \'Security\' | translate }}"></i>\n  </span>\n  <span class="errata-count">\n    <span>\n      {{ errataCounts.bugfix || 0 }}\n    </span>\n    <i class="icon-bug inline-icon"\n       ng-class="{black: errataCounts.bugfix === 0, yellow: errataCounts.bugfix > 0}"\n       title="{{ \'Bug Fix\' | translate }}"></i>\n  </span>\n  <span class="errata-count">\n    <span>\n      {{ errataCounts.enhancement || 0 }}\n    </span>\n    <i class="icon-plus-sign-alt inline-icon"\n       ng-class="{black: errataCounts.enhancement === 0, yellow: errataCounts.enhancement > 0}"\n       title="{{ \'Enhancement\' | translate }}"></i>\n  </span>\n</span>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/errata/views/errata-table-collapsed.html",'<table bst-table="table" class="table table-striped table-full" ng-class="{\'table-mask\': table.working}">\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column sortable>{{ "Errata ID" | translate }}</th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row\n        ng-repeat="errata in table.rows"\n        row-select="product"\n        active-row="stateIncludes(\'errata.details\', {errataId: errata.id})">\n      <td bst-table-cell>\n        <a ui-sref="errata.details.info({errataId: errata.id})">\n          {{ errata.errata_id }}\n        </a>\n      </td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/errata/views/errata-table-full.html",'<table class="table table-striped" ng-class="{\'table-mask\': table.working}">\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column="errataId" sortable>{{ "Errata ID" | translate }}</th>\n      <th bst-table-column="title">{{ "Title" | translate }}</th>\n      <th bst-table-column="type">{{ "Type" | translate }}</th>\n      <th bst-table-column="numberOfContentHosts">{{ "Affected Content Hosts" | translate }}</th>\n      <th bst-table-column="updated">{{ "Updated" | translate }}</th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row ng-repeat="errata in table.rows" row-select="errata">\n      <td bst-table-cell>\n        <a ui-sref="errata.details.info({errataId: errata.id})">\n          {{ errata.errata_id }}\n        </a>\n        <i class="icon-chevron-right selected-icon" ng-show="errata.selected"></i>\n      </td>\n      <td bst-table-cell>\n        {{ errata.title }}\n      </td>\n      <td bst-table-cell>\n          <span ng-show="errata.type == \'security\'">\n            <i class="icon-warning-sign inline-icon" title="{{ \'Security\' | translate }}"></i>\n          </span>\n\n          <span ng-show="errata.type == \'bugfix\'">\n            <i class="icon-bug inline-icon" title="{{ \'Bug Fix\' | translate }}"></i>\n          </span>\n\n          <span ng-show="errata.type == \'enhancement\'">\n            <i class="icon-plus-sign-alt inline-icon" title="{{ \'Enhancement\' | translate }}"></i>\n          </span>\n\n        {{ errata.type | errataType}}\n        <span ng-show="errata.severity">- {{ errata.severity | errataSeverity}}</span>\n      </td>\n      <td bst-table-cell>{{ errata.systems_available_count || 0 }}</td>\n      <td bst-table-cell>{{ errata.updated | date:\'shortDate\'}}</td>\n    </tr>\n  </tbody>\n</table>\n'
)}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/errata/views/errata.html",'<span page-title>{{ \'Errata\' | translate }}</span>\n\n<div data-extend-template="layouts/nutupane.html">\n\n  <div data-block="header">\n    {{ \'Errata\' | translate }}\n  </div>\n\n  <div data-block="actions">\n  </div>\n\n</div>\n')}]),angular.module("Bastion.environments",["ngResource","ui.router","Bastion","Bastion.utils","Bastion.components","Bastion.errata"]),function(){"use strict";function EnvironmentContentController($scope,Nutupane,Erratum){var nutupane,contentTypes,currentState;currentState=$scope.$state.current.name.split(".").pop(),contentTypes={errata:Erratum},nutupane=new Nutupane(contentTypes[currentState],{environment_id:$scope.$stateParams.environmentId}),nutupane.masterOnly=!0,$scope.nutupane=nutupane,$scope.detailsTable=nutupane.table}angular.module("Bastion.environments").controller("EnvironmentContentController",EnvironmentContentController),EnvironmentContentController.$inject=["$scope","Nutupane","Erratum"]}(),function(){"use strict";function EnvironmentController($scope,Environment,translate){$scope.errorMessages=[],$scope.successMessages=[],$scope.environment=Environment.get({id:$scope.$stateParams.environmentId}),$scope.save=function(environment){function success(){$scope.successMessages.push(translate("Environment saved"))}function error(response){angular.forEach(response.data.errors,function(errorMessage){$scope.errorMessages.push(translate("An error occurred saving the Environment: ")+errorMessage)})}var promise;return promise=environment.$update(),promise.then(success,error),promise},$scope.remove=function(environment){function success(){$scope.successMessages.push(translate("Remove Successful.")),$scope.transitionTo("environments.index")}function error(response){$scope.errorMessages.push(translate("An error occurred removing the environment: ")+response.data.displayMessage)}var promise;return promise=environment.$delete(),promise.then(success,error),promise}}angular.module("Bastion.environments").controller("EnvironmentController",EnvironmentController),EnvironmentController.$inject=["$scope","Environment","translate"]}(),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/environments/details/views/environment-details.html",'<div class="details">\n\n  <div class="detail">\n    <span class="info-label" translate>Name</span>\n      <span class="info-value"\n            bst-edit-text="environment.name"\n            on-save="save(environment)"\n            readonly="denied(\'edit_lifecycle_environments\', environment) || environment.library">\n      </span>\n  </div>\n\n  <div class="detail">\n    <span class="info-label" translate>Label</span>\n    <span class="info-value">{{ environment.label }}</span>\n  </div>\n\n  <div class="detail">\n    <span class="info-label" translate>Description</span>\n    <span class="info-value"\n          bst-edit-textarea="environment.description"\n          on-save="save(environment)"\n          readonly="denied(\'edit_lifecycle_environments\', environment) || environment.library">\n     </span>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/environments/details/views/environment-errata.html",'<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="header"></div>\n  <div data-block="selection-summary"></div>\n\n  <table data-block="table" class="table table-striped table-bordered">\n    <thead>\n      <tr bst-table-head>\n        <th bst-table-column="errataId" sortable>{{ "Errata ID" | translate }}</th>\n        <th bst-table-column="title">{{ "Title" | translate }}</th>\n        <th bst-table-column="type">{{ "Type" | translate }}</th>\n        <th bst-table-column="numberOfContentHosts">{{ "Affected Content Hosts" | translate }}</th>\n        <th bst-table-column="updated">{{ "Updated" | translate }}</th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr bst-table-row ng-repeat="errata in detailsTable.rows">\n        <td bst-table-cell>\n          <a ui-sref="errata.details.info({errataId: errata.id})">\n            {{ errata.errata_id }}\n          </a>\n        </td>\n        <td bst-table-cell>\n          {{ errata.title }}\n        </td>\n        <td bst-table-cell>\n            <span ng-show="errata.type == \'security\'">\n              <i class="icon-warning-sign inline-icon" title="{{ \'Security\' | translate }}"></i>\n            </span>\n\n            <span ng-show="errata.type == \'bugfix\'">\n              <i class="icon-bug inline-icon" title="{{ \'Bug Fix\' | translate }}"></i>\n            </span>\n\n            <span ng-show="errata.type == \'enhancement\'">\n              <i class="icon-plus-sign-alt inline-icon" title="{{ \'Enhancement\' | translate }}"></i>\n            </span>\n\n          {{ errata.type | errataType}}\n          <span ng-show="errata.severity">- {{ errata.severity | errataSeverity}}</span>\n        </td>\n        <td bst-table-cell class="number-cell">{{ errata.systems_available_count || 0 }}</td>\n        <td bst-table-cell>{{ errata.updated | date:\'shortDate\'}}</td>\n      </tr>\n    </tbody>\n  </table>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/environments/details/views/environment.html",'<section class="details-page">\n\n  <ol class="breadcrumb">\n    <li>\n      <a ui-sref="environments.index" translate>Environments List</a>\n    </li>\n    \n    <li class="active">\n      <a translate>\n        {{ environment.name }} Environment\n      </a>\n    </li>\n  </ol>\n\n  <div class="row">\n    <h1 class="col-sm-12">\n      <span translate>Environment: {{ environment.name }}</span>\n      <button ng-show="!environment.library && !environment.successor"\n              ng-click="remove(environment)"\n              class="btn btn-default fr">\n        <i class="icon-trash inline-icon"></i>\n        Remove Environment\n      </button>\n    </h1>\n  </div>\n\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <nav>\n    <ul class="nav nav-tabs">\n\n      <li ng-class="{active: isState(\'environments.environment.errata\')}">\n        <a ui-sref="environments.environment.errata({environmentId: environment.id})">\n          <span translate>Errata</span>\n        </a>\n      </li>\n\n      <li ng-class="{active: isState(\'environments.environment.details\')}">\n        <a ui-sref="environments.environment.details({environmentId: environment.id})">\n          <span translate>Details</span>\n        </a>\n      </li>\n\n    </ul>\n  </nav>\n\n  <div ui-view></div>\n\n</section>\n')}]),angular.module("Bastion.environments").factory("Environment",["BastionResource","CurrentOrganization",function(BastionResource,CurrentOrganization){return BastionResource("/katello/api/v2/environments/:id/:action",{id:"@id",organization_id:CurrentOrganization},{update:{method:"PUT"}})}]),angular.module("Bastion.environments").controller("EnvironmentsController",["$scope","Organization","CurrentOrganization",function($scope,Organization,CurrentOrganization){Organization.paths({id:CurrentOrganization},function(paths){var actualPaths=[];$scope.library=paths[0].environments[0],angular.forEach(paths,function(path,index){paths[index].environments.splice(0,1),paths[index].environments.length!==0&&actualPaths.push(path)}),$scope.paths=actualPaths}),$scope.lastEnvironment=function(path){return path.environments[path.environments.length-1]}}]),angular.module("Bastion.environments").config(["$stateProvider",function($stateProvider){$stateProvider.state("environments",{"abstract":!0,permission:"view_lifecycle_environments",template:"<div ui-view></div>"}),$stateProvider.state("environments.index",{url:"/lifecycle_environments",permission:"view_lifecycle_environments",controller:"EnvironmentsController",templateUrl:"environments/views/environments.html"}).state("environments.new",{url:"/lifecycle_environments/:priorId/new",permission:"create_lifecycle_environments",controller:"NewEnvironmentController",templateUrl:"environments/views/new-environment.html"}),$stateProvider.state("environments.environment",{url:"/lifecycle_environments/:environmentId",permission:"view_lifecycle_environments",controller:"EnvironmentController",templateUrl:"environments/details/views/environment.html"}).state("environments.environment.details",{url:"/details",permission:"view_lifecycle_environments",templateUrl:"environments/details/views/environment-details.html"}).state("environments.environment.errata",{url:"/errata",permission:"view_lifecycle_environments",controller:"EnvironmentContentController",templateUrl:"environments/details/views/environment-errata.html"})}]),function(){"use strict";function NewEnvironmentController($scope,Environment,FormUtils){function success(){$scope.transitionTo("environments.index")}function error(response){$scope.working=!1,angular.forEach(response.data.errors,function(errors,field){$scope.environmentForm[field].$setValidity("server",!1),$scope.environmentForm[field].$error.messages=errors})}$scope.loading=!0,$scope.environment=new Environment,$scope.priorEnvironment=Environment.get({id:$scope.$stateParams.priorId}),$scope.priorEnvironment.$promise.then(function(){$scope.loading=!1}),$scope.save=function(environment){environment.prior=$scope.$stateParams.priorId,environment.$save(success,error)},$scope.$watch("environment.name",function(){$scope.environmentForm.name&&($scope.environmentForm.name.$setValidity("server",!0),FormUtils.labelize($scope.environment))})}angular.module("Bastion.environments").controller("NewEnvironmentController",NewEnvironmentController),NewEnvironmentController.$inject=["$scope","Environment","FormUtils"]}(),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/environments/views/environments.html",'<span page-title>{{ \'Lifecycle Environment Paths\' | translate }}</span>\n\n<section ng-cloak bst-container-scroll class="row">\n\n  <h2 class="col-sm-12">\n    <span data-block="header" translate>\n      Lifecycle Environment Paths\n    </span>\n\n    <a class="fr btn btn-default"\n        ui-sref="environments.new({priorId: library.id})"\n        ng-hide="denied(\'create_lifecycle_environments\')">\n      <i class="icon-plus"></i>\n      {{ "New Environment Path" | translate }}\n    </a>\n  </h2>\n\n  <section class="row nutupane-sub-section">\n\n    <div class="col-sm-12">\n\n      <div class="col-sm-12">\n        <table class="table table-bordered info-blocks">\n          <tbody>\n            <tr>\n              <td class="info-block-head"><a ui-sref="environments.environment.details({environmentId: library.id})" translate>Library</a></td>\n              <td class="info-block" translate>Content Views <div>{{ library.counts.content_views || 0 }}</div></td>\n              <td class="info-block" translate>Products <div>{{ library.counts.products || 0 }}</div></td>\n              <td class="info-block" translate>Yum Repositories <div>{{ library.counts.yum_repositories || 0 }}</div></td>\n              <td class="info-block" translate>Docker Repositories <div>{{ library.counts.docker_repositories || 0 }}</div></td>\n              <td class="info-block" translate>Packages <div>{{ library.counts.packages || 0 }}</div></td>\n              <td class="info-block" translate>Errata <div>{{ library.counts.errata.total || 0 }}</div></td>\n              <td class="info-block" translate>Puppet Modules <div>{{ library.counts.puppet_modules || 0 }}</div></td>\n            </tr>\n          </tbody>\n        </table>\n      </div>\n\n      <div class="col-sm-12 environment" ng-repeat="path in paths">\n        <div class="row">\n          <div class="col-sm-12">\n            <a ui-sref="environments.new({priorId: lastEnvironment(path).id})" class="btn btn-default fr">\n              <i class="icon-plus inline-icon"></i>\n              <span translate>Add New Environment</span>\n            </a>\n          </div>\n        </div>\n\n        <table class="table table-bordered environment-table">\n          <thead>\n            <tr>\n              <th></th>\n              <th ng-repeat="environment in path.environments">\n                <a ui-sref="environments.environment.details({environmentId: environment.id})"\n                   ng-hide="denied(\'create_lifecycle_environments\')">\n                  {{ environment.name }}\n                </a>\n              </th>\n            </tr>\n          </thead>\n\n          <tbody>\n            <tr>\n              <td translate>Content Views</td>\n              <td ng-repeat="environment in path.environments">{{ environment.counts.content_views || 0 }}</td>\n            </tr>\n            <tr>\n              <td translate>Content Hosts</td>\n              <td ng-repeat="environment in path.environments">{{ environment.counts.content_hosts || 0 }}</td>\n            </tr>\n          </tbody>\n        </table>\n      </div>\n\n    </div>\n  </section>\n\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/environments/views/new-environment.html",'<span page-title>{{ \'New Environment\' | translate }}</span>\n\n<section class="details-page" ng-cloak>\n\n  <ol class="breadcrumb">\n    <li>\n      <a ui-sref="environments.index" translate>Environments List</a>\n    </li>\n    \n    <li class="active">\n      <a translate>\n        New Environment\n      </a>\n    </li>\n  </ol>\n\n  <header>\n    <h1 translate>New Environment</h1>\n  </header>\n  \n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <div ng-show="priorEnvironment.successor && !loading">\n    <p translate>Lifecycle Environment "{{ priorEnvironment.name }}" exists within the middle of a path. New Lifecycle Environments can only be added to the end of a path.</p>\n  </div>\n\n  <div ng-show="!priorEnvironment.successor && !loading" class="row">\n\n    <p class="col-sm-12" translate>Adding Lifecycle Environment to the end of "{{ priorEnvironment.name }}"</p>\n\n    <form name="environmentForm" class="form-horizontal col-sm-8" novalidate role="form">\n      <div bst-form-group label="{{ \'Name\' | translate }}">\n        <input id="name"\n               name="name"\n               ng-model="environment.name"\n               type="text"\n               tabindex="1"\n               autofocus\n               required/>\n      </div>\n\n      <div bst-form-group label="{{ \'Label\' | translate }}">\n        <input id="label"\n               name="label"\n               ng-model="environment.label"\n               type="text"\n               tabindex="2"\n               required/>\n      </div>\n\n      <div bst-form-group label="{{ \'Description\' | translate }}">\n        <textarea id="description"\n                  name="description"\n                  ng-model="environment.description"\n                  tabindex="3">\n        </textarea>\n      </div>\n\n      <div bst-form-buttons\n           on-cancel="transitionTo(\'environments.index\')"\n           on-save="save(environment)"\n           working="working">\n      </div>\n    </form>\n  </div>\n\n</section>\n')}]),angular.module("Bastion.capsules",["ngResource","Bastion"]),angular.module("Bastion.capsules").factory("Capsule",["BastionResource",function(BastionResource){return BastionResource("/katello/api/capsules/:id/:action",{id:"@id"},{})}]),angular.module("Bastion.organizations",["ngResource","Bastion"]),angular.module("Bastion.organizations").factory("Organization",["BastionResource","CurrentOrganization",function(BastionResource,CurrentOrganization){return BastionResource("/katello/api/v2/organizations/:id/:action",{id:"@id"},{update:{method:"PUT"},repoDiscover:{method:"POST",params:{action:"repo_discover"}},cancelRepoDiscover:{method:"POST",params:{action:"cancel_repo_discover"}},autoAttachSubscriptions:{method:"POST",params:{action:"autoattach_subscriptions"}},paths:{method:"GET",url:"/katello/api/v2/organizations/:id/environments/paths",isArray:!0,transformResponse:function(data){return angular.fromJson(data).results}},readableEnvironments:{method:"GET",url:"/katello/api/v2/organizations/:id/environments/paths",isArray:!0,transformResponse:function(data){return _.map(angular.fromJson(data).results,function(path){return _.map(path.environments,function(env){return env.select=env.permissions.readable,env})})}},redhatProvider:{method:"GET",url:"/katello/api/v2/organizations/:organization_id/redhat_provider",params:{organization_id:CurrentOrganization}}})}]),angular.module("Bastion.packages",["Bastion"]),angular.module("Bastion.packages").factory("Package",["BastionResource","CurrentOrganization",function(BastionResource){return BastionResource("/katello/api/v2/packages/:id",{id:"@id"},{autocomplete:{method:"GET",url:"/katello/packages/auto_complete",transformResponse:function(data){return data=angular.fromJson(data),{results:data}}}})}]),function(){"use strict";angular.module("Bastion.package-groups",["Bastion"])}(),function(){"use strict";function PackageGroup(BastionResource){return BastionResource("/katello/api/v2/package_groups/:id",{id:"@id"})}angular.module("Bastion.package-groups").factory("PackageGroup",PackageGroup),PackageGroup.$inject=["BastionResource"]}(),function(){"use strict";angular.module("Bastion.puppet-modules",["Bastion"])}(),function(){"use strict";function PuppetModule(BastionResource){return BastionResource("/katello/api/v2/puppet_modules/:id",{id:"@id"})}angular.module("Bastion.puppet-modules").factory("PuppetModule",PuppetModule),PuppetModule.$inject=["BastionResource"]}(),angular.module("Bastion.products",["ngResource","ui.router","Bastion","Bastion.utils","Bastion.components","Bastion.sync-plans","Bastion.gpg-keys","Bastion.tasks"]),angular.module("Bastion.products").config(["$stateProvider",function($stateProvider){$stateProvider.state("products",{"abstract":!0,controller:"ProductsController",templateUrl:"products/views/products.html"}).state("products.index",{url:"/products",permission:"view_products",views:{table:{templateUrl:"products/views/products-table-full.html"}}}).state("products.new",{"abstract":!0,collapsed:!0,views:{table:{templateUrl:"products/views/products-table-collapsed.html"},"action-panel":{controller:"NewProductController",templateUrl:"products/new/views/product-new.html"}}}).state("products.new.form",{url:"/products/new",permission:"create_products",collapsed:!0,controller:"ProductFormController",templateUrl:"products/new/views/product-new-form.html"}).state("products.new.sync-plan",{url:"/products/new/sync-plan",permission:"create_sync_plans",collapsed:!0,controller:"NewSyncPlanController",templateUrl:"sync-plans/new/views/new-sync-plan-form.html"}).state("products.discovery",{collapsed:!0,"abstract":!0,views:{table:{templateUrl:"products/views/products-table-collapsed.html"},"action-panel":{templateUrl:"products/discovery/views/discovery-base.html",controller:"DiscoveryController"}}}).state("products.discovery.scan",{collapsed:!0,url:"/products/discovery/scan",permission:"edit_products",templateUrl:"products/discovery/views/discovery.html"}).state("products.discovery.create",{collapsed:!0,url:"/products/discovery/scan/create",permission:"edit_products",templateUrl:"products/discovery/views/discovery-create.html",controller:"DiscoveryFormController"}).state("products.details",{"abstract":!0,url:"/products/:productId",permission:"view_products",collapsed:!0,views:{table:{templateUrl:"products/views/products-table-collapsed.html"},"action-panel":{controller:"ProductDetailsController",templateUrl:"products/details/views/product-details.html"}}}).state("products.details.info",{url:"/info",permission:"view_products",collapsed:!0,controller:"ProductDetailsInfoController",templateUrl:"products/details/views/product-info.html"}).state("products.details.info.new-sync-plan",{url:"/sync-plan/new",permission:"create_sync_plans",collapsed:!0,views:{"@products.details":{controller:"NewSyncPlanController",templateUrl:"sync-plans/new/views/new-sync-plan-form.html"}}}).state("products.details.repositories",{"abstract":!0,controller:"ProductRepositoriesController",template:"<div ui-view></div>"}).state("products.details.repositories.index",{collapsed:!0,url:"/repositories",permission:"view_products",templateUrl:"products/details/views/product-repositories.html"}).state("products.details.repositories.new",{url:"/repositories/new",permission:"create_products",collapsed:!0,controller:"NewRepositoryController",templateUrl:"repositories/new/views/repository-new.html"}).state("products.details.repositories.info",{url:"/repositories/:repositoryId",permission:"view_products",collapsed:!0,controller:"RepositoryDetailsInfoController",templateUrl:"repositories/details/views/repository-info.html"}).state("products.details.repositories.manage-content",{"abstract":!0,controller:"RepositoryManageContentController",template:"<div ui-view></div>"}).state("products.details.repositories.manage-content.packages",{url:"/repositories/:repositoryId/content/packages",permission:"edit_products",collapsed:!0,templateUrl:"repositories/details/views/repository-manage-packages.html"}).state("products.details.repositories.manage-content.puppet-modules",{url:"/repositories/:repositoryId/content/puppet_modules",permission:"edit_products",collapsed:!0,templateUrl:"repositories/details/views/repository-manage-puppet-modules.html"}).state("products.details.repositories.manage-content.docker-images",{url:"/repositories/:repositoryId/content/docker_images",permission:"edit_products",collapsed:!0,templateUrl:"repositories/details/views/repository-manage-docker-images.html"}),$stateProvider.state("products.details.tasks",{"abstract":!0,collapsed:!0,template:"<div ui-view></div>"}).state("products.details.tasks.index",{url:"/tasks",permission:"view_products",collapsed:!0,templateUrl:"products/details/views/product-tasks.html"}).state("products.details.tasks.details",{url:"/tasks/:taskId",permission:"view_products",collapsed:!0,controller:"TaskDetailsController",templateUrl:"tasks/views/task-details.html"}),$stateProvider.state("products.bulk-actions",{"abstract":!0,collapsed:!0,views:{table:{templateUrl:"products/views/products-table-collapsed.html"},"action-panel":{controller:"ProductsBulkActionController",templateUrl:"products/bulk/views/bulk-actions.html"}}}).state("products.bulk-actions.sync",{url:"/products/bulk-actions/sync",permission:"sync_products",collapsed:!0,controller:"ProductsBulkActionSyncController",templateUrl:"products/bulk/views/bulk-actions-sync.html"}).state("products.bulk-actions.sync-plan",{url:"/products/bulk-actions/sync-plan",permission:"edit_products",collapsed:!0,controller:"ProductsBulkActionSyncPlanController",templateUrl:"products/bulk/views/bulk-actions-sync-plan.html"}).state("products.bulk-actions.sync-plan.new",{url:"/products/bulk-actions/sync-plan/new",permission:"create_sync_plans",collapsed:!0,views:{"@products.bulk-actions":{controller:"NewSyncPlanController",templateUrl:"sync-plans/new/views/new-sync-plan-form.html"}}})}]),angular.module("Bastion.products").controller("ProductsBulkActionSyncPlanController",["$scope","Nutupane","SyncPlan","ProductBulkAction",function($scope,Nutupane,SyncPlan,ProductBulkAction){function success(response){$scope.$parent.successMessages=response.displayMessages.success,$scope.$parent.errorMessages=response.displayMessages.error,$scope.updatingSyncPlans=!1}function error(response){$scope.$parent.errorMessages=response.data.errors,$scope.updatingSyncPlans=!1}var syncPlanNutupane=new Nutupane(SyncPlan);$scope.successMessages=[],$scope.errorMessages=[],$scope.syncPlanTable=syncPlanNutupane.table,syncPlanNutupane.query(),$scope.updateSyncPlan=function(){$scope.updatingSyncPlans=!0,$scope.actionParams.ids=$scope.getSelectedProductIds(),$scope.actionParams.plan_id=$scope.syncPlanTable.chosenRow.id,ProductBulkAction.updateProductSyncPlan($scope.actionParams,success,error)},$scope.removeSyncPlan=function(){$scope.updatingSyncPlans=!0,$scope.actionParams.ids=$scope.getSelectedProductIds(),$scope.actionParams.plan_id=null,ProductBulkAction.updateProductSyncPlan($scope.actionParams,success,error)}}]),angular.module("Bastion.products").controller("ProductsBulkActionSyncController",["$scope","$state","translate","ProductBulkAction",function($scope,$state,translate,ProductBulkAction){$scope.repositoryCount=0,$scope.syncProducts=function(){$scope.actionParams.ids=$scope.getSelectedProductIds(),ProductBulkAction.syncProducts($scope.actionParams,function(task){$state.go("task",{taskId:task.id})})}}]),angular.module("Bastion.products").controller("ProductsBulkActionController",["$scope","translate","ProductBulkAction","CurrentOrganization",function($scope,translate,ProductBulkAction,CurrentOrganization){$scope.successMessages=[],$scope.errorMessages=[],$scope.removeProducts={confirm:!1,workingMode:!1},$scope.actionParams={ids:[],organization_id:CurrentOrganization},$scope.getSelectedProductIds=function(){var rows=$scope.productTable.getSelected();return _.pluck(rows,"id")},$scope.removeProducts=function(){var success,error;$scope.removingProducts=!0,$scope.actionParams.ids=$scope.getSelectedProductIds(),success=function(data){$scope.productsNutupane.refresh(),$scope.table.selectAll(!1),$scope.$parent.successMessages=data.displayMessages.success,$scope.$parent.errorMessages=data.displayMessages.error,$scope.removingProducts=!1,$scope.transitionTo("products.index")},error=function(error){angular.forEach(error.data.errors,function(errorMessage){$scope.errorMessages.push(translate("An error occurred removing the Products: ")+errorMessage)}),$scope.removingProducts=!1},ProductBulkAction.removeProducts($scope.actionParams,success,error)}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/bulk/views/bulk-actions-sync-plan.html",'<span page-title>{{ \'Bulk Alter Products Sync Plan\' | translate }}</span>\n\n<section class="details details-full">\n\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <input type="text"\n         class="form-control filter-input"\n         placeholder="{{ \'Filter\' | translate }}"\n         ng-model="syncPlanSearch"/>\n\n  <span class="pull-right">\n\n    <button class="btn btn-default"\n            ng-hide="denied(\'create_sync_plans\')"\n            ui-sref="products.bulk-actions.sync-plan.new"\n            translate>\n      Create Sync Plan\n    </button>\n    <button class="btn btn-default"\n            ng-hide="denied(\'edit_products\')"\n            ng-click="removeSyncPlan()">\n      <i class="icon-spinner icon-spin" ng-show="updatingSyncPlans && !syncPlanTable.chosenRow"></i>\n      <span ng-show="updatingSyncPlans && !syncPlanTable.chosenRow" translate>Unattaching...</span>\n      <i ng-hide="updatingSyncPlans && !syncPlanTable.chosenRow" class="icon-remove"></i>\n      <span ng-hide="updatingSyncPlans && !syncPlanTable.chosenRow" translate>Unattach Sync Plan</span>\n    </button>\n    <button class="btn btn-primary"\n            ng-hide="denied(\'edit_products\')"\n            ng-click="updateSyncPlan()"\n            ng-disabled="!syncPlanTable.chosenRow">\n      <i class="icon-spinner icon-spin" ng-show="updatingSyncPlans && syncPlanTable.chosenRow"></i>\n      <span ng-show="updatingSyncPlans && syncPlanTable.chosenRow" translate>Updating...</span>\n      <i ng-hide="updatingSyncPlans && syncPlanTable.chosenRow" class="icon-refresh"></i>\n      <span ng-hide="updatingSyncPlans && syncPlanTable.chosenRow" translate>Update Sync Plan</span>\n    </button>\n  </span>\n\n  <div class="nutupane">\n    <table bst-table="syncPlanTable"\n           class="table table-striped"\n           ng-class="{\'table-mask\': syncPlanTable.working}">\n      <thead>\n        <tr bst-table-head row-choice>\n          <th bst-table-column="name" translate>Name</th>\n          <th bst-table-column="description" translate>Description</th>\n          <th bst-table-column="interval" translate>Interval</th>\n          <th bst-table-column="sync-date" translate>Start Date</th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row\n            row-choice="syncPlan"\n            ng-repeat="syncPlan in syncPlanTable.rows | filter:syncPlanSearch">\n          <td bst-table-cell>{{ syncPlan.name }}</td>\n          <td bst-table-cell>{{ syncPlan.description }}</td>\n          <td bst-table-cell>{{ syncPlan.interval | capitalize }}</td>\n          <td bst-table-cell>{{ syncPlan.sync_date }}</td>\n        </tr>\n      </tbody>\n    </table>\n  </div>\n\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/bulk/views/bulk-actions-sync.html",'<span page-title>{{ \'Bulk Sync Products\' | translate }}</span>\n\n<div>\n  <header translate>Press \'Sync Now\' below to begin syncing the following product(s).</header>\n\n  <table class="table table-striped">\n    <thead>\n      <tr>\n        <th translate>Name</th>\n        <th translate>Description</th>\n        <th translate>Repositories</th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr ng-repeat="product in productTable.getSelected()">\n        <td>\n          <a ui-sref="products.details.info({ productId: product.id })">{{ product.name }}</a>\n        </td>\n        <td>{{ product.description }}</td>\n        <td>\n          <span ng-repeat="repository in product.repositories">\n            {{ repository.name }}<span ng-show="!$last">, </span>\n          </span>\n        </td>\n      </tr>\n    </tbody>\n  </table>\n\n  <div class="pull-left">\n    <button class="btn btn-default"\n            ng-hide="denied(\'sync_products\')"\n            ng-click="syncProducts()">\n      <i class="icon-refresh"></i>\n      <span translate>Sync Now</span>\n    </button>\n  </div>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/bulk/views/bulk-actions.html",'<span page-title>{{ \'Product Bulk Actions\' | translate }}</span>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n  <header class="details-header">\n    <h2 class="fl" translate>Bulk Actions</h2>\n\n    <div class="fr">\n      <button class="btn btn-default"\n              ng-disabled="product.readonly || removeProducts.workingMode"\n              ng-click="openModal()"\n              ng-hide="denied(\'delete_products\')">\n        <i class="icon-trash"></i>\n        {{ "Remove Products" | translate }}\n      </button>\n\n      <span ng-show="removeProducts.workingMode">\n        <i class="icon-spinner inline-icon icon-spin"></i>\n        <span>{{ "Removing Products" | translate }}</span>\n      </span>\n\n      <button class="btn btn-default" ui-sref="products.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n\n      <div bst-modal="removeProducts()" model="table"\n           modal-header=\'Remove {{ productTable.getSelected().length }} Products?\'\n           modal-body=\'Are you sure you want to remove the {{ productTable.getSelected().length }} products(s) selected?\'>\n      </div>\n\n    </div>\n  </header>\n\n  <nav class="details-navigation">\n    <ul>\n      <li>\n        <a translate\n           ui-sref="products.bulk-actions.sync"\n           ng-class="{active: stateIncludes(\'products.bulk-actions.sync\')}">\n          Product Sync\n        </a>\n      </li>\n\n      <li>\n        <a translate\n           ui-sref="products.bulk-actions.sync-plan"\n           ng-class="{active: stateIncludes(\'products.bulk-actions.sync-plan\')}">\n          Alter Sync Plans\n        </a>\n      </li>    \n    </ul>\n  </nav>\n\n  <div>\n    <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n    <div class="alert warning alert-warning" ng-show="table.numSelected == 0">\n      <i class="icon-exclamation-sign"></i>\n      {{ \'At least one product needs to be selected in order to perform a bulk action.\' | translate }}\n    </div>\n\n    <span ng-hide="table.numSelected == 0">\n      <div ui-view></div>\n    </span>\n  </div>\n\n</section>\n'
)}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/details/partials/sync-status.html",'<div class="detail">\n  <span class="info-label" translate>Sync Interval</span>\n  <span class="info-value" ng-if="product.sync_plan.interval == \'hourly\'">\n    <span translate>\n      Hourly at {{ product.sync_plan.sync_date | date:\'m\' }} minutes and {{ product.sync_plan.sync_date | date:\'s\' }} seconds\n    </span>\n  </span>\n  <span class="info-value" ng-if="product.sync_plan.interval == \'daily\'">\n    <span translate>\n      Daily at {{ product.sync_plan.sync_date | date:\'mediumTime\' }} (Server Time)\n    </span>\n  </span>\n  <span class="info-value" ng-if="product.sync_plan.interval == \'weekly\'">\n    <span translate>\n      Weekly on {{ product.sync_plan.sync_date | date:\'EEEE\' }} at {{ product.sync_plan.sync_date | date:\'mediumTime\' }} (Server Time)\n    </span>\n  </span>\n  <span class="info-value" ng-hide="product.sync_plan.next_sync">\n    <span translate>\n      Synced manually, no interval set.\n    </span>\n  </span>\n</div>\n')}]),angular.module("Bastion.products").controller("ProductDetailsInfoController",["$scope","$state","$q","translate","Product","SyncPlan","GPGKey","MenuExpander",function($scope,$state,$q,translate,Product,SyncPlan,GPGKey,MenuExpander){$scope.successMessages=[],$scope.errorMessages=[],$scope.menuExpander=MenuExpander,$scope.panel=$scope.panel||{loading:!1},$scope.product=$scope.product||Product.get({id:$scope.$stateParams.productId},function(){$scope.panel.loading=!1}),$scope.gpgKeys=function(){var deferred=$q.defer();return GPGKey.queryUnpaged(function(gpgKeys){var results=gpgKeys.results;results.unshift({id:null}),deferred.resolve(results)}),deferred.promise},$scope.syncPlans=function(){return SyncPlan.queryUnpaged().$promise},$scope.save=function(product){var deferred=$q.defer();return product.$update(function(response){deferred.resolve(response),$scope.successMessages.push(translate("Product Saved"))},function(response){deferred.reject(response),angular.forEach(response.data.errors,function(errorMessage){$scope.errorMessages.push(translate("An error occurred saving the Product: ")+errorMessage)})}),deferred.promise},$scope.$on("$stateChangeSuccess",function(event,toState,toParams,fromState){fromState.name==="products.details.info.new-sync-plan"&&$scope.product.$update()}),$scope.syncProduct=function(){Product.sync({id:$scope.product.id},function(task){$state.go("products.details.tasks.details",{taskId:task.id})})}}]),angular.module("Bastion.products").controller("ProductDetailsController",["$scope","$state","Product",function($scope,$state,Product){$scope.successMessages=[],$scope.errorMessages=[],$scope.product?$scope.panel={loading:!1}:$scope.panel={loading:!0},$scope.product=Product.get({id:$scope.$stateParams.productId},function(){$scope.panel.loading=!1}),$scope.removeProduct=function(product){var id=product.id;product.$delete(function(data){$scope.removeRow(id),$scope.$emit("productDelete",data.id),$scope.transitionTo("products.index")})},$scope.getReadOnlyReason=function(product){var readOnlyReason=null;return product.$resolved&&($scope.denied("delete_products",product)?readOnlyReason="permissions":product.published_content_view_ids.length>0?readOnlyReason="published":product.redhat&&(readOnlyReason="redhat")),readOnlyReason}}]),angular.module("Bastion.products").controller("ProductRepositoriesController",["$scope","$state","Repository","RepositoryBulkAction","CurrentOrganization","Nutupane","translate",function($scope,$state,Repository,RepositoryBulkAction,CurrentOrganization,Nutupane,translate){function getParams(){return{ids:repositoriesNutupane.getAllSelectedResults("id").included.ids}}function success(response){$scope.successMessages=response.displayMessages.success,$scope.errorMessages=response.displayMessages.error}function error(response){$scope.successMessages=response.data.errors}var repositoriesNutupane=new Nutupane(Repository,{product_id:$scope.$stateParams.productId,library:!0,organization_id:CurrentOrganization,enabled:!0,full_result:!0});$scope.successMessages=[],$scope.errorMessages=[],$scope.checksums=[{name:translate("Default"),id:null},{id:"sha256",name:"sha256"},{id:"sha1",name:"sha1"}],$scope.repositoriesTable=repositoriesNutupane.table,repositoriesNutupane.query(),$scope.syncSelectedRepositories=function(){var params=getParams();RepositoryBulkAction.syncRepositories(params,function(task){$state.go("products.details.tasks.details",{taskId:task.id})})},$scope.removeSelectedRepositories=function(){var params=getParams(),removalPromise;$scope.removingRepositories=!0,removalPromise=RepositoryBulkAction.removeRepositories(params,success,error).$promise,removalPromise["finally"](function(){repositoriesNutupane.refresh(),$scope.removingRepositories=!1})},$scope.removeRepository=function(repository){repositoriesNutupane.removeRow(repository.id),repository.$delete(function(){$scope.transitionTo("products.details.repositories.index",{productId:$scope.$stateParams.productId})})},$scope.getRepositoriesNonDeletableReason=function(product){var readOnlyReason=null;return product.$resolved&&($scope.denied("delete_products",product)?readOnlyReason="permissions":product.redhat&&(readOnlyReason="redhat")),readOnlyReason},$scope.canRemoveRepositories=function(product){return $scope.getRepositoriesNonDeletableReason(product)===null}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/details/views/product-details.html",'<span page-title ng-model="product">{{ \'Details for Product:\' | translate }} {{ product.name }}</span>\n\n<div class="loading-mask loading-mask-panel" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="details-header">\n    <h2 class="fl" translate>Product {{ product.name }}</h2>\n\n    <div class="fr">\n\n      <div bst-modal="removeProduct(product)" model="product"\n           modal-header=\'Remove Product "{{product.name}}"?\'\n           modal-body=\'Are you sure you want to remove product "{{ product.name }}"?\'></div>\n\n      <span ng-switch="getReadOnlyReason(product)">\n        <i class="icon-question-sign" ng-switch-when="permissions"\n           tooltip="{{ \'You cannot remove this product because you do not have permission.\' | translate }}"\n           tooltip-animation="false"\n           tooltip-append-to-body="true">\n        </i>\n        <i class="icon-question-sign" ng-switch-when="published"\n           tooltip="{{ \'You cannot remove this product because it was published to a content view.\' | translate }}"\n           tooltip-animation="false"\n           tooltip-append-to-body="true">\n        </i>\n        <i class="icon-question-sign" ng-switch-when="redhat"\n           tooltip="{{ \'You cannot remove this product because it is a Red Hat product.\' | translate }}"\n           tooltip-animation="false"\n           tooltip-append-to-body="true">\n        </i>\n      </span>\n\n      <button class="btn btn-default"\n              ng-hide="denied(\'delete_products\', product) || product.readonly || product.published_content_view_ids.length > 0"\n              ng-click="openModal()">\n        <i class="icon-trash"></i>\n        {{ "Remove Product" | translate }}\n      </button>\n      <button class="btn btn-default" ui-sref="products.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <nav>\n    <ul class="nav nav-tabs">\n      <li ng-class="{active: stateIncludes(\'products.details.info\')}">\n        <a translate\n           ui-sref="products.details.info({productId: product.id})">\n          Details\n        </a>\n      </li>\n      <li ng-class="{active: stateIncludes(\'products.details.repositories\')}">\n        <a translate\n           ui-sref="products.details.repositories.index({productId: product.id})">\n          Repositories\n        </a>\n      </li>\n      <li ng-class="{active: stateIncludes(\'products.details.tasks\')}">\n        <a translate\n           ui-sref="products.details.tasks.index({productId: product.id})">\n          Tasks\n        </a>\n      </li>\n      <li ng-repeat="menuItem in menuExpander.getMenu(\'product\')">\n        <a href="{{ menuItem.url }}">\n          {{ menuItem.label }}\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <section class="nutupane-sub-section" ui-view></section>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/details/views/product-info.html",'<span page-title ng-model="product">{{ \'Product information for:\' | translate }} {{ product.name }}</span>\n<div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n<div class="details fl">\n  <section>\n    <h4 translate>Basic Information</h4>\n\n    <div class="detail">\n      <span class="info-label" translate>Name</span>\n      <span class="info-value"\n            bst-edit-text="product.name"\n            on-save="save(product)"\n            readonly="product.readonly || denied(\'edit_products\', product)">\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Label</span>\n      <span class="info-value">{{ product.label }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>GPG Key</span>\n      <span class="info-value"\n            bst-edit-select="product.gpg_key.name"\n            readonly="product.readonly || denied(\'edit_products\', product)"\n            selector="product.gpg_key_id"\n            options="gpgKeys()"\n            on-save="save(product)">\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Description</span>\n      <span class="info-value"\n            bst-edit-textarea="product.description"\n            on-save="save(product)"\n            readonly="product.readonly || denied(\'edit_products\', product)">\n       </span>\n    </div>\n\n  </section>\n</div>\n\n<div class="details fr">\n  <section>\n    <h4 translate>Sync Status</h4>\n\n    <div ng-include="\'products/details/partials/sync-status.html\'"></div>\n\n    <div class="detail">\n      <span class="info-label" translate>Sync Plan</span>\n      <span class="info-value"\n            bst-edit-select="product.sync_plan.name"\n            options="syncPlans()"\n            options-format="option.id as option.name for option in options.results"\n            selector="product.sync_plan_id"\n            on-save="save(product)"\n            deletable="product.sync_plan_id != null"\n            readonly="denied(\'edit_products\', product)"\n            on-delete="product.sync_plan_id = null; save(product)">\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Last Sync</span>\n      <span class="info-value" translate>\n        {{ product.last_sync_words }} Ago ({{ product.sync_status.finish_time | date:\'medium\' }} Local Time)\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Next Sync</span>\n      <span class="info-value" ng-show="product.sync_plan.next_sync" translate>\n        {{ product.sync_plan.next_sync | date:\'medium\' }} (Server Time)\n      </span>\n      <span class="info-value" ng-hide="product.sync_plan.next_sync" translate>\n        Synced manually, no interval set.\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Sync State</span>\n      <span class="info-value">\n        <a ng-href="/katello/sync_management">{{ product.sync_status.state }}</a>\n      </span>\n    </div>\n\n    <div class="detail">\n      <button class="btn btn-default"\n              ng-hide="denied(\'create_sync_plans\')"\n              ui-sref="products.details.info.new-sync-plan">\n        <i class="icon-plus"></i>\n        <span translate>New Sync Plan</span>\n      </button>\n\n      <button class="btn btn-default"\n              ng-click="syncProduct()"\n              ng-hide="denied(\'sync_products\', product)">\n        <i class="icon-refresh"></i>\n        <span translate>Sync Now</span>\n      </button>\n    </div>\n  </section>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/details/views/product-repositories.html",'<span page-title ng-model="product">{{ \'Repositories for Product:\' | translate }} {{ product.name }}</span>\n\n<section class="details details-full">\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n  <h4 translate>Repositories</h4>\n\n  <input type="text"\n         class="form-control filter-input"\n         placeholder="{{ \'Filter\' | translate }}"\n         ng-model="repositorySearch"/>\n\n  <span class="pull-right">\n\n      <div bst-modal="removeSelectedRepositories()" model="table"\n           modal-header=\'Remove {{ repositoriesTable.numSelected  }} Repositories?\'\n           modal-body=\'Are you sure you want to remove the {{ repositoriesTable.numSelected }} repositories selected?\'></div>\n\n      <span ng-switch="getRepositoriesNonDeletableReason(product)">\n        <i class="icon-question-sign" ng-switch-when="permissions"\n           tooltip="{{ \'You cannot remove these repositories because you do not have permission.\' | translate }}"\n           tooltip-animation="false"\n           tooltip-placement="left"\n           tooltip-append-to-body="true">\n        </i>\n        <i class="icon-question-sign" ng-switch-when="redhat"\n           tooltip="{{ \'You cannot remove these repositories because they belong to a Red Hat product.\' | translate }}"\n           tooltip-animation="false"\n           tooltip-placement="left"\n           tooltip-append-to-body="true">\n        </i>\n      </span>\n\n      <button class="btn btn-default"\n              ng-click="openModal()"\n              ng-show="canRemoveRepositories(product)"\n              ng-disabled="removingRepositories || repositoriesTable.numSelected == 0">\n        <span ng-show="removingRepositories">\n          <i class="icon-spinner inline-icon icon-spin"></i>\n          <span>{{ "Removing Repositories" | translate }}</span>\n        </span>\n        <span ng-hide="removingRepositories">\n          <i class="icon-trash"></i>\n          {{ "Remove Repositories" | translate }}\n        </span>\n\n      </button>\n\n    <button class="btn btn-default"\n            ng-click="syncSelectedRepositories()"\n            ng-hide="denied(\'sync_products\', product)"\n            ng-disabled="syncInProgress || repositoriesTable.numSelected == 0">\n      <i class="icon-spinner icon-spin" ng-show="syncInProgress"></i>\n      <span ng-show="syncInProgress" translate>Syncing...</span>\n      <i ng-hide="syncInProgress" class="icon-refresh"></i>\n      <span ng-hide="syncInProgress" translate>Sync Now</span>\n    </button>\n    <button class="btn btn-primary"\n            translate\n            ng-hide="denied(\'edit_products\', product)"\n            ng-disabled="product.readonly"\n            ui-sref="products.details.repositories.new({productId: product.id})">\n      Create Repository\n    </button>\n  </span>\n\n  <table bst-table="repositoriesTable"\n         class="table table-striped"\n         ng-class="{\'table-mask\': repositoriesTable.working}"\n         ng-show="repositoriesTable.rows.length > 0">\n    <thead>\n      <tr bst-table-head row-select>\n        <th bst-table-column="name" translate>Name</th>\n        <th bst-table-column="type" translate>Type</th>\n        <th bst-table-column="sync-status" translate>Sync Status</th>\n        <th bst-table-column="content" translate>Content</th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr bst-table-row\n          row-select="repository"\n          ng-repeat="repository in repositoriesTable.rows | filter:repositorySearch">\n        <td bst-table-cell>\n          <a ng-href="/products/{{ product.id }}/repositories/{{ repository.id }}">{{ repository.name }}</a>\n        </td>\n        <td bst-table-cell>{{ repository.content_type }}</td>\n        <td bst-table-cell>\n          <span ng-show="repository.url">\n            <span ng-show="repository.last_sync == null" translate>\n              Not Synced\n            </span>\n            <span ng-hide="repository.last_sync == null">\n              <a href="/foreman_tasks/tasks/{{repository.last_sync.id}}">{{ repository.last_sync.result | capitalize}}</a>\n              <span translate>{{ repository.last_sync_words }} ago</span>\n            </span>\n          </span>\n          <span ng-hide="repository.url" translate>N/A</span>\n        </td>\n        <td bst-table-cell>\n          <span ng-show="repository.content_type == \'puppet\'">\n            <a translate ng-href="/katello/content_search#/!=&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_puppet_modules">\n              {{ repository.content_counts.puppet_module || 0 }} Puppet Modules\n            </a>\n          </span>\n\n          <span ng-show="repository.content_type == \'yum\'">\n            <div>\n              <a translate ng-href="/katello/content_search#/!=&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_packages">\n                {{ repository.content_counts.rpm || 0 }} Packages\n              </a>\n            </div>\n\n            <div>\n              <a translate ng-href="/katello/content_search#/!=&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_errata">\n                {{ repository.content_counts.erratum || 0 }} Errata\n              </a>\n            </div>\n          </span>\n\n          <span ng-show="repository.content_type == \'docker\'">\n            <div>\n              <span translate>\n                {{ repository.content_counts.docker_image || 0 }} Docker Images\n              </span>\n            </div>\n           <div>\n              <span translate>\n                {{ repository.content_counts.docker_tag || 0 }} Docker Tags\n              </span>\n            </div>\n          </span>\n        </td>\n      </tr>\n    </tbody>\n  </table>\n</section>\n\n<p class="alert alert-info" ng-show="repositoriesTable.rows.length === 0" translate>\n  You currently don\'t have any Repositories included in this Product, you can add Repositories using the button on the right.\n</p>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/details/views/product-tasks.html",'<div tasks-table  details-state="products.details.tasks.details"\n              known-context="product,organization"\n              resource-type="Katello::Product"\n              resource-id="{{ product.id }}"/>\n')}]),angular.module("Bastion.products").controller("DiscoveryFormController",["$scope","$q","CurrentOrganization","Product","Repository","GPGKey","FormUtils",function($scope,$q,CurrentOrganization,Product,Repository,GPGKey,FormUtils){function productCreateSuccess(response){$scope.createRepoChoices.existingProductId=response.id,$scope.createRepoChoices.newProduct="false",$scope.products.unshift(response),$scope.productTable.addRow(response),createNextRepo()}function productCreateError(response){$scope.working=!1,$scope.createRepoChoices.creating=!1,angular.forEach(response.data.errors,function(errors,field){$scope.productForm[field].$setValidity("server",!1),$scope.productForm[field].$error.messages=errors})}function createNextRepo(){var toCreate,repoObject;toCreate=getNextRepoToCreate(),toCreate?($scope.currentlyCreating=toCreate,repoObject=convertToResource(toCreate),toCreate.creating=!0,toCreate.form.$invalid=!1,repoObject.$save(function(){toCreate.creating=!1,toCreate.created=!0,createNextRepo()},repoCreateError)):$scope.transitionTo("products.details.repositories.index",{productId:$scope.createRepoChoices.existingProductId})}function getNextRepoToCreate(){var found;return angular.forEach($scope.discovery.selected,function(repo){repo.created!==!0&&found===undefined&&(found=repo)}),found}function convertToResource(repo){return new Repository({name:repo.name,label:repo.label,content_type:"yum",url:repo.url,product_id:$scope.createRepoChoices.existingProductId,unprotected:$scope.createRepoChoices.unprotected})}function repoCreateError(response){var currentlyCreating=$scope.currentlyCreating;$scope.currentlyCreating=undefined,$scope.createRepoChoices.creating=!1,currentlyCreating.form.$invalid=!0,currentlyCreating.form.messages=response.data.errors}function filterEditable(items){return _.where(items,{readonly:!1})}$scope.discovery=$scope.discovery||{selected:[]},$scope.panel={loading:!0},$scope.$watch("createRepoChoices.product.name",function(){FormUtils.labelize($scope.createRepoChoices.product)}),$scope.createRepoChoices={existingProductId:undefined,newProduct:"false",product:new Product,unprotected:!0,creating:!1},$scope.createRepoChoices.product.organization_id=CurrentOrganization,angular.forEach($scope.discovery.selected,function(repo){repo.form={messages:"",$invalid:!1},FormUtils.labelize(repo)}),Product.queryUnpaged({organization_id:CurrentOrganization,custom:!0},function(values){$scope.products=filterEditable(values.results),$scope.products.length>0?$scope.createRepoChoices.existingProductId=$scope.products[0].id:$scope.createRepoChoices.newProduct="true",$scope.panel.loading=!1}),$scope.creating=function(){return $scope.createRepoChoices.creating},$scope.requiredFieldsEnabled=function(){var fieldsEnabled=!0;return $scope.createRepoChoices.newProduct==="true"?fieldsEnabled=$scope.productForm.$valid:$scope.createRepoChoices.existingProductId===undefined&&(fieldsEnabled=!1),fieldsEnabled?$scope.productForm.$valid:fieldsEnabled},$scope.gpgKeys=GPGKey.queryUnpaged(),$scope.$watch("discovery.selected",function(newList,oldList){newList&&angular.forEach(newList,function(newItem,position){(oldList===undefined||newItem.name!==oldList[position].name)&&FormUtils.labelize(newItem)})},function(newList,oldList){var isEqual=!0;return angular.forEach(newList,function(newItem,position){newList[position].name!==oldList[position].name&&(isEqual=!1)}),isEqual}),$scope.createRepos=function(){$scope.createRepoChoices.creating=!0,$scope.createRepoChoices.newProduct==="true"?Product.save($scope.createRepoChoices.product,productCreateSuccess,productCreateError):createNextRepo()}}]),angular.module("Bastion.products").controller("DiscoveryController",["$scope","$q","$timeout","$http","Task","Organization","CurrentOrganization",function($scope,$q,$timeout,$http,Task,Organization,CurrentOrganization){var transformRows,setDiscoveryDetails;$scope.discovery={url:""},$scope.panel={loading:!1},$scope.discoveryTable||($scope.discoveryTable={rows:[]}),setDiscoveryDetails=function(task){$scope.discovery.pending=task.pending,task.pending||($scope.discovery.working=!1),$scope.discovery.url=task.input,$scope.discoveryTable.rows=transformRows(task.output)},$scope.setupSelected=function(){$scope.panel.loading=!0,$scope.discovery.selected=$scope.discoveryTable.getSelected(),$scope.transitionTo("products.discovery.create")},$scope.defaultName=function(basePath){return basePath.replace(/^\//,"").replace(/\/$/,"").replace(/\//g," ")},$scope.cancelDiscovery=function(){$scope.discovery.working=!0,Organization.cancelRepoDiscover({id:CurrentOrganization})},transformRows=function(urls){var baseUrl,toRet;return baseUrl=$scope.discovery.url,toRet=_.map(urls,function(url){var path=url.replace(baseUrl,"");return{url:url,path:path,name:$scope.defaultName(path),label:""}}),_.sortBy(toRet,function(item){return item.url})},$scope.updateTask=function(task){setDiscoveryDetails(task),task.pending||Task.unregisterSearch($scope.taskSearchId)},$scope.discover=function(){$scope.discovery.pending=!0,$scope.discoveryTable.rows=[],$scope.discoveryTable.selectAll(!1),Organization.repoDiscover({id:CurrentOrganization,url:$scope.discovery.url},function(task){$scope.taskSearchId=Task.registerSearch({type:"task",task_id:task.id},$scope.updateTask)})}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/discovery/views/discovery-base.html",'<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="new-header details-header">\n    <h2 class="fl" translate>Yum Repo Discovery</h2>\n\n    <div class="fr">\n      <button class="btn btn-default" ui-sref="products.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <div ui-view></div>\n\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/discovery/views/discovery-create.html",'<span page-title>{{ \'Create Repositories\' | translate }}</span>\n\n<div class="loading-mask loading-mask-panel" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  <span translate>Loading...</span>\n</div>\n\n<a ui-sref="products.discovery.scan">\n  <i class="icon-double-angle-left"></i>\n  {{ "Back To Repository Selection" | translate }}\n</a>\n\n<form name="productForm" class="form-horizontal" ng-disabled="creating()" novalidate role="form"> \n\n  <section>\n    <h4 translate>Create Repositories Within:</h4>\n\n    <div class="form-group">\n      <label class="checkbox-inline">\n        <input type="radio"\n               name="newProduct"\n               value="false"\n               ng-model="createRepoChoices.newProduct"\n               ng-disabled="creating()"/>\n        <span translate>Existing Product</span> \n      </label>\n\n      <label class="checkbox-inline"> \n        <input type="radio"\n               name="newProduct"\n               value="true"\n               ng-model="createRepoChoices.newProduct"\n               ng-disabled="creating()"/>\n        <span translate>New Product</span>\n      </label>\n    </div>\n\n    <div class="form-group">\n      <div class="col-md-5" ng-hide="createRepoChoices.newProduct">\n        <select class="form-control" ng-disabled="creating()"\n                ng-model="createRepoChoices.existingProductId"\n                ng-options="product.id as product.name for product in products">\n        </select>\n      </div>\n    </div>  \n    \n    <div ng-show="createRepoChoices.newProduct">\n      \n      <div bst-alert error-messages="productErrorMessages"></div>\n  \n      <div class="form-group required">\n        <label class="control-label col-sm-1 text-left" translate>Name</label>\n        <div class="col-sm-5 input">\n          <input ng-model="createRepoChoices.product.name"\n                 id="name"\n                 name="name"\n                 type="text"\n                 class="form-control"\n                 tabindex=1\n                 ng-required="createRepoChoices.newProduct === \'true\'"/>\n        </div>\n      </div>\n  \n      <div class="form-group required">\n        <label class="control-label col-sm-1" translate>Label</label>\n        <div class="col-sm-5 input">\n          <input ng-model="createRepoChoices.product.label"\n                 id="label"\n                 name="label"\n                 type="text"\n                 class="form-control"\n                 tabindex=2\n                 ng-required="createRepoChoices.newProduct === \'true\'"/>\n        </div>\n      </div>\n  \n      <div class="form-group">\n        <label class="control-label col-sm-1" translate>GPG Key</label>\n        <div class="col-sm-5 input">\n          <select class="form-control" ng-model="createRepoChoices.product.gpg_key_id"\n                  ng-options="gpg_key.id as gpg_key.name for gpg_key in gpgKeys">\n          </select>\n        </div>\n      </div>\n\n     </div> \n  </section>\n  \n  <section>\n    <h4 translate>Options:</h4>\n    <div class="checkbox">\n      <label>\n        <input type="checkbox" \n               id="unprotected" \n               ng-model="createRepoChoices.unprotected" \n               ng-disabled="creating()"/>\n        <span translate>Serve via HTTP.</span>\n      </label>\n    </div>\n  </section>\n\n  <section>\n    <h4 ng-show="discovery.selected.length > 0" translate>Selected URLs:</h4>\n  \n    <div ng-repeat="repo in discovery.selected">\n      \n      <div class="col-sm-offset-0 bottom-padding">\n        <i class="icon-circle"></i>\n        <span>{{  repo.url }}</span> \n        <i class="icon-check" ng-show="repo.created"></i>\n      </div>\n  \n      <div class="form-group required">\n        <label class="control-label col-sm-1" translate>Name</label>\n        <div class="col-sm-4 input">\n          <input ng-model="repo.name"\n                 ng-disabled="creating() || repo.created"\n                 name="repo_name"    \n                 type="text"\n                 class="form-control"\n                 required/>\n        </div>\n      </div>\n  \n      <div class="form-group required">\n        <label class="control-label col-sm-1" translate>Label</label>\n        <div class="col-sm-4 input">\n          <input ng-model="repo.label"\n                 ng-disabled="creating() || repo.created"\n                 name="repo_label"\n                 type="text"                 \n                 class="form-control"\n                 required/>\n        </div>\n      </div>\n    </div>\n\n    <div class="form"> \n      <div class="control-group buttons">\n        <div class="input">\n          <button ng-click="createRepos()"\n                  ng-disabled="creating() || !requiredFieldsEnabled()"\n                  translate\n                  class="btn btn-primary btn-large">\n            <i class="icon-spinner icon-spin" ng-show="creating()"></i>\n            Create\n          </button>\n        </div>\n      </div>  \n    </div>\n  </section>\n</form>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/discovery/views/discovery.html",'<span page-title>{{ \'Repository Discovery\' | translate }}</span>\n\n<div class="row">\n  <form ng-submit="discover()" role="form" class="col-sm-6">\n    <div class="input-group">\n\n      <input type="url"\n             class="form-control input-lg"\n             placeholder="{{ \'URL to discover\' | translate }}"\n             ng-model="discovery.url"\n             ng-disabled="discovery.pending"/>\n\n      <span class="input-group-btn input-group-lg">\n        <button ng-show="!discovery.pending && permitted(\'edit_products\')"\n               ng-disabled="!discovery.url"\n               translate\n               type="submit"\n               class="btn btn-primary btn-lg">\n          Discover\n        </button>\n\n        <button type="button"\n                ng-disabled="discovery.working"\n                ng-show="discovery.pending && permitted(\'edit_products\')"\n                ng-click="cancelDiscovery()"\n                class="btn btn-primary btn-lg">\n          <i class="icon-spinner icon-spin" ng-show="discovery.pending"></i>\n          {{ \'Cancel\' | translate }}\n        </button>\n      </span>\n\n    </div>\n  </form>\n</div>\n\n<section class="nutupane-sub-section row">\n  <div class="row">\n    \n    <h3 class="col-sm-12" translate>Results</h3>\n\n    <div class="col-sm-4">\n      <input type="text"\n             class="form-control"\n             placeholder="{{ \'Filter\' | translate }}"\n             ng-model="discoveryTable.filterTerm"/>\n    </div>\n\n    <div class="fr">\n      <div class="fl nutupane-info">\n        <span translate>{{ discoveryTable.numSelected }} Selected</span>\n      </div>   \n\n      <div ng-hide="system.readonly" class="nutupane-actions fr">\n        <button class="btn btn-primary"\n                translate\n                ng-hide="denied(\'create_products\')"\n                ng-disabled="discoveryTable.getSelected().length == 0"\n                ng-click="setupSelected()">\n            Create Selected\n        </button>\n      </div>      \n    </div>\n\n  </div>\n\n  <div class="col-sm-12">\n    <table bst-table="discoveryTable" class="table table-striped">\n      <thead>\n        <tr bst-table-head row-select>\n          <th bst-table-column translate>Discovered URLs</th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row\n            row-select="urlRow"\n            ng-repeat="urlRow in discoveryTable.rows | filter:discoveryTable.filterTerm">\n          <td bst-table-cell>{{ urlRow.path }}</td>\n        </tr>\n      </tbody>\n    </table>\n  </div>\n\n</section>\n'
)}]),angular.module("Bastion.products").controller("NewProductController",["$scope","Product","CurrentOrganization",function($scope,Product,CurrentOrganization){$scope.product=new Product({organization_id:CurrentOrganization}),$scope.panel={loading:!0}}]),angular.module("Bastion.products").controller("ProductFormController",["$scope","$q","Product","GPGKey","SyncPlan","FormUtils",function($scope,$q,Product,GPGKey,SyncPlan,FormUtils){function fetchGpgKeys(){return GPGKey.queryUnpaged(function(gpgKeys){$scope.gpgKeys=gpgKeys.results})}function fetchSyncPlans(){return SyncPlan.queryUnpaged(function(syncPlans){$scope.syncPlans=syncPlans.results})}function success(response){$scope.productTable.addRow(response),$scope.transitionTo("products.details.repositories.index",{productId:$scope.product.id})}function error(response){$scope.working=!1,angular.forEach(response.data.errors,function(errors,field){$scope.productForm[field].$setValidity("server",!1),$scope.productForm[field].$error.messages=errors})}$scope.product=$scope.product||new Product,$scope.$watch("product.name",function(){$scope.productForm.name&&($scope.productForm.name.$setValidity("server",!0),FormUtils.labelize($scope.product))}),$scope.save=function(product){product.$save(success,error)},$q.all([fetchSyncPlans().$promise,fetchGpgKeys().$promise]).finally(function(){$scope.panel.loading=!1})}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/new/views/product-new-form.html",'<form name="productForm" class="form-horizontal" novalidate role="form">\n\n  <div bst-form-group label="{{ \'Name\' | translate }}">\n    <input id="name"\n           name="name"\n           ng-model="product.name"\n           type="text"\n           tabindex="1"\n           autofocus\n           required/>\n  </div>\n\n  <div bst-form-group label="{{ \'Label\' | translate }}">\n    <input id="label"\n           name="label"\n           ng-model="product.label"\n           type="text"\n           tabindex="2"\n           required/>\n  </div>\n\n  <div bst-form-group label="{{ \'GPG Key\' | translate }}">\n    <select id="gpg_key_id"\n            name="gpg_key_id"\n            ng-model="product.gpg_key_id"\n            ng-options="gpg_key.id as gpg_key.name for gpg_key in gpgKeys"\n            tabindex="4">\n      <option value=""></option>\n    </select>\n  </div>\n\n  <div bst-form-group label="{{ \'Sync Plan\' | translate }}">\n    <select id="sync_plan_id"\n            name="sync_plan_id"\n            ng-model="product.sync_plan_id"\n            ng-options="syncPlan.id as syncPlan.name for syncPlan in syncPlans"\n            tabindex="5">\n      <option value=""></option>\n    </select>\n    <a ui-sref="products.new.sync-plan" translate>+ New Sync Plan</a>\n  </div>\n\n  <div bst-form-group label="{{ \'Description\' | translate }}">\n    <textarea id="description"\n              name="description"\n              ng-model="product.description">\n    </textarea>\n  </div>\n\n  <div bst-form-buttons\n       on-cancel="transitionTo(\'products.index\')"\n       on-save="save(product)"\n       working="working">\n  </div>\n\n</form>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/new/views/product-new.html",'<span page-title>{{ \'New Product\' | translate }}</span>\n\n<div class="loading-mask loading-mask-panel" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n  <header class="new-header details-header">\n    <h2 class="fl" translate>New Product</h2>\n\n    <div class="fr">\n      <button class="btn btn-default" ui-sref="products.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <div ui-view></div>\n\n</section>\n')}]),angular.module("Bastion.products").factory("Product",["BastionResource",function(BastionResource){return BastionResource("/katello/api/products/:id/:action",{id:"@id"},{update:{method:"PUT"},sync:{method:"POST",params:{action:"sync"}},updateSyncPlan:{method:"POST",params:{action:"sync_plan"}}})}]),angular.module("Bastion.products").factory("ProductBulkAction",["BastionResource",function(BastionResource){return BastionResource("/katello/api/products/bulk/:action",{},{removeProducts:{method:"PUT",params:{action:"destroy"}},syncProducts:{method:"PUT",params:{action:"sync"}},updateProductSyncPlan:{method:"PUT",params:{action:"sync_plan"}}})}]),angular.module("Bastion.products").controller("ProductsController",["$scope","$location","Nutupane","Product","CurrentOrganization",function($scope,$location,Nutupane,Product,CurrentOrganization){var watch,params={organization_id:CurrentOrganization,search:$location.search().search||"",sort_by:"name",sort_order:"ASC",enabled:!0,paged:!0};$scope.productsNutupane=new Nutupane(Product,params),$scope.productTable=$scope.productsNutupane.table,$scope.removeRow=$scope.productsNutupane.removeRow,$scope.productTable.closeItem=function(){$scope.transitionTo("products.index")},$scope.$on("productDelete",function(event,taskId){$scope.productDeletionTaskId=taskId}),$scope.unsetProductDeletionTaskId=function(){$scope.productDeletionTaskId=undefined},$scope.productTable.refresh=$scope.productsNutupane.refresh,$scope.table=$scope.productTable,watch=$scope.$watch("productTable.rows",function(rows){_.isArray(rows)&&!_.isEmpty(rows)&&(angular.forEach(rows,function(row){row.repositoriesByState=_.groupBy(row.repositories,function(repository){if(repository.last_sync!==null)return repository.last_sync.result})}),watch())})}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/views/partials/product-table-sync-status.html",'<ul class="list-unstyled" ng-show="product.sync_status.finish_time">\n  <p translate>\n    Last synced {{ product.last_sync_words }} ago\n  </p>\n  <li ng-repeat="(key, value) in product.repositoriesByState">\n    <a ng-href="/katello/sync_management">{{ key | capitalize }}</a>:\n            <span translate\n                  translate-n="value.length"\n                  translate-plural="{{ value.length }} repositories">\n              {{ value.length }} repository\n            </span>\n  </li>\n</ul>\n<span ng-hide="product.sync_status.finish_time" translate>Never synced</span>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/views/products-table-collapsed.html",'<table class="table table-striped" ng-class="{\'table-mask\': productTable.working}">\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column sortable><span translate>Name</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row\n        ng-repeat="product in productTable.rows"\n        row-select="product"\n        active-row="stateIncludes(\'products.details\', {productId: product.id})">\n      <td bst-table-cell>\n        <a ui-sref="products.details.repositories.index({productId: product.id})">\n          {{ product.name }}\n        </a>\n      </td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/views/products-table-full.html",'<p class="alert alert-info" ng-show="productTable.rows.length === 0" translate>\n  You currently don\'t have any Products, you can add Products using the button on the right.\n</p>\n\n<table class="table table-striped" ng-class="{\'table-mask\': productTable.working}" ng-show="productTable.rows.length > 0">\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column="name" sortable><span translate>Name</span></th>\n      <th bst-table-column="description"><span translate>Description</span></th>\n      <th bst-table-column="sync_status"><span translate>Sync Status</span></th>\n      <th bst-table-column="sync_plan"><span translate>Sync Plan</span></th>\n      <th bst-table-column class="number-cell"><span translate>Repositories</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row ng-repeat="product in productTable.rows" row-select="product">\n      <td bst-table-cell>\n        <a ui-sref="products.details.repositories.index({productId: product.id})">\n          {{ product.name }}\n        </a>\n        <i class="icon-chevron-right selected-icon" ng-show="product.selected"></i>\n      </td>\n      <td bst-table-cell>{{ product.description }}</td>\n      <td bst-table-cell>\n        <div ng-include="\'products/views/partials/product-table-sync-status.html\'"></div>\n      </td>\n      <td bst-table-cell>\n        {{ product.sync_plan.name }}\n        <span ng-hide="product.sync_plan" translate>None</span>\n        <span ng-show="product.sync_plan">\n          ({{ product.sync_plan.interval }})\n        </span>\n      </td>\n      <td bst-table-cell class="number-cell">{{ product.repository_count }}</td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/products/views/products.html",'<span page-title>{{ \'Products\' | translate }}</span>\n\n<div data-extend-template="layouts/nutupane.html">\n\n  <div data-block="header">\n    {{ \'Products\' | translate }}\n  </div>\n\n  <div data-block="messages">\n    <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n    <div class="alert alert-success" ng-hide="productDeletionTaskId === undefined">\n      <button type="button" class="close" ng-click="unsetProductDeletionTaskId()">×</button>\n      <p translate>\n        Product delete operation has been initiated in the background.  Click <a href="{{ taskUrl(productDeletionTaskId) }}">Here</a> to monitor the progress.\n      </p>\n    </div>\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-default"\n            ng-show="permitted(\'edit_products\') || permitted(\'destroy_products\')"\n            ui-sref="products.bulk-actions.sync">\n      <i class="icon-group leading-icon"></i>\n      {{ "Bulk Actions" | translate }}\n    </button>\n\n    <button class="btn btn-default"\n            ng-hide="denied(\'edit_products\')"\n            ui-sref="products.discovery.scan">\n      <i class="icon-screenshot"></i>\n      {{ "Repo Discovery" | translate }}\n    </button>\n\n    <button class="btn btn-primary" ui-sref="products.new.form" ng-hide="denied(\'create_products\')">\n      <i class="icon-plus"></i>\n      {{ "New Product" | translate }}\n    </button>\n  </div>\n\n</div>\n')}]),angular.module("Bastion.repositories",["ngResource","ui.router","ngUpload","Bastion","Bastion.utils","Bastion.components","Bastion.components.formatters","Bastion.packages","Bastion.docker-images"]),angular.module("Bastion.repositories").run(["$rootScope","$state","$stateParams",function($rootScope,$state,$stateParams){$rootScope.$state=$state,$rootScope.$stateParams=$stateParams}]),angular.module("Bastion.repositories").controller("RepositoryDetailsInfoController",["$scope","$state","$q","translate","Repository","GPGKey",function($scope,$state,$q,translate,Repository,GPGKey){var updateRepositoriesTable;$scope.successMessages=[],$scope.errorMessages=[],$scope.uploadSuccessMessages=[],$scope.uploadErrorMessages=[],$scope.progress={uploading:!1},$scope.repository=Repository.get({product_id:$scope.$stateParams.productId,id:$scope.$stateParams.repositoryId}),$scope.repository.$promise.then(function(){$scope.uploadURL="/katello/api/v2/repositories/"+$scope.repository.id+"/upload_content"}),$scope.gpgKeys=function(){var deferred=$q.defer();return GPGKey.queryUnpaged(function(gpgKeys){var results=gpgKeys.results;results.unshift({id:null}),deferred.resolve(results)}),deferred.promise},$scope.save=function(repository){var deferred=$q.defer();return repository.$update(function(response){deferred.resolve(response),$scope.successMessages=[translate("Repository Saved.")],updateRepositoriesTable()},function(response){deferred.reject(response),_.each(response.data.errors,function(errorMessage){$scope.errorMessages.push(translate("An error occurred saving the Repository: ")+errorMessage)})}),deferred.promise},$scope.uploadContent=function(content){var returnData,error;if(content){try{returnData=JSON.parse(angular.element(content).html())}catch(err){returnData=content}returnData||(returnData=content),returnData!==null&&returnData.status==="success"?($scope.uploadSuccessMessages=[translate("Content successfully uploaded")],$scope.repository.$get(),updateRepositoriesTable()):(typeof returnData=="string"&&returnData.indexOf("Request Entity Too Large")?error=translate("File too large. Please use the CLI instead."):error=returnData.displayMessage,$scope.uploadErrorMessages=[translate("Error during upload: ")+error]),$scope.progress.uploading=!1}},$scope.syncInProgress=function(task){var inProgress=!1;return task&&(task.state==="pending"||task.state==="running")&&(inProgress=!0),inProgress},$scope.syncRepository=function(repository){Repository.sync({id:repository.id},function(task){$state.go("products.details.tasks.details",{taskId:task.id})}),updateRepositoriesTable()},$scope.getRepoNonDeletableReason=function(repo,product){var readOnlyReason=null;return repo.$resolved&&product.$resolved&&($scope.denied("delete_products",product)?readOnlyReason="permissions":repo.promoted?readOnlyReason="published":repo.product_type==="redhat"&&(readOnlyReason="redhat")),readOnlyReason},$scope.canRemove=function(repo,product){return $scope.getRepoNonDeletableReason(repo,product)===null},$scope.checksumTypeDisplay=function(checksum){return checksum===null&&(checksum=translate("Default")),checksum},updateRepositoriesTable=function(){$scope.repositoriesTable.replaceRow($scope.repository)}}]),angular.module("Bastion.repositories").controller("RepositoryManageContentController",["$scope","$state","translate","Nutupane","Repository","Package","PuppetModule","DockerImage",function($scope,$state,translate,Nutupane,Repository,Package,PuppetModule,DockerImage){function success(response,selected){var message;$scope.contentNutupane.refresh(),$scope.detailsTable.working=!0,selected.length===1?message=translate("Successfully removed 1 item."):message=translate("Successfully removed %s items.").replace("%s",selected.length),$scope.successMessages=[message],$scope.generationTaskId=response.output.task_id}function error(data){$scope.detailsTable.working=!0,$scope.errorMessages=[data.response.displayMessage]}var currentState,contentTypes;$scope.repository=Repository.get({id:$scope.$stateParams.repositoryId}),currentState=$state.current.name.split(".").pop(),contentTypes={packages:{type:Package},"puppet-modules":{type:PuppetModule},"docker-images":{type:DockerImage}},$scope.contentNutupane=new Nutupane(contentTypes[currentState].type,{repository_id:$scope.$stateParams.repositoryId}),$scope.detailsTable=$scope.contentNutupane.table,$scope.detailsTable.closeItem=function(){},$scope.removeContent=function(){var selected=$scope.detailsTable.getSelected();$scope.detailsTable.working=!0,Repository.removeContent({id:$scope.repository.id,uuids:_.pluck(selected,"id")},function(response){success(response,selected)},error)},$scope.taskUrl=function(){return $scope.$state.href("products.details.tasks.details",{productId:$scope.product.id,taskId:$scope.generationTaskId})},$scope.clearTaskId=function(){$scope.generationTaskId=undefined}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/repositories/details/views/repository-info.html",'<span page-title ng-model="repository">{{ \'Repository:\' | translate }} {{ repository.name }}</span>\n<div>\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <a ui-sref="products.details.repositories.index({productId: product.id})">\n    <i class="icon-double-angle-left"></i>\n    {{ "Back to Repository List" | translate }}\n  </a>\n\n  <div class="fr">\n\n    <button class="btn btn-default"\n            ui-sref="products.details.repositories.manage-content.packages({productId: product.id, repositoryId: repository.id})"\n            ng-hide="repository.content_type !== \'yum\' || product.readonly">\n      <span translate>Manage Packages</span>\n    </button>\n\n    <button class="btn btn-default"\n            ui-sref="products.details.repositories.manage-content.puppet-modules({productId: product.id, repositoryId: repository.id})"\n            ng-hide="repository.content_type !== \'puppet\' || product.readonly">\n      <span translate>Manage Puppet Modules</span>\n    </button>\n\n    <button class="btn btn-default"\n            ui-sref="products.details.repositories.manage-content.docker-images({productId: product.id, repositoryId: repository.id})"\n            ng-hide="repository.content_type !== \'docker\' || product.readonly">\n      <span translate>Manage Docker Images</span>\n    </button>\n\n    <button class="btn btn-default"\n            ng-click="syncRepository(repository); working = true"\n            ng-hide="!repository.url || denied(\'sync_products\', product)"\n            ng-disabled="syncInProgress(repository.last_sync)">\n      <i class="icon-refresh"></i>\n      <span translate>Sync Now</span>\n    </button>\n\n    <div bst-modal="removeRepository(repository)" model="repository"\n         modal-header=\'Remove Repository "{{repository.name}}"?\'\n         modal-body=\'Are you sure you want to remove repository "{{ repository.name }}"?\'></div>\n\n      <span ng-switch="getRepoNonDeletableReason(repository, product)">\n        <i class="icon-question-sign" ng-switch-when="permissions"\n           tooltip="{{ \'You cannot remove this repository because you do not have permission.\' | translate }}"\n           tooltip-animation="false"\n           tooltip-placement="left"\n           tooltip-append-to-body="true">\n        </i>\n        <i class="icon-question-sign" ng-switch-when="published"\n           tooltip="{{ \'You cannot remove this repository because it was published to a content view.\' | translate }}"\n           tooltip-animation="false"\n           tooltip-placement="left"\n           tooltip-append-to-body="true">\n        </i>\n        <i class="icon-question-sign" ng-switch-when="redhat"\n           tooltip="{{ \'You cannot remove this repository because it is a Red Hat repository.\' | translate }}"\n           tooltip-animation="false"\n           tooltip-placement="left"\n           tooltip-append-to-body="true">\n        </i>\n      </span>\n\n      <button class="btn btn-default"\n              ng-click="openModal()"\n              ng-show="canRemove(repository, product)">\n        {{ "Remove Repository" | translate }}\n      </button>\n  </div>\n\n</div>\n\n<div class="details fl">\n  <section>\n\n    <h4 translate>Basic Information</h4>\n\n    <div class="detail">\n      <span class="info-label" translate>Name</span>\n      <span class="info-value"\n            bst-edit-text="repository.name"\n            on-save="save(repository)"\n            readonly="product.readonly || denied(\'edit_products\', product)">\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Label</span>\n      <span class="info-value">{{ repository.label }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Type</span>\n      <span class="info-value">{{ repository.content_type }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>URL</span>\n      <span class="info-value"\n            bst-edit-text="repository.url"\n            on-save="save(repository)"\n            readonly="product.readonly || denied(\'edit_products\', product)">\n      </span>\n    </div>\n\n    <div class="detail" ng-show="repository.content_type == \'yum\'">\n      <span class="info-label" translate>Yum Metadata Checksum</span>\n      <span class="info-value"\n            bst-edit-select="checksumTypeDisplay(repository.checksum_type)"\n            readonly="product.readonly || denied(\'edit_products\', product)"\n            selector="repository.checksum_type"\n            options="checksums"\n            on-save="save(repository)">\n      </span>\n    </div>\n\n    <div class="detail" ng-show="repository.content_type == \'yum\'">\n      <span class="info-label" translate>Publish via HTTPS</span>\n      <span class="info-value" translate> true </span>\n    </div>\n\n    <div class="detail" ng-show="repository.content_type == \'yum\'">\n      <span class="info-label" translate>Publish via HTTP</span>\n      <span class="info-value"\n            bst-edit-checkbox="repository.unprotected"\n            formatter="booleanToYesNo"\n            on-save="save(repository)"\n            readonly="product.readonly || denied(\'edit_products\', product)">\n      </span>\n\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Published At</span>\n      <span class="info-value">\n        <a ng-href="{{ repository.full_path }}">{{ repository.full_path }}</a>\n      </span>\n    </div>\n\n    <div class="detail" ng-show="repository.content_type == \'yum\'">\n      <span class="info-label" translate>GPG Key</span>\n      <span class="info-value"\n            bst-edit-select="repository.gpg_key.name"\n            readonly="product.readonly || denied(\'edit_products\', product)"\n            selector="repository.gpg_key_id"\n            options="gpgKeys()"\n            on-save="save(repository)">\n      </span>\n    </div>\n\n    <div class="divider"></div>\n  </section>\n\n  <section>\n    <h4 translate>Sync Status</h4>\n\n    <div ng-include="\'products/details/partials/sync-status.html\'"></div>\n\n    <div class="detail">\n      <span class="info-label" translate>Last Sync</span>\n      <span class="info-value" translate>\n        {{ repository.last_sync_words }} Ago ({{ repository.last_sync.ended_at | date:\'medium\' }} Local Time)\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Next Sync</span>\n      <span class="info-value" ng-show="repository.product.sync_plan.next_sync" translate>\n        {{ repository.product.sync_plan.next_sync | date:\'medium\' }} (Server Time)\n      </span>\n      <span class="info-value" ng-hide="repository.product.sync_plan.next_sync" translate>\n        Synced manually, no interval set.\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Sync State</span>\n      <span class="info-value">\n        <a href="/foreman_tasks/tasks/{{repository.last_sync.id}}">{{ repository.last_sync.result }}</a>\n      </span>\n    </div>\n  </section>\n\n</div>\n\n<div class="details fl">\n\n  <section>\n    <h4 translate>Content Counts</h4>\n\n    <table class="table table-striped">\n      <thead>\n        <tr>\n          <th colspan="2" translate>Content Type</th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr ng-show="repository.content_type == \'yum\'">\n          <td translate>Packages</td>\n          <td class="align-center">\n            <a ng-href="/katello/content_search#/!=&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_packages">\n              {{ repository.content_counts.rpm || 0 }}\n            </a>\n          </td>\n        </tr>\n        <tr ng-show="repository.content_type == \'yum\'">\n          <td translate>Errata</td>\n          <td class="align-center">\n            <a ng-href="/katello/content_search#/!=&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_errata">\n            {{ repository.content_counts.erratum || 0 }}\n            </a>\n          </td>\n        </tr>\n        <tr ng-show="repository.content_type == \'yum\'">\n          <td translate>Package Groups</td>\n          <td class="align-center">{{ repository.content_counts.package_group || 0 }}</td>\n        </tr>\n        <tr ng-show="repository.content_type == \'puppet\'">\n          <td translate>Puppet Modules</td>\n          <td class="align-center">\n            <a ng-href="/katello/content_search#/!=&search[subgrid][repo_id]={{ repository.id }}&search[subgrid][type]=repo_puppet_modules">\n            {{ repository.content_counts.puppet_module || 0 }}\n            </a>\n          </td>\n        </tr>\n        <tr ng-show="repository.content_type == \'docker\'">\n          <td translate>Docker Images</td>\n          <td class="align-center">{{ repository.content_counts.docker_image || 0 }}</td>\n        </tr>\n        <tr ng-show="repository.content_type == \'docker\'">\n          <td translate>Docker Tags</td>\n          <td class="align-center">{{ repository.content_counts.docker_tag || 0 }}</td>\n        </tr>\n      </tbody>\n    </table>\n  </section>\n\n  <section class="well" ng-show="permitted(\'edit_products\', product)">\n    <h5 translate ng-show="repository.content_type == \'puppet\'">Upload Puppet Module</h5>\n    <h5 translate ng-show="repository.content_type == \'yum\'">Upload Package</h5>\n    <h5 translate ng-show="repository.content_type == \'docker\'">Upload Docker Image</h5>\n\n    <div bst-alert success-messages="uploadSuccessMessages" error-messages="uploadErrorMessages"></div>\n\n    <form role="form"\n          action="{{ uploadURL }}"\n          ng-upload="uploadContent(content)"\n          upload-options-enable-controls\n          upload-options-enable-rails-csrf>\n\n      <div class="control-group">\n        <div class="input">\n          <input type="file" name="content[]" ng-hide="denied(\'edit_products\', product)" multiple/>\n        </div>\n      </div>\n\n      <div class="control-group">\n        <div class="control-button">\n          <button class="primary"\n		        ng-hide="denied(\'edit_products\', product)"\n	          upload-submit ng-click="progress.uploading = true">\n            <i class="icon-spinner icon-spin" ng-show="progress.uploading"></i>\n            <span ng-show="progress.uploading" translate>Uploading...</span>\n            <span ng-hide="progress.uploading" translate>Upload</span>\n          </button>\n        </div>\n      </div>\n\n    </form>\n  </section>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/repositories/details/views/repository-manage-docker-images.html",'<span page-title ng-model="repository">{{ \'Manage Docker Images for Repository:\' | translate }} {{ repository.name }}</span>\n\n<a ui-sref="products.details.repositories.info({productId: product.id, repositoryId: repository.id})">\n  <i class="icon-double-angle-left"></i>\n  {{ "Back to Repository Details" | translate }}\n</a>\n\n<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="pane-loading"></div>\n\n  <div data-block="messages">\n    <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n    <div class="alert alert-success" ng-hide="generationTaskId === undefined">\n      <button type="button" class="close" ng-click="clearTaskId()">×</button>\n      <p translate>\n        Docker metadata generation has been initiated in the background.  Click\n        <a ng-href="{{ taskUrl() }}">Here</a> to monitor the progress.\n      </p>\n    </div>\n  </div>\n\n  <div data-block="header">\n    <h3 translate>Docker Images in {{ repository.name }}</h3>\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-default"\n            ng-click="removeContent()"\n            ng-disabled="detailsTable.working || detailsTable.numSelected === 0">\n      <i class="icon-trash" ng-hide="detailsTable.working"></i>\n      <span translate>Remove Docker Images</span>\n    </button>\n  </div>\n\n  <div data-block="table">\n    <table class="table table-striped table-bordered" >\n\n      <thead>\n        <tr bst-table-head row-select>\n          <th bst-table-column><span translate>Image ID</span></th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row ng-repeat="item in detailsTable.rows" row-select="item">\n          <td bst-table-cell>\n            {{ item.image_id }}\n          </td>\n        </tr>\n      </tbody>\n\n    </table>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/repositories/details/views/repository-manage-packages.html",'<span page-title ng-model="repository">{{ \'Manage Packages for Repository:\' | translate }} {{ repository.name }}</span>\n\n<a ui-sref="products.details.repositories.info({productId: product.id, repositoryId: repository.id})">\n  <i class="icon-double-angle-left"></i>\n  {{ "Back to Repository Details" | translate }}\n</a>\n\n<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="pane-loading"></div>\n\n  <div data-block="messages">\n    <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n    <div class="alert alert-success" ng-hide="generationTaskId === undefined">\n      <button type="button" class="close" ng-click="clearTaskId()">×</button>\n      <p translate>\n        Yum metadata generation has been initiated in the background.  Click <a href="{{ taskUrl() }}">Here</a> to monitor the progress.\n      </p>\n    </div>\n  </div>\n\n  <div data-block="header">\n    <h3 translate>Packages in {{ repository.name }}</h3>\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-default"\n            ng-click="removeContent()"\n            ng-disabled="detailsTable.working || detailsTable.numSelected === 0">\n      <i class="icon-trash" ng-hide="detailsTable.working"></i>\n      <span translate>Remove Packages</span>\n    </button>\n  </div>\n\n  <div data-block="table">\n    <table class="table table-striped table-bordered" >\n\n      <thead>\n        <tr bst-table-head row-select>\n          <th bst-table-column><span translate>Name</span></th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row ng-repeat="package in detailsTable.rows" row-select="package">\n          <td bst-table-cell>\n            {{ package.nvrea }}\n          </td>\n        </tr>\n      </tbody>\n\n    </table>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/repositories/details/views/repository-manage-puppet-modules.html",'<span page-title ng-model="repository">{{ \'Manage Puppet Modules for Repository:\' | translate }} {{ repository.name }}</span>\n\n<a ui-sref="products.details.repositories.info({productId: product.id, repositoryId: repository.id})">\n  <i class="icon-double-angle-left"></i>\n  {{ "Back to Repository Details" | translate }}\n</a>\n\n<div data-extend-template="layouts/details-nutupane.html">\n\n  <div data-block="pane-loading"></div>\n\n  <div data-block="messages">\n    <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n    <div class="alert alert-success" ng-hide="generationTaskId === undefined">\n      <button type="button" class="close" ng-click="clearTaskId()">×</button>\n      <p translate>\n        Puppet module metadata generation has been initiated in the background.\n        Click <a ng-href="{{ taskUrl() }}">Here</a> to monitor the progress.\n      </p>\n    </div>\n  </div>\n\n  <div data-block="header">\n    <h3 translate>Puppet Modules in {{ repository.name }}</h3>\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-default"\n            ng-click="removeContent()"\n            ng-disabled="detailsTable.working || detailsTable.numSelected === 0">\n      <i class="icon-trash" ng-hide="detailsTable.working"></i>\n      <i class="icon-spinner icon-spin" ng-show="detailsTable.working"></i>\n      <span translate>Remove Puppet Modules</span>\n    </button>\n  </div>\n\n  <div data-block="table">\n    <table class="table table-striped table-bordered" >\n\n      <thead>\n        <tr bst-table-head row-select>\n          <th bst-table-column><span translate>Name</span></th>\n          <th bst-table-column><span translate>Author</span></th>\n          <th bst-table-column><span translate>Version</span></th>\n        </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row ng-repeat="item in detailsTable.rows" row-select="item">\n          <td bst-table-cell>\n            {{ item.name }}\n          </td>\n          <td bst-table-cell>\n            {{item.author}}\n          </td>\n          <td bst-table-cell>\n            {{ item.version }}\n          </td>\n        </tr>\n      </tbody>\n\n    </table>\n  </div>\n\n</div>\n'
)}]),angular.module("Bastion.repositories").controller("NewRepositoryController",["$scope","Repository","GPGKey","FormUtils","translate",function($scope,Repository,GPGKey,FormUtils,translate){function success(response){$scope.repositoriesTable.rows.push(response),$scope.successMessages.push(translate("Repository %s successfully created.").replace("%s",$scope.repository.name)),$scope.transitionTo("products.details.repositories.index",{productId:$scope.$stateParams.productId})}function error(response){var foundError=!1;$scope.working=!1,angular.forEach($scope.repositoryForm,function(value,field){$scope.repositoryForm.hasOwnProperty(field)&&value.hasOwnProperty("$setValidity")&&(value.$setValidity("server",!0),$scope.repositoryForm[field].$error.messages=[])}),angular.forEach(response.data.errors,function(errors,field){$scope.repositoryForm.hasOwnProperty(field)&&(foundError=!0,$scope.repositoryForm[field].$setValidity("server",!1),$scope.repositoryForm[field].$error.messages=errors)}),foundError||($scope.errorMessages=[response.data.displayMessage])}$scope.repository=new Repository({product_id:$scope.$stateParams.productId,unprotected:!0,checksum_type:null}),$scope.repositoryTypes=[{},{name:"yum"},{name:"puppet"},{name:"docker"}],$scope.$watch("repository.name",function(){$scope.repositoryForm.name&&($scope.repositoryForm.name.$setValidity("server",!0),FormUtils.labelize($scope.repository))}),GPGKey.queryUnpaged(function(gpgKeys){$scope.gpgKeys=gpgKeys.results}),$scope.save=function(repository){repository.$save(success,error)}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/repositories/new/views/repository-new.html",'<span page-title>{{ \'New Repository\' | translate }}</span>\n\n<section>\n\n  <header>\n    <h5>\n      <i class="icon-double-angle-left" ui-sref="products.details.repositories.index({productId: $scope.product.id})"></i>\n      {{ "Add New Repository" | translate }}\n    </h5>\n  </header>\n\n  <div bst-alert error-messages="errorMessages" success-messages="successMessages"></div>\n\n  <form name="repositoryForm" class="form-horizontal" novalidate role="form">\n\n    <div bst-form-group label="{{ \'Name\' | translate }}">\n      <input id="name"\n             name="name"\n             ng-model="repository.name"\n             type="text"\n             tabindex="1"\n             autofocus\n             required/>\n    </div>\n\n    <div bst-form-group label="{{ \'Label\' | translate }}">\n      <input id="label"\n             name="label"\n             ng-model="repository.label"\n             type="text"\n             tabindex="1"\n             required/>\n    </div>\n\n    <div bst-form-group label="{{ \'Type\' | translate }}">\n      <select required\n              tabindex="3"\n              id="content_type"\n              name="content_type"\n              ng-model="repository.content_type"\n              ng-options="type.name as type.name for type in repositoryTypes">\n      </select>\n    </div>\n\n    <div bst-form-group label="{{ \'Checksum\' | translate }}" ng-show="repository.content_type == \'yum\'">\n      <select tabindex="4"\n              id="checksum_type"\n              name="checksum_type"\n              ng-model="repository.checksum_type"\n              ng-options="type.id as type.name for type in checksums">\n      </select>\n      <h6 translate>\n        For older operating systems such as Red Hat Enterprise Linux 5 or CentOS 5 it is recommended to use sha1.\n      </h6>\n    </div>\n\n    <div bst-form-group label="{{ \'URL\' | translate }}">\n      <input id="url"\n             name="url"\n             ng-model="repository.url"\n             type="text"\n             tabindex="5"/>\n    </div>\n\n    <div bst-form-group label="{{ \'Publish via HTTP\' | translate }}" ng-show="repository.content_type == \'yum\'">\n      <input id="unprotected"\n             name="unprotected"\n             ng-model="repository.unprotected"\n             type="checkbox"\n             tabindex="6"/>\n    </div>\n\n    <div bst-form-group label="{{ \'GPG Key\' | translate }}" ng-show="repository.content_type == \'yum\'">\n      <select id="gpg_key_id"\n              name="gpg_key_id"\n              ng-model="repository.gpg_key_id"\n              ng-options="gpg_key.id as gpg_key.name for gpg_key in gpgKeys"\n              tabindex="7">\n        <option value=""></option>\n      </select>\n    </div>\n\n    <div bst-form-buttons\n         on-cancel="transitionTo(\'products.details.repositories.index\', {productId: repository.product_id})"\n         on-save="save(repository)"\n         working="working">\n    </div>\n\n  </form>\n</section>\n')}]),angular.module("Bastion.repositories").factory("Repository",["BastionResource","CurrentOrganization",function(BastionResource,CurrentOrganization){return BastionResource("/katello/api/v2/repositories/:id/:action",{id:"@id",organization_id:CurrentOrganization},{update:{method:"PUT"},sync:{method:"POST",params:{action:"sync"}},removePackages:{method:"PUT",params:{action:"remove_packages"}},removeContent:{method:"PUT",params:{action:"remove_content"}}})}]),angular.module("Bastion.repositories").factory("RepositoryBulkAction",["BastionResource","CurrentOrganization",function(BastionResource,CurrentOrganization){return BastionResource("/katello/api/v2/repositories/bulk/:action",{organization_id:CurrentOrganization},{removeRepositories:{method:"PUT",params:{action:"destroy"}},syncRepositories:{method:"POST",params:{action:"sync"}}})}]),angular.module("Bastion.sync-plans",["ngResource","ui.router","Bastion","Bastion.components.formatters"]),angular.module("Bastion.sync-plans").config(["$stateProvider",function($stateProvider){$stateProvider.state("sync-plans",{"abstract":!0,controller:"SyncPlansController",templateUrl:"sync-plans/views/sync-plans.html"}).state("sync-plans.index",{url:"/sync_plans",permission:"view_sync_plans",views:{table:{templateUrl:"sync-plans/views/sync-plans-table-full.html"}}}).state("sync-plans.new",{url:"/sync_plans/new",permission:"create_sync_plans",collapsed:!0,views:{table:{templateUrl:"sync-plans/views/sync-plans-table-collapsed.html"},"action-panel":{controller:"NewSyncPlanController",templateUrl:"sync-plans/new/views/new-sync-plan.html"},"sync-plan-form@sync-plans.new":{controller:"NewSyncPlanController",templateUrl:"sync-plans/new/views/new-sync-plan-form.html"}}}).state("sync-plans.details",{"abstract":!0,url:"/sync_plans/:syncPlanId",permission:"view_sync_plans",collapsed:!0,views:{table:{templateUrl:"sync-plans/views/sync-plans-table-collapsed.html"},"action-panel":{controller:"SyncPlanDetailsController",templateUrl:"sync-plans/details/views/sync-plan-details.html"}}}).state("sync-plans.details.info",{url:"/info",permission:"view_sync_plans",collapsed:!0,controller:"SyncPlanDetailsInfoController",templateUrl:"sync-plans/details/views/sync-plan-info.html"}).state("sync-plans.details.products",{"abstract":!0,collapsed:!0,templateUrl:"sync-plans/details/views/sync-plan-products.html"}).state("sync-plans.details.products.list",{url:"/products",permission:"view_sync_plans",collapsed:!0,controller:"SyncPlanProductsController",templateUrl:"sync-plans/details/views/sync-plan-products-table.html"}).state("sync-plans.details.products.add",{url:"/products/add",permission:"edit_sync_plans",collapsed:!0,controller:"SyncPlanAddProductsController",templateUrl:"sync-plans/details/views/sync-plan-products-table.html"})}]),angular.module("Bastion.sync-plans").controller("SyncPlanAddProductsController",["$scope","$q","$location","translate","SyncPlan","Nutupane",function($scope,$q,$location,translate,SyncPlan,Nutupane){var productsNutupane,params;$scope.successMessages=[],$scope.errorMessages=[],params={search:$location.search().search||"",sort_by:"name",sort_order:"ASC",full_result:!0,id:$scope.$stateParams.syncPlanId},productsNutupane=new Nutupane(SyncPlan,params,"availableProducts"),$scope.productsTable=productsNutupane.table,$scope.addProducts=function(){var data,success,error,deferred=$q.defer(),productsToAdd=_.pluck($scope.productsTable.getSelected(),"id");return data={product_ids:productsToAdd},success=function(data){$scope.successMessages=[translate('Added %x products to sync plan "%y".').replace("%x",$scope.productsTable.numSelected).replace("%y",$scope.syncPlan.name)],$scope.productsTable.working=!1,$scope.productsTable.selectAll(!1),productsNutupane.refresh(),$scope.syncPlan.$get(),deferred.resolve(data)},error=function(error){deferred.reject(error.data.errors),$scope.errorMessages=error.data.errors.base,$scope.productsTable.working=!1},$scope.productsTable.working=!0,SyncPlan.addProducts({id:$scope.syncPlan.id},data,success,error),deferred.promise}}]),angular.module("Bastion.sync-plans").controller("SyncPlanDetailsInfoController",["$scope","$q","translate","SyncPlan","MenuExpander",function($scope,$q,translate,SyncPlan,MenuExpander){$scope.successMessages=[],$scope.errorMessages=[],$scope.intervals=[{id:"hourly",value:translate("hourly")},{id:"daily",value:translate("daily")},{id:"weekly",value:translate("weekly")}],$scope.menuExpander=MenuExpander,$scope.panel=$scope.panel||{loading:!1},$scope.syncPlan=$scope.syncPlan||SyncPlan.get({id:$scope.$stateParams.syncPlanId},function(){$scope.panel.loading=!1}),$scope.save=function(syncPlan){var deferred=$q.defer();return syncPlan.$update(function(response){deferred.resolve(response),$scope.successMessages.push(translate("Sync Plan Saved"))},function(response){deferred.reject(response),angular.forEach(response.data.errors,function(errorMessage,key){angular.isString(key)&&(errorMessage=[key,errorMessage].join(" ")),$scope.errorMessages.push(translate("An error occurred saving the Sync Plan: ")+errorMessage)})}),deferred.promise}}]),angular.module("Bastion.sync-plans").controller("SyncPlanDetailsController",["$scope","$state","SyncPlan",function($scope,$state,SyncPlan){$scope.successMessages=[],$scope.errorMessages=[],$scope.syncPlan?$scope.panel={loading:!1}:$scope.panel={loading:!0},$scope.syncPlan=SyncPlan.get({id:$scope.$stateParams.syncPlanId},function(){$scope.panel.loading=!1})}]),angular.module("Bastion.sync-plans").controller("SyncPlanProductsController",["$scope","$q","$location","translate","SyncPlan","Nutupane",function($scope,$q,$location,translate,SyncPlan,Nutupane){var productsNutupane,params;$scope.successMessages=[],$scope.errorMessages=[],params={id:$scope.$stateParams.syncPlanId,search:$location.search().search||"",sort_by:"name",sort_order:"ASC",full_result:!0},productsNutupane=new Nutupane(SyncPlan,params,"products"),$scope.productsTable=productsNutupane.table,$scope.removeProducts=function(){var data,success,error,deferred=$q.defer(),productsToRemove=_.pluck($scope.productsTable.getSelected(),"id");return data={product_ids:productsToRemove},success=function(data){$scope.successMessages=[translate('Removed %x products from sync plan "%y".').replace("%x",$scope.productsTable.numSelected).replace("%y",$scope.syncPlan.name)],$scope.productsTable.working=!1,$scope.productsTable.selectAll(!1),productsNutupane.refresh(),$scope.syncPlan.$get(),deferred.resolve(data)},error=function(error){deferred.reject(error.data.errors),$scope.errorMessages=error.data.errors,$scope.productsTable.working=!1},$scope.productsTable.working=!0,SyncPlan.removeProducts({id:$scope.syncPlan.id},data,success,error),deferred.promise}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/sync-plans/details/views/sync-plan-details.html",'<span page-title ng-model="syncPlan">{{ \'Sync Plan:\' | translate }} {{ syncPlan.name }}</span>\n\n<div class="loading-mask loading-mask-panel" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="details-header">\n    <h2 class="fl" translate>Sync Plan {{ syncPlan.name }}</h2>\n\n    <div class="fr">\n\n      <div bst-modal="removeSyncPlan(syncPlan)" model="syncPlan"\n           modal-header=\'Remove Sync Plan "{{syncPlan.name}}"?\'\n           modal-body=\'Are you sure you want to remove the sync plan "{{ syncPlan.name }}"?\'></div>\n\n\n      <button class="btn btn-default" ng-click="openModal()" ng-hide="denied(\'destroy_sync_plans\', syncPlan)">\n        <i class="icon-trash"></i>\n        {{ "Remove Sync Plan" | translate }}\n      </button>\n      <button class="btn btn-default" ui-sref="sync-plans.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <nav>\n    <ul class="nav nav-tabs">\n      <li ng-class="{active: stateIncludes(\'sync-plans.details.info\')}">\n        <a translate\n           ui-sref="sync-plans.details.info({syncPlanId: syncPlan.id})">\n          Details\n        </a>\n      </li>\n      <li ng-class="{active: stateIncludes(\'sync-plans.details.products\')}">\n        <a translate\n           ui-sref="sync-plans.details.products.list({syncPlanId: syncPlan.id})">\n          Products\n        </a>\n      </li>\n      <li ng-repeat="menuItem in menuExpander.getMenu(\'syncPlan\')">\n        <a href="{{ menuItem.url }}">\n          {{ menuItem.label }}\n        </a>\n      </li>\n    </ul>\n  </nav>\n\n  <section class="nutupane-sub-section" ui-view></section>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/sync-plans/details/views/sync-plan-info.html",'<span page-title ng-model="syncPlan">{{ \'Sync Plan:\' | translate }} {{ syncPlan.name }}</span>\n\n<div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n<div class="details fl">\n  <section>\n    <h4 translate>Basic Information</h4>\n\n    <div class="detail">\n      <span class="info-label" translate>Name</span>\n      <span class="info-value"\n            bst-edit-text="syncPlan.name"\n            on-save="save(syncPlan)"\n            readonly="denied(\'edit_sync_plans\', syncPlan)">\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Description</span>\n      <span class="info-value"\n            bst-edit-textarea="syncPlan.description"\n            on-save="save(syncPlan)"\n            readonly="denied(\'edit_sync_plans\', syncPlan)">\n      </span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Start Date</span>\n      <span class="info-value">{{ syncPlan.sync_date | date:\'medium\' }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Next Sync</span>\n      <span class="info-value">{{ syncPlan.next_sync | date:\'medium\' }}</span>\n    </div>\n\n    <div class="detail">\n      <span class="info-label" translate>Sync Enabled</span>\n      <span class="info-value"\n            bst-edit-checkbox="syncPlan.enabled"\n            readonly="denied(\'edit_sync_plans\', syncPlan)"\n            formatter="booleanToYesNo"\n            on-save="save(syncPlan)">\n      </span>\n    </div> \n\n         \n    <div class="detail" ng-show="syncPlan.enabled">\n      <span class="info-label" translate>Interval</span>\n      <span class="info-value"\n            bst-edit-select="syncPlan.interval"\n            formatter="translate"\n            readonly="denied(\'edit_sync_plans\', syncPlan)"\n            selector="syncPlan.interval"\n            options="intervals"\n            options-format="value.id as value.value for value in options"\n            on-save="save(syncPlan)">\n      </span>\n    </div>\n\n    <div class="detail grey" ng-show="!syncPlan.enabled">\n      <span class="info-label" translate>Interval</span>\n      <span class="info-value" >{{ syncPlan.interval }}</span>\n    </div>    \n    \n  </section>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/sync-plans/details/views/sync-plan-products-table.html",'<section class="nutupane-sub-section">\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <div class="row">\n\n    <div class="col-sm-3">\n      <input type="text"\n             class="form-control"\n             placeholder="{{ \'Filter\' | translate }}"\n             ng-model="productFilter"/>\n    </div>\n\n    <div class="fr select-action">\n      <span class="nutupane-info">\n        <span translate>{{ productsTable.numSelected }} Selected</span>\n      </span>\n\n      <button ng-if="isState(\'sync-plans.details.products.list\')"\n              class="btn btn-default"\n              ng-hide="denied(\'edit_products\')"\n              ng-disabled="productsTable.numSelected == 0 || productsTable.working"\n              ng-click="removeProducts()">\n        {{ \'Remove Selected\' | translate}}\n      </button>\n      <button ng-if="isState(\'sync-plans.details.products.add\')"\n              class="btn btn-default"\n              ng-hide="denied(\'edit_products\')"\n              ng-disabled="productsTable.numSelected == 0 || productsTable.working"\n              ng-click="addProducts()">\n        {{ \'Add Selected\' | translate }}\n      </button>\n\n    </div>\n  </div>\n\n  <div bst-table="productsTable" class="nutupane">\n    <div bst-container-scroll bst-infinite-scroll="productsTable.nextPage()">\n\n      <div ng-show="productsTable.rows.length == 0">\n        <div class="loading-mask" ng-show="productsTable.working">\n          <i class="icon-spinner icon-spin"></i>\n          {{ "Loading..." | translate }}\n        </div>\n\n        <p class="alert alert-info" \n           ng-hide="productsTable.working" \n           translate>No Products to show. \n        </p>\n      </div>\n\n      <table ng-show="productsTable.rows.length > 0"\n             ng-class="{\'table-mask\': productsTable.working}" class="table table-full table-striped">\n        <thead>\n        <tr bst-table-head row-select="product">\n          <th bst-table-column="name" translate>Name</th>\n          <th bst-table-column="description" translate>Description</th>\n          <th bst-table-column="sync_status" translate>Sync Status</th>\n          <th bst-table-column class="number-cell"><span translate>Repositories</span></th>\n        </tr>\n        </thead>\n\n        <tbody>\n        <tr bst-table-row ng-repeat="product in productsTable.rows | filter:productFilter" row-select="product">\n          <td bst-table-cell>\n            <a ui-sref="products.details.info({productId: product.id})">\n              {{ product.name }}\n            </a>\n          </td>\n          <td bst-table-cell>{{ product.description }}</td>\n          <td bst-table-cell>\n            <div ng-include="\'products/views/partials/product-table-sync-status.html\'"></div>\n          </td>\n          <td bst-table-cell class="number-cell">{{ product.repository_count }}</td>\n        </tr>\n        </tbody>\n      </table>\n    </div>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/sync-plans/details/views/sync-plan-products.html",'<span page-title ng-model="syncPlan">{{ \'Product Management for Sync Plan:\' | translate }} {{ syncPlan.name }}</span>\n\n<h4 translate>Product Management</h4>\n<nav>\n  <ul class="nav nav-tabs">\n    <li ng-class="{active: isState(\'sync-plans.details.products.list\')}">\n      <a ui-sref="sync-plans.details.products.list">\n        <span translate>List/Remove</span>\n      </a>\n    </li>\n\n    <li ng-class="{active: isState(\'sync-plans.details.products.add\')}"\n        ng-show="permitted(\'edit_sync_plans\', syncPlan)">\n      <a ui-sref="sync-plans.details.products.add">\n        <span translate>Add</span>\n      </a>\n    </li>\n  </ul>\n</nav>\n\n<div ui-view></div>\n')}]),angular.module("Bastion.sync-plans").controller("NewSyncPlanController",["$scope","translate","SyncPlan",function($scope,translate,SyncPlan){function success(syncPlan){$scope.working=!1,$scope.successMessages=[translate("New sync plan successfully created.")],$scope.product?($scope.product.sync_plan_id=syncPlan.id,$scope.$state.go("products.details.info",{productId:$scope.product.id})):$scope.syncPlanTable&&($scope.syncPlanTable.rows.unshift(syncPlan),$scope.$state.go("sync-plans.details.info",{syncPlanId:syncPlan.id}))}function error(response){$scope.working=!1,angular.forEach(response.data.errors,function(errors,field){$scope.syncPlanForm[field].$setValidity("server",!1),$scope.syncPlanForm[field].$error.messages=errors})}$scope.intervals=[{id:"hourly",value:translate("hourly")},{id:"daily",value:translate("daily")},{id:"weekly",value:translate("weekly")}],$scope.successMessages=[],$scope.syncPlan=new SyncPlan,$scope.syncPlan.interval=$scope.intervals[0].id,$scope.syncPlan.startDate=new Date,$scope.createSyncPlan=function(syncPlan){var syncDate=new Date(syncPlan.startDate),syncTime=new Date(syncPlan.startTime||new Date);syncDate.setHours(syncTime.getHours()),syncDate.setMinutes(syncTime.getMinutes()),syncDate.setSeconds(0),syncPlan.sync_date=syncDate.toString(),syncPlan.$save(success,error)}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/sync-plans/new/views/new-sync-plan-form.html",'<form name="syncPlanForm" class="form-horizontal" novalidate role="form">\n <div bst-form-group label="{{ \'Name\' | translate }}">\n   <input id="name"\n          name="name"\n          ng-model="syncPlan.name"\n          type="text"\n          tabindex="1"\n          autofocus\n          required/>\n </div>\n\n <div bst-form-group label="{{ \'Description\' | translate }}">\n   <textarea id="description"\n             name="description"\n             ng-model="syncPlan.description"\n             tabindex="2">\n   </textarea>\n </div>\n\n <div bst-form-group label="{{ \'Interval\' | translate }}">\n   <select id="interval"\n           name="interval"\n           ng-model="syncPlan.interval"\n           ng-options="interval.id as interval.value for interval in intervals"\n           tabindex="3"\n           required>\n      <option value="" translate>-- select an interval --</option>\n   </select>\n </div>\n\n <div bst-form-group label="{{ \'Start Date\' | translate }}">\n   <input type="text" datepicker-popup\n          id="startDate"\n          name="startDate"\n          ng-model="syncPlan.startDate"\n          show-weeks="false"\n          tabindex="4"\n          required/>\n </div>\n\n <div bst-form-group label="{{ \'Start Time\' | translate }}">\n   <timepicker type="time" show-meridian="false"\n          id="startTime"\n          name="startTime"\n          ng-model="syncPlan.startTime"\n          tabindex="5">\n   </timepicker>\n </div>\n\n <div bst-form-buttons\n      on-cancel="transitionBack()"\n      on-save="createSyncPlan(syncPlan)"\n      working="working">\n </div>\n</form>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/sync-plans/new/views/new-sync-plan.html",'<span page-title>{{ \'New Sync Plan\' | translate }}</span>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n  <header class="new-header details-header">\n    <h2 class="fl" translate>New Sync Plan</h2>\n\n    <div class="fr">\n      <button class="btn btn-default" ng-click="transitionBack()">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <div ui-view="sync-plan-form"></div>\n\n</section>\n\n')}]),angular.module("Bastion.sync-plans").factory("SyncPlan",["BastionResource","CurrentOrganization",function(BastionResource,CurrentOrganization){return BastionResource("/katello/api/v2/organizations/:organizationId/sync_plans/:id/:action",{id:"@id",organizationId:CurrentOrganization},{autocomplete:{method:"GET",isArray:!0,params:{id:"auto_complete_search"}},update:{method:"PUT"},availableProducts:{method:"GET",params:{action:"available_products"}},addProducts:{method:"PUT",params:{action:"add_products"}},removeProducts:{method:"PUT",params:{action:"remove_products"}},products:{method:"GET",transformResponse:function(data){var syncPlan=angular.fromJson(data);return{results:syncPlan.products}}}})}]),angular.module("Bastion.sync-plans").controller("SyncPlansController",["$scope","$location","translate","Nutupane","SyncPlan","CurrentOrganization",function($scope,$location,translate,Nutupane,SyncPlan,CurrentOrganization){$scope.successMessages=[],$scope.errorMessages=[];var params={organization_id:CurrentOrganization,search:$location.search().search||"",sort_by:"name",sort_order:"ASC"},nutupane=new Nutupane(SyncPlan,params);$scope.syncPlanTable=nutupane.table,$scope.removeRow=nutupane.removeRow,$scope.nutupane=nutupane,nutupane.enableSelectAllResults(),$location.search().select_all&&nutupane.table.selectAllResults(!0),$scope.syncPlanTable.closeItem=function(){$scope.transitionTo("sync-plans.index")},$scope.table=$scope.syncPlanTable,$scope.removeSyncPlan=function(syncPlan){syncPlan.$remove(function(){$scope.successMessages.push(translate("Sync Plan %s has been deleted.").replace("%s",syncPlan.name)),$scope.removeRow(syncPlan.id),$scope.transitionTo("sync-plans.index")})}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/sync-plans/views/sync-plans-table-collapsed.html",'<table class="table table-striped" ng-class="{\'table-mask\': syncPlanTable.working}">\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column sortable><span translate>Name</span></th>\n    </tr>\n  </thead>\n\n  <div data-extend-template="layouts/select-all-results.html"></div>\n\n  <tbody>\n    <tr bst-table-row\n        ng-repeat="syncPlan in syncPlanTable.rows"\n        row-select="syncPlan"\n        active-row="stateIncludes(\'sync-plans.details\', {syncPlanId: syncPlan.id})">\n      <td bst-table-cell>\n        <a ui-sref="sync-plans.details.info({syncPlanId: syncPlan.id})">\n          {{ syncPlan.name }}\n        </a>\n      </td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/sync-plans/views/sync-plans-table-full.html",'<p class="alert alert-info" ng-show="syncPlanTable.rows.length === 0" translate>\n  You currently don\'t have any Sync Plan, you can add Sync Plans using the button on the right.\n</p>\n<table class="table table-striped" \n       ng-class="{\'table-mask\': syncPlanTable.working}" \n       ng-show="syncPlanTable.rows.length > 0">\n  <thead>\n    <tr bst-table-head row-select>\n      <th bst-table-column="name" sortable><span translate>Name</span></th>\n      <th bst-table-column="description"><span translate>Description</span></th>\n      <th bst-table-column="syncDate"><span translate>Original Sync Date</span></th>\n      <th bst-table-column="enabled"><span translate>Sync Enabled</span></th>\n      <th bst-table-column="interval"><span translate>Interval</span></th>\n      <th bst-table-column="nextSync"><span translate>Next Sync</span></th>\n    </tr>\n  </thead>\n\n  <div data-extend-template="layouts/select-all-results.html"></div>\n\n  <tbody>\n    <tr bst-table-row ng-repeat="syncPlan in syncPlanTable.rows" row-select="syncPlan">\n      <td bst-table-cell>\n        <a ui-sref="sync-plans.details.info({syncPlanId: syncPlan.id})">\n          {{ syncPlan.name }}\n        </a>\n      </td>\n      <td bst-table-cell>{{ syncPlan.description }}</td>\n      <td bst-table-cell>{{ syncPlan.sync_date | date:\'medium\' }}</td>\n      <td bst-table-cell>{{ syncPlan.enabled }}</td>\n      <td bst-table-cell>{{ syncPlan.interval | translate | capitalize }}</td>\n      <td bst-table-cell>{{ syncPlan.next_sync | date:\'medium\' }}</td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/sync-plans/views/sync-plans.html",'<span page-title>{{ \'Sync Plans\' | translate }}</span>\n\n<div data-extend-template="layouts/nutupane.html">\n\n  <div data-block="header">\n    {{ \'Sync Plans\' | translate }}\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-primary" ui-sref="sync-plans.new" ng-hide="denied(\'create_sync_plans\')">\n      <i class="icon-signin leading-icon"></i>\n      {{ "New Sync Plan" | translate }}\n    </button>\n  </div>\n\n</div>\n')}]),angular.module("Bastion.tasks",["ngResource","ui.router","Bastion"]),angular.module("Bastion.tasks").config(["$stateProvider",function($stateProvider){$stateProvider.state("tasks",{"abstract":!0,templateUrl:"tasks/views/tasks.html"}).state("tasks.index",{url:"/katello_tasks",permission:"view_tasks",templateUrl:"tasks/views/tasks-index.html"}).state("tasks.details",{url:"/katello_tasks/:taskId",permission:"view_tasks",collapsed:!0,controller:"TaskDetailsController",templateUrl:"tasks/views/task-details-standalone.html"}).state("task",{url:"/katello_tasks/single/:taskId",controller:"TaskDetailsController",permission:"view_tasks",templateUrl:"tasks/views/task-details-standalone.html"})}]),angular.module("Bastion.tasks").factory("AggregateTask",["Task",function(Task){var newAggregate=function(taskIds,callback){var taskMap={},taskSearches={},taskRepresentation={state:undefined,result:undefined,progressbar:{}},updateTask=function(task){taskMap[task.id]=task,task.pending||unregisterSearch(task.id),updateProgress(),callback&&callback(task)},unregisterSearch=function(taskId){taskSearches[taskId]&&Task.unregisterSearch(taskSearches[taskId])},unregisterAll=function(){_.each(taskSearches,function(searchId,taskId){unregisterSearch(taskId)})},greatestType=function(){var found="success",weights={error:3,danger:2,success:1};return _.each(taskMap,function(task){weights[task.progressbar.type]>weights[found]&&(found=task.progressbar.type)}),found},greatestState=function(){var found="stopped",weights={running:3,pending:2,stopped:1};return _.each(taskMap,function(task){weights[task.state]>weights[found]&&(found=task.state)}),found},greatestResult=function(){var found="success",weights={error:4,warning:3,pending:2,success:1};return _.each(taskMap,function(task){weights[task.result]>weights[found]&&(found=task.result)}),found},updateProgress=function(){var total=0;_.each(taskMap,function(task){total+=task.progressbar.value}),taskRepresentation.progressbar.value=total/_.size(taskMap),taskRepresentation.progressbar.type=greatestType(),taskRepresentation.state=greatestState(),taskRepresentation.result=greatestResult()};return taskRepresentation.unregisterAll=unregisterAll,taskRepresentation.unregisterSearch=unregisterSearch,_.each(taskIds,function(taskId){taskSearches[taskId]===undefined&&(taskSearches[taskId]=Task.registerSearch({type:"task",task_id:taskId},updateTask))}),taskRepresentation};return{"new":newAggregate}}]),angular.module("Bastion.tasks").controller("TaskDetailsController",["$scope","Task",function($scope,Task){var taskId;taskId=$scope.$stateParams.taskId,$scope.unregisterSearch=function(){Task.unregisterSearch($scope.searchId),$scope.searchId=undefined},$scope.updateTask=function(task){$scope.task=task,$scope.task.pending||$scope.unregisterSearch()},$scope.isArray=_.isArray,$scope.$on("$destroy",function(){$scope.unregisterSearch()}),$scope.searchId=Task.registerSearch({type:"task",task_id:taskId},$scope.updateTask)}]),angular.module("Bastion.tasks").filter("taskInputCompile",function(){return function(humanizedTaskInput){if(!_.isArray(humanizedTaskInput)&&!_.isObject(humanizedTaskInput))return humanizedTaskInput;var parts=_.map(humanizedTaskInput,function(part){return part.length===2?part[1]
.text:part});return parts.join("; ")}}),angular.module("Bastion.tasks").directive("taskInputPart",function(){return{restrict:"A",template:'<span ng-if="!link()">{{text()}}</span><a ng-if="link()" href="{{link()}}">{{text()}}</a>',scope:{data:"="},link:function(scope){scope.text=function(){return _.isString(scope.data)?scope.data:scope.data[1].text},scope.link=function(){if(!_.isString(scope.data)&&scope.data[1])return scope.data[1].link}}}}),angular.module("Bastion.tasks").filter("taskInputReduce",function(){return function(humanizedTaskInput,skippedParts){return _.isString(humanizedTaskInput)||!skippedParts?humanizedTaskInput:(_.isString(skippedParts)&&(skippedParts=skippedParts.split(",")),_.reject(humanizedTaskInput,function(part){return part.length===2?_.contains(skippedParts,part[0]):!1}))}}),angular.module("Bastion.tasks").filter("taskInputShort",function(){return function(humanizedTaskInput){return _.isString(humanizedTaskInput)?humanizedTaskInput:_.first(humanizedTaskInput,1)}}),angular.module("Bastion.tasks").factory("Task",["BastionResource","$timeout","$log","$q","CurrentOrganization",function(BastionResource,$timeout,$log,$q,CurrentOrganization){function bulkSearchParams(){var searches=[];return _.each(searchParamsById,function(searchParams,id){searchParams.search_id=id,searches.push(searchParams)}),{searches:searches}}function taskProgressbar(task){var mapping={error:"danger",warning:"warning","default":"success"},type=mapping[task.result]||mapping["default"];return{value:task.progress*100,type:type}}function schedulePoll(){$timeout(function(){updateProgress(!0)},1500)}function normalizeTask(task){task.progressbar=taskProgressbar(task),task.humanized.errors?_.isArray(task.humanized.errors)||(task.humanized.errors=[task.humanized.errors]):task.humanized.errors=[]}function updateProgress(periodic){if(_.keys(searchParamsById).length===0){bulkSearchRunning=!1;return}foremanTasksResource.bulkSearch(bulkSearchParams(),function(response){try{_.each(response,function(tasksSearch){var searchId=tasksSearch.search_params.search_id,callback=callbackById[searchId];if(!callback)return;try{_.each(tasksSearch.results,function(task){normalizeTask(task)}),tasksSearch.search_params.type==="task"?callback(tasksSearch.results[0]):callback(tasksSearch.results)}catch(e){$log.error(e)}})}finally{periodic&&schedulePoll()}},function(){periodic&&schedulePoll()})}function ensureBulkSearchRunning(){bulkSearchRunning||(bulkSearchRunning=!0,updateProgress(!0))}function generateSearchId(){return searchIdGenerator+=1,searchIdGenerator}function addSearch(searchParams,callback){var searchId=generateSearchId();return searchParamsById[searchId]=searchParams,callbackById[searchId]=callback,ensureBulkSearchRunning(),searchId}function deleteSearch(searchId){delete callbackById[searchId],delete searchParamsById[searchId]}var bulkSearchRunning=!1,searchIdGenerator=0,searchParamsById={},callbackById={},resource=BastionResource("/katello/api/v2/tasks/:id/:action",{id:"@id",organization_id:CurrentOrganization},{}),foremanTasksResource=BastionResource("/foreman_tasks/api/tasks/:id/:action",{},{bulkSearch:{method:"POST",isArray:!0,params:{action:"bulk_search"}}});return resource.poll=function(task,returnFunction){resource.get({id:task.id},function(data){data.pending?$timeout(function(){resource.poll(data,returnFunction)},8e3):returnFunction(data)},function(){returnFunction({human_readable_result:"Failed to fetch task",failed:!0})})},resource.registerSearch=function(searchParams,callback){return addSearch(searchParams,callback)},resource.unregisterSearch=function(id){deleteSearch(id)},resource.monitorTask=function(task){function updateTask(task){runningTask.task=task;if(task.state==="paused"||task.state==="stopped"){resource.unregisterSearch(searchId),task.result==="success"&&(runningTask.state="stopped",deferred.resolve(task));if(task.result==="error"||task.result==="warning")runningTask.state="paused",deferred.reject(task.humanized.errors)}else runningTask.state="running",deferred.notify(task)}function pollTask(task){searchId=resource.registerSearch({type:"task",task_id:task.id},updateTask)}var searchId,deferred=$q.defer(),runningTask={promise:deferred.promise,task:task,state:null,stopMonitoring:function(){searchId&&resource.unregisterSearch(searchId)}};return task.$promise?(runningTask.state="starting",task.$promise.then(pollTask,function(error){var errors=[];runningTask.state="stopped",error.data.errors?errors=error.data.errors:error.data.error&&(errors=error.data.error.message),_.isArray(errors)||(errors=[errors]),deferred.reject(errors)})):(updateTask(task),pollTask(task)),runningTask},resource}]),angular.module("Bastion.tasks").factory("TasksNutupane",["Task","Nutupane",function(Task,Nutupane){var TasksNutupane=function(){var self=this;Nutupane.call(self,Task,{}),self.existingTasks={},self.registerSearch=function(params){self.searchId||(self.searchId=Task.registerSearch(params,self.updateTasks))},self.unregisterSearch=function(){self.searchId&&(Task.unregisterSearch(self.searchId),self.searchId=undefined)},self.load=function(){self.table.working=!0},self.updateTasks=function(tasks){self.refreshTasks(tasks),self.deleteOldRows(tasks),self.table.working=!1},self.table.search=function(){self.table.resource.offset=0,self.table.rows=[],self.table.working||self.load()},self.refreshTasks=function(tasks){_.each(tasks.reverse(),function(task){var existingTask=self.existingTasks[task.id];existingTask?_.each(task,function(value,key){existingTask[key]=value}):(self.table.rows.unshift(task),self.existingTasks[task.id]=task)})},self.deleteOldRows=function(tasks){var newTaskIds=_.map(tasks,function(task){return task.id}),oldTaskIds=_.keys(self.existingTasks),taskIdsToDelete=_.difference(oldTaskIds,newTaskIds),rowsToDelete=[];_.each(taskIdsToDelete,function(id){delete self.existingTasks[id]}),_.each(self.table.rows,function(row,i){_.contains(taskIdsToDelete,row.id)&&rowsToDelete.push(i)}),_.each(rowsToDelete.reverse(),function(i){self.table.rows.splice(i,1)})}};return TasksNutupane}]),angular.module("Bastion.tasks").directive("tasksTable",["TasksNutupane",function(TasksNutupane){return{restrict:"A",templateUrl:function(element,attrs){return attrs.templateUrl?attrs.templateUrl:"tasks/views/tasks-table.html"},scope:{resourceId:"@",resourceType:"@",userId:"@",activeOnly:"@",all:"@",detailsState:"@",knownContext:"@"},controller:["$scope","$state",function($scope,$state){$scope.tasksNutupane=new TasksNutupane,$scope.tasksTable=$scope.tasksNutupane.table,$scope.tasksNutupane.table.gotoDetails=function(taskId){$state.go($scope.detailsState,{taskId:taskId})}}],link:function(scope,element){scope.$watch("resourceId",function(resourceId){resourceId&&scope.tasksNutupane.registerSearch({type:"resource",active_only:scope.activeOnly,resource_type:scope.resourceType,resource_id:resourceId})}),scope.$watch("userId",function(userId){userId&&scope.tasksNutupane.registerSearch({type:"user",active_only:scope.activeOnly,user_id:userId})}),scope.$watch("all",function(){scope.tasksNutupane.registerSearch({type:"all",active_only:scope.activeOnly})}),element.bind("$destroy",function(){scope.tasksNutupane.unregisterSearch()})}}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/tasks/views/task-details-standalone.html","<div>\n  <ng-include src=\"'tasks/views/task-details.html'\"></ng-include>\n</div>\n")}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/tasks/views/task-details.html",'<a href="" ng-click="transitionBack()">\n  <i class="icon-double-angle-left"></i>\n  {{ "Back" | translate }}\n</a>\n\n<h3 translate>Task Details</h3>\n\n<div class="nutupane-sub-section">\n  <div class="details">\n    <section>\n      <div class="detail">\n        <span class="info-label" translate>Action Type</span>\n        <span class="info-value">{{ task.humanized.action }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>User</span>\n        <span class="info-value">{{ task.username }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Started At</span>\n        <span class="info-value">{{ task.started_at | date:"short"  }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Finished At</span>\n        <span class="info-value">{{ task.ended_at | date:"short"  }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Parameters</span>\n        <span class="info-value" ng-switch="isArray(task.humanized.input)">\n          <span ng-switch-when="true">\n            <span ng-repeat="inputPart in task.humanized.input">\n              <span task-input-part  data="inputPart"></span>\n              <span ng-show="!$last">; </span>\n            </span>\n          </span>\n          <span ng-switch-default>{{task.humanized.input}}</span>\n        </span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>State</span>\n        <span class="info-value">{{ task.state }}</span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Result</span>\n        <i class="icon-spinner icon-spin" ng-show="task.pending"></i>\n        <span class="info-value">{{ task.result }}</span>\n      </div>\n\n       <div ng-class="{ active: (task.state === \'pending\' || task.state === \'running\') }" class="progress progress-striped">\n         <span progressbar animate="false" value="task.progressbar.value" type="{{task.progressbar.type}}"></span>\n       </div>\n\n       <div class="detail" ng-show="task.humanized.output.length > 0">\n         <span class="info-label" translate>Details</span>\n         <pre>{{ task.humanized.output }}</pre>\n       </div>\n\n       <a href="/foreman_tasks/tasks/{{task.id}}">\n         {{ "More Details" | translate }}\n       </a>\n\n    </section>\n  </div>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/tasks/views/tasks-index.html",'<div tasks-table  details-state="tasks.details" all/>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/tasks/views/tasks-table.html",'<section class="nutupane-sub-section">\n  <div bst-table="tasksTable">\n    <div bst-container-scroll control-width="table" bst-infinite-scroll="tasksTable.nextPage()">\n      <table ng-class="{\'table-mask\': tasksTable.working}" class="table table-full table-striped tasks-table">\n        <thead>\n          <tr bst-table-head>\n            <th bst-table-column="Status" class=\'task-status\' translate>Status</th>\n            <th bst-table-column="Event" translate>Event</th>\n            <th bst-table-column="User" class=\'task-user\' translate>User</th>\n            <th bst-table-column="Date" translate>Date</th>\n          </tr>\n        </thead>\n\n        <tbody>\n          <tr bst-table-row ng-repeat="task in tasksTable.rows">\n            <td bst-table-cell>\n              <div ng-class="{ active: (task.state === \'pending\' || task.state === \'running\') }" class="progress progress-striped">\n                <span progressbar animate="false" value="task.progressbar.value" type="{{task.progressbar.type}}"></span>\n              </div>\n            </td>\n            <td bst-table-cell>\n              <a class="active" ng-click="tasksTable.gotoDetails(task.id)">\n                {{ task.humanized.action }}\n                {{ task.humanized.input | taskInputReduce:knownContext | taskInputCompile }}\n              </a>\n            </td>\n            <td bst-table-cell>{{ task.username }}</td>\n            <td bst-table-cell>{{ task.started_at | date:"short" }}</td>\n          </tr>\n        </tbody>\n      </table>\n    </div>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/tasks/views/tasks.html",'<section>\n\n  <div class="row">\n    <h2 class="col-sm-2" translate>\n      Tasks\n    </h2>\n  </div>\n\n  <div ui-view></div>\n\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/tasks/views/user-tasks-table.html",'<section class="nutupane-sub-section">\n  <div bst-table="tasksTable">\n    <table ng-class="{\'table-mask\': tasksTable.working}" class="table table-full table-striped">\n      <thead>\n      <tr bst-table-head>\n        <th bst-table-column="Status" style="width: 20%" translate>Status</th>\n        <th bst-table-column="Event" translate>Event</th>\n        <th bst-table-column="Date" style="width: 10em" translate>Date</th>\n      </tr>\n      </thead>\n\n      <tbody>\n        <tr bst-table-row ng-repeat="task in tasksTable.rows">\n          <td bst-table-cell>\n            <div ng-class="{ active: (task.state === \'pending\' || task.state === \'running\') }" class="progress progress-striped">\n              <span progressbar value="task.progressbar.value" type="{{task.progressbar.type}}"></span>\n            </div>\n          </td>\n          <td bst-table-cell>\n            <a class="active" ng-click="tasksTable.gotoDetails(task.id)">\n              {{ task.humanized.action }}\n              {{ task.humanized.input | taskInputShort | taskInputCompile }}\n            </a>\n          </td>\n          <td bst-table-cell>{{ task.started_at | date:"short" }}</td>\n        </tr>\n      </tbody>\n    </table>\n  </div>\n</section>\n')}]),angular.module("Bastion.gpg-keys",["ngResource","ui.router","Bastion","Bastion.components","ngUpload"]),angular.module("Bastion.gpg-keys").config(["$stateProvider",function($stateProvider){$stateProvider.state("gpgKeys",{"abstract":!0,controller:"GPGKeysController",templateUrl:"gpg-keys/views/gpg-keys.html"}).state("gpgKeys.index",{url:"/gpg_keys",permission:"view_gpg_keys",views:{table:{templateUrl:"gpg-keys/views/gpg-keys-table-full.html"}}}).state("gpgKeys.new",{url:"/gpg_keys/new",permission:"create_gpg_keys",collapsed:!0,views:{table:{templateUrl:"gpg-keys/views/gpg-keys-table-collapsed.html"},"action-panel":{controller:"NewGPGKeyController",templateUrl:"gpg-keys/new/views/gpg-key-new.html"}}}).state("gpgKeys.details",{"abstract":!0,url:"/gpg_keys/:gpgKeyId",permission:"view_gpg_keys",collapsed:!0,views:{table:{templateUrl:"gpg-keys/views/gpg-keys-table-collapsed.html"},"action-panel":{controller:"GPGKeyDetailsController",templateUrl:"gpg-keys/details/views/gpg-key-details.html"}}}).state("gpgKeys.details.info",{url:"/info",permission:"view_gpg_keys",collapsed:!0,controller:"GPGKeyDetailsInfoController",templateUrl:"gpg-keys/details/views/gpg-key-info.html"}).state("gpgKeys.details.products",{url:"/products",permission:"view_gpg_keys",collapsed:!0,controller:"GPGKeyDetailsController",templateUrl:"gpg-keys/details/views/gpg-key-products.html"}).state("gpgKeys.details.repositories",{url:"/repositories",permission:"view_gpg_keys",collapsed:!0,controller:"GPGKeyDetailsController",templateUrl:"gpg-keys/details/views/gpg-key-repositories.html"})}]),angular.module("Bastion.gpg-keys").controller("GPGKeyDetailsInfoController",["$scope","GPGKey","translate",function($scope,GPGKey,translate){$scope.panel=$scope.panel||{loading:!1},$scope.progress={uploading:!1},$scope.gpgKey=$scope.gpgKey||GPGKey.get({id:$scope.$stateParams.gpgKeyId},function(){$scope.panel.loading=!1}),$scope.gpgKey.$promise.then(function(){$scope.uploadURL="/katello/api/v2/gpg_keys/"+$scope.gpgKey.id+"/content"}),$scope.uploadContent=function(content){content&&content!=="Please wait..."&&(content.status==="success"?($scope.$parent.successMessages=[translate("GPG Key successfully uploaded")],$scope.uploadStatus="success",$scope.gpgKey.$get()):($scope.$parent.errorMessages=[content.displayMessage],$scope.uploadStatus="error"),$scope.progress.uploading=!1)}}]),angular.module("Bastion.gpg-keys").controller("GPGKeyDetailsController",["$scope","GPGKey","$q","translate",function($scope,GPGKey,$q,translate){$scope.errorMessages=[],$scope.successMessages=[],$scope.panel=$scope.panel||{loading:!1},$scope.gpgKey=GPGKey.get({id:$scope.$stateParams.gpgKeyId},function(){$scope.panel.loading=!1}),$scope.save=function(gpgKey){var deferred=$q.defer();return gpgKey.$update(function(response){deferred.resolve(response),$scope.successMessages.push(translate("Gpg Key updated")),$scope.table.replaceRow(response)},function(response){deferred.reject(response),$scope.errorMessages=[response.data.displayMessage]}),deferred.promise},$scope.removeGPGKey=function(gpgKey){var id=gpgKey.id;gpgKey.$delete(function(){$scope.removeRow(id),$scope.transitionTo("gpgKeys.index")})}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/gpg-keys/details/views/gpg-key-details.html",'<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="details-header new-header">\n    <h2 class="fl" translate>\n      GPG Key {{ gpgKey.name }}\n    </h2>\n\n    <div class="details-actions fr">\n      <button class="btn btn-default"\n              ng-click="openModal()"\n              ng-hide="denied(\'destroy_gpg_keys\', gpgKey)"\n              translate>\n        Remove GPG Key\n      </button>\n\n      <button class="btn btn-default" ng-click="table.closeItem()">\n        <i class="icon-remove"></i>\n        <span translate>Close</span>\n      </button>\n\n      <div bst-modal="removeGPGKey(gpgKey)"\n           model="gpgKey"\n           modal-header="{{ \'Remove GPG Key \' + gpgKey.name + \'?\' | translate }}"\n           modal-body="{{ \'Are you sure you want to remove GPG key \' + gpgKey.name + \'?\' | translate }}">\n      </div>\n\n    </div>\n  </header>\n\n  <nav class="details-navigation">\n    <ul>\n      <li ng-class="{active: isState(\'gpgKeys.details.info\')}">\n        <a ui-sref="gpgKeys.details.info" translate>Details</a>\n      </li>\n\n      <li ng-class="{active: stateIncludes(\'gpgKeys.details.products\')}">\n        <a ui-sref="gpgKeys.details.products" translate>Products</a>\n      </li>\n\n      <li ng-class="{active: stateIncludes(\'gpgKeys.details.repositories\')}">\n        <a ui-sref="gpgKeys.details.repositories" translate>Repositories</a>\n      </li>\n    </ul>\n  </nav>\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <section class="nutupane-sub-section" ui-view></section>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/gpg-keys/details/views/gpg-key-info.html",'<div class="details fl gpg-details" >\n  <div class="detail">\n    <span class="info-label" translate>Name</span>\n    <span class="info-value"\n          bst-edit-text="gpgKey.name"\n          on-save="save(gpgKey)"\n          readonly="denied(\'edit_gpg_keys\', gpgKey)">\n    </span>\n  </div>\n  <div class="detail" ng-if="permitted(\'edit_gpg_keys\', gpgKey)">\n    <span class="info-label" translate>Upload GPG Key</span>\n    <span class="info-value">\n        <form role="form"\n              action="{{ uploadURL }}"\n              ng-upload="uploadContent(content)"\n              upload-options-enable-controls\n              upload-options-enable-rails-csrf>\n\n          <div class="control-group">\n              <input type="file" name="content"/>\n\n              <button class="btn btn-default" upload-submit ng-click="progress.uploading = true">\n                <i class="icon-spinner icon-spin" ng-show="progress.uploading"></i>\n                <span ng-show="progress.uploading" translate>Uploading...</span>\n                <span ng-hide="progress.uploading" translate>Upload</span>\n              </button>\n          </div>\n        </form>\n    </span>\n  </div>\n\n  <div class="detail">\n    <span class="info-label" translate>Content</span>\n    <span class="gpg-bst-edit info-value"\n        bst-edit-textarea="gpgKey.content"\n        readonly="denied(\'edit_gpg_keys\', gpgKey)"\n        on-save="save(gpgKey)">\n     </span>\n  </div>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/gpg-keys/details/views/gpg-key-products.html",'<section class="details details-full">\n  <h4 translate>Products</h4>\n  <input type="text"\n         class="form-control filter-input"\n         placeholder="{{ \'Filter\' | translate }}"\n         ng-model="productSearch"/>\n\n  \n  <table bst-table="table" class="table table-striped" ng-show="gpgKey.products.length > 0">\n    <thead>\n      <tr bst-table-head>\n        <th bst-table-column="name" sortable><span translate>Name</span></th>\n        <th bst-table-column class="number-cell" translate>Repositories</th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr bst-table-row ng-repeat="product in gpgKey.products | filter:productSearch">\n        <td bst-table-cell>\n          <a ui-sref="products.details.repositories.index({productId: product.id})">\n            {{ product.name }}\n          </a>\n        </td>\n        <td bst-table-cell class="number-cell">{{ product.repository_count }}</td>\n      </tr>\n    </tbody>\n  </table>\n</section>\n\n<p class="alert alert-info" ng-show="gpgKey.products.length === 0" translate>\n  You currently don\'t have any Products associated with this Gpg Key.\n</p>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/gpg-keys/details/views/gpg-key-repositories.html",'<section class="details details-full">\n  <h4 translate>Repositories</h4>\n\n  <input type="text"\n         class="form-control filter-input"\n         placeholder="{{ \'Filter\' | translate }}"\n         ng-model="repositorySearch"/>\n\n  <table class="table table-striped" ng-show="gpgKey.repositories.length > 0">\n    <thead>\n      <tr>\n        <th translate>Name</th>\n        <th translate>Product</th>\n        <th translate>Type</th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr ng-repeat="repository in gpgKey.repositories | filter:repositorySearch">\n        <td>\n          <a ng-href="/products/{{ repository.product.id }}/repositories/{{ repository.id }}">{{ repository.name }}</a>\n        </td>\n        <td>\n          <a ui-sref="products.details.repositories.index({productId: repository.product.id})">\n            {{ repository.product.name }}\n          </a>\n        </td>\n        <td>{{ repository.content_type }}</td>\n      </tr>\n    </tbody>\n  </table>\n\n</section>\n\n<p class="alert alert-info" ng-show="gpgKey.repositories.length === 0" translate>\n  You currently don\'t have any Repositories associated with this Gpg Key.\n</p>\n')}]),angular.module("Bastion.gpg-keys").factory("GPGKey",["BastionResource","CurrentOrganization",function(BastionResource,CurrentOrganization){return BastionResource("/katello/api/v2/gpg_keys/:id/:action",{id:"@id",organization_id:CurrentOrganization},{autocomplete:{method:"GET",isArray:!0,params:{id:"auto_complete_search"}},update:{method:"PUT"}})}]),angular.module("Bastion.gpg-keys").controller("GPGKeysController",["$scope","$location","Nutupane","GPGKey","CurrentOrganization",function($scope,$location,Nutupane,GPGKey,CurrentOrganization){var params={organization_id:CurrentOrganization,search:$location.search().search||"",sort_by:"name",sort_order:"ASC",paged:!0},nutupane=new Nutupane(GPGKey,params);$scope.table=nutupane.table,$scope.panel={loading:!1},$scope.removeRow=nutupane.removeRow,$scope.$state.current.collapsed&&($scope.panel.loading=!0),$scope.table.openGPGKey=function(gpgKey){$scope.panel.loading=!0,$scope.transitionTo("gpgKeys.details.info",{gpgKeyId:gpgKey.id})},$scope.transitionToNewGPGKey=function(){$scope.panel.loading=!0,$scope.transitionTo("gpgKeys.new")},$scope.table.closeItem=function(){$scope.transitionTo("gpgKeys.index")}}]),angular.module("Bastion.gpg-keys").controller("NewGPGKeyController",["$scope","GPGKey","CurrentOrganization",function($scope,GPGKey,CurrentOrganization){$scope.panel={loading:!1},$scope.gpgKey=new GPGKey,$scope.CurrentOrganization=CurrentOrganization,$scope.progress={uploading:!1},$scope.contentFormType="paste",$scope.uploadURL="/katello/api/v2/gpg_keys?organization_id="+CurrentOrganization,$scope.uploadContent=function(content){content&&(content.errors===undefined?($scope.table.addRow(content),$scope.uploadStatus="success",$scope.transitionTo("gpgKeys.index")):($scope.errorMessages=[content.displayMessage],$scope.uploadStatus="error"),$scope.progress.uploading=!1)}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/gpg-keys/new/views/gpg-key-new.html",'<div class="loading-mask loading-mask-panel icon-3x" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="new-header details-header">\n    <h2 class="fl" translate>New GPG Key</h2>\n    <div class="fr">\n      <button class="btn btn-default" ui-sref="gpgKeys.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n  <div>\n    <div bst-alert error-messages="errorMessages"></div>\n\n    <form name="gpgKeyForm" class="form form-horizontal" novalidate role="form"\n          action="{{ uploadURL }}"\n          ng-upload="uploadContent(content)"\n          upload-options-enable-rails-csrf>\n\n      <div bst-form-group label="{{ \'Name\' | translate }}">\n        <input id="name"\n               name="name"\n               ng-model="gpgKey.name"\n               type="text"\n               tabindex="1"\n               autofocus\n               required/>\n      </div>\n\n      <div bst-form-group label="{{ \'Contents\' | translate }}">\n        <div>\n          <div class="radio">\n             <input type="radio"\n                 name="contentFormType"\n                 ng-model="contentFormType"\n                 value="upload"/>\n              <label translate>Upload GPG Key</label>\n          </div>\n          <input type="file" name="file_path" ng-disabled="contentFormType != \'upload\'"/>\n        </div>\n\n        <div>\n          <div class="radio">\n             <input type="radio"\n                 name="contentFormType"\n                 ng-model="contentFormType"\n                 value="paste"/>\n              <label translate>Paste GPG Key Contents</label>\n          </div>\n          <textarea id="content"\n                    name="content"\n                    ng-model="gpgKey.content"\n                    tabindex="1"\n                    class="gpg-textarea"\n                    placeholder="{{ \'Paste contents...\' | translate }}"\n                    ng-disabled="contentFormType != \'paste\'">\n          </textarea>\n        </div>\n      </div>\n\n      <div bst-form-buttons upload-submit\n           on-cancel="transitionTo(\'gpgKeys.index\')"\n           ng-disabled="gpgKey.name == undefined"\n           working="progress.uploading">\n      </div>\n    </form>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/gpg-keys/views/gpg-keys-table-collapsed.html",'<table bst-table="table" class="table table-striped" ng-class="{\'table-mask\': table.working}">\n  <thead>\n    <tr bst-table-head>\n      <th bst-table-column="name" sortable><span translate>Name</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row\n        ng-repeat="gpgKey in table.rows"\n        active-row="stateIncludes(\'gpg-keys.details\', {gpgKeyId: gpgKey.id})">\n      <td bst-table-cell>\n        <a class="clickable" ng-click="table.openGPGKey(gpgKey)">{{ gpgKey.name }}</a>\n      </td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/gpg-keys/views/gpg-keys-table-full.html",'<p class="alert alert-info" ng-show="table.rows.length === 0" translate>\n      You currently don\'t have any Gpg keys, you can add Gpg keys using the button on the right.\n</p>\n<table bst-table="table"\n       class="table table-striped"\n       ng-class="{\'table-mask\': table.working}"\n       ng-show="table.rows.length > 0">\n  <thead>\n    <tr bst-table-head>\n      <th bst-table-column="name" sortable><span translate>Name</span></th>\n      <th bst-table-column="organization"><span translate>Organization</span></th>\n      <th bst-table-column="products" class="number-cell"><span translate>Product Count</span></th>\n      <th bst-table-column class="number-cell"><span translate>Repository Count</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row ng-repeat="gpgKey in table.rows">\n      <td bst-table-cell>\n        <a class="clickable" ng-click="table.openGPGKey(gpgKey)">{{ gpgKey.name }}</a>\n      </td>\n      <td bst-table-cell>{{ gpgKey.organization.name }}</td>\n      <td bst-table-cell class="number-cell">{{ gpgKey.products.length || 0 }}</td>\n      <td bst-table-cell class="number-cell">{{ gpgKey.repositories.length || 0 }}</td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/gpg-keys/views/gpg-keys.html",'<span page-title>{{ \'GPG Keys\' | translate }}</span>\n\n<div data-extend-template="layouts/nutupane.html">\n\n  <div data-block="header">\n    {{ \'Gpg Keys\' | translate }}\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-primary" ui-sref="gpgKeys.new" ng-hide="denied(\'create_gpg_keys\')">\n      <i class="icon-plus"></i>\n      {{ "New Gpg Key" | translate }}\n    </button>\n  </div>\n\n</div>\n')}]),angular.module("Bastion.custom-info",["ngResource","Bastion"]),angular.module("Bastion.custom-info").factory("CustomInfo",["BastionResource",function(BastionResource){return BastionResource("/katello/api/v2/custom_info/:type/:id/:action",{},{update:{method:"PUT"}})}]),angular.module("Bastion.activation-keys",["ngResource","ui.router","Bastion","Bastion.utils","Bastion.components","Bastion.host-collections"]),angular.module("Bastion.activation-keys").config(["$stateProvider",function($stateProvider){$stateProvider.state("activation-keys",{"abstract":!0,controller:"ActivationKeysController",templateUrl:"activation-keys/views/activation-keys.html"}).state("activation-keys.index",{url:"/activation_keys",permission:"view_activation_keys",views:{table:{templateUrl:"activation-keys/views/activation-keys-table-full.html"}}}).state("activation-keys.new",{url:"/activation_keys/new",permission:"create_activation_keys",collapsed:!0,views:{table:{templateUrl:"activation-keys/views/activation-keys-table-collapsed.html"},"action-panel":{controller:"NewActivationKeyController",templateUrl:"activation-keys/new/views/activation-key-new.html"}}}),$stateProvider.state("activation-keys.details",{"abstract":!0,url:"/activation_keys/:activationKeyId",permission:"view_activation_keys",collapsed:!0,views:{table:{templateUrl:"activation-keys/views/activation-keys-table-collapsed.html"},"action-panel":{controller:"ActivationKeyDetailsController",templateUrl:"activation-keys/details/views/activation-key-details.html"
}}}).state("activation-keys.details.info",{url:"/info",permission:"view_activation_keys",collapsed:!0,controller:"ActivationKeyDetailsInfoController",templateUrl:"activation-keys/details/views/activation-key-info.html"}).state("activation-keys.details.products",{url:"/products",permission:"view_activation_keys",collapsed:!0,controller:"ActivationKeyProductsController",templateUrl:"activation-keys/details/views/activation-key-products.html"}).state("activation-keys.details.subscriptions",{"abstract":!0,collapsed:!0,templateUrl:"activation-keys/details/views/activation-key-subscriptions.html"}).state("activation-keys.details.subscriptions.list",{url:"/subscriptions",permission:"view_activation_keys",collapsed:!0,controller:"ActivationKeySubscriptionsController",templateUrl:"activation-keys/details/views/activation-key-subscriptions-list.html"}).state("activation-keys.details.subscriptions.add",{url:"/add-subscriptions",permission:"edit_activation_keys",collapsed:!0,controller:"ActivationKeyAddSubscriptionsController",templateUrl:"activation-keys/details/views/activation-key-add-subscriptions.html"}),$stateProvider.state("activation-keys.details.host-collections",{"abstract":!0,collapsed:!0,templateUrl:"activation-keys/details/views/activation-key-host-collections.html"}).state("activation-keys.details.host-collections.list",{url:"/host-collections",permission:"view_activation_keys",collapsed:!0,controller:"ActivationKeyHostCollectionsController",templateUrl:"activation-keys/details/views/activation-key-host-collections-table.html"}).state("activation-keys.details.host-collections.add",{url:"/host-collections/add",permission:"edit_activation_keys",collapsed:!0,controller:"ActivationKeyAddHostCollectionsController",templateUrl:"activation-keys/details/views/activation-key-host-collections-table.html"}).state("activation-keys.details.associations-content-hosts",{url:"/associations/content-hosts",permission:"view_activation_keys",collapsed:!0,controller:"ActivationKeyAssociationsController",templateUrl:"activation-keys/details/views/activation-key-associations-content-hosts.html"})}]),angular.module("Bastion.activation-keys").factory("ActivationKey",["BastionResource",function(BastionResource){return BastionResource("/katello/api/v2/activation_keys/:id/:action/:action2",{id:"@id"},{get:{method:"GET",params:{fields:"full"}},update:{method:"PUT"},copy:{method:"POST",params:{action:"copy"}},releaseVersions:{method:"GET",params:{action:"releases"}},subscriptions:{method:"GET",params:{action:"subscriptions"}},products:{method:"GET",params:{action:"products"}},contentHosts:{method:"GET",params:{action:"systems"}},availableSubscriptions:{method:"GET",params:{action:"subscriptions",action2:"available"}},removeSubscriptions:{method:"PUT",isArray:!1,params:{action:"remove_subscriptions"}},addSubscriptions:{method:"PUT",isArray:!1,params:{action:"add_subscriptions"}},hostCollections:{method:"GET",params:{action:"host_collections"}},availableHostCollections:{method:"GET",params:{action:"host_collections",action2:"available"}},removeHostCollections:{method:"PUT",isArray:!1,params:{action:"host_collections"}},addHostCollections:{method:"POST",isArray:!1,params:{action:"host_collections"}},contentOverride:{method:"PUT",isArray:!1,params:{action:"content_override"}}})}]),angular.module("Bastion.activation-keys").controller("ActivationKeysController",["$scope","$location","translate","Nutupane","ActivationKey","CurrentOrganization",function($scope,$location,translate,Nutupane,ActivationKey,CurrentOrganization){var params={organization_id:CurrentOrganization,search:$location.search().search||"",sort_by:"name",sort_order:"ASC",paged:!0},nutupane=new Nutupane(ActivationKey,params);$scope.table=nutupane.table,$scope.removeRow=nutupane.removeRow,$scope.table.closeItem=function(){$scope.transitionTo("activation-keys.index")}}]),angular.module("Bastion.activation-keys").filter("activationKeyConsumedFilter",["$filter","translate",function($filter,translate){return function(activationKey){var quantity=$filter("unlimitedFilter")(activationKey.max_content_hosts,activationKey.unlimited_content_hosts);return translate("%(consumed)s out of %(quantity)s").replace("%(consumed)s",activationKey.usage_count).replace("%(quantity)s",quantity)}}]),angular.module("Bastion.activation-keys").controller("ActivationKeyAddHostCollectionsController",["$scope","$q","$location","translate","ActivationKey","Nutupane",function($scope,$q,$location,translate,ActivationKey,Nutupane){var hostCollectionsPane,params;$scope.successMessages=[],$scope.errorMessages=[],params={search:$location.search().search||"",sort_by:"name",sort_order:"ASC",paged:!0,id:$scope.$stateParams.activationKeyId},hostCollectionsPane=new Nutupane(ActivationKey,params,"availableHostCollections"),$scope.hostCollectionsTable=hostCollectionsPane.table,$scope.addHostCollections=function(){var data,success,error,deferred=$q.defer(),hostCollectionsToAdd=_.pluck($scope.hostCollectionsTable.getSelected(),"id");return data={activation_key:{host_collection_ids:hostCollectionsToAdd}},success=function(data){$scope.successMessages=[translate('Added %x host collections to activation key "%y".').replace("%x",$scope.hostCollectionsTable.numSelected).replace("%y",$scope.activationKey.name)],$scope.hostCollectionsTable.working=!1,$scope.hostCollectionsTable.selectAll(!1),hostCollectionsPane.refresh(),$scope.activationKey.$get(),deferred.resolve(data)},error=function(error){deferred.reject(error.data.errors),$scope.errorMessages=error.data.errors.base,$scope.hostCollectionsTable.working=!1},$scope.hostCollectionsTable.working=!0,ActivationKey.addHostCollections({id:$scope.activationKey.id},data,success,error),deferred.promise}}]),angular.module("Bastion.activation-keys").controller("ActivationKeyAddSubscriptionsController",["$scope","$state","$location","translate","Nutupane","CurrentOrganization","Subscription","ActivationKey","SubscriptionsHelper",function($scope,$state,$location,translate,Nutupane,CurrentOrganization,Subscription,ActivationKey,SubscriptionsHelper){var addSubscriptionsPane,params;params={id:$scope.$stateParams.activationKeyId,organization_id:CurrentOrganization,search:$location.search().search||"",sort_by:"name",sort_order:"ASC"},addSubscriptionsPane=new Nutupane(ActivationKey,params,"availableSubscriptions"),$scope.addSubscriptionsTable=addSubscriptionsPane.table,$scope.isAdding=!1,$scope.addSubscriptionsTable.closeItem=function(){},$scope.groupedSubscriptions={},$scope.$watch("addSubscriptionsTable.rows",function(rows){$scope.groupedSubscriptions=SubscriptionsHelper.groupByProductName(rows)}),$scope.disableAddButton=function(){return $scope.addSubscriptionsTable.numSelected===0||$scope.isAdding},$scope.addSelected=function(){var selected;selected=SubscriptionsHelper.getSelectedSubscriptionAmounts($scope.addSubscriptionsTable),$scope.isAdding=!0,ActivationKey.addSubscriptions({id:$scope.activationKey.id,subscriptions:selected},function(){$scope.successMessages.push(translate("Successfully added %s subscriptions.").replace("%s",selected.length)),$scope.isAdding=!1,addSubscriptionsPane.refresh()},function(response){$scope.$parent.errorMessages=response.data.displayMessage,$scope.isAdding=!1})},$scope.amountSelectorValues=function(subscription){var value,values;values=[];for(value=1;value<subscription.quantity&&values.length<5;value+=1)values.push(value);return values.push(subscription.quantity),values}}]),angular.module("Bastion.activation-keys").controller("ActivationKeyAssociationsController",["$scope","translate","ActivationKey","ContentHostsHelper","CurrentOrganization",function($scope,translate,ActivationKey,ContentHostsHelper,CurrentOrganization){$scope.contentHosts?$scope.table.working=!1:$scope.table.working=!0,$scope.activationKey.$promise.then(function(){ActivationKey.contentHosts({id:$scope.activationKey.id,organization_id:CurrentOrganization},function(response){$scope.contentHosts=response.results,$scope.table.working=!1})}),$scope.getStatusColor=ContentHostsHelper.getStatusColor,$scope.memory=ContentHostsHelper.memory}]),angular.module("Bastion.activation-keys").controller("ActivationKeyDetailsInfoController",["$scope","$q","translate","ActivationKey","ContentView","Organization","CurrentOrganization",function($scope,$q,translate,ActivationKey,ContentView,Organization,CurrentOrganization){$scope.editContentView=!1,$scope.disableEnvironmentSelection=!1,$scope.environments=[],$scope.environments=Organization.readableEnvironments({id:CurrentOrganization}),$scope.$on("activationKey.loaded",function(){$scope.originalEnvironment=$scope.activationKey.environment}),$scope.$watch("activationKey.environment",function(environment){environment&&$scope.originalEnvironment&&environment.id!==$scope.originalEnvironment.id&&($scope.editContentView=!0,$scope.disableEnvironmentSelection=!0)}),$scope.cancelContentViewUpdate=function(){$scope.editContentView&&($scope.editContentView=!1,$scope.activationKey.environment=$scope.originalEnvironment,$scope.disableEnvironmentSelection=!1)},$scope.saveContentView=function(activationKey){$scope.editContentView=!1,$scope.save(activationKey).then(function(activationKey){$scope.originalEnvironment=activationKey.environment}),$scope.disableEnvironmentSelection=!1},$scope.releaseVersions=function(){var deferred=$q.defer();return ActivationKey.releaseVersions({id:$scope.activationKey.id},function(response){deferred.resolve(response.results)}),deferred.promise},$scope.clearReleaseVersion=function(){$scope.activationKey.release_version="",$scope.save($scope.activationKey)},$scope.clearServiceLevel=function(){$scope.activationKey.service_level="",$scope.save($scope.activationKey)},$scope.contentViews=function(){var deferred=$q.defer();return ContentView.queryUnpaged({environment_id:$scope.activationKey.environment.id},function(response){deferred.resolve(response.results)}),deferred.promise}}]),angular.module("Bastion.activation-keys").controller("ActivationKeyDetailsController",["$scope","$state","$q","translate","ActivationKey","Organization","CurrentOrganization",function($scope,$state,$q,translate,ActivationKey,Organization,CurrentOrganization){$scope.successMessages=[],$scope.errorMessages=[],$scope.copyErrorMessages=[],$scope.activationKey?$scope.panel={loading:!1}:$scope.panel={loading:!0},$scope.activationKey=ActivationKey.get({id:$scope.$stateParams.activationKeyId},function(activationKey){$scope.$broadcast("activationKey.loaded",activationKey),$scope.panel.loading=!1}),$scope.save=function(activationKey){var deferred=$q.defer();return activationKey.$update(function(response){deferred.resolve(response),$scope.successMessages.push(translate("Activation Key updated")),$scope.table.replaceRow(response)},function(response){deferred.reject(response),$scope.errorMessages.push(translate("An error occurred saving the Activation Key: ")+response.data.displayMessage)}),deferred.promise},$scope.copy=function(newName){ActivationKey.copy({id:$scope.activationKey.id,new_name:newName},function(response){$scope.showCopy=!1,$scope.table.addRow(response),$scope.transitionTo("activation-keys.details.info",{activationKeyId:response.id})},function(response){$scope.copyErrorMessages.push(response.data.displayMessage)})},$scope.removeActivationKey=function(activationKey){var id=activationKey.id;activationKey.$delete(function(){$scope.removeRow(id),$scope.transitionTo("activation-keys.index"),$scope.successMessages.push(translate("Activation Key removed."))},function(response){$scope.errorMessages.push(translate("An error occurred removing the Activation Key: ")+response.data.displayMessage)})},$scope.serviceLevels=function(){var deferred=$q.defer();return Organization.get({id:CurrentOrganization},function(organization){deferred.resolve(organization.service_levels)}),deferred.promise}}]),angular.module("Bastion.activation-keys").controller("ActivationKeyHostCollectionsController",["$scope","$q","$location","translate","ActivationKey","Nutupane",function($scope,$q,$location,translate,ActivationKey,Nutupane){var hostCollectionsPane,params;$scope.successMessages=[],$scope.errorMessages=[],params={id:$scope.$stateParams.activationKeyId,search:$location.search().search||"",sort_by:"name",sort_order:"ASC",paged:!0},hostCollectionsPane=new Nutupane(ActivationKey,params,"hostCollections"),$scope.hostCollectionsTable=hostCollectionsPane.table,$scope.removeHostCollections=function(){var data,success,error,deferred=$q.defer(),hostCollectionsToRemove=_.pluck($scope.hostCollectionsTable.getSelected(),"id");return data={activation_key:{host_collection_ids:hostCollectionsToRemove}},success=function(data){$scope.successMessages=[translate('Removed %x host collections from activation key "%y".').replace("%x",$scope.hostCollectionsTable.numSelected).replace("%y",$scope.activationKey.name)],$scope.hostCollectionsTable.working=!1,$scope.hostCollectionsTable.selectAll(!1),hostCollectionsPane.refresh(),$scope.activationKey.$get(),deferred.resolve(data)},error=function(error){deferred.reject(error.data.errors),$scope.errorMessages=error.data.errors,$scope.hostCollectionsTable.working=!1},$scope.hostCollectionsTable.working=!0,ActivationKey.removeHostCollections({id:$scope.activationKey.id},data,success,error),deferred.promise}}]),angular.module("Bastion.activation-keys").controller("ActivationKeyProductDetailsController",["$scope","translate","ActivationKey",function($scope,translate,ActivationKey){$scope.expanded=!0,$scope.details=null,$scope.productDetails=function(product){var override;$scope.details===null&&($scope.details=product,angular.forEach($scope.details.available_content,function(content){override=_.findWhere($scope.activationKey.content_overrides,{contentLabel:content.content.label,name:"enabled"}),override===undefined?content.overrideEnabled=null:content.overrideEnabled=Number(override.value),content.enabledText=$scope.getEnabledText(content.enabled,content.overrideEnabled)}))},$scope.overrideEnableChoices=function(content){return[{name:$scope.getEnabledText(content.enabled,null),id:null},{name:$scope.getEnabledText(null,1),id:1},{name:$scope.getEnabledText(null,0),id:0}]},$scope.getEnabledText=function(enabled,overrideEnabled){var enabledText;return overrideEnabled===null?enabledText=enabled?translate("Yes (Default)"):translate("No (Default)"):overrideEnabled===1?enabledText=translate("Override to Yes"):enabledText=translate("Override to No"),enabledText},$scope.success=function(content){content.enabledText=$scope.getEnabledText(content.enabled,content.overrideEnabled),$scope.successMessages.push(translate('Updated override to "%x".').replace("%x",content.enabledText))},$scope.error=function(error){$scope.errorMessages.push(error.data.errors)},$scope.saveContentOverride=function(content){content.overrideEnabled===null?ActivationKey.contentOverride({id:$scope.activationKey.id},{content_override:{content_label:content.content.label,name:"enabled"}},function(){$scope.success(content)},$scope.error):ActivationKey.contentOverride({id:$scope.activationKey.id},{content_override:{content_label:content.content.label,name:"enabled",value:content.overrideEnabled}},function(){$scope.success(content)},$scope.error)}}]),angular.module("Bastion.activation-keys").controller("ActivationKeyProductsController",["$scope","translate","ActivationKey","Product","CurrentOrganization",function($scope,translate,ActivationKey,Product,CurrentOrganization){$scope.successMessages=[],$scope.errorMessages=[],$scope.displayArea={working:!0,isAvailableContent:!1},$scope.isAnyAvailableContent=function(products){var isAvailableContent=!1;return angular.forEach(products,function(product){product.available_content.length>0&&(isAvailableContent=!0)}),isAvailableContent},$scope.activationKey.$promise.then(function(){ActivationKey.products({id:$scope.activationKey.id,organization_id:CurrentOrganization,enabled:!0,full_result:!0},function(response){$scope.products=response.results,$scope.displayArea.isAvailableContent=$scope.isAnyAvailableContent($scope.products),$scope.displayArea.working=!1})})}]),angular.module("Bastion.activation-keys").controller("ActivationKeySubscriptionsController",["$scope","$location","translate","Nutupane","ActivationKey","SubscriptionsHelper",function($scope,$location,translate,Nutupane,ActivationKey,SubscriptionsHelper){var subscriptionsPane,params;params={id:$scope.$stateParams.activationKeyId,search:$location.search().search||"",sort_by:"name",sort_order:"ASC",paged:!0},subscriptionsPane=new Nutupane(ActivationKey,params,"subscriptions"),$scope.subscriptionsTable=subscriptionsPane.table,$scope.subscriptionsTable.closeItem=function(){},$scope.isRemoving=!1,$scope.groupedSubscriptions={},$scope.$watch("subscriptionsTable.rows",function(rows){$scope.groupedSubscriptions=SubscriptionsHelper.groupByProductName(rows)}),$scope.disableRemoveButton=function(){return $scope.subscriptionsTable.numSelected===0||$scope.isRemoving},$scope.removeSelected=function(){var selected;selected=SubscriptionsHelper.getSelectedSubscriptionAmounts($scope.subscriptionsTable),$scope.isRemoving=!0,ActivationKey.removeSubscriptions({id:$scope.activationKey.id,subscriptions:selected},function(){subscriptionsPane.table.selectAll(!1),subscriptionsPane.refresh(),$scope.successMessages.push(translate("Successfully removed %s subscriptions.").replace("%s",selected.length)),$scope.isRemoving=!1},function(response){$scope.isRemoving=!1,$scope.errorMessages.push(translate("An error occurred removing the subscriptions.")+response.data.displayMessage)})}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/details/views/activation-key-add-subscriptions.html",'<span page-title ng-model="activationKey">{{ \'Add Subscriptions for Activation Key:\' | translate }} {{ activationKey.name }}</span>\n\n<section class="nutupane-sub-section">\n\n  <div class="row">\n\n    <div class="col-sm-3">\n      <div class="input-group input-group">\n        <input type="text"\n               class="form-control"\n               placeholder="{{ \'Search...\' | translate }}"\n               ng-model="addSubscriptionsTable.searchTerm"\n               bst-on-enter="addSubscriptionsTable.search(addSubscriptionsTable.searchTerm)"/>\n        <span class="input-group-btn">\n          <button ng-click="addSubscriptionsTable.search(addSubscriptionsTable.searchTerm)" class="btn btn-default" type="button"><i class="icon-search"></i></button>\n        </span>\n      </div>\n    </div>\n\n    <div class="col-sm-3 nutupane-info">\n      <span translate>Showing {{ addSubscriptionsTable.rows.length }} of {{ addSubscriptionsTable.resource.subtotal }} ({{ addSubscriptionsTable.resource.total }} Total) Subscriptions</span>\n    </div>\n\n    <div class="pull-right">\n      <div class="pull-left nutupane-info">\n        <span translate>{{ addSubscriptionsTable.numSelected }} Selected</span>\n      </div>\n\n      <div ng-hide="denied(\'edit_activation_keys\', activationKey)" class="nutupane-actions pull-right">\n         <button class="btn btn-primary"\n                 translate\n                 ng-disabled="disableAddButton()"\n                 ng-click="addSelected()">\n           Add Selected\n         </button>\n      </div>\n\n    </div>\n  </div>\n\n  <div bst-table="addSubscriptionsTable" class="nutupane">\n    <div bst-container-scroll bst-infinite-scroll="addSubscriptionsTable.nextPage()">\n\n      <div class="loading-mask icon-3x" ng-show="addSubscriptionsTable.working && addSubscriptionsTable.rows.length == 0">\n        <i class="icon-spinner icon-spin"></i>\n        {{ "Loading..." | translate }}\n      </div>\n\n      <table ng-class="{\'table-mask\': subscriptionsTable.working}" class="table table-full table-striped">\n        <thead>\n          <tr bst-table-head row-select>\n            <th bst-table-column="quantity" sortable class="align-center"><span translate>Quantity</span></th>\n            <th bst-table-column="attached" sortable><span translate>Attached</span></th>\n            <th bst-table-column="type"><span translate>Type</span></th>\n            <th bst-table-column="startDate" sortable><span translate>Starts</span></th>\n            <th bst-table-column="endDate" sortable><span translate>Expires</span></th>\n            <th bst-table-column="supportLevel"><span translate>Support Level</span></th>\n            <th bst-table-column="contractNumber" sortable><span translate>Contract</span></th>\n            <th bst-table-column="accountNumber" sortable><span translate>Account</span></th>\n          </tr>\n        </thead>\n\n        <tbody>\n          <tr bst-table-row ng-repeat-start="(name, subscriptions) in groupedSubscriptions">\n            <td bst-table-cell colspan="8">\n              <a href=\'/subscriptions?search=product_name:"{{ name }}"\'>\n                {{ name }}\n              </a>\n            </td>\n          </tr>\n          <tr bst-table-row ng-repeat-end ng-repeat="subscription in subscriptions" row-select="subscription">\n            <td bst-table-cell>\n              <span ng-hide="subscription.multi_entitlement">\n                1\n              </span>\n              <select ng-hide="!subscription.multi_entitlement"\n                      ng-model="subscription.amount"\n                      ng-options="amount for amount in amountSelectorValues(subscription)"\n                      >\n                <option value="">{{ "Automatic" | translate }}</option>\n              </select>\n            </td>\n            <td bst-table-cell>{{ subscription | subscriptionConsumedFilter }}</td>\n            <td bst-table-cell><div subscription-type="subscription"></div></td>\n            <td bst-table-cell>{{ subscription.start_date | date:"shortDate" }}</td>\n            <td bst-table-cell>{{ subscription.end_date | date:"shortDate" }}</td>\n            <td bst-table-cell>{{ subscription.support_level }}</td>\n            <td bst-table-cell>{{ subscription.contract_number }}</td>\n            <td bst-table-cell>{{ subscription.account_number }}</td>\n          </tr>\n        </tbody>\n\n      </table>\n    </div>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/details/views/activation-key-associations-content-hosts.html",'<span page-title ng-model="activationKey">{{ \'Content Hosts for Activation Key:\' | translate }} {{ activationKey.name }}</span>\n\n<div class="details details-full">\n\n  <h3 translate>\n    Attached to Content Hosts\n  </h3>\n\n  <table class="table table-striped" bst-table="table" ng-class="{\'table-mask\': table.working}">\n    <thead>\n      <tr bst-table-head>\n        <th bst-table-column="name" sortable><span translate>Name</span></th>\n        <th bst-table-column="status">\n          {{ "Subscription Status" | translate }}\n        </th>\n        <th bst-table-column="environment" sortable><span translate>Environment</span></th>\n        <th bst-table-column="contentView"><span translate>Content View</span></th>\n        <th bst-table-column="serviceLevel"><span translate>Service Level</span></th>\n        <th bst-table-column="releaseVersion"><span translate>Release Version</span></th>\n      </tr>\n    </thead>\n\n    <tbody>\n      <tr ng-show="!table.working && contentHosts.length === 0">\n        <td colspan="6" translate>This activation key is not associated with any content hosts.</td>\n      </tr>\n\n      <tr bst-table-row ng-repeat="contentHost in contentHosts"\n          ng-controller="ContentHostStatusController">\n        <td bst-table-cell>\n          <a ui-sref="content-hosts.details.info({contentHostId: contentHost.uuid})">\n            {{ contentHost.name }}\n          </a>\n        </td>\n        <td bst-table-cell>\n          <span class="icon-circle" ng-class="getStatusColor(contentHost.entitlementStatus)">\n          </span>\n        </td>\n        <td bst-table-cell>{{ contentHost.environment.name }}</td>\n        <td bst-table-cell>{{ contentHost.content_view.name || "" }}</td>\n        <td bst-table-cell>{{ contentHost.service_level }}</td>\n        <td bst-table-cell>{{ contentHost.release_ver }}</td>\n      </tr>\n    </tbody>\n  </table>\n\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/details/views/activation-key-details.html",'<span page-title ng-model="activationKey">{{ \'Activation Key:\' | translate }} {{ activationKey.name }}</span>\n\n<div class="loading-mask loading-mask-panel icon-3x" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n\n  <header class="details-header">\n    <h2 class="pull-left" translate>Activation Key: {{ activationKey.name }}</h2>\n\n    <div class="details-actions pull-right">\n      <button class="btn btn-default"\n              ng-click="openModal()" ng-hide="denied(\'destroy_activation_keys\', activationKey)" translate>\n        Remove\n      </button>\n\n      <!-- RFE copy activation key - http://projects.theforeman.org/issues/4407 -->\n      <button class="btn btn-default"\n              ng-click="showCopy = true"\n              ng-hide="denied(\'create_activation_key\')">\n        <i class="icon-copy"></i>\n        {{ "Copy Activation Key" | translate }}\n      </button>\n\n      <button class="btn btn-default" ui-sref="activation-keys.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n\n      <div bst-modal="removeActivationKey(activationKey)" model="activationKey"\n           modal-header="{{ \'Remove Activation Key \' + activationKey.name + \'?\' | translate }}"\n           modal-body="{{ \'Are you sure you want to remove activation key \' + activationKey.name + \'?\' | translate }}"></div>\n\n    </div>\n  </header>\n\n  <div ng-show="showCopy" class="pull-right action-pane" >\n    <form>\n      <h5 translate>Copy</h5>\n      <div class="input">\n        <div bst-alert error-messages="copyErrorMessages"></div>\n        <div class="info-label">\n          <label for="copy_name" translate>New Name:</label>\n        </div>\n        <input ng-model="copyName"\n               id="copy_name"\n               name="copy_name"\n               tabindex="1"\n               autofocus\n               required/>\n        <div>\n          <button class="btn btn-default" ng-click="copy(copyName)">\n            {{ "Create" | translate }}\n          </button>\n          <button class="btn btn-default" ng-click="showCopy = false">\n            {{ "Cancel" | translate }}\n          </button>\n        </div>\n      </div>\n    </form>\n  </div>\n\n  <nav>\n    <ul class="nav nav-tabs">\n      <li ng-class="{active: isState(\'activation-keys.details.info\')}">\n        <a ui-sref="activation-keys.details.info">\n          <span translate>\n            Details\n          </span>\n        </a>\n      </li>\n      <li ng-class="{active: stateIncludes(\'activation-keys.details.subscriptions\')}">\n        <a ui-sref="activation-keys.details.subscriptions.list">\n          <span translate>\n            Subscriptions\n          </span>\n        </a>\n      </li>\n      <li ng-class="{active: stateIncludes(\'activation-keys.details.products\')}">\n        <a ui-sref="activation-keys.details.products">\n          <span translate>\n            Product Content\n          </span>\n        </a>\n      </li>\n      <li ng-class="{active: stateIncludes(\'activation-keys.details.host-collections\')}">\n        <a ui-sref="activation-keys.details.host-collections.list">\n          <span translate>\n            Host Collections\n          </span>\n        </a>\n      </li>\n      <li class="dropdown"\n          ng-class="{active: stateIncludes(\'activation-keys.details.associations-content-hosts\')}">\n        <a class="dropdown-toggle">\n          <span translate>Associations</span>\n          <i class="icon-chevron-down"></i>\n        </a>\n        <ul class="dropdown-menu">\n          <li>\n            <a ui-sref="activation-keys.details.associations-content-hosts({activationKeyId: activationKey.id})" translate>\n              Content Hosts\n            </a>\n          </li>\n        </ul>\n      </li>\n    </ul>\n  </nav>\n\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <section class="nutupane-sub-section" ui-view></section>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/details/views/activation-key-host-collections-table.html",'<section class="nutupane-sub-section">\n  <div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n  <div class="row">\n\n    <div class="col-sm-3">\n      <div class="input-group">\n        <input type="text"\n               class="form-control"\n               placeholder="{{ \'Filter\' | translate }}"\n               ng-model="hostCollectionFilter"/>\n      </div>\n    </div>\n\n    <div class="fr select-action">\n      <span class="nutupane-info">\n        <span translate>{{ hostCollectionsTable.numSelected }} Selected</span>\n      </span>\n\n      <button ng-if="isState(\'activation-keys.details.host-collections.list\')"\n              class="btn btn-default"\n              ng-hide="denied(\'edit_activation_key\', activationKey)"\n              ng-disabled="hostCollectionsTable.numSelected == 0 || hostCollectionsTable.working"\n              ng-click="removeHostCollections()">\n        {{ \'Remove Selected\' | translate }}\n      </button>\n      <button ng-if="isState(\'activation-keys.details.host-collections.add\')"\n              class="btn btn-default"\n              ng-hide="denied(\'edit_activation_key\', activationKey)"\n              ng-disabled="hostCollectionsTable.numSelected == 0 || hostCollectionsTable.working"\n              ng-click="addHostCollections()">\n        {{ \'Add Selected\' | translate }}\n      </button>\n\n    </div>\n  </div>\n\n  <div bst-table="hostCollectionsTable" class="nutupane">\n    <div bst-container-scroll bst-infinite-scroll="hostCollectionsTable.nextPage()">\n\n      <div ng-show="hostCollectionsTable.rows.length == 0">\n        <div class="loading-mask" ng-show="hostCollectionsTable.working">\n          <i class="icon-spinner icon-spin"></i>\n          {{ "Loading..." | translate }}\n        </div>\n\n        <p ng-hide="hostCollectionsTable.working" translate>No host collections</p>\n      </div>\n\n      <table ng-show="hostCollectionsTable.rows.length > 0"\n             ng-class="{\'table-mask\': hostCollectionsTable.working}" class="table table-full table-striped">\n        <thead>\n          <tr bst-table-head row-select="hostCollection">\n            <th bst-table-column="name" translate>Name</th>\n            <th bst-table-column="description" translate>Description</th>\n            <th bst-table-column="capacity" translate>Capacity</th>\n          </tr>\n        </thead>\n\n        <tbody>\n          <tr bst-table-row ng-repeat="hostCollection in hostCollectionsTable.rows | filter:hostCollectionFilter" row-select="hostCollection">\n            <td bst-table-cell>\n              <a ui-sref="host-collections.details.info({hostCollectionId: hostCollection.id})">\n                {{ hostCollection.name }}\n              </a>\n            </td>\n            <td bst-table-cell>{{ hostCollection.description }}</td>\n            <td bst-table-cell>{{ hostCollection.total_content_hosts }} / {{ hostCollection.max_content_hosts | unlimitedFilter:hostCollection.unlimited_content_hosts }}</td>\n          </tr>\n        </tbody>\n      </table>\n    </div>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/details/views/activation-key-host-collections.html",'<span page-title ng-model="activationKey">{{ \'Host Collections for:\' | translate }} {{ activationKey.name }}</span>\n\n<h4 translate>Host Collection Management</h4>\n<nav>\n  <ul class="nav nav-tabs" ng-show="permitted(\'edit_activation_keys\', activationKey)">\n    <li ng-class="{active: isState(\'activation-keys.details.host-collections.list\')}">\n      <a ui-sref="activation-keys.details.host-collections.list">\n        <span translate>List/Remove</span>\n      </a>\n    </li>\n\n    <li ng-class="{active: isState(\'activation-keys.details.host-collections.add\')}">\n      <a ui-sref="activation-keys.details.host-collections.add">\n        <span translate>Add</span>\n      </a>\n    </li>\n  </ul>\n</nav>\n\n<div ui-view></div>\n'
)}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/details/views/activation-key-info.html",'<span page-title ng-model="activationKey">{{ \'Details for Activation Key:\' | translate }} {{ activationKey.name }}</span>\n\n<div alert type="\'info\'">\n  <p translate>\n    This activation key may be used during system registration. For example:\n  </p>\n  <p translate>\n    subscription-manager register --org="{{ activationKey.organization.label }}" --activationkey="{{ activationKey.name }}"\n  </p>\n</div>\n\n<section>\n\n  <div class="details pull-left">\n    <section>\n      <div class="detail">\n        <span class="info-label" translate>Name</span>\n        <span class="info-value"\n              bst-edit-text="activationKey.name"\n              readonly="denied(\'edit_activation_keys\', activationKey)"\n              on-save="save(activationKey)">\n        </span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Description</span>\n        <span class="info-value"\n              bst-edit-textarea="activationKey.description"\n              readonly="denied(\'edit_activation_keys\', activationKey)"\n              on-save="save(activationKey)">\n        </span>\n        </div>\n\n      <div class="detail">\n\n        <span class="info-label" translate>Content Host Limit</span>\n\n        <span class="info-value"\n              bst-edit-custom="activationKey.max_content_hosts"\n              formatter="unlimitedFilter"\n              formatter-options="activationKey.unlimited_content_hosts"\n              readonly="denied(\'edit_activation_keys\', activationKey)"\n              on-save="save(activationKey)">\n\n          <div class="form input">\n            <div>\n              <span translate>\n                Unlimited Content Hosts:\n              </span>\n              <input type=\'checkbox\' ng-model="activationKey.unlimited_content_hosts"/>\n            </div>\n            <div ng-hide="activationKey.unlimited_content_hosts" >\n              <span translate>\n                Limit:\n              </span>\n              <input ng-model="activationKey.max_content_hosts"\n                     name="max_content_hosts"\n                     type="number"\n                     min="1"\n                     ng-required="!activationKey.unlimited_content_hosts"\n                     tabindex="2"/>\n            </div>\n          </div>\n\n        </span>\n      </div>\n      <div class="detail">\n        <span class="info-label" translate>Service Level</span>\n        <span class="info-value"\n              bst-edit-select="activationKey.service_level"\n              readonly="denied(\'edit_activation_keys\', activationKey)"\n              selector="activationKey.service_level"\n              options="serviceLevels()"\n              options-format="option for option in options"\n              deletable="true"\n              on-delete="clearServiceLevel()"\n              on-save="save(activationKey)">\n        </span>\n      </div>\n      <div class="detail">\n        <span class="info-label" translate>Auto-Attach</span>\n        <span class="info-value"\n              bst-edit-checkbox="activationKey.auto_attach"\n              formatter="booleanToYesNo"\n              readonly="denied(\'edit_activation_keys\', activationKey)"\n              on-save="save(activationKey)">\n        </span>\n      </div>\n    </section>\n  </div>\n\n  <div class="details pull-left">\n    <section>\n      <h4 translate>Activation Key Content</h4>\n\n      <div class="detail">\n        <span class="info-label" translate>Release Version</span>\n        <span class="info-value"\n              bst-edit-select="activationKey.release_version"\n              readonly="denied(\'edit_activation_keys\', activationKey)"\n              selector="activationKey.release_version"\n              options="releaseVersions()"\n              options-format="option for option in options"\n              deletable="true"\n              on-delete="clearReleaseVersion()"\n              on-save="save(activationKey)">\n        </span>\n      </div>\n\n      <div class="detail">\n        <div alert type="\'info\'" ng-show="editContentView">\n          <p translate>You must select a new content view before your change of environment can be saved. Use the cancel button on content view selection to revert your environment selection.</p>\n        </div>\n        <span class="info-label" translate>Environment</span>\n        <span path-selector="environments"\n              ng-model="activationKey.environment"\n              mode="singleSelect"\n              disabled="denied(\'edit_activation_keys\', activationKey)"\n              disable-trigger="disableEnvironmentSelection">\n        </span>\n      </div>\n\n      <div class="detail">\n        <span class="info-label" translate>Content View</span>\n        <span class="info-value"\n              bst-edit-select="activationKey.content_view.name"\n              readonly="denied(\'edit_activation_keys\', activationKey)"\n              selector="activationKey.content_view.id"\n              options="contentViews()"\n              on-cancel="cancelContentViewUpdate()"\n              on-save="saveContentView(activationKey)"\n              edit-trigger="editContentView">\n        </span>\n      </div>\n    </section>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/details/views/activation-key-products.html",'<div alert type="\'info\'">\n  {{ "Below are the repository content sets currently available for this activation key through its subscriptions. For Red Hat subscriptions, additional content can be made available through the" | translate}}\n  <a ng-href="/katello/providers/redhat_provider" translate>Red Hat Repositories page</a>.\n  {{ "Changing default settings for content hosts that register with this activation key requires subscription-manager version 1.10 or newer to be installed on that host." | translate }}\n</div>\n\n<div bst-alert success-messages="successMessages" error-messages="errorMessages"></div>\n\n<div class="loading-mask loading-mask-panel" ng-show="displayArea.working">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<div class="details details-full pull-left">\n  <section>\n    <div ng-hide="displayArea.isAvailableContent" translate>\n      No repository content provided through subscriptions.\n    </div>\n\n    <div ng-repeat="product in products" ng-hide="product.available_content.length < 1"\n         ng-controller="ActivationKeyProductDetailsController" ng-init="productDetails(product)">\n      <i ng-class="{\'icon-plus\': !expanded, \'icon-minus\': expanded}" class="expand-icon"\n         ng-click="expanded = !expanded"></i>\n      <b>{{ product.name }}</b>\n\n      <div class="row" ng-show="expanded">\n        <div class="col-md-11 col-md-offset-1" ng-show="details.available_content.length < 1"\n             translate>\n          No repository content.\n        </div>\n\n        <div class="col-md-11 col-md-offset-1" ng-repeat="content in product.available_content">\n          <h4><u>{{ content.content.name }}</u></h4>\n\n          <div class="detail row">\n            <span class="col-sm-4" translate>Enabled?</span>\n            <span class="col-sm-3"\n                  bst-edit-select="content.enabledText"\n                  readonly="denied(\'edit_activation_keys\', activationKey)"\n                  selector="content.overrideEnabled"\n                  options="overrideEnableChoices(content)"\n                  on-save="saveContentOverride(content)">\n            </span>\n          </div>\n        </div>\n      </div>\n    </div>\n  </section>\n</div>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/details/views/activation-key-subscriptions-list.html",'<span page-title ng-model="activationKey">{{ \'Current Subscriptions for Activation Key:\' | translate }} {{ activationKey.name }}</span>\n\n<section class="nutupane-sub-section" >\n\n  <div class="row">\n\n    <div class="col-sm-3">\n      <div class="input-group input-group">\n        <input type="text"\n               class="form-control"\n               placeholder="{{ \'Search...\' | translate }}"\n               ng-model="subscriptionsTable.searchTerm"\n               bst-on-enter="subscriptionsTable.search(subscriptionsTable.searchTerm)"/>\n        <span class="input-group-btn">\n          <button ng-click="subscriptionsTable.search(subscriptionsTable.searchTerm)" class="btn btn-default" type="button"><i class="icon-search"></i></button>\n        </span>\n      </div>\n    </div>\n\n    <div class="col-sm-3 nutupane-info">\n      <span translate>Showing {{ subscriptionsTable.rows.length }} of {{ subscriptionsTable.resource.subtotal }} ({{ subscriptionsTable.resource.total }} Total) Subscriptions</span>\n    </div>\n\n    <div class="pull-right">\n      <div class="pull-left nutupane-info">\n        <span translate>{{ subscriptionsTable.numSelected }} Selected</span>\n      </div>\n\n      <div class="nutupane-actions pull-right">\n         <button class="btn btn-primary"\n                 translate\n                 ng-hide="denied(\'edit_activation_keys\', activationKey)"\n                 ng-disabled="disableRemoveButton()"\n                 ng-click="removeSelected()">\n           Remove Selected\n         </button>\n      </div>\n    </div>\n  </div>\n\n  <div bst-table="subscriptionsTable" class="nutupane">\n    <div bst-container-scroll bst-infinite-scroll="subscriptionsTable.nextPage()">\n\n      <div class="loading-mask icon-3x" ng-show="subscriptionsTable.working && subscriptionsTable.rows.length == 0">\n        <i class="icon-spinner icon-spin"></i>\n        {{ "Loading..." | translate }}\n      </div>\n\n      <table ng-class="{\'table-mask\': subscriptionsTable.working}" class="table table-full table-striped">\n        <thead>\n          <tr bst-table-head row-select>\n            <th bst-table-column="quantity" sortable class="align-center"><span translate>Quantity</span></th>\n            <th bst-table-column="attached" sortable><span translate>Attached</span></th>\n            <th bst-table-column="type"><span translate>Type</span></th>\n            <th bst-table-column="startDate" sortable><span translate>Starts</span></th>\n            <th bst-table-column="endDate" sortable><span translate>Expires</span></th>\n            <th bst-table-column="supportLevel"><span translate>Support Level</span></th>\n            <th bst-table-column="contractNumber" sortable><span translate>Contract</span></th>\n            <th bst-table-column="accountNumber" sortable><span translate>Account</span></th>\n          </tr>\n        </thead>\n\n        <tbody>\n          <tr bst-table-row  ng-repeat-start="(name, subscriptions) in groupedSubscriptions">\n            <td bst-table-cell colspan="8">\n              <a href=\'/subscriptions?search=product_name:"{{ name }}"\'>\n                {{ name }}\n              </a>\n            </td>\n          </tr>\n          <tr bst-table-row ng-repeat-end ng-repeat="subscription in subscriptions" row-select="subscription">\n            <td bst-table-cell>{{ subscription | subscriptionAttachAmountFilter }}</td>\n            <td bst-table-cell>{{ subscription | subscriptionConsumedFilter }}</td>\n            <td bst-table-cell><div subscription-type="subscription"></div></td>\n            <td bst-table-cell>{{ subscription.start_date | date:"shortDate" }}</td>\n            <td bst-table-cell>{{ subscription.end_date | date:"shortDate" }}</td>\n            <td bst-table-cell>{{ subscription.service_level }}</td>\n            <td bst-table-cell>{{ subscription.contract_number }}</td>\n            <td bst-table-cell>{{ subscription.account_number }}</td>\n          </tr>\n        </tbody>\n      </table>\n    </div>\n  </div>\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/details/views/activation-key-subscriptions.html",'<span page-title ng-model="activationKey">{{ \'Subscriptions for Activation Key:\' | translate }} {{ activationKey.name }}</span>\n\n<nav>\n  <ul class="nav nav-tabs" ng-show="permitted(\'edit_activation_keys\', activationKey)">\n    <li ng-class="{active: isState(\'activation-keys.details.subscriptions.list\')}">\n      <a ui-sref="activation-keys.details.subscriptions.list">\n        <!-- TODO: other pages too - label "List" vs. "List/Remove" based on edit permissions -->\n        <span translate>\n          List/Remove\n        </span>\n      </a>\n    </li>\n\n    <!-- TODO: permissions? ng-show="activationKey.permissions.editable" -->\n    <li ng-class="{active: stateIncludes(\'activation-keys.details.subscriptions.add\')}">\n      <a ui-sref="activation-keys.details.subscriptions.add">\n        <span translate>\n          Add\n        </span>\n      </a>\n    </li>\n  </ul>\n</nav>\n\n<div ui-view></div>\n')}]),angular.module("Bastion.activation-keys").controller("NewActivationKeyController",["$scope","$q","FormUtils","ActivationKey","Organization","CurrentOrganization","ContentView",function($scope,$q,FormUtils,ActivationKey,Organization,CurrentOrganization,ContentView){function success(response){$scope.table.addRow(response),$scope.transitionTo("activation-keys.details.info",{activationKeyId:$scope.activationKey.id})}function error(response){$scope.working=!1,angular.forEach(response.data.errors,function(errors,field){$scope.activationKeyForm[field].$setValidity("server",!1),$scope.activationKeyForm[field].$error.messages=errors})}$scope.activationKey=$scope.activationKey||new ActivationKey,$scope.activationKey.unlimited_content_hosts=!0,$scope.panel={loading:!1},$scope.organization=CurrentOrganization,$scope.contentViews=[],$scope.editContentView=!1,$scope.environments=[],$scope.environments=Organization.readableEnvironments({id:CurrentOrganization}),$scope.$watch("activationKey.environment",function(environment){environment&&($scope.editContentView=!0,ContentView.queryUnpaged({environment_id:environment.id},function(response){$scope.contentViews=response.results}))}),$scope.save=function(activationKey){activationKey.organization_id=CurrentOrganization,activationKey.$save(success,error)}}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/new/views/activation-key-new.html",'<span page-title>{{ \'New Activation Key\' | translate }}</span>\n\n<div class="loading-mask loading-mask-panel icon-3x" ng-show="panel.loading">\n  <i class="icon-spinner icon-spin"></i>\n  {{ "Loading..." | translate }}\n</div>\n\n<section class="nutupane-details" ng-cloak bst-container-scroll>\n  <header class="new-header details-header">\n    <h2 class="pull-left" translate>New Activation Key</h2>\n\n    <div class="details-actions pull-right">\n      <button class="btn btn-default" ui-sref="activation-keys.index">\n        <i class="icon-remove"></i>\n        {{ "Close" | translate }}\n      </button>\n    </div>\n  </header>\n\n  <form name="activationKeyForm" class="form-horizontal" novalidate role="form">\n\n    <div bst-form-group label="{{ \'Name\' | translate }}">\n      <input id="name"\n             name="name"\n             ng-model="activationKey.name"\n             type="text"\n             tabindex="1"\n             autofocus\n             required/>\n    </div>\n\n    <div bst-form-group label="{{ \'Content Host Limit\' | translate }}" field="max_content_hosts">\n      <span translate>Unlimited Content Hosts:</span>\n      <input type="checkbox"\n             name="limit"\n             ng-model="activationKey.unlimited_content_hosts"/>\n\n      <div bst-form-group label="{{ \'Limit\' | translate }}" ng-hide="activationKey.unlimited_content_hosts">\n        <input id="max_content_hosts"\n               name="max_content_hosts"\n               class="form-control"\n               ng-model="activationKey.max_content_hosts"\n               ng-required="!activationKey.unlimited_content_hosts"\n               type="number"\n               min="1"\n               tabindex="2"/>\n      </div>\n    </div>\n\n    <div bst-form-group label="{{ \'Description\' | translate }}">\n      <textarea id="description"\n                name="description"\n                ng-model="activationKey.description"\n                tabindex="3">\n      </textarea>\n    </div>\n\n    <div class="form-group">\n      <label class="control-label col-sm-2" translate>Environment</label>\n      <div class="col-sm-5 input">\n        <span path-selector="environments"\n              ng-model="activationKey.environment"\n              selection-required="false"\n              mode="singleSelect">\n        </span>\n      </div>\n    </div>\n\n    <div bst-form-group label="{{ \'Content View\' | translate }}">\n      <select ng-hide="contentViews.length === 0 || activationKey.environment === undefined "\n              id="content_view_id"\n              name="content_view_id"\n              ng-model="activationKey.content_view_id"\n              ng-options="contentView.id as contentView.name for contentView in contentViews"\n              tabindex="4"\n              autofocus>\n      </select>\n      <span class="help-block" ng-show="activationKey.environment !== undefined && contentViews.length === 0" translate>\n        The selected environment contains no Content Views, please select a different environment.\n      </span>\n      <span class="help-block" ng-show="activationKey.environment === undefined" translate>\n        Please select an environment.\n      </span>\n    </div>\n\n\n    <div bst-form-buttons\n         on-cancel="transitionTo(\'activation-keys.index\')"\n         on-save="save(activationKey)"\n         working="working">\n    </div>\n\n  </form>\n\n\n</section>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/views/activation-keys-table-collapsed.html",'<table bst-table="table" class="table table-striped table-full" ng-class="{\'table-mask\': table.working}">\n  <thead>\n    <tr bst-table-head>\n      <th bst-table-column sortable><span translate>Name</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row\n        ng-repeat="activationKey in table.rows"\n        active-row="stateIncludes(\'activation-keys.details\', {activationKeyId: activationKey.id})">\n      <td bst-table-cell>\n        <a ui-sref="activation-keys.details.info({activationKeyId: activationKey.id})">\n          {{ activationKey.name }}\n        </a>\n      </td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/views/activation-keys-table-full.html",'<p class="alert alert-info" ng-show="table.rows.length === 0" translate>\n  You currently don\'t have any Activation Keys, you can add Activation Keys using the button on the right.\n</p>\n\n<table class="table table-striped" ng-class="{\'table-mask\': table.working}" ng-show="table.rows.length > 0">\n  <thead>\n    <tr bst-table-head>\n      <th bst-table-column="name" sortable><span translate>Name</span></th>\n      <th bst-table-column="consumed"><span translate>Consumed</span></th>\n      <th bst-table-column="environment"><span translate>Environment</span></th>\n      <th bst-table-column="contentView"><span translate>Content View</span></th>\n    </tr>\n  </thead>\n\n  <tbody>\n    <tr bst-table-row ng-repeat="activationKey in table.rows">\n      <td bst-table-cell>\n        <a ui-sref="activation-keys.details.info({activationKeyId: activationKey.id})">\n          {{ activationKey.name }}\n        </a>\n        <i class="icon-chevron-right selected-icon" ng-show="activationKey.selected"></i>\n      </td>\n      <td bst-table-cell>{{ activationKey | activationKeyConsumedFilter }}</td>\n      <td bst-table-cell>{{ activationKey.environment.name || "" }}</td>\n      <td bst-table-cell>{{ activationKey.content_view.name || "" }}</td>\n    </tr>\n  </tbody>\n</table>\n')}]),window.AngularRailsTemplates||(window.AngularRailsTemplates=angular.module("templates",[])),window.AngularRailsTemplates.run(["$templateCache",function($templateCache){$templateCache.put("bastion_katello/activation-keys/views/activation-keys.html",'<span page-title>{{ \'Activation Keys\' | translate }}</span>\n\n<div data-extend-template="layouts/nutupane.html">\n\n  <div data-block="header">\n    {{ \'Activation Keys\' | translate }}\n  </div>\n\n  <div data-block="actions">\n    <button class="btn btn-primary" ui-sref="activation-keys.new" ng-hide="denied(\'create_activation_keys\')">\n      <i class="icon-plus"></i>\n      {{ "New Activation Key" | translate }}\n    </button>\n  </div>\n\n</div>\n')}]),BASTION_MODULES.push("Bastion.activation-keys","Bastion.content-views","Bastion.content-views.versions","Bastion.custom-info","Bastion.environments","Bastion.gpg-keys","Bastion.capsules","Bastion.organizations","Bastion.products","Bastion.repositories","Bastion.subscriptions","Bastion.sync-plans","Bastion.host-collections","Bastion.content-hosts","Bastion.tasks");